var __jtolog = '';

(function() {
  var BrowserDetect = function() {
    var agt = this.agt = navigator.userAgent.toLowerCase();

    this.gk = agt.indexOf('gecko') >= 0;

    // Mozilla Firefox v1.5-4
    this.fx = this.gk && (agt.indexOf('firefox') >= 0 || agt.indexOf('granparadiso') >= 0);
    if (this.fx) {
      var vers = this._getVersionAfter('firefox/') || this._getVersionAfter('granparadiso/');
      this.fx1_5 = vers >= 1.5 && vers < 2;
      this.fx2 = vers >= 2 && vers < 3;
      this.fx3 = vers >= 3 && vers < 4;
      this.fx4 = vers >= 4;
    }

    // Apple WebKit (Safari) v3-4
    this.sf = agt.indexOf('applewebkit') >= 0;
    if (this.sf) {
      if (agt.indexOf('chrome/' >= 0)) {
        this.gc1 = true;
      } else {
        var vers = this._getVersionAfter('version/');
        this.sf3 = vers >= 3 && vers < 4;
        this.sf4 = vers >= 4;
      }
    }

    // Opera v9-10
    this.op = agt.indexOf("opera") >= 0;
    if (this.op) {
      var vers = this._getVersionAfter('opera/') || this._getVersionAfter('opera ');
      this.op9 = vers >= 9 && vers < 10;
      this.op10 = vers >= 10;
    }

    // Microsoft Internet Explorer v6-8
    this.ie = agt.indexOf("msie") >= 0 && !this.op;
    if (this.ie) {
      var vers = this._getVersionAfter('msie ');
      this.ie6 = vers >= 6 && vers < 7;
      this.ie7 = vers >= 7 && vers < 8;
      this.ie8 = vers >= 8;
    }
  };

  BrowserDetect._ORDER = [
      "ie8", "ie7", "ie6",
      "fx4", "fx3", "fx2", "fx1_5",
      "gc1", "sf4", "sf3",
      "op10", "op9",
      "ie", "fx", "sf", "op", "gk"
  ];

  BrowserDetect.prototype._getVersionAfter = function(strToken) {
    var index = this.agt.indexOf(strToken);
    return index >= 0 ? parseFloat(this.agt.substring(index+strToken.length)) : 0;
  };

  BrowserDetect.prototype.getType = function() {
    for (var i = 0; i < BrowserDetect._ORDER.length; i++)
      if (this[BrowserDetect._ORDER[i]])
        return BrowserDetect._ORDER[i];
    return "xx";
  };

  if (window.jsx3 == null) {
    window.jsx3 = {};
    jsx3.lang = {};
    jsx3.util = {};

    jsx3.SYSTEM_ROOT = "JSX";

    jsx3.SYSTEM_SCRIPTS = jsx3.SYSTEM_ROOT + "/js";

    jsx3.MAIN_SCRIPT = jsx3.SYSTEM_SCRIPTS + "/JSX30.js";

    jsx3.APP_DIR_NAME = "JSXAPPS";

    jsx3.CONFIG_FILE = "config.xml";

    jsx3.ABSOLUTEPATH = "";

    jsx3.APPPATH = "";

    jsx3.STARTUP_EVENT = null;

    jsx3.ENVIRONMENT = {};

    jsx3.getEnv = function(strKey) {
      return jsx3.ENVIRONMENT[strKey];
    };

    jsx3.setEnv = function(strKey, strValue) {
      if (jsx3.ENVIRONMENT[strKey] != null && jsx3.ENVIRONMENT[strKey] != strValue)
        window.alert(jsx3._msg("boot.env_reset", strKey, jsx3.ENVIRONMENT[strKey], strValue));
      jsx3.ENVIRONMENT[strKey] = strValue;
    };

    jsx3.tcf = function __jsx3_tcf(fctTry, fctCatch, fctFinally, objThis) {
      if (jsx3.CLASS_LOADER.IE) {
        fctTry.apply(objThis);
        if (fctFinally)
          fctFinally.apply(objThis);
      } else {
        if (fctCatch) {
          try {
            fctTry.apply(objThis);
          } catch (e) {
            fctCatch.apply(objThis, [e]);
          } finally {
            if (fctFinally)
              fctFinally.apply(objThis);
          }
        } else {
          try {
            fctTry.apply(objThis);
          } finally {
            if (fctFinally)
              fctFinally.apply(objThis);
          }
        }
      }
    };

    jsx3._msg = function(strKey, strTokens) {
      if (jsx3.System && jsx3.System.getMessage) return jsx3.System.getMessage.apply(null, arguments);
      var a = new Array(arguments.length);
      for (var i = 0; i < a.length; i++) a[i] = arguments[i];
      return a.join(" ");
    };

    jsx3.lstr = function(objBundle, strKey) {
      if (!objBundle.__) {
        // It is an error for the default locale not to be defined.
        var defaultLocale = objBundle._;
        if (!defaultLocale) defaultLocale = objBundle._ = {};

        // Construct the master for the current locale. Do this once as an optimization.
        var master = objBundle.__ = {};
        var localeBundles = [];

        // Get the locale string from a variety of sources.
        //  1. System.getLocale() if loaded
        //  2. window.navigator.userLanguage (IE)
        //  3. window.navigator.language (other browsers)
        //  4. ""
        var localeString = jsx3.System ? jsx3.System.getLocale().toString() :
            (window.navigator.userLanguage || window.navigator.language || "");

        // See if the first (language+country) locale is defined.
        var firstLocale = objBundle[localeString];
        if (firstLocale) localeBundles.push(firstLocale);

        // if dash is used convert to underscore
        var indexDash = localeString.indexOf("-"); // Mozilla and IE use - as seperator in navigator language
        if (indexDash > 0) {
          var ll = localeString.substring(0, indexDash);
          var country = localeString.substring(indexDash+1).toUpperCase(); // country is upper case.
          var trueLocale = objBundle[ll + '_' + country];
          if (trueLocale)
            localeBundles.push(trueLocale);
        }

        // See if the second (language only) locale is defined.
        var index = localeString.indexOf("_");
        if (index >= 0) {
          var secondLocale = objBundle[localeString.substring(0, index)];
          if (secondLocale) localeBundles.push(secondLocale);
        }

        localeBundles.push(defaultLocale);

        for (var i = localeBundles.length - 1; i >= 0; i--) {
          var b = localeBundles[i];
          for (var f in b)
            master[f] = b[f];
        }
      }

      var value = objBundle.__[strKey];
      return typeof(value) == "undefined" ? strKey : value;
    };

    var msgBundle = {};
    var getMsgStr = function(strKey) {
      return jsx3.lstr(msgBundle, strKey);
    };

    // A simple event publishing interface for the classes in this file.
    var evtPub = {};

    evtPub._subscribe = function(strSubject, objTarget, strMethod) {
      if (!this._evtpubreg)

        this._evtpubreg = {};
      var list = this._evtpubreg[strSubject];
      if (!list)
        list = this._evtpubreg[strSubject] = [];
      list[list.length] = [objTarget, strMethod];
    };

    evtPub._unsubscribe = function(strSubject, objTarget) {
      if (this._evtpubreg) {
        var list = this._evtpubreg[strSubject];
        for (var i = list.length - 1; i >= 0; i--) {
          if (list[i][0] == objTarget)
            list.splice(i, 1);
        }
      }
    };

    evtPub._publish = function(objEvent) {
      if (this._evtpubreg) {
        var list = this._evtpubreg[objEvent.subject];
        if (list) {
          if (list.length > 1)
            list = list.concat(); // defensive copy
          var max = list.length;
          for (var i = 0; i < max; i++) {
            var a1 = list[i][0];
            var a2 = list[i][1];
            var fct = typeof(a2) == "function" ? a2 : a1[a2];
            fct.call(a1, objEvent);
          }
        }
      }

      if (this.publish)
        this.publish(objEvent);
    };

    evtPub._import = function(objTarget) {
      objTarget._subscribe = this._subscribe;
      objTarget._unsubscribe = this._unsubscribe;
      objTarget._publish = this._publish;
    };

    jsx3._bsLog = "";
    jsx3._logIt = function(strMessage) {
      jsx3._bsLog += strMessage + "\n";
//      if (jsx3.html && jsx3.html.copy)
//        jsx3.html.copy(jsx3._bsLog);
      if (jsx3.util.Logger)
        jsx3.log(strMessage);
    };

//    window.setTimeout(function() {alert(jsx3._bsLog);}, 5000);

    var defClass = jsx3._defClass = function(objNS, strName, objSuper, fctDef) {
      var noInit = {};

      var c = objNS[strName] = function() {
        if (arguments[0] !== noInit)
          this.init.apply(this, arguments);
      };

      if (objSuper) {
        c.prototype = new objSuper(noInit);
        c._super = function(fct, arrArgs) {
          if (!arrArgs) arrArgs = [];
//          alert("_super this:" + this + " name:" + strName + " fct:" + fct + " args:" + arrArgs);
          var sf = objSuper.prototype[fct];
          return sf.apply(this, arrArgs);
        };
      }

      fctDef(c, c.prototype);
    };

    defClass(jsx3.util, "Graph", null, function(Graph, Graph_prototype) {

      Graph_prototype.init = function() {
        this.clear();
      };

      Graph_prototype.node = function(id) {
        return this._index[id];
      };

      Graph_prototype.size = function() {
        return this._count;
      };

      Graph_prototype.add = function(objNode) {
        var id = objNode._id;
        if (objNode._graph || this._index[id]) return false;

        objNode._graph = this;
        this._index[id] = objNode;
        this._count++;

        var as = [objNode._down, objNode._up];
        for (var i = 0; i < as.length; i++) {
          var a = as[i];
          for (var j = 0; j < a.length; j++) {
            if (! a[j]._graph)
              this.add(a[j]);
          }
        }

        return true;
      };

      Graph_prototype.del = function(objNode) {
        var id = objNode._id;
        if (this._index[id] !== objNode) return false;

        for (var i = 0; i < objNode._up.length; i++) {
          var downs = objNode._up[i]._down;
          for (var j = 0; j < downs.length; j++) {
            if (downs[j] == objNode) {
              downs.splice(j, 1);
              break;
            }
          }
        }
        objNode._up = [];

        for (var i = 0; i < objNode._down.length; i++) {
          var ups = objNode._down[i]._up;
          for (var j = 0; j < ups.length; j++) {
            if (ups[j] == objNode) {
              ups.splice(j, 1);
              break;
            }
          }
        }
        objNode._down = [];

        objNode._graph = null;
        delete this._index[id];
        this._count--;
        return true;
      };

      Graph_prototype.roots = function() {
        var r = [];
        for (var id in this._index) {
          if (this._index[id]._up.length == 0)
            r.push(this._index[id]);
        }
        return r;
      };

      Graph_prototype.nodes = function() {
        var n = [];
        for (var id in this._index)
          n.push(this._index[id]);
        return n;
      };

      Graph_prototype.clear = function() {
        this._index = {};
        this._count = 0;
      };

    });

    defClass(jsx3.util, "GNode", null, function(GNode, GNode_prototype) {

      GNode._SERIAL = 0;

      GNode_prototype.init = function(id) {
        this._id = id != null ? id : (++GNode._SERIAL);
        this._graph = null;
        this._up = [];
        this._down = [];
      };

      GNode_prototype.graph = function() {
        return this._graph;
      };

      GNode_prototype.id = function() {
        return this._id;
      };

      GNode_prototype.add = function(objNode) {
        if (this._graph != objNode._graph) return false;

        this._down.push(objNode);
        objNode._up.push(this);
        return true;
      };

      GNode_prototype.del = function(objNode) {
        var found = false;

        for (var i = 0; i < this._down.length; i++) {
          if (this._down[i] == objNode) {
            this._down.splice(i, 1);
            found = true;
            break;
          }
        }

        if (!found) return found;

        for (var i = 0; i < objNode._up.length; i++) {
          if (objNode._up[i] == this) {
            objNode._up.splice(i, 1);
            break;
          }
        }

        return true;
      };

      GNode_prototype.up = function() {
        return this._up;
      };

      GNode_prototype.down = function() {
        return this._down;
      };

      GNode_prototype.toString = function() {
        return this._id;
      };

    });

    defClass(jsx3.util, "Job", jsx3.util.GNode, function(Job, Job_prototype) {

      evtPub._import(Job_prototype);

      Job.FINISH = "finish";

      Job.WAIT = 0;

      Job.DONE = 1;

      Job.SLEEP = 2;

      Job.PUSH = 3;

      Job.WAITING = 0;

      Job.FINISHED = 1;

      Job_prototype.init = function(id, fctRun) {
        Job._super.call(this, "init", [id]);

        this._state = Job.WAITING;

        if (fctRun)
          this.run = fctRun;
      };

      Job_prototype.run = function() {
        return Job.DONE;
      };

      Job_prototype.finish = function() {
        this._state = Job.FINISHED;

        this._publish({subject:Job.FINISH});

        if (this._notifygraph)
          this.graph()._onFinish(this);
      };

      Job_prototype.state = function() {
        return this._state;
      };

      Job_prototype._checkDuplicate = function(dupJob) {
        if (dupJob) {
          if (dupJob.state() == Job.FINISHED) {
            return Job.DONE;
          } else {
            this.graph().addPrereq(this, dupJob);
            return Job.PUSH;
          }
        }
      };

    });

    defClass(jsx3.util, "JobGraph", jsx3.util.Graph, function(JobGraph, JobGraph_prototype) {

      evtPub._import(JobGraph_prototype);

      var Job = jsx3.util.Job;

      JobGraph.DONE = "done";

      JobGraph.RAN_JOB = "ran";

      JobGraph_prototype.init = function() {
        JobGraph._super.call(this, "init");
        this.reset();
      };

      JobGraph_prototype.reset = function() {

        this._running = false;  // whether this job manager is running

        this._runningJobs = {}; // index all running ids so we don't run them twice

        this._doneCt = 0;       // the number of finished jobs

        this._finishingJobsQueue = [];     // the finishing queue, a list of jobs that are finishing

        this._finishSP = false; // the finishing queue semaphore, indicates that the queue is processing
      };

      JobGraph_prototype.clear = function() {
        JobGraph._super.call(this, "clear");
        this.reset();
      };

      JobGraph_prototype.addJob = function(objJob, preReqs, postReqs) {
        if (! this.add(objJob))
          throw new Error(jsx3._msg("job.dup", objJob._id));
        var newJobs = this._getAllJobs(objJob);

        if (preReqs) {
          if (!(preReqs instanceof Array)) preReqs = [preReqs];
          for (var i = 0; i < preReqs.length; i++)
            this.addPrereq(objJob, preReqs[i]);
        }

        if (postReqs) {
          if (!(postReqs instanceof Array)) postReqs = [postReqs];
          for (var i = 0; i < postReqs.length; i++)
            this.addPrereq(postReqs[i], objJob);
        }

//        jsx3._logIt("Add job " + objJob.toString() + " with pres [" + objJob.up() + "] tried [" + preReqs + "]");

        for (var i = 0; i < newJobs.length; i++)
          this._runIfReady(newJobs[i]);
      };

      JobGraph_prototype.insertJob = function(newJob, referenceJob) {
        if (! this.add(newJob))
          throw new Error(jsx3._msg("job.dup", newJob._id));
        var newJobs = this._getAllJobs(newJob);

        var d = referenceJob.down();
        for (var i = 0; i < d.length; i++)
          newJob.add(d[i]);

        for (var i = 0; i < newJobs.length; i++)
          this._runIfReady(newJobs[i]);
      };

      JobGraph_prototype._getAllJobs = function(objJob) {
        var map = {};
        var jobs = [objJob];
        var i = 0;
        while (i < jobs.length) {
          var node = jobs[i];
          map[node._id] = 1;
          var as = [node.up(), node.down()];
          for (var j = 0; j < as.length; j++) {
            var a = as[j];
            for (var k = 0; k < a.length; k++) {
              var x = a[k];
              if (! map[x._id])
                jobs.push(x);
            }
          }
          i++;
        }

        return jobs;
      };

      JobGraph_prototype.addPrereq = function(objJob, preJob) {
        if (typeof(objJob) != "object")
            objJob = this.node(objJob);

        if (!objJob)
          throw new Error(jsx3._msg("job.pre_bad", arguments[0], preJob));

        if (typeof(preJob) != "object")
          preJob = this.node(preJob);

        if (preJob)
          preJob.add(objJob);
      };

      JobGraph_prototype.start = function __JobGraph_prototype_start() {
        if (! this._running) {
          this._running = true;
          this._runIfReady();
        }
      };

      JobGraph_prototype.isRunning = function() {
        return this._running;
      };

      JobGraph_prototype.pause = function() {
        this._running = false;
      };

      JobGraph_prototype.doneCt = function() {
        return this._doneCt;
      };

      JobGraph_prototype._runIfReady = function __JobGraph_prototype_runIfReady(objJob) {
        if (this._running) {
          if (objJob) {
//            jsx3._logIt("try to run:" + objJob + " up:" + objJob.up());
            if (objJob.up().length == 0)
              this._runJob(objJob);
          } else {
//            jsx3._logIt("roots:" + this.roots());
            var roots = this.roots();

            if (roots.length == 0 && this.size() > 0) {
              // ERROR: deadlock!
//            jsx3._logIt("ERROR: deadlock with jobs remaining: " + this.nodes());
              this.clear();
            }

            for (var i = 0; i < roots.length; i++)
              this._runJob(roots[i]);
          }
        }
      };

      JobGraph_prototype._runJob = function __JobGraph_prototype_runJob(objJob) {
        var jobId = objJob._id;

        if (this._runningJobs[jobId]) return;
        this._runningJobs[jobId] = true;

//        jsx3._logIt("Running job " + objJob);
        var intCmd = objJob.run();
//        jsx3._logIt("... ran job " + objJob._id + " with result " + intCmd);

        if (typeof(intCmd) == "undefined" || intCmd == Job.DONE) {
          objJob.finish();
          this._onFinish(objJob);
        } else if (intCmd == Job.WAIT && objJob.state() == Job.FINISHED) {
          // This should be called by the job itself after returning WAIT
          this._onFinish(objJob);
        } else if (intCmd == Job.SLEEP) {
          var me = this;
          window.setTimeout(function() {
            me._onFinish(objJob);
          }, 0);
        } else if (intCmd == Job.PUSH) {
          this._runningJobs[jobId] = false;
          return;
        } else {
          objJob._notifygraph = true;
        }

        delete objJob.run;
      };

      JobGraph_prototype._onFinish = function __JobGraph_prototype_onFinish(objJob) {
//        jsx3._logIt("_onFinish " + objJob._id + " (running:" + this._finishSP + ")");

        this._finishingJobsQueue.push(objJob);
        if (!this._finishSP)
          this._finishThread();
      };

      JobGraph_prototype._finishThread = function __JobGraph_prototype_finishThread() {
        // Set the semaphore to true so that the loop cannot cause this method to be called again in an ever-growing stack.
        this._finishSP = true;

        jsx3.tcf(this._finishThreadTry, null,
            function __JobGraph_prototype_finishThread_lambda() { this._finishSP = false; }, this);

        if (this.size() == 0) {
          if (this.publish)
            this.publish({subject:JobGraph.DONE});
        } else {
//          jsx3._logIt("Not done! waiting: done:" + this._doneCt);
        }
      };

      JobGraph_prototype._finishThreadTry = function __JobGraph_prototype_finishThreadTry() {
        // This array may get appended to while this is iterating
        for (var i = 0; i < this._finishingJobsQueue.length; i++) {
          var objJob = this._finishingJobsQueue[i];

          delete this._runningJobs[objJob._id];

          var dependentJobs = objJob.down(); // need defensive backup?
          this.del(objJob);
          this._doneCt++;

          if (this.publish) // I don't listen for this event, so just bypass to EventDispatcher method
            this.publish({subject:JobGraph.RAN_JOB, job:objJob});

          for (var j = 0; j < dependentJobs.length; j++)
            this._runIfReady(dependentJobs[j]);
        }

        this._finishingJobsQueue = [];
      };

      JobGraph_prototype._finishThreadFinally = function() {
        this._finishSP = false;
      };
    });

    defClass(jsx3.lang, "ClassLoader", null, function(ClassLoader, ClassLoader_prototype) {

      var Job = jsx3.util.Job;
      var proto = null;

      evtPub._import(ClassLoader_prototype);

      ClassLoader.INCLUDES = [
      ];

      ClassLoader._BROWSERS = {
        ie6:["ie6", ["IE","IE6","VML"], "allow", 6],
        ie7:["ie7", ["IE","IE7","VML"], "allow", 7],
        ie8:["ie7", ["IE","IE8","VML"], 0, 8],
        fx1_5:["fx", ["FX","SVG","GKO"], "allow", 1.5],
        fx2:["fx", ["FX","FX2","SVG","GKO"], "allow", 2],
        fx3:["fx", ["FX","FX3","SVG","GKO"], "allow", 3],
        fx4:["fx", ["FX","FX4","SVG","GKO"], 0, 4],
        gc1:["saf", ["SAF","SAF3","SVG","KON","GOG"], "allow", 3],
        sf3:["saf", ["SAF","SAF3","SVG","KON"], "allow", 3],
        sf4:["saf", ["SAF","SAF4","SVG","KON"], 0, 4],
        op9:["ie", ["OPERA"], 0, 9],
        op10:["ie", ["OPERA"], 0, 10],
        ie:["ie", ["IE","IE6","VML"]],
        fx:["fx", ["FX","SVG","GKO"]],
        sf:["saf", ["SAF","SVG","KON"]],
        op:["ie", ["OPERA"]],
        gk:["fx", ["FX","SVG","GKO"]],
        xx:["fx", []]
      };

      ClassLoader.MODE_MAP = {0:"IE_MQ", 1: "FX_MQ", 2: "IE_MS", 3: "FX_MS"};

      ClassLoader.LOAD_ALWAYS = 1;

      ClassLoader.LOAD_AUTO = 0;

      var LOG = null;
      var Logger = null;

      ClassLoader_prototype.init = function(objBrowser) {
        this._type = objBrowser.getType();

        var defines = ClassLoader._BROWSERS[this._type][1];
        for (var i = 0; i < defines.length; i++)
          this[defines[i]] = true; // so that jsx3.CLASS_LOADER.IE, etc are defined for precompiler

        this._apps = [];

        this._addins = {};
      };

      ClassLoader_prototype.destroy = function() {
        for (var i = 0; i < this._apps.length; i++) {
          var app = this._apps[i];
          for (var f in app) delete app[f];
        }
        delete this._apps;
        delete this._addins;
        delete this._jobManager;
      };

      ClassLoader_prototype.getType = function() {
        return this._type;
      };

      ClassLoader_prototype.getVersion = function() {
        return ClassLoader._BROWSERS[this._type][3] || Number(0);
      };

      ClassLoader_prototype._start = function() {
        if (this._jobManager) return;

        this._jobManager = new jsx3.util.JobGraph();
        var jobManager = this._jobManager;
        var includes = ClassLoader.INCLUDES;

        var me = this;

        // update progress bars
        var progJob = new Job("jsx.prog1", function() {
          me._updateAllProgressTo(1, 1);
        });
        jobManager.addJob(progJob);

        // 1. Required JavaScript (obsolete -- all snarfed in here now)

        // 2. Classes
        var classes = ["jsx3.xml.Document", "jsx3.app.Settings", "jsx3.util.Logger.AlertHandler", "jsx3.util.Locale",
            "jsx3.html.Selection", "jsx3.util.EventDispatcher", "jsx3.app.Server", "jsx3.net.URI", "jsx3.lang.System"];
        for (var i = 0; i < classes.length; i++)
          jobManager.addJob(new ClassLoader.ClassJob(classes[i]));

        // 4A. jsx3.util.EventDispatcher mixin
        var edMixinJob = new Job("jsx.edmix", function() {
          var targets = [ClassLoader_prototype, Job.prototype, jsx3.util.JobGraph.prototype];
          for (var i = 0; i < targets.length; i++)
            jsx3.util.EventDispatcher.jsxclass.mixin(targets[i]);
          me._jobManager.subscribe("*", me, function(objEvent) { this.publish(objEvent); });
        });
        jobManager.addJob(edMixinJob, "jsx3.util.EventDispatcher");

        // 4B. Determine HTML Mode
        var htmlModeJob = new Job("jsx.html.mode", function() {
          me[ClassLoader.MODE_MAP[jsx3.html.getMode()]] = true;
        });
        jobManager.addJob(htmlModeJob, "jsx3.html.Selection");

        // 5A. Request system JSS Properties and localized PropBundles
        var requestJssJob = new Job("jsx.jss.request", function() {
          var allJsxJss = [];
          for (var i = 0; i < includes.length; i++) {
            var inc = includes[i];
if (inc.type == "ljss" && jsx3.app.PropsBundle) {
              var src = ClassLoader._toAbsolute(jsx3.SYSTEM_ROOT + "/" + me.resolvePath(inc.src));
              var job = new ClassLoader.PBJob(inc.id, src, jsx3.System.LJSS, jsx3.getSystemCache());
              allJsxJss.push(job);
              jobManager.addJob(job);
            }
          }

          jobManager.addJob(new Job("jsx.xml"), allJsxJss);
          jobManager.addPrereq("jsx", "jsx.xml");
        });
        jobManager.addJob(requestJssJob, "jsx3.lang.System");

        // 6. jsx job for the JSX runtime
        jobManager.addJob(new Job("jsx"), ["jsx.js", "jsx.xsl", requestJssJob]);
        jobManager.addJob(new Job("jsx.startup", function() { jsx3.startup(); }), "jsx");

        // 7. load each queued app
        for (var i = 0; i < this._apps.length; i++)
          this._loadApp(this._apps[i]);

        // 8. start the threaded queue, after a timeout
        window.setTimeout(function() {
          jobManager.start();
        }, 0);
      };

      ClassLoader_prototype._cleanUpApp = function(objApp) {
        for (var i = this._apps.length - 1; i >= 0; i--) {
          if (this._apps[i] == objApp) {
            this._apps.splice(i, 1);
            break;
          }
        }
      };

      ClassLoader_prototype._updateAllProgressTo = function(intStage, intTotal) {
        for (var i = 0; i < this._apps.length; i++) {
          var prog = this._apps[i]._progress;
          prog.updateStage(intStage, intTotal);
        }
      };

      ClassLoader_prototype._onJsJobFinished = function(objEvent) {
        for (var i = 0; i < this._apps.length; i++)
          this._apps[i]._progress._incrementDone(false);
      };

      ClassLoader_prototype._isSupported = function() {
        var browserOverride = jsx3.getEnv("jsx_browsers");

        var allowDeny = (browserOverride && browserOverride.match(new RegExp("\\b" + this._type + "=(\\w*)\\b", "i"))) ?
            RegExp.$1.toLowerCase() : ClassLoader._BROWSERS[this._type][2];

        return this._forcesupported || allowDeny == "allow";
      };

      ClassLoader_prototype.passesLoad = function(intLoad) {
        return intLoad === true ||
               intLoad == ClassLoader.LOAD_ALWAYS;
      };

      ClassLoader_prototype._passesBrowser = function(strBrowser) {
        if (strBrowser == null) return true;
        if (this[strBrowser]) return true;
        if (strBrowser.indexOf("!") == 0) return !this[strBrowser.substring(1)];

        var def = ClassLoader._BROWSERS[this._type][1].join("|");
        var regexp = new RegExp("\\b(" + def + ")\\b");
        return regexp.test(strBrowser);
      };

      ClassLoader_prototype.addJob = function(objJob, preReq) {
        return this._jobManager.addJob.apply(this._jobManager, arguments);
      };

      ClassLoader_prototype.loadResource = function(strSrc, strId, strType, objJob) {
        var job = null;
        if (strType == "script") {
          job = new ClassLoader.JsJob(strId, strSrc);
        } else {
          throw new jsx3.IllegalArgumentException("strType", strType);
        }

        this._jobManager.addJob(job);
        if (objJob)
          this._jobManager.addJob(objJob, job);

        return job;
      };

      ClassLoader_prototype._initClassPath = function() {
        if (this._cp == null)

          this._cp = [[ClassLoader._toAbsolute(jsx3.SYSTEM_SCRIPTS + "/"), /^jsx3\.(gui|util|app|xml|net|html)\.[\w\.]+$/]];
        return this._cp;
      };

      ClassLoader_prototype._addClassPath = function(strPath, strRegex) {
        var tokens = strRegex.split(".");
        for (var i = 0; i < tokens.length; i++) {
          if (tokens[i] == "**")
            tokens[i] = "\\w+(\\.\\w+)*";
          else if (tokens[i] == "*")
            tokens[i] = "\\w+";
        }
        this._initClassPath().push([strPath, new RegExp("^" + tokens.join("\\.") + "$")]);
      };

      ClassLoader_prototype._addClassPathOf = function(obj) {
        var settings = obj.getSettings();
        var classPath = settings.get("classpath");
        if (classPath) {
          var paths = classPath.split(",");
          for (var i = 0; i < paths.length; i++) {
            var tokens = paths[i].split(":");
            this._addClassPath(obj.resolveURI(tokens[0]).toString(), tokens[1]);
          }
        }
      };

      ClassLoader_prototype._classDidLoad = function(objClass) {
        var strName = objClass.getName();

        this._publish({subject:"class", name:strName});
        this._publish({subject:"class." + strName});
      };

      ClassLoader_prototype._packageDidLoad = function(objPackage) {

      };

      ClassLoader_prototype._setStatus = function(strStatus, intExpire) {
        if (intExpire == null) intExpire = 1000;
        var status = getMsgStr("st_pr") + getMsgStr("st_l1") + strStatus + getMsgStr("st_l2");
        window.status = status;

        // clear the previous timeout
        if (jsx3._jsxstatustimeout != null)
          window.clearTimeout(jsx3._jsxstatustimeout);

        jsx3._jsxstatustimeout = window.setTimeout(function() {
          jsx3._jsxstatustimeout = null;
          if (window.status == status)
            window.status = "";
        }, intExpire);
      };

      ClassLoader_prototype.loadClass = function(strClass) {
        this._setStatus(strClass);
        var path = strClass.replace(/\./g, "/") + ".js";

        this._initClassPath();
        for (var i = 0; i < this._cp.length; i++) {
          var regex = this._cp[i][1];

          if (regex.test(strClass)) {
            var filePath = this._cp[i][0] + path;
            var success = false;
            try {
	      throw new Error("deleted");
            } catch (e) {
	      __jtolog += "oops, trying to load class " + strClass + "\nfrom: " + e.stack + "\n\n";
              var ex = jsx3.NativeError.wrap(e);
              throw new jsx3.Exception(jsx3._msg("boot.class_ex", strClass, ex), ex);
            }

            if (success) {
              var objClass = jsx3.Class.forName(strClass);
              if (objClass == null)
                throw new jsx3.Exception(jsx3._msg("boot.class_undef", filePath, strClass));

              return objClass;
            }
          }
        }

        throw new jsx3.Exception(jsx3._msg("boot.class_err", strClass));
      };

      ClassLoader_prototype.resolvePath = function(strPath) {
        return strPath.replace(/@path@/g, ClassLoader._BROWSERS[this._type][0]);
      };

      ClassLoader._toAbsolute = function(strURL) {
        var s = null;
        //given portal implementations, any string instance that represents a URI can call this method to add a prepend of the absolute path
        if (strURL.charAt(0) == "/" || strURL.match(/^\w+:\/\//)) {
          s = strURL.toString();
        } else if (strURL.substring(0, 4) == "JSX/") {
          s = jsx3.getEnv("jsxabspath") + strURL;
        } else {
          s = jsx3.getEnv("jsxhomepath") + strURL;
        }

        return s;
      };

      // @jsxobf-clobber  _settings _path _gui _loaded _ns _progress _queue _type _done _running _tick _ticktime
      // @jsxobf-clobber  _src _id _pre _status _type _painted _env _classloader _stage _total

      ClassLoader._SERIAL = 0;

      ClassLoader_prototype.loadApp = function(strAppPath, objGUI, objEnv) {
//        jsx3._logIt("loadApp " + strAppPath);
        // Decode URI encoding of app path
        strAppPath = strAppPath.replace(/%([0-9a-fA-F]{2})/g,
            function(m, g1) { return String.fromCharCode(parseInt(g1, 16)); });

        // Remove trailing / from app path
        if (strAppPath.charAt(strAppPath.length - 1) == "/")
          strAppPath = strAppPath.substring(0, strAppPath.length - 1);

        // Set env variables for the home path, etc.
        var appDirIndex = strAppPath.indexOf(jsx3.APP_DIR_NAME + "/");
        var appPrefix = appDirIndex >= 0 ? strAppPath.substring(0, appDirIndex) : "";

        if (! jsx3.getEnv("jsxmanualhome"))
          jsx3.setEnv("jsxhomepath", appPrefix);    // when Builder is running, we wait to set this to the user home dir
        jsx3.setEnv("jsxscriptapppath", appPrefix); // this is always the path to the main project, including Builder

        var app = {_path:strAppPath, _gui:objGUI, _loaded:false, _env: objEnv, _serial:ClassLoader._SERIAL++};

        if (objGUI) {
          var intType = objEnv["jsxapploader"] != null ? objEnv["jsxapploader"] : this._apps.length > 0 ? 1 : 0;
          var progress = app._progress = new ClassLoader.Progress(this, intType, objGUI);

          if (this._isSupported()) {
            window.setTimeout(function(){ progress.paintProgress();}, 0);
          } else {
            window.setTimeout(function(){ progress.paintNotSupported();}, 0);
          }
        }

        this._apps.push(app);

        if (this._jobManager)
          return this._loadApp(app);
      };

      ClassLoader_prototype._loadApp = function(objApp) {
//        jsx3._logIt("_loadApp " + objApp._path);
        var strAppPath = objApp._path;
        var jobPrefix = "app." + objApp._serial;
        var jobManager = this._jobManager;

        var configJob = new ClassLoader.XmlJob(jobPrefix + ".config", strAppPath + "/" + jsx3.CONFIG_FILE);

        var me = this;
        var loadJob = new Job(jobPrefix + ".queue", function() {
          me._onAppConfigLoaded(configJob.getXML(), objApp);
        });

        jobManager.addJob(configJob, "jsx3.xml.Document");
        jobManager.addJob(loadJob, ["jsx3.app.Server", configJob]);

        var appJob = new Job(jobPrefix);
        jobManager.addJob(appJob, loadJob);
        return appJob;
      };

      ClassLoader_prototype._onAppConfigLoaded = function(objXML, objApp) {
        var jobMgr = this._jobManager;
        var server = null;
        jobMgr.pause();

        if (objXML.hasError()) {
          LOG.fatal(":" + jsx3.getEnv("jsxhomepath") + ": :" + jsx3.resolveURI(objXML.getSourceURL()) + ": " + jsx3._msg("boot.app_cfgerr", objXML.getSourceURL(), objXML.getError()));
        }

        var settings = objApp._settings = new jsx3.app.Settings(objXML);
        objApp._env.jsxsettings = settings;

        try {
          server = objApp._server = new jsx3.app.Server(objApp._path, objApp._gui, false, objApp._env);
          delete objApp._gui;
        } catch (e) {
          var ex = jsx3.NativeError.wrap(e);
          LOG.fatal(jsx3._msg("boot.app_insterr", objApp._path, ex), ex);
          return;
        }

        var prog = objApp._progress;
        var jobPrefix = "app." + objApp._serial;

        // 0.
        this._addClassPathOf(server);

        // 1. Queue all required addins
        var jsPrereqs = ["jsx.js", "logger.init", "jsx.xml"];
        var arrAddins = settings.get("addins");
        if (arrAddins) {
          for (var j = 0; j < arrAddins.length; j++) {
            var addinKey = arrAddins[j];
            var addinJob = this._loadAddin(addinKey);
            jsPrereqs.push(addinJob);
          }
        }

        var progJob = new Job(jobPrefix + ".prog");
        jobMgr.addJob(progJob, jsPrereqs);

        var includes = settings.get("includes");

        if (includes) {
          var jsCount = 0;
          var cssIds = [], xmlIds = [], lastJsJob = progJob;

          for (var i = 0; i < includes.length; i++) {
            var inc = includes[i];

            if (this.passesLoad(inc.onLoad || inc.load) &&
                this._passesBrowser(inc.browser)) {

              var src = server.resolveURI(inc.src);
              var rsrcJobId = jobPrefix + "." + i + "." + (inc.id || inc.src);

	      if (inc.type == "script") {
                // 3. Load App JS
                var job = new ClassLoader.JsJob(rsrcJobId, src);
                job._subscribe(Job.FINISH, prog, "_incrementDone");

                jobMgr.addJob(job, lastJsJob);
                lastJsJob = job;
                jsCount++;
              } else if (inc.type == "xml" || inc.type == "xsl") {
                var job = new ClassLoader.XmlJob(rsrcJobId, src, server.getCache(), (inc.id || inc.src));
                jobMgr.addJob(job);
                xmlIds.push(job);
              } else if (inc.type == "jss") {
                var job = new ClassLoader.JssJob(rsrcJobId, src, server.getCache(), (inc.id || inc.src), server.getProperties());
                jobMgr.addJob(job);
                xmlIds.push(job);
              } else if (inc.type == "ljss") {
                var job = new ClassLoader.PBJob(rsrcJobId, src, server.LJSS, server.getCache(), server.getLocale());
                jobMgr.addJob(job);
                xmlIds.push(job);
              }
            }
          }

          progJob.run = function() {
            prog.updateStage(3, jsCount);
          };

          if (cssIds.length > 0)
            jobMgr.addJob(new Job(jobPrefix + ".css"), cssIds);

          if (xmlIds.length > 0)
            jobMgr.addJob(new Job(jobPrefix + ".xml"), xmlIds);

          if (lastJsJob)
            jobMgr.addJob(new Job(jobPrefix + ".js"), lastJsJob);
        }
        var allPreReqs = ["jsx", jobPrefix + ".css", jobPrefix + ".xml", jobPrefix + ".js"];

        // 4. Load App Component
        var compURL = settings.get("objectseturl");
        var componentJob = null;
        if (compURL) {
          componentJob = new ClassLoader.XmlJob(jobPrefix + ".comp", objApp._server.resolveURI(compURL));
          jobMgr.addJob(componentJob);
        }

        var progJob2 = new Job(jobPrefix + ".prog1", function() {
          prog.updateStage(4, 1);
          return Job.SLEEP;
        });
        jobMgr.addJob(progJob2, allPreReqs);

        var me = this;
        jobMgr.addJob(new Job(jobPrefix + ".progx", function() {
          prog._destroy();
          me._cleanUpApp(objApp);
        }), progJob2);

        // 5. Paint
        if (!objApp._server.getEnv("manualpaint")) {
          var paintJob = new Job(jobPrefix + ".paint");
          if (componentJob != null) {
            paintJob.run = function() {
//            jsx3._logIt("Painting " + objApp._server);
              objApp._server.paint(componentJob.getXML());
            };
            jobMgr.addJob(paintJob, [componentJob, progJob2]);
          } else {
            paintJob.run = function() {
              objApp._server.paint();
            };
            jobMgr.addJob(paintJob, progJob2);
          }
        }

        for (var i = 0; i < allPreReqs.length; i++)
          jobMgr.addPrereq(jobPrefix, allPreReqs[i]);

        jobMgr.start();
      };

       ClassLoader_prototype._forceStartQueue = function() {
        if (! this._forcesupported) {

          this._forcesupported = true;

          for (var i = 0; i < this._apps.length; i++)
            this._apps[i]._progress.paintProgress();

          this._start();
        }
      };

      ClassLoader_prototype.loadAddin = function(objAddin) {
        var strKey;
        if (typeof(objAddin) == "string") {
          strKey = objAddin;
          objAddin = null;
        } else {
          strKey = objAddin.getKey();
        }
        return this._loadAddin(strKey, objAddin);
      };

      ClassLoader_prototype._loadAddin = function(strKey, objAddin) {
        var jobPrefix = "addin." + strKey;

        if (this._addins[strKey]) {
          ;
        } else {
          this._addins[strKey] = {};

          if (! objAddin)
            objAddin = new jsx3.app.AddIn(strKey);

          var xmlPath = objAddin.getPath();
          var configJob = new ClassLoader.XmlJob(jobPrefix + ".config", xmlPath + (xmlPath.search(/\/$/) == -1 ? "/" : "") + jsx3.CONFIG_FILE);

          var me = this;
          var configLoadJob = new Job(jobPrefix + ".load", function() {
            me._onAddinConfigLoaded(configJob.getXML(), strKey, objAddin);
          });

          this._jobManager.addJob(configJob, "jsx3.xml.Document");
          this._jobManager.addJob(configLoadJob, [configJob, "jsx3.lang.System"]);

          return this._createAddinJobs(strKey, configLoadJob);
        }
      };

      ClassLoader_prototype._createAddinJobs = function(strKey, strJobId) {
        var jobPrefix = "addin." + strKey;
        var jm = this._jobManager;

        var jsJob = new Job(jobPrefix + ".js"),
            jssJob = new Job(jobPrefix + ".jss"),
            addinJob = new Job(jobPrefix);

        jm.addJob(jsJob, strJobId);
        jm.addJob(jssJob, strJobId);
        jm.addJob(addinJob, [jsJob, jssJob]);

        return addinJob;
      };

      ClassLoader_prototype._onAddinConfigLoaded = function(objXML, strKey, objAddin) {
        var addin = null, settings = null;

        if (objXML.hasError()) {
          LOG.fatal(jsx3._msg("boot.add_cfgerr", objXML.getSourceURL(), objXML.getError()));
          return;
        }

        settings = new jsx3.app.Settings(objXML);
        addin = this._addins[strKey]._addin = objAddin;
        addin.setSettings(settings);

        var jobPrefix = "addin." + strKey;
        var jobManager = this._jobManager;

        var addinVarPath = settings.get("addin");
        if (addinVarPath)
          jsx3.System.registerAddin(addinVarPath, addin);
        this._addClassPathOf(addin);

        jobManager.pause();

        var addinIncludes = settings.get('includes');
        if (addinIncludes != null) {
          var lastJsJob = ["jsx.js", "logger.init", "jsx.xml"];

          for (var i = 0; i < addinIncludes.length; i++) {
            var include = addinIncludes[i];
            var rsrcJobId = jobPrefix + "." + i + "." + (include.id || include.src);

            if (this.passesLoad(include.onLoad || include.load) && this._passesBrowser(include.browser)) {
              var src = addin.resolveURI(include.src).toString();

              if (include.type == 'script') {
                var job = new ClassLoader.JsJob(rsrcJobId, src);
                jobManager.addJob(job, lastJsJob);
                job._subscribe(Job.FINISH, this, "_onJsJobFinished");
                lastJsJob = job;
              } else if (include.type == 'jss') {
                var job = new ClassLoader.JssJob(rsrcJobId,  src, jsx3.getSystemCache(), (include.id || src), jsx3.System.JSS);
                jobManager.addJob(job);
                jobManager.addPrereq(jobPrefix + ".jss", job);
              } else if (include.type == "ljss") {
                var job = new ClassLoader.PBJob(rsrcJobId, src, jsx3.System.LJSS, jsx3.getSystemCache(), jsx3.System.getLocale());
                jobManager.addJob(job);
                jobManager.addPrereq(jobPrefix + ".jss", job);
              }
            }
          }

          if (lastJsJob instanceof Array)
            for (var i = 0; i < lastJsJob.length; i++)
              jobManager.addPrereq(jobPrefix + ".js", lastJsJob[i]);
          else
            jobManager.addPrereq(jobPrefix + ".js", lastJsJob);
        }

        jobManager.start();
      };

      ClassLoader_prototype.toString = function() {
        return this.getType() + " " + this.getVersion() + " (" + ClassLoader._BROWSERS[this._type][1] + ")";
      };

    });

    var ClassLoader = jsx3.lang.ClassLoader;
    var Job = jsx3.util.Job;

    // @jsxobf-clobber  _src _doc _cache _cacheid _props _class _locale

    defClass(ClassLoader, "JsJob", Job, function(JsJob, JsJob_prototype) {

      JsJob._ALL = {};

      JsJob_prototype.init = function(strId, strSrc) {
        JsJob._super.call(this, "init", [strId]);

        this._src = strSrc;
      };

      JsJob_prototype.run = function() {

        if (jsx3.util.Timer)
          var t1 = new jsx3.util.Timer("jsx3.lang.ClassLoader", this._src);

        var dupStatus = this._checkDuplicate(JsJob._ALL[this._src]);
        if (dupStatus) return dupStatus;
        JsJob._ALL[this._src] = this;

        // instance a new DOM element
	__jtolog += "loading script: " + this._src + "\n";
        var element = document.createElement("script");
        element.setAttribute("src", this._src);
        element.setAttribute("type", 'text/javascript');
        element.setAttribute("id", this._id);

        // set up onload handler
        var me = this;
        if (jsx3.CLASS_LOADER.IE) {
          element.onreadystatechange = function() {
            var state = this.readyState;
            if (state == "loaded" || state == "interactive" || state == "complete") {

              if (t1) t1.log("js.load");

              element.onreadystatechange = null;
              me.finish();
            }
          };
        } else {
          element.onload = function() {

            if (t1) t1.log("js.load");

            element.onload = null;
            me.finish();
          };
        }

        jsx3.CLASS_LOADER._setStatus(this._src);

        // bind the element to the browser DOM to begin loading the resource
        document.getElementsByTagName("head")[0].appendChild(element);

        return Job.WAIT;
      };

    });

    defClass(ClassLoader, "XmlJob", Job, function(XmlJob, XmlJob_prototype) {

      XmlJob_prototype.init = function(strId, strSrc, objCache, strCacheId, objClass) {
        XmlJob._super.call(this, "init", [strId || strSrc]);
        this._src = strSrc;

        this._cache = objCache;

        this._cacheid = strCacheId || this._id;

        this._class = objClass;
      };

      XmlJob_prototype.run = function() {
        this._load();
        return Job.WAIT;
      };

      XmlJob_prototype.getXML = function() {
        return this._doc;
      };

      XmlJob_prototype._load = function() {
        var d = this._doc = (this._class || jsx3.xml.Document.jsxclass).newInstance();
        d.setAsync(true);
        d.subscribe("*", this, "_finish");

        jsx3.CLASS_LOADER._setStatus(this._src);
        d.load(this._src);
      };

      XmlJob_prototype._finish = function() {
        if (this._cache)
          this._cache.setDocument(this._cacheid, this._doc);
        this.finish();
      };

    });

    defClass(ClassLoader, "JssJob", ClassLoader.XmlJob, function(JssJob, JssJob_prototype) {

      JssJob_prototype.init = function(strId, strSrc, objCache, strCacheId, objProps) {
        JssJob._super.call(this, "init", [strId, strSrc, objCache, strCacheId]);

        this._props = objProps;
      };

      JssJob_prototype.run = function() {
        if (this._cache) {
          var doc = this._cache.getDocument(this._cacheid);

          if (doc) {
            this._props.loadXML(doc, this._cacheid);
            return Job.DONE;
          }
        }

        this._load();
        return Job.WAIT;
      };

      JssJob_prototype._finish = function(objEvent) {
        var doc = objEvent.target;

        if (this._cache)
          this._cache.setDocument(this._cacheid, doc);

        if (! doc.hasError()) {
          this._props.loadXML(doc, this._cacheid);
        } else {
//          jsx3._logIt("Error loading JSS properties file " + this._src + ": " + doc.getError());
        }

        this.finish();
      };

    });

    defClass(ClassLoader, "PBJob", Job, function(PBJob, PBJob_prototype) {

      PBJob_prototype.init = function(strId, strSrc, objProps, objCache, objLocale) {
        PBJob._super.call(this, "init", [strId]);

        this._src = strSrc;

        this._props = objProps;

        this._cache = objCache;

        this._locale = objLocale;
      };

      PBJob_prototype.run = function() {
        var me = this;
        jsx3.app.PropsBundle.getPropsAsync(this._src, this._locale, function(props) {
          me._propsbundle = props;
          me._props.addParent(props);
          me.finish();
        }, this._cache);

        return Job.WAIT;
      };

      PBJob_prototype.getProps = function() {
        return this._propsbundle;
      };

    });

    defClass(ClassLoader, "ClassJob", Job, function(ClassJob, ClassJob_prototype) {

      ClassJob_prototype.init = function(strClass) {
        ClassJob._super.call(this, "init", [strClass]);
      };

      ClassJob_prototype.run = function() {
        if (jsx3.lang.Class && jsx3.lang.Class.forName(this._id))
          return Job.DONE;

        jsx3.CLASS_LOADER._subscribe("class." + this._id, this, "_onClass");
        return Job.WAIT;
      };

      ClassJob_prototype._onClass = function(objEvent) {
        jsx3.CLASS_LOADER._unsubscribe("class." + this._id, this);
        this.finish();
      };

    });

    // @jsxobf-clobber  Progress
    defClass(ClassLoader, "Progress", null, function(Progress, Progress_prototype) {

      Progress.STAGE_NAMES = [getMsgStr("s_ini"), getMsgStr("s_sys"), getMsgStr("s_add"),
          getMsgStr("s_app"), getMsgStr("s_pnt")];

      Progress.STAGE_WEIGHTS = [[0.0,0.10,0.60,0.80,0.97,1.00,1.00], [0,0,0,0,0.95,1.00]];

      Progress.WAITING = getMsgStr("s_wat");

      Progress.WAITING_SUFFIX = ["&#160;.","&#160;&#160;.","&#160;&#160;&#160;."];

      Progress.TYPE_NORMAL = 0;

      Progress.TYPE_PORTAL = 1;

      Progress.isStrict = function(objProgress) {
        if (Progress.STRICT == null) {

          Progress.STRICT = ! objProgress._classloader.IE;
          if (! Progress.STRICT) {
            try {
              var test = '<input type="text" id="_jsx3_progress_test" style="position:absolute;top:0px;left:-120px;width:100px;height:30px;padding:8px;margin:0px;"/>';
              objProgress._gui.insertAdjacentHTML("beforeEnd", test);
              var input = objProgress._gui.ownerDocument.getElementById("_jsx3_progress_test");
              Progress.STRICT = input.offsetHeight != 30;
              input.parentNode.removeChild(input);
            } catch (e) {
              window.alert(e.description);
            }
          }
        }
        return Progress.STRICT;
      };

      Progress_prototype.init = function(objClassLoader, intType, objGUI) {
        this._classloader = objClassLoader;

        this._type = intType;
        this._gui = objGUI;
        this._stage = 0;
        this._done = 0;
        this._total = 1;
      };

      Progress_prototype.paintProgress = function() {
        var w = this._gui.offsetWidth;
        var h = this._gui.offsetHeight;
        var strict = Progress.isStrict(this);

        this._painted = true;

        var html, bgcolor;
        if (this._type == Progress.TYPE_NORMAL) {
          var width = 222 - (strict ? 4 : 0);
          var height = 62 - (strict ? 4 : 0);
          var barHeight = 17 - (strict ? 2 : 0);
          var insideBarHeight = barHeight - (strict ? 0 : 1);
          var top = Math.max(0, Math.round((h - height)/3));
          var left = Math.max(0, Math.round((w - width)/2));

          html = '<div style="position:absolute;top:'+top+'px;left:'+left+'px;font-family:Arial,sans-serif;width:'+width+'px;'+
                  'border:1px solid #666677;padding:2px;background-color:#BBBBCC;">'+
              '<div style="height:'+height+'px;border:1px solid #8899AA;padding:0px;background-color:#EEEEEE;">'+
                '<div style="padding: 4px;">'+
                  '<div style="font-size:10px;">' + getMsgStr("b_pow") + '</div>'+
                  '<div style="font-size:16px;">TIBCO&#160;<span style="font-weight:bold;">General&#160;Interface&#8482;</span></div>'+
                '</div>'+
                '<div style="position:absolute;top:'+(height-barHeight+(strict?2:1))+'px;height:'+barHeight+'px;width:'+(width-(strict?2:8))+'px;background-color:#DDE0EE;border-top:1px solid #8899AA;">'+
                  '<div style="height:'+insideBarHeight+'px;position:absolute;background-color:#BBCCEE;width:0px;overflow:hidden;">&#160;</div>'+
                  '<div style="height:'+insideBarHeight+'px;font-family:Verdana,sans-serif;position:absolute;font-size:10px;color:#000033;padding:1px 4px 2px 4px;">'+Progress.STAGE_NAMES[0]+'</div>'+
                '</div>'+
              '</div>'+
            '</div>';

          bgcolor = "#9898a5";
        } else {
          var width = 165 - (strict ? 4 : 0);
          var height = 52 - (strict ? 4 : 0);
          var barHeight = 16 - (strict ? 2 : 0);
          var insideBarHeight = barHeight - (strict ? 0 : 2);
          var top = Math.max(0, Math.round((h - height)/3));
          var left = Math.max(0, Math.round((w - width)/2));

          html = '<div><div style="position:absolute;top:'+top+'px;left:'+left+'px;font-family:Arial,sans-serif;width:'+width+'px;height:'+height+'px;padding:0px;">'+
              '<div style="padding: 6px;">'+
                '<div style="font-size:9px;">' + getMsgStr("b_pow") + '</div>'+
                '<div style="font-size:12px;">TIBCO&#160;<span style="font-weight:bold;">General&#160;Interface&#8482;</span></div>'+
              '</div>'+
              '<div style="position:absolute;top:'+(height-barHeight+(strict?2:1))+'px;height:'+barHeight+'px;width:'+(width-(strict?2:0))+'px;background-color:#EEF5FF;border:1px solid #88AACC;">'+
                '<div style="height:'+insideBarHeight+'px;position:absolute;background-color:#BBDDFF;width:0px;overflow:hidden;">&#160;</div>'+
                '<div style="height:'+insideBarHeight+'px;text-align:center;font-family:Verdana,sans-serif;z-index:1;position:absolute;font-size:9px;color:#556677;padding:1px 4px 2px 4px;">&#160;</div>'+
              '</div>'+
            '</div></div>';

          bgcolor = "#FFFFFF";
        }

        this._gui.innerHTML = html;
        this._gui.style.backgroundColor = bgcolor;
      };

      Progress_prototype.paintNotSupported = function() {
        var w = this._gui.offsetWidth;
        var h = this._gui.offsetHeight;
        var strict = Progress.isStrict(this);

        this._painted = true;

        var width = 232 - (strict ? 4 : 0);
        var height = 156 - (strict ? 4 : 0);
        var barHeight = 17 - (strict ? 2 : 0);
        var insideBarHeight = barHeight - (strict ? 0 : 1);
        var top = Math.max(0, Math.round((h - height)/3));
        var left = Math.max(0, Math.round((w - width)/2));

        var _forceStartQueue = "_forceStartQueue";
        this._gui.innerHTML =
          '<div style="position:absolute;top:'+top+'px;left:'+left+'px;font-family:Arial,sans-serif;width:'+width+'px;'+
              'border:1px solid #666677;padding:2px;background-color:#BBBBCC;">'+
            '<div style="height:'+height+'px;border:1px solid #8899AA;padding:0px;background-color:#EEEEEE;">'+
              '<div style="padding: 4px;">'+
                '<div style="font-size:10px;">' + getMsgStr("b_pow") + '</div>'+
                '<div style="font-size:16px;">TIBCO&#160;<span style="font-weight:bold;">General&#160;Interface&#8482;</span></div>'+
                '<div style="padding:6px 0px 0px 0px;font-size:10px;font-family:Verdana,sans-serif;">' + getMsgStr("nosup") +
                   '<div style="color:#000033;padding:8px 0px 0px 0px;margin:0px 0px 0px -2px;">'+
                     '<span style="font-size:8px;">&gt; </span><a style="color:#000033;" href="http://gi.tibco.com/links/sysreqs37/" target="_blank">' + getMsgStr("b_req") + '</a>'+
                     '<div style="padding:2px 0px 0px 0px;"><span style="font-size:8px;">&gt; </span><span id="jsxforcestart_span" tabindex="1" style="cursor:pointer;text-decoration:underline;" ' +
                       'onclick="jsx3.CLASS_LOADER.'+_forceStartQueue+'();" onkeydown="if (event.keyCode == 13) this.onclick();">' + getMsgStr("contd") + '</span></div>'+
                   '</div>'+
                '</div>'+
              '</div>'+
            '</div>'+
          '</div>';

        this._gui.style.backgroundColor = "#9898a5";

        window.setTimeout(function() { document.getElementById("jsxforcestart_span").focus(); }, 0);
      };

      Progress_prototype.updateStage = function(intStage, intTotal) {
//        jsx3._logIt("updateStage stage:" + intStage + " total:" + intTotal);

        this._stage = intStage;
        this._total = intTotal;
        this._done = 0;
        this.updateProgress(true);
      };

      Progress_prototype._incrementDone = function() {
        this._done++;
//        jsx3._logIt("_incrementDone:" + this._done + "/" + this._total);
        this.updateProgress(false);

        if (this._classloader.IE && (this._done == 0 || (this._done % 20) == 0 || this._total < 5 || this._done == this._total)) {
          var jobManager = this._classloader._jobManager;

          if (jobManager._running) {
//            jsx3._logIt("Pausing class loader");
            jobManager.pause();
            window.setTimeout(function() { jobManager.start(); }, 0);
          }
        }
      };

      Progress_prototype.updateProgress = function(bLabel) {
        if (! this._painted) return;

        var weights = Progress.STAGE_WEIGHTS[this._type];

        var ratio = this._total == 0 ? 1 : Math.max(0, Math.min(1, (this._done/this._total)));
        var percent = weights[this._stage] + (weights[this._stage+1] - weights[this._stage]) * ratio;
        percent = Math.min(percent, 1);

//        jsx3._logIt("total:" + this._total + ", done:" + this._done + " ratio:" + ratio + " percent:" + percent);

        try {
          if (bLabel && this._type == Progress.TYPE_NORMAL)
            this._setMessage(Progress.STAGE_NAMES[this._stage]);

          var bar = this._gui.childNodes[0].childNodes[0].childNodes[1].childNodes[0];
          var pixels = Math.round(bar.parentNode.offsetWidth*percent);

          if (this._type == Progress.TYPE_PORTAL) {
            if (pixels > 0) {
              this._setMessage(Progress.STAGE_NAMES[4]);
            } else {
              if (this._tick == null) {
                this._tick = 0;
                this._setMessage(Progress.WAITING + Progress.WAITING_SUFFIX[0]);
                this._ticktime = (new Date()).getTime();
              } else {
                var now = (new Date()).getTime();
                if (now - this._ticktime > 500) {
                  this._tick++;
                  this._setMessage(Progress.WAITING + Progress.WAITING_SUFFIX[this._tick % Progress.WAITING_SUFFIX.length]);
                  this._ticktime = now;
                }
              }
            }
          }

          bar.style.width = pixels + "px";
        } catch (e) { ; }
      };

      Progress_prototype._setMessage = function(strMessage) {
        try {
          this._gui.childNodes[0].childNodes[0].childNodes[1].childNodes[1].innerHTML = strMessage;
        } catch (e) {;}
      };

      Progress_prototype._destroy = function(objEvent) {
        delete this._gui;
      };
    });

    jsx3.CLASS_LOADER = new ClassLoader(new BrowserDetect());
  }
}());

if (window.jsx_main == null)
var jsx_main = function() {
  var getUrlParameters = function(strURL) {
    var p = {};
    var queryIndex = strURL.indexOf("?");
    if (queryIndex >= 0) {
      strURL = strURL.substring(queryIndex + 1);
      var tokens = strURL.split("&");
      for (var i = 0; i < tokens.length; i++) {
        var equalsIndex = tokens[i].indexOf("=");
        if (equalsIndex >= 0) {
          p[tokens[i].substring(0, equalsIndex)] = tokens[i].substring(equalsIndex + 1);
        } else {
          p[tokens[i]] = true;
        }
      }
    }
    return p;
  };

  var scriptAttributes = {id:true, space:true, type:true, charset:true, defer:true, src:true, language:true};

  var loadScript = function(objScript) {
//    jsx3._logIt("found script: " + objScript.src);

    var params = getUrlParameters(objScript.src);
    var attrs = objScript.attributes;
    for (var i = 0; i < attrs.length; i++) {
      if (!scriptAttributes[attrs[i].nodeName]) {
        params[attrs[i].nodeName] = attrs[i].nodeValue;
      }
    }

    for (var f in params) {
      if (f.indexOf("jsx") == 0 && f.indexOf("jsxapp") != 0) {
        jsx3.setEnv(f, params[f]);
        delete params[f];
      }
    }

    var src = objScript.getAttribute("src");
    var abspath = src.substring(0, src.indexOf(jsx3.MAIN_SCRIPT));
    abspath = abspath.replace(/\/\.\//g, "/").replace(/^\.\//, "");
    jsx3.setEnv("jsxabspath", abspath);

    if (!params["jsxappempty"]) {
      var strAppPath = params["jsxapppath"];
      if (strAppPath) {
        objScript.setAttribute("jsxloaded", "1");
        jsx3.CLASS_LOADER.loadApp(strAppPath, objScript.parentNode, params);
        return true;
      } else {
        window.alert(getMsgStr("b_pat"));
      }
    }

    return false;
  };

  var loadAllScripts = function() {
    var allScripts = document.getElementsByTagName("script");
    var bStart = false;

//    jsx3._logIt("script count: " + allScripts.length);

    // iterate through all scripts to find this script
    for (var i = 0; i < allScripts.length; i++) {
      var oneScript = allScripts[i];
      var src = oneScript.getAttribute("src");
      if (!oneScript.getAttribute("jsxloaded") && src && src.indexOf(jsx3.MAIN_SCRIPT) >= 0) {
        bStart = loadScript(oneScript) || bStart;
      }
    }

    if (bStart && jsx3.CLASS_LOADER._isSupported())
      jsx3.CLASS_LOADER._start();
  };

  loadAllScripts();
};

// *** jsx3 system scripts

Array.prototype.indexOf = function(objElement, intStartAt) {
  if (intStartAt == null) intStartAt = 0;
  for (var i = intStartAt; i < this.length; i++) {
    if (this[i] == objElement)
      return i;
  }
  return -1;
};

Array.prototype.lastIndexOf = function(objElement, intStartAt) {
  if (intStartAt == null) intStartAt = this.length - 1;
  for (var i = intStartAt; i >= 0; i--) {
    if (this[i] == objElement)
      return i;
  }
  return -1;
};

Array.prototype.contains = function(objElement) {
  return this.indexOf(objElement) >= 0;
};

Array.prototype.remove = function(objElement) {
  var index = this.indexOf(objElement);
  if (index >= 0)
    return this.splice(index, 1)[0];
  return null;
};

Array.prototype.clone = function() {
  return this.concat();
};

Array.prototype.pushAll = function(a) {
  if (typeof(a) == "array" && a.length > 0) {
    for (var i = 0; i < a.length; i++)
      this.push(a[i]);
  } else if (typeof(a) == "object" && typeof(a.length) == "number" && a.length > 0) {
    for (var i = 0; i < a.length; i++)
      this.push(a[i]);
  }
};

Array.prototype.contentsEqual = function(a) {
  if (a == null) return false;
  if (this.length != a.length) return false;
  for (var i = 0; i < a.length; i++) {
    if (this[i] != a[i]) return false;
  }
  return true;
};

Array.prototype.filter = function(fctFilter) {
  var filtered = [];
  for (var i = 0; i < this.length; i++) {
    if (fctFilter(this[i]))
      filtered.push(this[i]);
  }
  return filtered;
};

Array.prototype.map = function(fctMapper, bExpand, bObject) {
  var mapped = null;
  if (bExpand) {
    if (bObject) {
      mapped = {};
      for (var i = 0; i < this.length; i++) {
        var pairs = fctMapper(this[i]);
        for (var j = 0; j < pairs.length; j+=2)
          mapped[pairs[i]] = pairs[i+1];
      }
    } else {
      mapped = [];
      for (var i = 0; i < this.length; i++) {
        var val = fctMapper(this[i]);
        if (val instanceof Array)
          mapped.pushAll(val);
        else
          mapped.push(val);
      }
    }
  } else {
    if (bObject) {
      mapped = {};
      for (var i = 0; i < this.length; i++) {
        var pair = fctMapper(this[i]);
        mapped[pair[0]] = pair[1];
      }
    } else {
      mapped = new Array(this.length);
      for (var i = 0; i < this.length; i++)
        mapped[i] = fctMapper(this[i]);
    }
  }
  return mapped;
};

Math.modpos = function(v, mod) {
  return jsx3.util.numMod(v, mod);
};

Math.isNaN = function(value) {
  return jsx3.util.numIsNaN(value);
};

Number.prototype.roundTo = function(intUnit) {
  return jsx3.util.numRound(this, intUnit);
};

Number.prototype.zeroPad = function(intDigits) {
  var s = "" + this;
  while (s.length < intDigits)
    s = "0" + s;
  return s;
};

Date.prototype.getLastDateOfMonth = function() {
  var month = this.getMonth();

  return Date._LAST_DATE_ARRAY[month] ||
      ((new Date(this.getYear(), month, 29)).getMonth() == month ? 29 : 28);
};

Date.prototype.equals = function(o) {
  return o != null && o instanceof Date && o.valueOf() == this.valueOf();
};

Date.prototype.compareTo = function(d) {
  var a = this.valueOf();
  var b = d.valueOf();
  return a == b ? 0 : a > b ? 1 : -1;
};

Date._LAST_DATE_ARRAY = [31,null,31,30,31,30,31,31,30,31,30,31];

String.prototype.trim = function() {
  return jsx3.util.strTrim(this);
};

String.prototype.doReplace = function(strReplace,strReplaceWith) {
  var re = new RegExp(strReplace,["g"]);
  return this.replace(re, strReplaceWith);
};

String.prototype.escapeHTML = function() {
  return jsx3.util.strEscapeHTML(this);
};

String.prototype.doTruncate = function(intLength) {
  return jsx3.util.strTruncate(this, intLength, "...", 1);
};

String.prototype.toAbsolute = function() {
  var s;
  //given portal implementations, any string instance that represents a URI can call this method to add a prepend of the absolute path
  if (this.substring(0,1) == "/" || this.substring(0,7).toUpperCase() == "HTTP://" || this.substring(0,8).toUpperCase() == "HTTPS://") {
    s = this.toString();
  } else if (this.substring(0,4) == "JSX/") {
    s = jsx3.getEnv("jsxabspath") + this;
  } else {
    s = jsx3.getEnv("jsxhomepath") + this;
  }
  return s;
};

String.prototype.urlTo = function(strRelative) {
  var concat = null;

  var index = this.lastIndexOf('/');
  if (index == this.length - 1)
    concat = this + strRelative;
  else if (index < 0)
    concat = strRelative;
  else
    concat = this.substring(0, index+1) + strRelative;

  concat = concat.replace(/\\/g,"/");
  var tokens = concat.split("/");

  for (var i = 0; i < tokens.length; i++) {
    var token = tokens[i];
    if (token == ".") {
      tokens.splice(i--, 1);
    } else if (token == "..") {
      if (i > 0 && tokens[i-1] != "..") {
        tokens.splice(i--, 1);
        tokens.splice(i--, 1);
      }
    }
  }

  return tokens.join("/");
};

String.prototype.endsWith = function(token) {
  return jsx3.util.strEndsWith(this, token);
};

String.prototype.constrainLength = function(intMax, ellipsis) {
  return jsx3.util.strTruncate(this, intMax, ellipsis, 2/3);
};

String.prototype.toBase64 = function() {
  return jsx3.util.strEncodeBase64(this);
};

String.prototype.fromBase64 = function() {
  return jsx3.util.strDecodeBase64(this);
};

(function(jsx3) {

  var extend = function(target, source) {
    for (var f in source)
      target[f] = source[f];
    return target;
  };

  var json = function(o) {
    // TODO: proper escaping
    if (o == null) return "null";
    if (typeof(o) == "object") {
      if (o instanceof Array) {
        var s = [];
        for (var i = 0; i < o.length; i++)
          s.push(json(o[i]));
        return "[" + s.join(",") + "]";
      } else {
        var s = [];
        for (var f in o)
          if (o[f] != o.constructor.prototype[f])
            s.push(f + ":" + json(o[f]));
        return "{" + s.join(",") + "}";
      }
    } else if (typeof(o) == "string") {
      return "\"" + jsx3.util.strEscapeJSON(o) + "\"";
    } else {
      return o.toString();
    }
  };

  jsx3.$Object = {

    extend: function(o) {
      return extend(this, o);
    },

    clone: function() {
      var c = jsx3.$O();
      c.extend(this);
      return c;
    },

    json: function() {
      return json(this);
    }
  };

  jsx3.$O = function(o) {
    return extend(o || {}, jsx3.$Object);
  };

  jsx3.$Array = {

    each: function __Array_each(fct) {
      for (var i = 0; i < this.length; i++)
        fct(this[i]);
    },

    map: function(fct) {
      var a = jsx3.$A();
      for (var i = 0; i < this.length; i++)
        a[i] = fct(this[i]);
      return a;
    },

    filter: function(fct) {
      var a = jsx3.$A();
      for (var i = 0; i < this.length; i++)
        if (fct(this[i]))
          a.push(this[i]);
      return a;
    },

    indexOf: function(o) {
      for (var i = 0; i < this.length; i++)
        if (this[i] === o)
          return i;
      return -1;
    },

    contains: function(o) {
      return this.indexOf(o) >= 0;
    },

    remove: function(o) {
      var index = this.indexOf(o);
      if (index >= 0)
        return this.splice(index, 1)[0];
    },

    find: function(fct) {
      for (var i = 0; i < this.length; i++)
        if (fct(this[i]))
          return this[i];
    },

    unique: function() {
      var a = this.concat();
      for (var i = a.length - 1; i >= 1; i--) {
        for (var j = i - 1; j >= 0; j--) {
          if (a[i] === a[j]) {
            a.splice(i, 1);
            break;
          }
        }
      }
      return jsx3.$A(a);
    },

    clone: function() {
      return jsx3.$A(this.concat());
    }
  };

  jsx3.$Hash = jsx3.$Object.clone().extend({

    each: function(fct) {
      for (var f in this) {
        if (this[f] != this.constructor.prototype[f] && this[f] != jsx3.$Hash[f])
          fct(f, this[f]);
      }
    },

    keys: function() {
      var a = [];
      for (var f in this) {
        if (this[f] != this.constructor.prototype[f] && this[f] != jsx3.$Hash[f])
          a.push(f);
      }
      return jsx3.$A(a);
    },

    values: function() {
      var a = [];
      for (var f in this) {
        if (this[f] != this.constructor.prototype[f] && this[f] != jsx3.$Hash[f])
          a.push(this[f]);
      }
      return jsx3.$A(a);
    }
  });

  jsx3.$Function = {
    bind: function(thisObj, argsArr) {
      var fct = this;

      if (argsArr == null || argsArr.length == 0) {
        return jsx3.$F(function __boundFunction() {
	  document.body;  // fall off trace
          return fct.apply(thisObj, arguments);
        });
      } else {
        return function() {
          var myArgs;

          if (arguments.length > 0) {
            myArgs = [];
            for (var i = 0; i < argsArr.length; i++)
              myArgs.push(argsArr[i]);
            for (var i = 0; i < arguments.length; i++)
              myArgs.push(arguments[i]);
          } else {
            myArgs = argsArr;
          }

          return fct.apply(thisObj, myArgs);
        };
      }
    },

    throttled: function() {
      var fct = this;
      return jsx3.$F(function() {
        if (fct._thlto)
          window.clearTimeout(fct._thlto);
        fct._thlto = window.setTimeout(jsx3.$F(fct).bind(this, arguments));
      });
    },

    slept: function() {
      var fct = this;
      return jsx3.$F(function() {
        window.setTimeout(fct.bind(this, arguments));
      });
    }
  };

  jsx3.$String = jsx3.$Object.clone().extend({

    endsWith: function(s) {
      return this.lastIndexOf(s) == this.length - s.length;
    },

    trim: function() {
      return jsx3.$S(this.replace(/(^\s*)|(\s*$)/g, ""));
    }
  });

  jsx3.$F = function(f) {
    return extend(f, jsx3.$Function);
  };

  var fixAsyncArg = jsx3.$F(function(args, n, arg) { args[n] = arg.rv(); });
  var handleAsyncArgs = function(args) {
    var c = null;

    for (var i = 0; i < args.length; i++) {
      var a = args[i];
      if (a instanceof AsyncRV) {
        if (a._done) {
          args[i] = a.rv();
        } else {
          a.when(fixAsyncArg.bind(null, [args, i, a]));
          c = c ? c.and(a) : a;
        }
      }
    }

    return c;
  };

  jsx3.$AsyncCB = function(objThis, arrArgs) {
    this._this = objThis;
    this._args = arrArgs;
    this._condition = handleAsyncArgs(arrArgs);
  };
  extend(jsx3.$AsyncCB.prototype, {
    _whenArg: jsx3.$F(function(n, arg) { this._args[n] = arg.rv(); }),

    done: function __AsyncCB_prototype_done(rv) {
      this._done = true;
      this._rv = rv;
    },

    args: function() {
      return this._args;
    }
  });

  var AsyncRV = jsx3.$AsyncRV = function() {};
  extend(AsyncRV.prototype, {

    _trigger: function __AsyncRV_prototype_trigger(rv) {
      this._done = true;

      this._rv = rv;
      if (this._sub) {
        for (var i = 0; i < this._sub.length; i++)
	  this._sub[i](rv);
        delete this._sub;
      }
    },

    rv: function() {
      if (!this._done)
        throw new Error("May not call $AsyncRV.rv() before the return value is set.");
      return this._rv;
    },

    when: function(cb, rv) {
      var fct = null;

      if (typeof(cb) == "function")
        fct = cb;
      else if (cb instanceof jsx3.$AsyncCB) {
        if (arguments.length > 1)
          fct = function() {cb.done(rv);};
        else
          fct = function __AsyncRV_prototype_when_lambda(chainedRV) {cb.done(chainedRV);};
      } else
        throw new Error();

      if (this._done) {
        fct(this._rv);
      } else {
        if (!this._sub)
          this._sub = jsx3.$A();
        this._sub.push(fct);
      }
    },

    and: function(rv) {
      var a = [this];
      for (var i = 0; i < arguments.length; i++)
        a.push(arguments[i]);
      return new AndRV(a);
    },

    or: function(rv) {
      var a = [this];
      for (var i = 0; i < arguments.length; i++)
        a.push(arguments[i]);
      return new OrRV(a);
    }
  });

  var MethodRV = function(cb) {
    var thisMethod = this;

    this._cb = cb;
    cb.done = function __MethodRV_cbdone(rv) {
        cb._done = true;
        cb._rv = rv;
	delete cb.done;
        thisMethod._trigger(rv);
      };
  };
  MethodRV.prototype = new AsyncRV();

  var AndRV = function(rvs) {
    var thisRV = this;

    this._ct = rvs.length;
    this._donect = 0;
    for (var i = 0; i < rvs.length; i++) {
      var e = rvs[i];
      if (e._done)
        this._donect++;
      else
        e.when(function __AndRV_inc() {
	  thisRV._donect++;
	  if (thisRV._donect == thisRV._ct)
	    thisRV._trigger();
	});
    }

    if (this._ct == this._donect)
      this._trigger();
  };
  AndRV.prototype = new AsyncRV();

  var OrRV = function(rvs) {
    jsx3.$A(rvs).each(jsx3.$F(function(e) {
      if (e._done)
        this._inc();
      else
        e.when(this._inc.bind(this));
    }).bind(this));
  };
  OrRV.prototype = new AsyncRV();
  extend(OrRV.prototype, {

    _inc: jsx3.$F(function() {
      if (!this._done)
        this._trigger();
    })
  });

  jsx3.$A = function(a) {
    if (a == null)
      a = [];
    else if (typeof(a) == "object") {
      if (a instanceof Array) {

      } else if (typeof(a.length) == "number") {
        // works on arguments array
        var t = [];
        for (var i = 0; i < a.length; i++)
          t[i] = a[i];
        a = t;
      } else {
        a = [a];
      }
    } else
      a = [a];
    return extend(a, jsx3.$Array);
  };

  jsx3.$H = function(o) {
    if (o && typeof(o) == "object" && typeof(o.length) != "undefined") {
      var h = {};
      for (var i = 0; i < o.length; i++)
        h[o[i]] = 1;
      return extend(h, jsx3.$Hash)
    } else {
      return extend(o || {}, jsx3.$Hash);
    }
  };

  jsx3.$S = function(s) {
    if (s == null) return s;
    return extend(s, jsx3.$String);
  };

  jsx3.$Y = function(f) {
    return function() {
      var cb = new jsx3.$AsyncCB(this, arguments);
      var rv = new MethodRV(cb);

//      var stack = (jsx3.lang && jsx3.lang.getStack) ? jsx3.lang.getStack() : [];
//      window.setTimeout(jsx3.$F(function() {
//        if (!cb._done) {
//          jsx3.log("Never finished: " + this + " " + f + "\nargs:" + jsx3.Method.argsAsArray(cb.args()) + "\n" +
//                   jsx3.Exception.formatStack(stack));
//        }
//      }).bind(this), 10000);

      if (cb._condition) {
        var objThis = this;
        cb._condition.when(function() {
          var r = f.apply(objThis, [cb]);
          if (r instanceof AsyncRV)
            r.when(cb);
        });
      } else {
        var r = f.apply(this, [cb]);
        if (r instanceof AsyncRV)
          r.when(cb);
      }

      return rv;
    };
  };

  jsx3.$Z = function(strMethod, objThis) {
    if (objThis instanceof AsyncRV)
      objThis.when(function(rv) { objThis = rv; });

    return function() {
      var rv = new AsyncRV();
      var a = jsx3.Method.argsAsArray(arguments);

      if (objThis instanceof AsyncRV) {
        objThis.when(function() {
          onceDone(objThis, strMethod, a, rv);
        });
      } else {
        onceDone(objThis || this, strMethod, a, rv);
      }

      return rv;
    }
  };

  var onceDone = function(objThis, strMethod, args, rv) {
    var fct = typeof(strMethod) == "function" ? strMethod : objThis[strMethod];
    var c = handleAsyncArgs(args);
    if (c) {
      c.when(function __$Z_onceDone_lambda() {
        rv._trigger(fct.apply(objThis, args))
      });
    } else {
      rv._trigger(fct.apply(objThis, args));
    }
  };
})(jsx3);

if (jsx3.lang == null) jsx3.lang = {};

(function(lang) {

  lang.STACK_MAX = 50;

  lang.getCaller = function(intUp) {
    var skip = (intUp != null ? intUp : 0) + 1;
    var a = arguments;

    if (a.callee) {
      for (a = a.callee; a != null; a = a.caller) {
        if (--skip >= 0) continue;
        return a.caller;
      }
    } else {
      for (a = a.caller; a != null; a = a.caller) {
        if (--skip >= 0) continue;
        return a.callee;
      }
    }

    return null;
  };

  lang.getStack = function(intUp) {
    var stack = [];
    var skip = (intUp != null ? intUp : 0) + 1;
    var a = arguments;

    if (a.callee) {
      for (a = a.callee; a != null && stack.length < jsx3.lang.STACK_MAX; a = a.caller) {
        if (--skip >= 0) continue;
        stack[stack.length] = a.caller;
      }
    } else {
      for (a = a.caller; a != null; a = a.caller) {
        if (--skip >= 0) continue;
        stack[stack.length] = a.callee;
      }
    }

    return stack;
  };

  lang.setVar = function(strPath, objValue) {
    var tokens = strPath.split(".");
    var parent = window;
    for (var i = 0; i < tokens.length - 1; i++) {
      var token = tokens[i];
      if (!parent[token]) parent[token] = {};
      parent = parent[token];
    }
    parent[tokens[tokens.length-1]] = objValue;
  };

  lang.getVar = function(strPath) {
    var tokens = strPath.split(".");
    var parent = window;
    for (var i = 0; i < tokens.length; i++) {
      if (parent == null) return;
      parent = parent[tokens[i]];
    }
    return parent;
  };

})(jsx3.lang);

if (window["jsx3"] == null) window["jsx3"] = {};
if (jsx3.lang == null) jsx3.lang = {};

jsx3.lang._NEW_FORCE = new window.Object();
jsx3.lang._NEW_NO_INIT = new window.Object();

jsx3.lang.newPrivateConstructor = function() {
  return function() {
    if (arguments[0] != jsx3.lang._NEW_FORCE) {
      var clazz = this.getClass ? this.getClass() : null;
      throw new jsx3.Exception(jsx3._msg("obj.no_inst", clazz || this));
    }
  };
};

jsx3.lang.newConstructor = function() {
  return function() {
    if (arguments[0] !== jsx3.lang._NEW_NO_INIT) {
      if (this.init) {
        this.init.apply(this, arguments);
      } else {
        var objConstr = jsx3.lang.getCaller(-1);
        throw new jsx3.Exception(jsx3._msg("obj.no_init", objConstr.jsxclass));
      }
    }
  };
};

jsx3.lang.Object = function() {
  this.init();
};

window._jsxtmp = function(Object, Object_prototype) {

  Object_prototype.init = function() {};

  Object_prototype.getClass = function() {
    return this.__jsxclass__.jsxclass;
  };

  Object_prototype.equals = function(obj) {
    return this === obj;
  };

  Object_prototype.clone = function() {
    return this.getClass().bless(this);
  };

  Object_prototype.instanceOf = function(objClass) {
    if (objClass instanceof jsx3.lang.Class) {
      return objClass.isInstance(this);
    } else if (typeof(objClass) == "function" && objClass.prototype != null) {
      return (this instanceof objClass) || (objClass.jsxclass != null && objClass.jsxclass.isInstance(this));
    } else if (typeof(objClass) == "string") {
      objClass = jsx3.lang.Class.forName(objClass);
      if (objClass != null)
        return objClass.isInstance(this);
    }
    throw new jsx3.IllegalArgumentException("objClass", objClass);
  };

  Object_prototype.toString = function() {
    return "@" + this.getClass().getName();
  };

  Object_prototype.jsxsuper = function(arg) {
    var Exception = jsx3.Exception;
    var fctCaller = jsx3.lang.getCaller();
    var objMethod = fctCaller != null ? fctCaller.jsxmethod : null;

    if (objMethod == null || !(objMethod instanceof jsx3.lang.Method))
      throw new Exception(jsx3._msg("obj.super_funct", fctCaller));
    if (objMethod.isStatic())
      throw new Exception(jsx3._msg("obj.super_static", objMethod));

    var objClass = objMethod.getDeclaringClass();
    var objSuperMethod = objClass._getSuperMethodFor(objMethod);

    if (objSuperMethod == null)
      throw new Exception(jsx3._msg("obj.super_none", objMethod));

    var result = objSuperMethod.apply(this, arguments);
    if (typeof(result) != "undefined")
      return result;
  };

  Object_prototype.jsxsupermix = function(arg) {
    var Exception = jsx3.Exception;
    var fctCaller = jsx3.lang.getCaller();
    var objMethod = fctCaller != null ? fctCaller.jsxmethod : null;

    if (objMethod == null || !(objMethod instanceof jsx3.lang.Method))
      throw new Exception(jsx3._msg("obj.supmx_funct", fctCaller));
    if (objMethod.isStatic())
      throw new Exception(jsx3._msg("obj.supmx_static", objMethod));

    var objClass = objMethod.getDeclaringClass();
    var objSuperMethod = objClass._getSuperMixinMethodFor(objMethod);

    if (objSuperMethod == null)
      throw new Exception(jsx3._msg("obj.supmx_none", objMethod));

    var result = objSuperMethod.apply(this, arguments);
    if (typeof(result) != "undefined")
      return result;
  };

  Object_prototype.jsxmix = function(arg) {};

  Object_prototype.isInstanceOf = function(strClassName,strPropName,bIsRecurse) {
    if (this.getClass() &&
        (typeof(strClassName) != "string" || jsx3.lang.Class.forName(strClassName) != null))
      return this.instanceOf(strClassName);

    //returns true if the instance is an instance of strClassName
    var f = jsx3.getClass(this.getInstanceOf());

    //default so that it's not necessary to call setInstanceOf()
    if(f == null) f = this.constructor;

    if(typeof(f) == "function") {
      var o = f[(strPropName) ? strPropName : "INTERFACES"];
      var e = (o) ? o[strClassName] : null;

  //BRIDGE: Remove this in 4.0
  //start
      if(e == 1) {
        return true;
      } else if(bIsRecurse) {
        return false;
      } else {
        return this.isInstanceOf(strClassName.replace(/jsx3/g,"jsx3.gui"),strPropName,true);
      }
  //end

  //BRIDGE: Replace with this
  //      return (e == 1);

    }
    return false;
  };

  Object_prototype.isSubclassOf = function(strClassName) {
    return this.isInstanceOf(strClassName,"SUPERS");
  };

  Object_prototype.getInstanceOf = function() {
    if (this.getClass()) return this.getClass().getName();

    return this.jsxinstanceof ? this.jsxinstanceof : this.constructor.className;
  };

  Object_prototype.setInstanceOf = function(strInstanceOf) {
    this.jsxinstanceof = strInstanceOf;
    return this;
  };

  Object_prototype.getInstanceOfPackage = function() {
    if (this.getClass()) return this.getClass().getPackageName();

    var fullName = this.getInstanceOf();
    if (fullName == null) return "";
    var index = fullName.lastIndexOf('.');
    if (index >= 0)
      return fullName.substring(0, index);
    else
      return "";
  };

  Object_prototype.getInstanceOfClass = function() {
    if (this.getClass()) {
      var name = this.getClass().getName();
      return name.substring(name.lastIndexOf(".") + 1);
    }

    var fullName = this.getInstanceOf();
    if (fullName == null) return "";
    var index = fullName.lastIndexOf('.');
    if (index >= 0)
      return fullName.substring(index+1);
    else
      return fullName;
  };

  Object_prototype.eval = function(strScript, objContext) {
    return jsx3.eval.call(this, strScript, objContext);
  };

};

window._jsxtmp(jsx3.lang.Object, jsx3.lang.Object.prototype);
window._jsxtmp = null;

jsx3.lang.Object.prototype.__noSuchMethod__ = function(strMethod, args) {
  throw new jsx3.Exception(jsx3._msg("class.nsm", this.getClass().getName() + "#" + strMethod + "()"));
};

window.inheritance = jsx3.lang.Object;

// @jsxobf-clobber  _params
// @jsxobf-clobber-shared  _name _class _static _abstract

if (window["jsx3"] == null) window["jsx3"] = {};
if (jsx3.lang == null) jsx3.lang = {};

jsx3.lang.Method = jsx3.lang.newPrivateConstructor();

jsx3.lang.Method.prototype = new jsx3.lang.Object;
jsx3.lang.Method.prototype.constructor = jsx3.lang.Method;

window._jsxtmp = function(Method, Method_prototype) {

  Method._PARAMS = /^\s*function(\s+\w+)?\s*\(\s*([^\)]*?)\s*\)/;

  Method_prototype._initParams = function() {
    if (Method._PARAMS.exec(this.getFunction().toString())) {
      var params = RegExp.$2;
      this._params = params ? params.split(/\s*,\s*/) : [];
    } else {
      this._params = [];
    }
  };

  Method_prototype.getName = function() {
    return this._name;
  };

  Method_prototype.getArity = function() {
    if (this._params == null) this._initParams();
    return this._params.length;
  };

  Method_prototype.getParameterNames = function() {
    if (this._params == null) this._initParams();
    return this._params.concat();
  };

  Method_prototype.getParameterName = function(intIndex) {
    if (this._params == null) this._initParams();
    return this._params[intIndex];
  };

  Method_prototype.getDeclaringClass = function() {
    return this._class;
  };

  Method_prototype.isPackageMethod = function() {
    return this._class instanceof jsx3.lang.Package;
  };

  Method_prototype.isStatic = function() {
    return this._static;
  };

  Method_prototype.isAbstract = function() {
    return this._abstract;
  };

  Method_prototype.getFunction = function() {
    if (this.isPackageMethod()) {
      return this._class.getNamespace()[this._name];
    } else {
      if (this._static) {
        return this._class.getConstructor()[this._name];
      } else {
        return this._class.getConstructor().prototype[this._name];
      }
    }
  };

  Method_prototype.apply = function(thisArg, argArray) {
    return this.getFunction().apply(thisArg, argArray);
  };

  Method_prototype.call = function(arg) {
    var a = arguments;
    if (a.length > 11)
      throw new jsx3.Exception(jsx3._msg("method.call", + a.length));
    return this.getFunction().call(a[0],a[1],a[2],a[3],a[4],a[5],a[6],a[7],a[8],a[9],a[10]);
  };

  Method_prototype.toString = function() {
    return this._class.getName() + "." + this._name;
  };

  Method.newAbstract = function(paramNames) {
    var paramString = "";
    for (var i = 0; i < arguments.length; i++) {
      if (! arguments[i].match(/^[a-zA-Z_]\w*$/))
        throw new jsx3.IllegalArgumentException("paramNames[" + i + "]", arguments[i]);

      paramString += "'" + arguments[i] + "', ";
    }

    var functBody =
        'var method = arguments.callee.jsxmethod;' +
        'if (method instanceof jsx3.lang.Method) {' +
        '  throw new jsx3.Exception("method " + method.getName() + " in class " + method.getDeclaringClass() +' +
        '    " is abstract and may not be invoked");' +
        '} else {' +
        '  throw new jsx3.Exception("invoked abstract method improperly initialized");' +
        '}';

    var fnct = jsx3.eval("new Function(" + paramString + "'" + functBody + "');");

    fnct._abstract = true;
    return fnct;
  };

  Method.newDelegate = function(strMethod, strField) {
    var functBody = 'return this.' + strField + '.' + strMethod + '.apply(this.' + strField + ', arguments);';
    return new Function(functBody);
  };

  Method.argsAsArray = function(args, from, to) {
    if (from == null)
      from = 0;

    if (to == null)
      to = args.length;
    else
      to = Math.min(to, args.length);

    var length = to - from;
    if (length <= 0) return [];

    var a = new Array(length);
    for (var i = 0; i < length; i++)
      a[i] = args[i+from];

    return a;
  };
};

window._jsxtmp(jsx3.lang.Method, jsx3.lang.Method.prototype);
window._jsxtmp = null;

if (window["jsx3"] == null) window["jsx3"] = new window.Object();
if (jsx3.lang == null) jsx3.lang = new window.Object();

// @jsxobf-clobber  _constructor _super _interface _implements _staticMethods _instanceMethods _instanceMethodIndex _staticFields _instanceFields _superMap _superMixinMap _ancestors
// @jsxobf-clobber-shared  _name _class _static _abstract _classDidLoad

jsx3.lang.Class = jsx3.lang.newPrivateConstructor();

// bootstrap Class superclass
jsx3.lang.Class.prototype = new jsx3.lang.Object;
jsx3.lang.Class.prototype.__jsxclass__ = jsx3.lang.Class;

window._jsxtmp = function(Class, Class_prototype) {

  Class._SPECIAL = {"jsx3.lang.Object":1, "jsx3.lang.Method":1, "jsx3.lang.ClassLoader": 1, "jsx3.lang.Class": 2};

  Class._NON_ITERATED = ["toString", "valueOf"];

  Class._SKIP_ITERATED = {prototype:1, constructor:1, jsxclass:1, __jsxclass__:1}; // Mozilla browser likes to iterate over the first two

  Class._LOG = null;

  Class.defineClass = function(strName, objExtends, arrImplements, fctBody) {
    this._define(strName, objExtends, arrImplements, fctBody, false);
  };

  Class.defineInterface = function(strName, objExtends, fctBody) {
    this._define(strName, objExtends, null, fctBody, true);
  };

  Class._define = function(strName, objExtends, arrImplements, fctBody, bInterface) {
    //3.6: added the following check at the outset of the class to stop a race condition with Fx3b4
    if(Class.forName && Class.forName(strName)) {
      jsx3.CLASS_LOADER._classDidLoad(Class.forName(strName));
      return;
    }

    if (Class._LOG == null && Class.forName && Class.forName("jsx3.util.Logger.Manager")
        && jsx3.util.Logger.Manager.getManager())
      Class._LOG = jsx3.util.Logger.getLogger("jsx3.lang.Class");

    // parse name into package and class name
    var pathTokens = strName.split(".");
    var className = pathTokens.pop();
    var myPackage = this._getOrCreatePackage(pathTokens);
    var bSpecial = this._SPECIAL[strName] != null;

    // resolve the super class
    var fctSuperConstructor = null;
    if (objExtends == null) {
      fctSuperConstructor = (bInterface || strName == "jsx3.lang.Object") ? window.Object : jsx3.lang.Object;
    } else if (objExtends instanceof Class) {
      fctSuperConstructor = objExtends.getConstructor();
    } else if (typeof(objExtends) == "function" && objExtends.prototype != null) {
      fctSuperConstructor = objExtends;
    } else {
      Class._throw(jsx3._msg("class.bad_super", objExtends));
    }

    var bConstructorExists = false;
    if (!bSpecial) {
      // check inheritance rules
      if (fctSuperConstructor.jsxclass != null) {
        if (bInterface && ! fctSuperConstructor.jsxclass.isInterface())
          Class._throw(jsx3._msg("class.int_ext_class", strName, fctSuperConstructor.jsxclass));
        if (! bInterface && fctSuperConstructor.jsxclass.isInterface())
          Class._throw(jsx3._msg("class.class_ext_int", strName, fctSuperConstructor.jsxclass));
      }

      // create the constructor, which calls init()
      if (typeof(myPackage[className]) == "function") {
        bConstructorExists = true;
      } else if (bInterface) {
        // will this work with JavaScript prototype inheritance?
        myPackage[className] = jsx3.lang.newPrivateConstructor();
      } else if (typeof(myPackage[className]) == "object") {
        // support a class being defined previously as a package ...
        var tmp = myPackage[className];
        myPackage[className] = jsx3.lang.newConstructor();
        for (var f in tmp)
          myPackage[className][f] = tmp[f];
      } else {
        myPackage[className] = jsx3.lang.newConstructor();
      }

      // set up JavaScript inheritance
      myPackage[className].prototype = this._newInstanceNoInit(fctSuperConstructor, bInterface);
    }

    myPackage[className].prototype.__jsxclass__ = myPackage[className];

    var fctConstructor = myPackage[className];
    // create a reference from constructor to jsx3.lang.Class
    if (fctConstructor.jsxclass != null) {
      //Class._throw(jsx3._msg("class.redefine", strName, fctConstructor.jsxclass));
    } else {
    // alias jsx3.lang to jsx3
    if (pathTokens.join(".") == "jsx3.lang")
      jsx3[className] = fctConstructor;

    // create the jsx3.lang.Class instance, bootstrap since we use this method to create Class as well
    var objClass = Class._newInstanceForce(Class);
    objClass._name = strName;

    objClass._constructor = fctConstructor; // create 2-way reference, if removed will still work
    if (fctSuperConstructor != null)
      objClass._super = fctSuperConstructor.jsxclass; // may be null, ok
    objClass._interface = bInterface;
    objClass._implements = [];
    objClass._staticMethods = [];
    objClass._instanceMethods = [];
    var staticFields = objClass._staticFields = [];
    var instanceFields = objClass._instanceFields = [];
    objClass._superMap = {};
    objClass._superMixinMap = {};

      fctConstructor.jsxclass = objClass;

      // define the body of the class
      try {
        fctBody(fctConstructor, fctConstructor.prototype);
      } catch (e) {
        var ex = jsx3.NativeError ? jsx3.NativeError.wrap(e) : null;
        Class._throw(jsx3._msg("class.def_error", strName, ex || e.description), ex);
      }

      // define static methods
      for (var f in fctConstructor) {
        if (Class._SKIP_ITERATED[f]) continue;

        if (typeof(fctConstructor[f]) == "function") {
          this._blessMethod(fctConstructor[f], objClass, f, true);
        } else {
          staticFields[staticFields.length] = f;
        }
      }
      // static methods that don't show up in a for loop
      for (var i = 0; i < Class._NON_ITERATED.length; i++) {
        var name = Class._NON_ITERATED[i];
        if (fctConstructor[name] != null && fctConstructor[name] != window.Function.prototype[name] &&
            fctConstructor[name].jsxmethod == null)
          this._blessMethod(fctConstructor[name], objClass, name, true);
      }

      // define instance methods and fields
      for (var f in fctConstructor.prototype) {
        if (Class._SKIP_ITERATED[f]) continue;

        var funct = fctConstructor.prototype[f];
        if (typeof(funct) == "function") {
          if (fctSuperConstructor == null || funct != fctSuperConstructor.prototype[f])
            this._blessMethod(funct, objClass, f, false);
        } else {
          instanceFields[instanceFields.length] = f;
        }
      }
      // instance methods that don't show up in a for loop
      for (var i = 0; i < Class._NON_ITERATED.length; i++) {
        var name = Class._NON_ITERATED[i];
        if (fctConstructor.prototype[name] != null && fctConstructor.prototype[name] != window.Object.prototype[name] &&
            fctConstructor.prototype[name].jsxmethod == null)
          this._blessMethod(fctConstructor.prototype[name], objClass, name, false);
      }

      // ensure init() method defined
      if (!bConstructorExists && !bInterface && !(typeof(fctConstructor.prototype.init) == "function"))
        Class._throw(jsx3._msg("class.no_init", strName));

      // import mixin interface methods
      if (arrImplements instanceof Array) {
        // go backwards through interfaces because we clobber and first defined interface has precedence
        for (var i = arrImplements.length-1; i >= 0; i--)
          Class._defineImplements(objClass, fctConstructor, arrImplements[i]);
      }

      if (Class._LOG)
        Class._LOG.trace("loaded " + strName);

  // Enables Class.require(), which is commented out below.
  //    Class._checkWaiting();
      jsx3.CLASS_LOADER._classDidLoad(objClass);
    }
  };

  Class._defineImplements = function(objClass, fctConstructor, anInterface) {
    if (typeof(anInterface) == "function" && anInterface.jsxclass != null)
      anInterface = anInterface.jsxclass;
    else if (!(anInterface instanceof Class))
      Class._throw(jsx3._msg("class.bad_int", objClass, anInterface));

    if (! anInterface.isInterface())
      Class._throw(jsx3._msg("class.class_imp_class", objClass, anInterface));

    // import interface methods into this class
    var interfacePrototype =  anInterface.getConstructor().prototype;
    for (var f in interfacePrototype) {
      var interfaceFunction = interfacePrototype[f];
      var interfaceMethod = typeof(interfaceFunction) == "function" ? interfaceFunction.jsxmethod : null;
      if (interfaceMethod == null) continue;
      var existingFunction = fctConstructor.prototype[f];

      // import method if no existing method by that name ...
      if (existingFunction == null) {
        fctConstructor.prototype[f] = interfaceFunction;
      }
      // ... or if there is existing method but it wasn't defined in this class
      else if (! existingFunction.jsxmethod.getDeclaringClass().equals(objClass)) {
        fctConstructor.prototype[f] = interfaceFunction;
      }
    }

    // add interface to list of interfaces
    objClass._implements.unshift(anInterface);
  };

  Class._getOrCreatePackage = function(arrTokens) {
    var node = window;
    for (var i = 0; i < arrTokens.length; i++) {
      var token = arrTokens[i];
      if (node[token] == null) node[token] = new window.Object();
      node = node[token];
    }
    return node;
  };

  Class._blessMethod = function(fctMethod, objClass, strName, bStatic) {
    if (fctMethod.jsxmethod instanceof jsx3.lang.Method) {
      if (fctMethod.jsxmethod.getDeclaringClass().equals(objClass))
        Class._throw(jsx3._msg("class.redef_method", fctMethod.jsxmethod, objClass + "." + strName));
      else
        return;
    }

    var objMethod = Class._newInstanceForce(jsx3.lang.Method);

    objMethod._class = objClass;
    objMethod._name = strName;
    objMethod._static = bStatic;
    objMethod._abstract = Boolean(fctMethod._abstract);

    fctMethod.jsxmethod = objMethod;

    var collection = bStatic ? objClass._staticMethods : objClass._instanceMethods;
    collection[collection.length] = objMethod;
  };

  Class._newInstanceNoInit = function(fctConstructor, bInterface) {
    if (fctConstructor == Object) return {};
    return new fctConstructor(bInterface ? jsx3.lang._NEW_FORCE : jsx3.lang._NEW_NO_INIT);
  };

  Class._newInstanceForce = function(fctConstructor) {
    return new fctConstructor(jsx3.lang._NEW_FORCE);
  };

  Class._throw = function(strMessage, objCause) {
    if (Class._LOG) {
      Class._LOG.fatal(strMessage, objCause);
    } else if (jsx3.Exception) {
      var e = new jsx3.Exception(strMessage, objCause);
      window.alert(e.printStackTrace());
    } else {
      window.alert(strMessage);
    }
  };
};

window._jsxtmp(jsx3.lang.Class, jsx3.lang.Class.prototype);
window._jsxtmp = null;

jsx3.lang.Class.defineClass("jsx3.lang.Class", null, null, function(Class, Class_prototype) {

  Class.forName = function(strName) {
    var c = jsx3.lang.getVar(strName);
    return c ? c.jsxclass : null;
  };

// JCG: Wrote this and now I don't use it anymore. Maybe it will come in handy in the future.
//
//
//  Class._WAITING = [];
//
//
//  Class.require = function(arrPrereq, fctCallback) {
//    for (var i = 0; i < arrPrereq.length; i++) {
//      if (! Class.forName(arrPrereq[i])) {
//        Class._WAITING.push([arrPrereq, fctCallback]);
//        return;
//      }
//    }
//    fctCallback();
//  };
//
//
//  Class._checkWaiting = function() {
//    WAITING: for (var i = 0; i < Class._WAITING.length; i++) {
//      var arrPrereq = Class._WAITING[i][0];
//      PREREQ: for (var j = 0; j < arrPrereq.length; j++) {
//        if (! Class.forName(arrPrereq[j]))
//          continue WAITING;
//      }
//
//      var fctCallback = Class._WAITING[i][1];
//      Class._WAITING.splice(i--, 1);
//      fctCallback();
//    }
//  };

  Class_prototype.getName = function() {
    return this._name;
  };

  Class_prototype.getPackage = function() {
    var path = this._name;
    while (true) {
      // get the fully-qualified name less the last token
      var index = path.lastIndexOf(".");
      if (index < 0) break;
      path = path.substring(0, index);
      // check for a package
      var pkg = jsx3.lang.Package.forName(path);
      if (pkg != null) return pkg;
      // OR, this could be an inner class
      if (Class.forName(path) == null) break;
    }
    return null;
  };

  Class_prototype.getPackageName = function() {
    var pkg = this.getPackage();
    if (pkg) {
      return pkg.getName();
    } else {
      var index = this._name.lastIndexOf(".") + 1;
      return index >= 0 ? this._name.substring(0, index-1) : "";
    }
  };

  Class_prototype.getConstructor = function() {
    if (this._constructor != null) return this._constructor;

    var c = jsx3.lang.getVar(this._name);
    return c || null;
  };

  Class_prototype.getSuperClass = function() {
    return this._super;
  };

  Class_prototype.isInterface = function() {
    return this._interface;
  };

  Class_prototype.toString = function() {
    return this._name;
  };

  Class_prototype.newInstance = function(arg) {
    if (arguments.length > 10)
      throw new jsx3.Exception(jsx3._msg("class.new_inst"));
    var a = arguments;
    var c = this.getConstructor();
    return new c(a[0],a[1],a[2],a[3],a[4],a[5],a[6],a[7],a[8],a[9]);
  };

  Class_prototype.isInstance = function(obj) {
    var objClass = obj.__jsxclass__ ? obj.__jsxclass__.jsxclass : null;
    return objClass != null && this.isAssignableFrom(objClass);
  };

  Class_prototype.isAssignableFrom = function(objClass) {
    if (this.equals(objClass)) return true;

    // lazily create ancestor hash
    if (objClass._ancestors == null)
      objClass._cacheAncestors();

    return objClass._ancestors[this.getName()] == true;
  };

  Class_prototype._cacheAncestors = function() {
    this._ancestors = {};
    for (var i = 0; i < this._implements.length; i++) {
      var anInterface = this._implements[i];
      this._ancestors[anInterface.getName()] = true;

      if (anInterface._ancestors == null)
        anInterface._cacheAncestors();
      for (var f in anInterface._ancestors)
        this._ancestors[f] = true;
    }

    if (this._super != null) {
      this._ancestors[this._super.getName()] = true;
      if (this._super._ancestors == null)
        this._super._cacheAncestors();
      for (var f in this._super._ancestors)
        this._ancestors[f] = true;
    }
  };

  Class_prototype.mixin = function(obj, bNoClobber, arrNames) {
    if (arrNames) {
      for (var i = 0; i < arrNames.length; i++) {
        var method = this.getInstanceMethod(arrNames[i]);
        if (method && obj[method.getName()] == null || !bNoClobber)
          obj[method.getName()] = method.getFunction();
      }
    } else {
      for (var i = 0; i < this._instanceMethods.length; i++) {
        var method = this._instanceMethods[i];
        if (obj[method.getName()] == null || !bNoClobber)
          obj[method.getName()] = method.getFunction();
      }
    }
  };

  Class_prototype.bless = function(obj) {
    if (this.isInterface())
      throw new jsx3.Exception(jsx3._msg("class.bless_int", this));

    var instance = Class._newInstanceNoInit(this.getConstructor());
    if (obj != null) {
      for (var f in obj) {
        if (!(typeof(obj[f]) == "function"))
          instance[f] = obj[f];
      }
    }
    return instance;
  };

  Class_prototype.newInnerClass = function(arg) {
    if (this.isInterface()) {
      return Class._newInstanceForce(this.getConstructor());
    } else {
      return this.newInstance.apply(this, arguments);
    }
  };

  Class_prototype.getStaticMethods = function() {
    return this._staticMethods.concat();
  };

  Class_prototype.getInstanceMethods = function() {
    return this._instanceMethods.concat();
  };

  Class_prototype.getStaticMethod = function(strMethodName) {
    for (var i = 0; i < this._staticMethods.length; i++) {
      if (strMethodName == this._staticMethods[i].getName())
        return this._staticMethods[i];
    }
    return null;
  };

  Class_prototype.getInstanceMethod = function(strMethodName) {
    if (!this._instanceMethodIndex) {
      this._instanceMethodIndex = {};
      for (var i = 0; i < this._instanceMethods.length; i++)
        this._instanceMethodIndex[this._instanceMethods[i].getName()] = this._instanceMethods[i];
    }
    return this._instanceMethodIndex[strMethodName] || null;
  };

  Class_prototype.getGetter = function(strProp) {
    strProp = strProp.charAt(0).toUpperCase() + strProp.substring(1);
    return this._findMethod("get" + strProp) || this._findMethod("is" + strProp);
  };

  Class_prototype.getSetter = function(strProp) {
    strProp = strProp.charAt(0).toUpperCase() + strProp.substring(1);
    return this._findMethod("set" + strProp);
  };

  Class_prototype.getStaticFieldNames = function() {
    return this._staticFields.concat();
  };

  Class_prototype.getInstanceFieldNames = function() {
    return this._instanceFields.concat();
  };

  Class_prototype.getInterfaces = function() {
    return this._implements.concat();
  };

  Class_prototype.addInterface = function(objInterface) {
    var errmsg = null;
    if (this.isInterface())
      errmsg = "class.int_imp_int";
    else if (! objInterface.isInterface())
      errmsg = "class.class_imp_class";
    else if (objInterface.isAssignableFrom(this))
      errmsg = "class.already_imp";
    if (errmsg) throw new jsx3.Exception(jsx3._msg(errmsg, this, objInterface));

    Class._defineImplements(this, this.getConstructor(), objInterface);
    delete this._ancestors;
  };

  Class_prototype.getInheritance = function() {
    var inherit = this._implements.concat();
    if (this._super != null) {
      inherit[inherit.length] = this._super;
      inherit.push.apply(inherit, this._super.getInheritance());
    }
    return inherit;
  };

  Class_prototype.getClasses = function() {
    var constructor = this.getConstructor();
    var classes = [];
    for (var f in constructor) {
      if (typeof(constructor[f]) == "function" && constructor[f].jsxclass instanceof Class) {
        classes[classes.length] = constructor[f].jsxclass;
        classes.push.apply(classes, constructor[f].jsxclass.getClasses());
      }
    }
    return classes;
  };

  Class_prototype.addMethodMixin = function(strMethod, objClass, strMixin) {
    var objMethod = this.getInstanceMethod(strMethod);
    if (!objMethod) Class._throw(jsx3._msg("class.mmix_bad", this, strMethod));

    var AOP = jsx3.AOP;
    if (!AOP) Class._throw(jsx3._msg("class.no_aop", this, strMethod));

    var pointName = this.getName() + "." + strMethod + "." + objClass.getName();
    AOP.pc(pointName, {classes:this, methods:strMethod, type:objClass}).after(pointName, function() {
      this[strMixin].apply(this, jsx3.Method.argsAsArray(arguments, 1));
    });
  };

  Class_prototype._findMethod = function(strMethodName, bExcludeSelf) {
    var objMethod = null;

    // look in self
    if (! bExcludeSelf)
      objMethod = this.getInstanceMethod(strMethodName);

    var inheritance = this.getInheritance();
    for (var i = 0; objMethod == null && i < inheritance.length; i++) {
      objMethod = inheritance[i].getInstanceMethod(strMethodName);
    }

    return objMethod;
  };

  Class_prototype._findSuperMethod = function(strMethodName, bExcludeSelf) {
    var objMethod = null;

    // look in self
    if (! bExcludeSelf)
      objMethod = this.getInstanceMethod(strMethodName);

    // look in superclass
    if (objMethod == null && this._super != null)
      objMethod = this._super._findSuperMethod(strMethodName);

    return objMethod;
  };

  Class_prototype._findMixinMethod = function(strMethodName) {
    var objMethod = null;

    for (var i = 0; i < this._implements.length && objMethod == null; i++)
      objMethod = this._implements[i].getInstanceMethod(strMethodName);

    if (objMethod == null && this._super != null)
      objMethod = this._super._findMixinMethod(strMethodName);

    return objMethod;
  };

  Class_prototype._getSuperMethodFor = function(objMethod) {
    var methodName = objMethod.getName();
    var superMethod = this._superMap["m:" + methodName];

    // will be null if already queried and not found, if undefined need to query still
    if (typeof(superMethod) == "undefined") {
      this._superMap["m:" + methodName] = superMethod = this._findSuperMethod(methodName, true);
    }

    return superMethod;
  };

  Class_prototype._getSuperMixinMethodFor = function(objMethod) {
    var methodName = objMethod.getName();
    var superMethod = this._superMixinMap["m:" + methodName];

    // will be null if already queried and not found, if undefined need to query still
    if (typeof(superMethod) == "undefined") {
      this._superMixinMap["m:" + methodName] = superMethod = this._findMixinMethod(methodName);
    }

    return superMethod;
  };

});

// define Object
jsx3.lang.Class.defineClass("jsx3.lang.Object", null, null, function(){});
// define Method
jsx3.lang.Class.defineClass("jsx3.lang.Method", null, null, function(){});

// set up super class of Class
jsx3.lang.Class.jsxclass._super = jsx3.lang.Object.jsxclass;

// @jsxobf-clobber  _before _after _around _name _cond _methodkeys _pc _method

jsx3.Class.defineClass("jsx3.lang.AOP", null, null, function(AOP, AOP_prototype) {

  var IllegalArgumentException = jsx3.IllegalArgumentException;

  AOP._nameToPC = {};

  AOP._methodToPC = {};

  AOP.pc = function(strName, objConditions) {};

  AOP.pcrem = function(strName) {};

  AOP._initMethod = function(objMethod) {};

  AOP._restoreMethod = function(strKey) {};

  AOP.before = function(strPName, fctAdvice, bRemove) {};

  AOP.after = function(strPName, fctAdvice, bRemove) {};

  AOP.around = function(strPName, fctAdvice, bRemove) {};

  AOP._add = function(strPName, fctAdvice, strType) {};

  AOP._remove = function(strPName, fctAdvice, strType) {};

  AOP._newCutPoint = function(strKey) {};

  AOP._cutPoint = function(strKey, objThis, arrArgs) {};

  AOP._cutPointNoAround = function(strKey, objThis, arrArgs, arrPC) {};

  AOP._filterCP = function(objThis, arrPC) {};

  AOP._getAllOf = function(a, f) {};

  AOP._getMethods = function(objConditions) {};

  AOP._getClasses = function(strClasses) {};

  AOP._getMethodsForClass = function(objClass, strMethods) {};

  AOP._getClass = function(strClass) {};

  AOP._AroundStack = function(strKey, arrArounds, objThis, arrArgs) {};

  AOP._AroundStack.prototype._start = function() {};

  AOP._AroundStack.prototype.proceed = function() {};

});

jsx3.Class.defineClass("jsx3.lang.Exception", null, null, function(Exception, Exception_prototype) {

  var Method = jsx3.lang.Method;

  Exception._ALERT_BEFORE_ONERROR = false;

  Exception._LAST_THROWN = null;

  Exception_prototype.init = function(strMessage, objCause) {
    this.msg = strMessage; this.cause = objCause;
  };

  Exception_prototype.toString = function() {
    var s = this.constructor.name + ": " + this.msg + "\n";
    if (this.stack)
      s += this.stack;
    if (this.cause)
      s += "  by: " + this.cause;
    return s;
  };

  Exception_prototype.getMessage = function() {};

  Exception_prototype.getCause = function() {};

  Exception_prototype.getStack = function() {};

  Exception._NOSTACK_METHODS = [

  ];

  Exception.formatStack = function(stack) {

//        if (funct.jsxmethod == Method.getInstanceMethod("apply")) continue; // BUG: not sure why this wasn't working

  };

  Exception_prototype.printStackTrace = function() {};

  Exception_prototype._storeStackTrace = function() {};

});

jsx3.Class.defineClass("jsx3.lang.IllegalArgumentException", jsx3.lang.Exception, null, function(IllegalArgumentException, IllegalArgumentException_prototype) {

  IllegalArgumentException_prototype.init = function(strArg, objValue) {};

});

// @jsxobf-clobber-shared  _stack

jsx3.Class.defineClass("jsx3.lang.NativeError", jsx3.lang.Exception, null, function(NativeError, NativeError_prototype) {

  var Exception = jsx3.Exception;

  NativeError.ALWAYS_ALERT_UNCAUGHT = false;

  NativeError.ALERT_UNCAUGHT = true;

  NativeError.wrap = function(objError) {
    // this branch is IE-specific
    if (objError instanceof Error)
      return new NativeError(objError);
    else if (objError instanceof Exception)
      return objError;
    else
      return new Exception("" + objError);
  };

  NativeError.initErrorCapture = function(fctTrap) {
    window.onerror = arguments.length > 0 ? fctTrap : NativeError.errorTrap;
  };

  NativeError.stopErrorCapture = function(fctTrap) {
    window.onerror = null;
  };

 if (jsx3.CLASS_LOADER.IE) {

  NativeError._UNCAUGHT_MATCH = "thrown and not caught";
 } else {

  NativeError._UNCAUGHT_MATCH = "uncaught exception:";
 }

  NativeError.errorTrap = function(msg, url, line) {
    try {
      if (!NativeError.ALWAYS_ALERT_UNCAUGHT &&
          jsx3.Class.forName("jsx3.util.Logger") != null && jsx3.util.Logger.GLOBAL != null) {
        if (typeof(msg) == "string" && msg.indexOf(NativeError._UNCAUGHT_MATCH) >= 0) {
          if (Exception._LAST_THROWN != null) {
            var stack = jsx3.lang.getStack(0);
            if (stack.length < 2 || stack.contentsEqual(Exception._LAST_THROWN.getStack())) {
              if (stack.length < 2)
                jsx3.util.Logger.GLOBAL.logStack(jsx3.util.Logger.ERROR,
                    jsx3._msg("error.trap", msg, NativeError._convertLineNumber(line), url), 1);
              jsx3.util.Logger.GLOBAL.error(jsx3._msg("error.uncaught"), Exception._LAST_THROWN);
              Exception._LAST_THROWN = true;
              return true;
            }
          }
        }
        // IE interprets line numbers incorrectly (one off)
        jsx3.util.Logger.GLOBAL.logStack(jsx3.util.Logger.ERROR,
            jsx3._msg("error.trap", msg, NativeError._convertLineNumber(line), url), 1);
        return true;
      } else if (NativeError.ALERT_UNCAUGHT) {
        if (typeof(msg) == "string" && msg.indexOf(NativeError._UNCAUGHT_MATCH) >= 0) {
          if (Exception._LAST_THROWN != null) {
            var stack = jsx3.lang.getStack(0);
            if (stack.contentsEqual(Exception._LAST_THROWN.getStack())) {
              window.alert(jsx3._msg("error.uncaught") + "\n" + Exception._LAST_THROWN.printStackTrace());
              return true;
            }
          }
        }

        var stack = jsx3.lang.getStack(0);
        window.alert(jsx3._msg("error.trap", msg, NativeError._convertLineNumber(line), url) +
            "\n" + Exception.formatStack(stack));
        return true;
      } else {
        return false;
      }
    } catch (e) {
      window.alert(jsx3._msg("error.trap_err", NativeError.wrap(e), msg, NativeError._convertLineNumber(line), url));
    }
  };

  NativeError_prototype._error = null;

  NativeError_prototype.init = function(objError) {
    if (!(objError instanceof Error))
      throw new jsx3.IllegalArgumentException("objError", objError);

    this._error = objError;
    this.jsxsuper();
  };

  NativeError_prototype.getMessage = function() {
    return (this._error.message || this._error.toString()).replace(/\s*$/,"");
  };

  NativeError_prototype.getFileName = function() {
 if (jsx3.CLASS_LOADER.SAF) {
    return this._error.sourceURL;
 } else {
    return this._error.fileName;
 }
  };

  NativeError_prototype.getLineNumber = function() {
 if (jsx3.CLASS_LOADER.SAF) {
    return this._error.line;
 } else {
    return NativeError._convertLineNumber(this._error.lineNumber);
 }
  };

  NativeError._convertLineNumber = function(line) {
    if (jsx3.util.numIsNaN(line)) return null;
 if (jsx3.CLASS_LOADER.IE) {
    return line - 1;
 } else {
    return line;
 }
  };

  NativeError_prototype.getName = function() {
    return this._error.name;
  };

  NativeError_prototype.isStructural = function() {
 if (jsx3.CLASS_LOADER.IE) {
    return this._error && (this._error.number & 0xFFFF) == 1009;
 } else {
    return false;
 }
  };

  NativeError_prototype.getType = function() {
    if (this._error instanceof EvalError) return "EvalError";
    if (this._error instanceof RangeError) return "RangeError";
    if (this._error instanceof ReferenceError) return "ReferenceError";
    if (this._error instanceof SyntaxError) return "SyntaxError";
    if (this._error instanceof TypeError) return "TypeError";
    return "Error";
  };

  NativeError_prototype.printStackTrace = function() {
    var s = this.getClass().getName() + ": " + this + "\n" + Exception.formatStack(this._stack);

    if (this._error.stack)
      s += "\n" + this._error.stack;

    if (this._cause != null)
      s += "\nCaused By:\n" + this._cause.printStackTrace();

    return s;
  };

  NativeError_prototype.toString = function() {
    var line = this.getLineNumber();
    var file = this.getFileName();
    var s = this.getMessage();
    if (line || file) {
      s += " (type:" + this.getType() + ", ";
      if (line) s += "line:" + line;
      if (file) {
        if (line) s += ", ";
        s += "file:" + file;
      }
      s += ")";
    }
    return s;
  };

});

// @jsxobf-clobber-shared  _name _class _static _packageDidLoad

jsx3.lang.Package = jsx3.lang.newPrivateConstructor();

jsx3.lang.Class.defineClass("jsx3.lang.Package", null, null, function(Package, Package_prototype) {

  // imports
  var Class = jsx3.lang.Class;
  var Method = jsx3.lang.Method;

  Package._PACKAGES = [];

  Package.definePackage = function(strName, fctBody) {
    var objOwner = Class._getOrCreatePackage(strName.split("."));

    var bRedefinition = false;
    var objPackage = null;
    if (objOwner.jsxpackage != null) {
      if (jsx3.Class.forName("jsx3.util.Logger"))
        jsx3.util.Logger.getLogger("jsx3.lang").info(jsx3._msg("pkg.redefine", strName));

      objPackage = objOwner.jsxpackage;
      bRedefinition = true;
      objPackage._staticFields = [];
      objPackage._staticMethods = [];
    } else {
      objPackage = Class._newInstanceForce(Package);
      objPackage._pname = strName;
      objPackage._staticFields = [];
      objPackage._staticMethods = [];
      objOwner.jsxpackage = objPackage;
    }

    try {
      fctBody(objOwner);
    } catch (e) {
      var ex = jsx3.NativeError.wrap(e);
      throw new jsx3.Exception(jsx3._msg("pkg.def_error", strName, ex), ex);
    }

    // define static methods
    for (var f in objOwner) {
      if (f == "jsxpackage") continue;
      if (typeof(objOwner[f]) == "function") {
        // don't define classes as static methods
        if (objOwner[f].jsxclass == null)
          this._blessMethod(objOwner[f], objPackage, f);
      } else {
        // don't define packages as static fields
        if (objOwner[f] == null || typeof(objOwner[f]) != "object" || objOwner[f].jsxpackage == null)
          objPackage._staticFields.push(f);
      }
    }

    // define no such method catch-all for Mozilla
    if (objOwner.__noSuchMethod__ == null)
      objOwner.__noSuchMethod__ = function(strMethod, args) {
        throw new jsx3.Exception(jsx3._msg("class.nsm", strName + "#" + strMethod + "()"));
      };

    Package._PACKAGES.push(objPackage);

    jsx3.CLASS_LOADER._packageDidLoad(objPackage);
  };

  Package._blessMethod = function(fctMethod, objPackage, strName) {
    if (fctMethod.jsxmethod instanceof Method) {
      // renaming a method in this package is an error
      if (fctMethod.jsxmethod.getDeclaringClass().equals(objPackage) && fctMethod.jsxmethod.getName() != strName) {
        throw new jsx3.Exception(jsx3._msg("class.redef_method", fctMethod.jsxmethod, objPackage + "." + strName));
      } else {
        if (fctMethod.jsxmethod.getDeclaringClass().equals(objPackage) &&
            jsx3.util.arrIndexOf(objPackage._staticMethods, fctMethod.jsxmethod) < 0)
          objPackage._staticMethods.push(fctMethod.jsxmethod);
        return;
      }
    }

    var objMethod = Class._newInstanceForce(Method);
    objMethod._class = objPackage;
    objMethod._name = strName;
    objMethod._static = true;

    fctMethod.jsxmethod = objMethod;

    objPackage._staticMethods.push(objMethod);
  };

  Package.forName = function(strName) {
    var c = jsx3.lang.getVar(strName);
    return c ? c.jsxpackage : null;
  };

  Package.getPackages = function() {
    return Package._PACKAGES.concat();
  };

  Package_prototype._pname = null;

  Package_prototype._owner = null;

  Package_prototype._staticMethods = null;

  Package_prototype._staticFields = null;

  Package_prototype.getName = function() {
    return this._pname;
  };

  Package_prototype.getNamespace = function() {
    if (this._owner != null) return this._owner;
    var c = jsx3.lang.getVar(this._pname);
    return c || null;
  };

  Package_prototype.getClasses = function() {
    var classes = [];
    var owner = this.getNamespace();
    for (var f in owner) {
      if (typeof(owner[f]) == "function" && owner[f].jsxclass instanceof Class) {
        if (owner[f].jsxclass.getPackage() == this &&
            (this.getName() + "." + f) == owner[f].jsxclass.getName()) {
          classes[classes.length] = owner[f].jsxclass;
          classes.push.apply(classes, owner[f].jsxclass.getClasses());
        }
      }
    }
    return classes;
  };

  Package_prototype.getStaticMethods = function() {
    return this._staticMethods.concat();
  };

  Package_prototype.getStaticMethod = function(strMethodName) {
    for (var i = 0; i < this._staticMethods.length; i++) {
      if (strMethodName == this._staticMethods[i].getName())
        return this._staticMethods[i];
    }
    return null;
  };

  Package_prototype.getStaticFieldNames = function() {
    return this._staticFields.concat();
  };

  Package_prototype.toString = function() {
    return this._pname;
  };

});

// @jsxobf-clobber  _jsxshaking

jsx3.Package.definePackage("jsx3", function() {

  jsx3.ADDINSPATH = "JSX/addins/";

  jsx3.getXmlVersion = function() {
    return 6;
  };

  jsx3.DESERIALIZE = "JSX30DESERIALIZE";

  jsx3.INITIALIZE = "JSX30INITIALIZE";

  // See: http://bugs.webkit.org/show_bug.cgi?id=15631
 if (jsx3.CLASS_LOADER.SAF) {
  jsx3.LOG10E = 0.4342944819032518;
 } else {
  jsx3.LOG10E = Math.LOG10E;
 }

  jsx3.STARTUP_EVENT = null;

  jsx3.CACHE = null;

  jsx3.EVENT = null;

  jsx3.getSharedCache = function() {
    if (jsx3.CACHE == null) jsx3.CACHE = new jsx3.app.Cache();
    return jsx3.CACHE;
  };

  jsx3.getSystemCache = function() {
    if (jsx3._SYSCACHE == null)

      jsx3._SYSCACHE = new jsx3.app.Cache();
    return jsx3._SYSCACHE;
  };

  jsx3.eval = function(strScript, objContext) {
    // name of parameter will be obfuscated so ...
    if (strScript != null && strScript !== "") {
      var vars = "";
      if (objContext) {

        var _ec = objContext;
        var a = [];

        for (var f in _ec)
          a[a.length] = "var " + f + " = _ec." + f + ";";

        vars = a.join("");
      }
      return eval(vars + strScript);
    }
  };

  jsx3.resolveURI = function(strURI) {
    return jsx3.net.URIResolver.DEFAULT.resolveURI(strURI).toString();
  };

  jsx3.makeCallback = function(fctBody, objThis, varArgs) {
    var argsAsArray = jsx3.Method.argsAsArray;
    var args = argsAsArray(arguments, 2);

    if (typeof(fctBody) == "string")
      fctBody = objThis[fctBody];

    return function() {
      var myArgs = arguments;
      // make arguments to this function available
      var a = myArgs.length > 0 ? args.concat(argsAsArray(myArgs)) : args;
      return fctBody.apply(objThis, a);
    };
  };

  jsx3.clone = function(obj) {
    if (typeof(obj) != "object") return obj;

    var c = {};
    for (var f in obj)
      c[f] = obj[f];
    return c;
  };

  jsx3._REQUIRE_MAP = {};
  jsx3._REQUIRE_MAP["jsx3.gui.MatrixColumn"] = "jsx3.gui.Matrix.Column"; // DEPRECATED: only way to make bridge work with lazy loading

  jsx3.require = function(strClass) {
    for (var i = 0; i < arguments.length; i++) {
      var className = arguments[i];

      className = jsx3._REQUIRE_MAP[className] || className;

      if (jsx3.Class.forName(className) == null)
        jsx3.CLASS_LOADER.loadClass(className);
    }
  };

  jsx3._SLEEP_QUEUE = [];

  jsx3._SLEEP_MAP = [];

  jsx3._SLEEP_TO = null;

  jsx3.sleep = function(objFunction, strId, objThis, bClobber) {
    if (strId && jsx3._SLEEP_MAP[strId]) {
      if (bClobber)
        jsx3._SLEEP_MAP[strId][0] = null;
      else
        return;
    }

    var record = [objFunction, strId, objThis];
    var queue = jsx3._SLEEP_QUEUE;

    queue[queue.length] = record;
    jsx3._SLEEP_MAP[strId] = record;

    if (jsx3._SLEEP_TO == null)
      jsx3._SLEEP_TO = window.setTimeout(jsx3._sleepChunk, 0);
  };

  jsx3.QUEUE_DONE = "queueDone";

  jsx3._sleepChunk = function() {

    jsx3.util.WeakMap.expire();

    jsx3.tcf(function() {
      var q = jsx3._SLEEP_QUEUE;
      jsx3._SLEEP_QUEUE = [];

      for (var i = 0; i < q.length; i++) {
        var record = q[i];

        var objFunction = record[0];
        if (!objFunction) continue; // necessary because of clobber option in sleep()
        var strId = record[1];
        var objThis = record[2];

        delete jsx3._SLEEP_MAP[strId];

        objFunction.apply(objThis);
      }
    }, null, function() {
      if (jsx3._SLEEP_QUEUE.length > 0)
        jsx3._SLEEP_TO = window.setTimeout(jsx3._sleepChunk, 0);
      else {
        jsx3._SLEEP_TO = null;
        jsx3.publish({subject:jsx3.QUEUE_DONE});
      }
    });
  };

  jsx3.startup = function() {
    if (window.OpenAjax) {
      try {
        OpenAjax.hub.registerLibrary("gi", "http://www.tibco.com/gi", jsx3.getVersion());
      } catch (e) {
        var l = jsx3.util.Logger;
        if (l) l.GLOBAL.error(jsx3._msg("boot.oah"), jsx3.NativeError.wrap(e));
      }
    }
  };

  jsx3.destroy = function() {
    if (jsx3.app && jsx3.app.Server) {
      var servers = jsx3.app.Server.allServers();
      for (var i = 0; i < servers.length; i++) {
        try {
          servers[i].destroy();
        } catch (e) {
          ;
        }
      }
    }

    if (jsx3.gui && jsx3.gui.Event) {
      var eTypes = ("BEFOREUNLOAD BLUR CHANGE CLICK DOUBLECLICK ERROR FOCUS KEYDOWN KEYPRESS KEYUP LOAD MOUSEDOWN " +
                    "MOUSEMOVE MOUSEOUT MOUSEOVER MOUSEUP MOUSEWHEEL UNLOAD RESIZE").split(/\s+/);
      for (var i = 0; i < eTypes.length; i++)
        jsx3.gui.Event.unsubscribeAll(jsx3.gui.Event[eTypes[i]]);
    }

    jsx3.NativeError.stopErrorCapture();

    var allScripts = document.getElementsByTagName("script");
    for (var i = 0; i < allScripts.length; i++) {
      var oneScript = allScripts.item(i);
      oneScript.parentNode.removeChild(oneScript);
    }

 if (jsx3.CLASS_LOADER.IE) {

//    window.alert("destroy " + window + " " + window.top + " " + (window == window.top) + " " + jsx3.gui.Event.wrap(window.event));

    if (window != window.top ||
        (window.event.clientX < -1 * window.screen.width && window.event.clientY < -1 * window.screen.height)) {
      // This helps IE to clean up memory in the same IE process. Without this call an IE process that spawns a
      // GI page over and over will use more and more memory.
//      window.document.write('');
//      if (window.opener && window.opener.jsx3)
//        window.opener.jsx3.log("closing window " + window.location);
    } else {
//      if (window.opener && window.opener.jsx3)
//        window.opener.jsx3.log("reloading window " + window.location);
    }
 }

    jsx3.CLASS_LOADER.destroy();

    window.jsx3 = null;
  };

  // DEPRECATED: remove in next version

  jsx3.getClass = function(strClassName) {
    try {
      var c = eval(strClassName);
      return typeof(c) == "function" ? c : null;
    } catch (e) {
      return null;
    }
  };

  jsx3.getClassPrototype = function(strClassName) {
    try {
      var p = eval(strClassName + ".prototype");
      return (typeof(p) == "object" && typeof(p.constructor) == "function") ? p : null;
    } catch (e) {
      return null;
    }
  };

  jsx3.getClassConstants = function(strClassName) {
    var o = jsx3.getClass(strClassName);
    if (o != null) {
      var a = [];
      for (var p in o) {
        if (p.toUpperCase() == p) a[a.length] = strClassName + "." + p;
      }
      return a;
    }
  };

  jsx3.getInstanceMethods = function(strClassName) {
    var o = jsx3.getClassPrototype(strClassName);
    var a = [];
    for (var p in o) {
      if (typeof(o[p]) == "function") {
        var t = o[p].toString();
        a[a.length] = t.substring(9,t.indexOf(')')+1);
      }
    }
    return a;
  };

  jsx3.getClassMethods = function(strClassName) {
    var o = jsx3.getClass(strClassName);
    var s = "";
    for (var p in o) {
      if (typeof(o[p]) == "function") {
        var t = o[p].toString();
        s+= p + t.substring(8,t.indexOf(')')+1) + '\n';
      }
    }
    return s;
  };

  jsx3.doInherit = function(subClass, superClass,bImplement) {
    var objClass = jsx3.getClass(subClass);
    var objSuper = jsx3.getClass(superClass);

    if (objSuper == null) {
      jsx3.util.Logger.doLog("INHR01","Super class '" + superClass + "' of '" + subClass +
          "' not properly defined", 1, false);
      return;
    }

    if (objClass.isInherited == null || (bImplement != null && bImplement)) {
      if (!bImplement) {
        objClass.SUPER = superClass;
        objClass.SUPERS = {};
        for (var p in objSuper.SUPERS) {
          objClass.SUPERS[p] = objSuper.SUPERS[p];
          objClass.SUPERS[subClass] = 1;
        }
      }
      objClass.className = subClass;

      // keep track of the order in which to seach classes for overridden members
      if (objClass.INHERITANCE == null) objClass.INHERITANCE = [subClass];
      if (objSuper.INHERITANCE)
        for (var i = objSuper.INHERITANCE.length - 1; i >= 0; i--)
          objClass.INHERITANCE.splice(1, 0, objSuper.INHERITANCE[i]);
      else
        objClass.INHERITANCE.splice(1, 0, superClass);

      if (objClass.INTERFACES == null) objClass.INTERFACES = {};
      if (objSuper.INTERFACES) {
        for (var p in objSuper.INTERFACES) objClass.INTERFACES[p] = objSuper.INTERFACES[p];
      } else {
        objClass.INTERFACES[superClass] = "1";
      }
      objClass.INTERFACES[subClass] = "1";

      if (!(bImplement != null && bImplement)) objClass.isInherited = true;
      var objParentPrototype = jsx3.getClassPrototype(superClass);

      var objChildPrototype = jsx3.getClassPrototype(subClass);
      for (var p in objParentPrototype) {
        if (typeof(objChildPrototype[p]) != "function") {
          objChildPrototype[p] = objParentPrototype[p];
        }
      }
    }
  };

  jsx3.doImplement = function(subClass, superClass) {
    jsx3.doInherit(subClass, superClass,true);
  };

  jsx3.doMixin = function(objInstance, strClassName) {
    var objClass = jsx3.getClassPrototype(strClassName);
    for (var f in objClass) {
      if (typeof(objClass[f]) == 'function') objInstance[f] = objClass[f];
    }
  };

  jsx3.doDefine = function(strClassName, anonymousFunction) {
    var objClass = jsx3.getClass(strClassName);
    if (objClass.isDefined == null) {
      objClass.isDefined = true;
      anonymousFunction();
    }
  };

  jsx3.out = function(strErrorNumber, strMessage, PRIORITY, bTrace) {
    if (jsx3.Class.forName("jsx3.util.Logger"))
      jsx3.util.Logger.doLog(strErrorNumber, strMessage, PRIORITY, bTrace);
  };

  window.doInherit = jsx3.doInherit;
  window.doImplement = jsx3.doImplement;
  window.doMixin = jsx3.doMixin;
  window.doDefine = jsx3.doDefine;

  jsx3.log = function(strMessage) {
    if (jsx3.Class.forName("jsx3.util.Logger") && jsx3.util.Logger.GLOBAL) {
      // check for cached messages
      if (jsx3._logcache) {
        for (var i = 0; i < jsx3._logcache.length; i++)
          jsx3.util.Logger.GLOBAL.info(jsx3._logcache[i]);
        delete jsx3._logcache;
      }
      jsx3.util.Logger.GLOBAL.info(strMessage);
    } else {
      var cache = jsx3._logcache;
      if (!cache)

        jsx3._logcache = cache = [];
      cache[cache.length] = strMessage;
    }
  };

});

jsx3.Package.definePackage("jsx3.app", function(){

});

jsx3.Boolean = {};

jsx3.Boolean.TRUE = 1;

jsx3.Boolean.FALSE = 0;

jsx3.Boolean.valueOf = function(v) {
  return v ? jsx3.Boolean.TRUE : jsx3.Boolean.FALSE;
};

jsx3.Package.definePackage("jsx3.gui", function(gui){

  gui.shakeStyles = function(objGUI, styleProps) {
    var args = [];
    for (var i = 0; i < arguments.length - 1; i+=2) {
      objGUI = arguments[i];

      if (objGUI._jsxshaking) continue;
      objGUI._jsxshaking = true;

      styleProps = arguments[i+1];
      var origProps = {};
      for (var f in styleProps) {
        origProps[f] = f == 'className' ? objGUI.className : objGUI.style[f];
      }

      args.push(objGUI, origProps, styleProps);
    }

    gui._shakeStyles(args, 0, 6);
  };

  gui._shakeStyles = function(args, thisTime, maxTimes) {
    if (thisTime == maxTimes) {
      for (var i = 0; i < args.length - 2; i+=3) {
        var objGUI = args[i];
        objGUI._jsxshaking = null;
      }
      return;
    }

    for (var i = 0; i < args.length - 2; i+=3) {
      var objGUI = args[i];
      var styleProps = (thisTime % 2 == 0) ? args[i+2] : args[i+1];

      for (var f in styleProps) {
        if (f == 'className')
          objGUI.className = styleProps[f];
        else
          objGUI.style[f] = styleProps[f];
      }
    }

    window.setTimeout(function() {gui._shakeStyles(args, thisTime+1, maxTimes);}, 75);
  };

  gui.isMouseEventModKey = function(objEvent) {
    if (jsx3.app.Browser.macosx)
      return objEvent.metaKey();
    else
      return objEvent.ctrlKey();
  };

});

jsx3.Package.definePackage("jsx3.lang", function(lang){

});

jsx3.Package.definePackage("jsx3.net", function(net){

});

jsx3.Class.defineInterface("jsx3.net.URIResolver", null, function(URIResolver, URIResolver_prototype) {

  URIResolver._SCHEME_REG = {};

  URIResolver.register = function(strScheme, objResolver) {
    URIResolver._SCHEME_REG[strScheme] = objResolver;
  };

  URIResolver._getAbsPathUri = function() {
    if (this._ABS_PATH_URI == null)

      this._ABS_PATH_URI = new jsx3.net.URI(jsx3.getEnv("jsxabspath"));
    return this._ABS_PATH_URI;
  };

  URIResolver._getHomePathUri = function() {
    var env = jsx3.getEnv("jsxhomepath");
    if (env == null) {
      // If we are running under Builder, and a jsxuser: URI is resolved before the project server loads,
      // then the URI will be resolved against the GI installation directory.
      return new jsx3.net.URI(jsx3.getEnv("jsxscriptapppath"));
    }

    if (this._HOME_PATH_URI == null)

      this._HOME_PATH_URI = new jsx3.net.URI(env);
    return this._HOME_PATH_URI;
  };

  URIResolver.DEFAULT = URIResolver.jsxclass.newInnerClass();

  URIResolver.DEFAULT.resolveURI = function(strURI) {
    var uri = jsx3.net.URI.valueOf(strURI);
    var scheme = uri.getScheme();
    var path = uri.getPath();
    var resolver = URIResolver.getResolver(uri);

    var resolved = uri;

    if (resolver && resolver != URIResolver.DEFAULT) {
      if (uri.isAbsolute())
        uri = jsx3.net.URI.fromParts(null, null, null, null, path.substring(1), uri.getQuery(), uri.getFragment());
      resolved = resolver.resolveURI(uri);
    } else if (resolver) {
      resolved = URIResolver._getAbsPathUri().resolve(uri);
    } else if (!scheme && path.indexOf("..") >= 0) {
      var loc = jsx3.app.Browser.getLocation();
      resolved = loc.relativize(loc.resolve(uri));
    }

    return resolved;
  };

  URIResolver.DEFAULT.getUriPrefix = function() {
    return URIResolver._getAbsPathUri().toString();
  };

  URIResolver.DEFAULT.relativizeURI = function(strURI, bRel) {
    return jsx3.net.URI.valueOf(strURI);
  };

  URIResolver.JSX = URIResolver.jsxclass.newInnerClass();
  URIResolver.register("jsx", URIResolver.JSX);

  URIResolver.JSX.getURI = function() {
    if (this._uri == null)
      this._uri = URIResolver._getAbsPathUri().resolve(jsx3.SYSTEM_ROOT + "/");
    return this._uri;
  };

  URIResolver.JSX.resolveURI = function(strURI) {
    var uri = jsx3.net.URI.valueOf(strURI);

    if (!URIResolver.isAbsoluteURI(uri))
      uri = this.getURI().resolve(uri);

    return URIResolver.DEFAULT.resolveURI(uri);
  };

  URIResolver.JSX.getUriPrefix = function() {
    return URIResolver._getAbsPathUri() + jsx3.SYSTEM_ROOT + "/";
  };

  URIResolver.JSX.relativizeURI = function(strURI, bRel) {
    var relative = this.getURI().relativize(strURI);
    if (relative.isAbsolute() || bRel)
      return relative;
    else
      return jsx3.net.URI.fromParts("jsx", null, null, null,
          "/" + relative.getPath(), relative.getQuery(), relative.getFragment());
  };

  URIResolver.USER = URIResolver.jsxclass.newInnerClass();
  URIResolver.register("jsxuser", URIResolver.USER);

  URIResolver.USER.resolveURI = function(strURI) {
    var uri = jsx3.net.URI.valueOf(strURI);

    if (uri.getPath().indexOf(jsx3.APP_DIR_NAME + "/") == 0 || !URIResolver.isAbsoluteURI(uri))
      return URIResolver._getHomePathUri().resolve(uri);

    return URIResolver.DEFAULT.resolveURI(uri);
  };

  URIResolver.USER.getUriPrefix = function() {
    return URIResolver._getHomePathUri().toString();
  };

  URIResolver.USER.relativizeURI = function(strURI, bRel) {
    var relative = URIResolver._getHomePathUri().relativize(strURI);
    if (relative.isAbsolute() || bRel)
      return relative;
    else
      return jsx3.net.URI.fromParts("jsxuser", null, null, null,
          "/" + relative.getPath(), relative.getQuery(), relative.getFragment());
  };

  URIResolver.isAbsoluteURI = function(strURI) {
    var uri = jsx3.net.URI.valueOf(strURI);
    if (uri.getScheme() != null) return true;
    var path = uri.getPath();
    return path.indexOf("/") == 0 ||
           path.indexOf(jsx3.SYSTEM_ROOT + "/") == 0 ||
           path.indexOf(jsx3.APP_DIR_NAME + "/") == 0 ||
           path.indexOf("GI_Builder/") == 0;
  };

  URIResolver.getResolver = function(strURI) {
    var uri = jsx3.net.URI.valueOf(strURI);
    var scheme = uri.getScheme();
    var resolver = null;

    if (scheme) {
      resolver = URIResolver._SCHEME_REG[scheme];

      if (typeof(resolver) == "function")
        resolver = resolver(uri);
    } else {
      var path = uri.getPath();

      if (path.indexOf(jsx3.SYSTEM_ROOT + "/") == 0) {
        resolver = URIResolver.DEFAULT;
      } else if (path.indexOf(jsx3.APP_DIR_NAME + "/") == 0) {
        resolver = URIResolver.USER;
      } else if (path.indexOf("GI_Builder/") == 0) {
        resolver = URIResolver.DEFAULT;
      }
    }

    return resolver;
  };

  URIResolver_prototype.resolveURI = jsx3.Method.newAbstract("strURI");

  URIResolver_prototype.getUriPrefix = jsx3.Method.newAbstract();

  URIResolver_prototype.relativizeURI = jsx3.Method.newAbstract("strURI", "bRel");

});

jsx3.Package.definePackage("jsx3.xml", function(xml){

});

jsx3.Package.definePackage("jsx3.util", function(util) {

  util.compareVersions = function(v1, v2) {
    var regex = /^(\d+)?([a-zA-Z_]\w*)?$/;

    var v1t = v1.split(/\./);
    var v2t = v2.split(/\./);
    var maxLength = Math.max(v1t.length, v2t.length);

    var ad, al, bd, bl;

    for (var i = 0; i < maxLength; i++) {
      if (v1t.length > i && regex.test(v1t[i])) {
        ad = parseInt(RegExp.$1) || Number(0);
        al = RegExp.$2;
      } else {
        ad = 0;
        al = "";
      }

      if (v2t.length > i && regex.test(v2t[i])) {
        bd = parseInt(RegExp.$1) || Number(0);
        bl = RegExp.$2;
      } else {
        bd = 0;
        bl = "";
      }

      if (ad > bd) return 1;
      if (ad < bd) return -1;
      if (al > bl) return 1;
      if (al < bl) return -1;
    }

    return 0;
  };

  util.numMod = function(v, mod) {
    var result = v % mod;
    return result < 0 ? result + mod : result;
  };

  util.numIsNaN = function(v) {
    return v == null || v === "" || isNaN(v);
  };

  util.numRound = function(v, intUnit) {
    return Math.round(v/intUnit) * intUnit;
  };

  util.strEmpty = function(s) {
    return s == null || s === "";
  };

  util._jsxescapemap = {};
  util._jsxescapemap['\b'] = '\\b';
  util._jsxescapemap['\t'] = '\\t';
  util._jsxescapemap['\n'] = '\\n';
  util._jsxescapemap['\f'] = '\\f';
  util._jsxescapemap['\r'] = '\\r';
  util._jsxescapemap['"'] = '\\"';
  util._jsxescapemap['\\'] = '\\\\';

  util.strEscapeJSON = function (str) {
    if (/["\\\x00-\x1f]/.test(str)) {
      return '"' + str.replace(/[\x00-\x1f\\"]/g, function (a) {
        var c = util._jsxescapemap[a];
        if (c)
          return c;
        c = a.charCodeAt();
        return '\\u00' + Math.floor(c / 16).toString(16) + (c % 16).toString(16);
      }) + '"';
    }
    return '"' + str + '"';
  };

  util.arrIndexOf = function(a, o) {
    for (var i = 0; i < a.length; i++)
      if (a[i] === o) return i;
    return -1;
  };

  util._TRIM_REGEX = /(^\s*)|(\s*$)/g;

  util.strTrim = function(s) {
    return s.replace(util._TRIM_REGEX, "");
  };

  util.strEscapeHTML = function(s) {
    return String(s).replace(/&/g,"&amp;").replace(/</g,"&lt;").replace(/>/g,"&gt;").replace(/"/g,"&quot;").replace(
        // NOTE: the XML spec would be [^\x09\x0A\x0D\x20-\xD7FF\xE000-\xFFFD\x10000-\x10FFFF] but Firefox won't
        // compile that regex, see http://www.w3.org/TR/REC-xml/
        /[^\x09\x0A\x0D\x20-\x7F]/g,
        function(m) {
          var c = m.charCodeAt(0);
          if (c < 0x20 || (c > 0xD7FF && c < 0xE000) || (c > 0xFFFD && c < 0x10000) || c > 0x10FFFF)
            return "\\u" + c.toString(16);
          else
            return m;
        } );
  };

  util.strTruncate = function(s, intMax, strEllipsis, fltPos) {
    if (strEllipsis == null) strEllipsis = "...";
    if (fltPos == null) fltPos = 1.0;

    if (s.length > intMax && strEllipsis.length < intMax) {
      var l = intMax - strEllipsis.length;
      var beforeLength = Math.round(l * fltPos);
      var before = s.substring(0, beforeLength);
      var after = s.substring(s.length - (l - beforeLength));
      return before + strEllipsis + after;
    } else {
      return s;
    }
  };

  util.strEndsWith = function(s, strTest) {
    var index = s.lastIndexOf(strTest);
    return index >= 0 && index == s.length - strTest.length;
  };

  util._BASE64S = "ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz0123456789+/";

  util.strEncodeBase64 = function(s) {
    var base64s = util._BASE64S;
    var buffer = new Array(Math.ceil(s.length * 4 / 3));

    var i = 0, c = 0, length = s.length;
    for (; i <= length - 3; i += 3) {
      var bits = (s.charCodeAt(i)   & 0xff) << 16 |
                 (s.charCodeAt(i+1) & 0xff) << 8  |
                 (s.charCodeAt(i+2) & 0xff);

      buffer[c++] = base64s.charAt((bits & 0xfc0000) >> 18);
      buffer[c++] = base64s.charAt((bits & 0x03f000) >> 12);
      buffer[c++] = base64s.charAt((bits & 0x000fc0) >> 6);
      buffer[c++] = base64s.charAt((bits & 0x00003f));
    }

    if (i < length) {
      var dual = i < length - 1;

      var bits = (s.charCodeAt(i) & 0xff) << 16;
      if (dual)
        bits |= (s.charCodeAt(i+1) & 0xff) << 8;

      buffer[c++] =   base64s.charAt((bits & 0xfc0000) >> 18);
      buffer[c++] =   base64s.charAt((bits & 0x03f000) >> 12);
      if (dual)
        buffer[c++] = base64s.charAt((bits & 0x000fc0) >> 6);
      else
        buffer[c++] = "=";
      buffer[c++] = "=";
    }

    return buffer.join("");
  };

  util.strDecodeBase64 = function(s) {
    var base64s = util._BASE64S;
    var buffer = new Array(Math.ceil(s.length / 4));

    //declare variables
    var i = 0, c = 0, length = s.length;
    for (; i < length; i += 4) {
      var bits = (base64s.indexOf(s.charAt(i))   & 0xff) << 18 |
                 (base64s.indexOf(s.charAt(i+1)) & 0xff) << 12 |
                 (base64s.indexOf(s.charAt(i+2)) & 0xff) <<  6 |
                 (base64s.indexOf(s.charAt(i+3)) & 0xff);

      buffer[c++] = String.fromCharCode((bits & 0xff0000) >> 16, (bits & 0xff00) >> 8, bits & 0xff);
    }

    if (s.charCodeAt(i-2) == 61)
      buffer[c-1] = buffer[c-1].substring(0,1);
    else if (s.charCodeAt(i-1) == 61)
      buffer[c-1] = buffer[c-1].substring(0,2);

    return buffer.join("");
  };

});

jsx3.Class.defineClass("jsx3.util.Timer", null, null, function(Timer, Timer_prototype) {

  Timer._LISTENERS = [];

  Timer.listen = function() {
    var l = [];
    Timer._LISTENERS.push(l);
    return l;
  };

  Timer.ignore = function(arrStats) {
    var i = jsx3.util.arrIndexOf(Timer._LISTENERS, arrStats);
    Timer._LISTENERS.splice(i, 1);
  };

  Timer._record = function(objTimer, strMessage, intMS) {
    var l = Timer._LISTENERS;
    if (l.length > 0) {
      var o = {topic:objTimer._topic, subtopic:objTimer._message, message:strMessage, ms:intMS};
      for (var i = 0; i < l.length; i++) {
        l[i].push(o);
      }
    }
  };

  Timer_prototype.init = function(strTopic, strSubtopic, intLevel) {

    this._t1 = new Date();

    this._topic = String(strTopic);

    this._message = String(strSubtopic);

    this._level = intLevel || 4; // default is INFO
  };

  Timer_prototype.log = function(strMessage) {
    var t2 = new Date();
    if (! this._logger) {
      if (jsx3.util.Logger)

        this._logger = jsx3.util.Logger.getLogger("bench." + this._topic);
    }

    var timeTaken = t2 - this._t1;
    if (this._logger && this._logger.isLoggable(this._level))
      this._logger.log(this._level,
          (this._message ? this._message  + " : " : "") + (strMessage ? strMessage + " : ": "") + timeTaken + "ms");

    Timer._record(this, strMessage, timeTaken);
    this._t1 = t2;
  };

});

jsx3.Class.defineClass("jsx3.util.WeakMap", null, null, function(WeakMap, WeakMap_prototype) {

  WeakMap._SERIAL = 0;

  WeakMap._ALL = {};

  WeakMap._TO = null;

  WeakMap.expire = function() {
    window.clearTimeout(WeakMap._TO);
    WeakMap._TO = null;
    for (var f in WeakMap._ALL) {
      var m = WeakMap._ALL[f];
      if (m._dirty) m._map = {};
    }
  };

  WeakMap_prototype.init = function() {

    this._serial = WeakMap._SERIAL++;

    this._map = {};

    this._dirty = false;

    WeakMap._ALL[this._serial] = this;
  };

  WeakMap_prototype.get = function(strKey) {
    return this._map[strKey];
  };

  WeakMap_prototype.set = function(strKey, strValue) {
    this._map[strKey] = strValue;
    this._dirty = true;
    if (! WeakMap._TO)
      WeakMap._TO = window.setTimeout(WeakMap.expire, 0);
  };

  WeakMap_prototype.destroy = function(strKey, strValue) {
    delete this._map;
    delete WeakMap._ALL[this._serial];
  };

});

jsx3.Class.defineClass('jsx3.util.List', null, null, function(List, List_prototype) {

  List.wrap = function(a) {
    if (a instanceof List) {
      return a;
    } else if (a instanceof Array) {
      return new List(a, true);
    } else {
      throw new jsx3.IllegalArgumentException("a", a);
    }
  };

  List_prototype.init = function(a, bLive) {
    if (typeof(a) == "number") {
      this._src = new Array(a);
    } else if (a instanceof List) {
      this._src = a._src.concat();
    } else {
      a = List._convertArrayLikeToArray(a);
      if (a instanceof Array) {
        this._src = bLive ? a : a.concat();
      } else {

        this._src = [];
      }
    }

    this._iterator = -1;

  };

  List_prototype.size = function() {
    return this._src.length;
  };

  List_prototype.get = function(intIndex) {
    return this._src[intIndex];
  };

  List_prototype.set = function(intIndex, objElm) {
    this._src[intIndex] = objElm;
  };

  List_prototype.iterator = function() {
    return new List.Iterator(this);
  };

  List_prototype.clear = function() {
    this._src.splice(0, this._src.length);
  };

  List_prototype.indexOf = function(objElm, intStartAt) {
    if (intStartAt == null) intStartAt = 0;
    var size = this.size();
    for (var i = intStartAt; i < size; i++) {
      if (this.get(i) === objElm)
        return i;
    }
    return -1;
  };

  List_prototype.lastIndexOf = function(objElm, intStartAt) {
    if (intStartAt == null) intStartAt = this.size() - 1;
    for (var i = intStartAt; i >= 0; i--) {
      if (this.get(i) === objElm)
        return i;
    }
    return -1;
  };

  List_prototype.contains = function(objElm) {
    return this.indexOf(objElm) >= 0;
  };

  List_prototype.remove = function(objElm) {
    var index = this.indexOf(objElm);
    if (index >= 0)
      return this._src.splice(index, 1)[0];
    return null;
  };

  List_prototype.removeAt = function(intStart, intEnd) {
    if (arguments.length == 2) {
      return List.wrap(this._src.splice(intStart, (intEnd - intStart)));
    } else {
      return this._src.splice(intStart, 1)[0];
    }
  };

  List_prototype.clone = function() {
    return new List(this);
  };

  List_prototype.add = function(objElm, intAt) {
    var src = this._src;
    if (intAt == null)
      src[src.length] = objElm;
    else
      src.splice(intAt, 0, objElm);
  };

  List_prototype.addAll = function(a, intAt) {
    if (a instanceof List)
      a = a.toArray(true);
    else
      a = List._convertArrayLikeToArray(a);

    if (a instanceof Array) {
      if (intAt == null)
        this._src.push.apply(this._src, a);
      else
        this._src = this._src.slice(0, intAt).concat(a, this._src.slice(intAt));
    } else {
      throw new jsx3.IllegalArgumentException("a", a);
    }
  };

  List._convertArrayLikeToArray = function(a) {
    if (a == null || a instanceof Array) {
      return a;
    } else if (typeof(a.length) == "number") {
      var c = new Array(a.length);
      for (var i = 0; i < a.length; i++)
        c[i] = a[i];
      return c;
    } else {
      return a;
    }
  };

  List_prototype.slice = function(intStart, intEnd) {
    // NOTE: Fx and IE behave differently even if null is sent as the second parameter
    return List.wrap(arguments.length > 1 ? this._src.slice(intStart, intEnd) : this._src.slice(intStart));
  };

  List_prototype.sort = function(fctComparator) {
    // NOTE: Fx and IE behave differently even if null is sent as the first parameter
    if (fctComparator) this._src.sort(fctComparator);
    else this._src.sort();
  };

  List_prototype.toArray = function(bLive) {
    return bLive ? this._src : this._src.concat();
  };

  List_prototype.equals = function(l) {
    if (this === l) return true;
    if (!(l instanceof List)) return false;
    var size = this.size();
    if (size != l.size()) return false;
    for (var i = 0; i < size; i++) {
      if (this.get(i) !== l.get(i)) return false;
    }
    return true;
  };

  List_prototype.filter = function(fctFilter) {
    var filtered = [];
    var size = this.size();
    for (var i = 0; i < size; i++) {
      var item = this.get(i);
      if (fctFilter(item))
        filtered[filtered.length] = item;
    }
    return List.wrap(filtered);
  };

  List_prototype.map = function(fctMapper, bExpand, bObject) {
    var size = this.size();
    if (bExpand) {
      if (bObject) {
        var mapped = {};
        for (var i = 0; i < size; i++) {
          var pairs = fctMapper(this.get(i));
          for (var j = 0; j < pairs.length; j+=2)
            mapped[pairs[j]] = pairs[j+1];
        }
        return mapped;
      } else {
        var mapped = [];
        for (var i = 0; i < size; i++) {
          var val = fctMapper(this.get(i));
          if (val instanceof Array)
            mapped.push.apply(mapped, val);
          else
            mapped[mapped.length] = val;
        }
        return List.wrap(mapped);
      }
    } else {
      if (bObject) {
        var mapped = {};
        for (var i = 0; i < size; i++) {
          var pair = fctMapper(this.get(i));
          mapped[pair[0]] = pair[1];
        }
        return mapped;
      } else {
        var mapped = new Array(size);
        for (var i = 0; i < size; i++)
          mapped[i] = fctMapper(this.get(i));
        return List.wrap(mapped);
      }
    }
  };

  List_prototype.toString = function() {
    return "[" + this._src + "]";
  };

  List_prototype.reset = function() {
    this._iterator = -1;
    return this;
  };

  List_prototype.next = function() {
    return this.get(++this._iterator);
  };

  List_prototype.move = function(intIndex) {
    this._iterator = intIndex;
    return this;
  };

  List_prototype.hasNext = function() {
    return this._iterator < (this.size() - 1);
  };

  List_prototype.getIndex = function() {
    return this._iterator;
  };

  List_prototype.getItem = function(intIndex) {
    return this.get(intIndex);
  };

  List_prototype.getLength = function() {
    return this.size();
  };

});

jsx3.Class.defineInterface('jsx3.util.Iterator', null, function(Iterator, Iterator_prototype) {

  Iterator_prototype.next = jsx3.Method.newAbstract();

  Iterator_prototype.hasNext = jsx3.Method.newAbstract();

  Iterator_prototype.remove = jsx3.Method.newAbstract();

});

// @jsxobf-clobber-shared  _list _index _size

jsx3.Class.defineClass('jsx3.util.List.Iterator', null, [jsx3.util.Iterator], function(Iterator, Iterator_prototype) {

  Iterator_prototype.init = function(objList) {
    this._list = objList;
    this._size = objList ? objList.size() : 0;
    this._index = 0;
  };

  Iterator_prototype.next = function() {
    return this._list.get(this._index++);
  };

  Iterator_prototype.hasNext = function() {
    return this._index < this._size;
  };

  Iterator_prototype.remove = function() {
    if (this._index > 0) {
      this._list.removeAt(--this._index);
      this._size--;
    }
  };

});

jsx3.Class.defineClass("jsx3.app.AddIn", null, [jsx3.net.URIResolver], function(AddIn, AddIn_prototype) {

  var URIResolver = jsx3.net.URIResolver;

  AddIn.PROTOTYPES_DIR = "prototypes/";

  AddIn_prototype.init = function(strKey) {

    this._key = strKey;

    this._path = strKey.indexOf("user:") == 0 ?
                 jsx3.resolveURI("jsxuser:/addins/" + strKey.substring(5) + "/") :
                 jsx3.resolveURI(jsx3.ADDINSPATH + strKey + "/");

    this._uri = new jsx3.net.URI(this._path);

    this._uriabs = jsx3.app.Browser.getLocation().resolve(this._uri);

    this._settings = null;
  };

  AddIn_prototype.getId = function() {
    return this.getSettings().get("id");
  };

  AddIn_prototype.getName = function() {
    return this.getSettings().get("name");
  };

  AddIn_prototype.getDescription = function() {
    return this.getSettings().get("description");
  };

  AddIn_prototype.getVersion = function() {
    return this.getSettings().get("version");
  };

  AddIn_prototype.getJsxVersion = function() {
    return this.getSettings().get("jsxversion") || "3.1";
  };

  AddIn_prototype.getKey = function() {
    return this._key;
  };

  AddIn_prototype.getPath = function() {
    return this._path;
  };

  AddIn_prototype.getSettings = function() {
    if (this._settings == null) {
      var objXML = jsx3.getSystemCache().getOrOpenDocument(this._uri.resolve(jsx3.CONFIG_FILE), "JSX_SETTINGS::" + this.getKey());

      this._settings = new jsx3.app.Settings(objXML);
    }
    return this._settings;
  };

  AddIn_prototype.setSettings = function(objSettings) {
    this._settings = objSettings;
  };

  AddIn_prototype.resolveURI = function(strURI) {
    var uri = jsx3.net.URI.valueOf(strURI);

    if (jsx3.util.compareVersions(this.getJsxVersion(), "3.2") >= 0 && !URIResolver.isAbsoluteURI(uri))
      uri = this._uri.resolve(uri);

    return URIResolver.DEFAULT.resolveURI(uri);
  };

  AddIn_prototype.getUriPrefix = function() {
    return this._uri.toString();
  };

  AddIn_prototype.relativizeURI = function(strURI, bRel) {
    var loc = jsx3.app.Browser.getLocation();
    var relative = this._uriabs.relativize(loc.resolve(strURI));

    if (relative.isAbsolute() || bRel)
      return relative;
    else
      return jsx3.net.URI.fromParts("jsxaddin", null, this.getKey().replace(/:/, "!"), null,
          "/" + relative.getPath(), relative.getQuery(), relative.getFragment());
  };

  AddIn_prototype.toString = function() {
    return this._key;
  };

  URIResolver.register("jsxaddin", function(uri) {
    var addinKey = uri.getHost().split("!", 2).join(":");
    return jsx3.System.getAddin(addinKey);
  });

});

jsx3.Class.defineInterface("jsx3.util.EventDispatcher", null, function(EventDispatcher, EventDispatcher_prototype) {

  EventDispatcher._OBJ_FUNCT = 1;

  EventDispatcher._OBJ_STRING = 2;

  EventDispatcher._STRING_FUNCT = 3;

  EventDispatcher._STRING_STRING = 4;

  EventDispatcher._FUNCT = 5;

  EventDispatcher.SUBJECT_ALL = "*";

  EventDispatcher_prototype.subscribe = function(strEventId, objHandler, objFunction) {
    var type1 = typeof(objHandler);
    var type2 = typeof(objFunction);

    var toAdd = null;
    if (type1 == "object" || type1 == "function") {
      if (type2 == "function") {
        toAdd = [EventDispatcher._OBJ_FUNCT, objHandler, objFunction];
      } else if (type2 == "string") {
        toAdd = [EventDispatcher._OBJ_STRING, objHandler, objFunction];
      } else if (type1 == "function") {
        toAdd = [EventDispatcher._FUNCT, objHandler];
      }

    } else if (type1 == "string") {
      if (type2 == "function") {
        toAdd = [EventDispatcher._STRING_FUNCT, objHandler, objFunction];
      } else if (type2 == "string") {
        toAdd = [EventDispatcher._STRING_STRING, objHandler, objFunction];
      }

    }

    // HACK: function subscriptions coming from other browser windows will be reported as type "object" in IE
    if (toAdd == null && (type1 == "object" && objHandler.call && objHandler.apply))
      toAdd = [EventDispatcher._FUNCT, objHandler];

    if (toAdd == null) {
      throw new jsx3.IllegalArgumentException("objHandler, objFunction",
          "{" + typeof(objHandler) + "}, {" + typeof(objFunction) + "}");
    }

    if (!(strEventId instanceof Array)) strEventId = [strEventId];

    for (var i = 0; i < strEventId.length; i++) {
      var registry = this._getEventRegistry();
      var eventId = strEventId[i];

      if (!registry[eventId])
        registry[eventId] = [toAdd];
      else
        registry[eventId].push(toAdd);
    }
  };

  EventDispatcher_prototype.unsubscribe = function(strEventId, objHandler) {
    if (!(strEventId instanceof Array)) strEventId = [strEventId];

    for (var i = 0; i < strEventId.length; i++) {
      var queue = this._getEventRegistry()[strEventId[i]];
      if (queue) {
        for (var j = 0; j < queue.length; j++) {
          if (queue[j][1] === objHandler)
            queue.splice(j--, 1);
        }
      }
    }
  };

  EventDispatcher_prototype.unsubscribeAll = function(strEventId) {
    if (this._jsxeventreg)
      delete this._jsxeventreg[strEventId];
  };

  EventDispatcher_prototype.unsubscribeAllFromAll = function() {
    this._jsxeventreg = {};
  };

  EventDispatcher_prototype.publish = function __EventDispatcher_prototype_publish(objEvent) {
    // always set the event target
    if (objEvent.target == null)
      objEvent.target = this;

    var strEventId = objEvent.subject;
    if (strEventId == null)
      throw new jsx3.IllegalArgumentException("objEvent", objEvent);

    var reg = this._jsxeventreg;

    if (!reg) return;

    var q1 = reg[strEventId];
    var q2 = reg[EventDispatcher.SUBJECT_ALL];

    if (!q1 && !q2) return;

    // defensive copy: subscribers may unsubscribe themselves
    var queue = [];
    if (q1) queue.push.apply(queue, q1);
    if (q2) queue.push.apply(queue, q2);

    for (var i = 0; i < queue.length; i++) {
      var item = queue[i];
      var type = item[0];
      var target = item[1];
      var method = item[2];

      if (type == EventDispatcher._OBJ_FUNCT) {
        method.call(target, objEvent);
      } else if (type == EventDispatcher._OBJ_STRING) {
        target[method](objEvent);

      } else if (type == EventDispatcher._STRING_FUNCT) {
        var objJSX = this.getServer().getJSX(target);
        if (objJSX)
          method.call(objJSX, objEvent);
      } else if (type == EventDispatcher._STRING_STRING) {
        var objJSX = this.getServer().getJSX(target);
        if (objJSX)
          objJSX[method](objEvent);

      } else if (type == EventDispatcher._FUNCT) {
        target.call(null, objEvent);
      } else {
        // assert false
      }
    }

    return queue.length;
  };

  EventDispatcher_prototype.getSubscriberCount = function(strEventId) {
    var list = this._getEventRegistry()[strEventId];
    return list ? list.length : 0;
  };

  EventDispatcher_prototype._getEventRegistry = function() {
    if (this._jsxeventreg == null)
      this._jsxeventreg = {};
    return this._jsxeventreg;
  };

});

jsx3.util.EventDispatcher.jsxclass.mixin(jsx3);

jsx3.EventDispatcher = jsx3.util.EventDispatcher;

jsx3.Class.defineClass("jsx3.net.URI", null, null, function(URI, URI_prototype) {

  URI.ALPHA = "ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz";

  URI.DIGIT = "0123456789";

  URI.ALPHANUM = URI.ALPHA + URI.DIGIT;

  URI.UNRESERVED = URI.ALPHANUM + "_-!.~'()*";

  URI.PUNCT = ",;:$&+=";

  URI.RESERVED = URI.PUNCT + "?/[]@";

  URI.ESCAPED = "%";

  URI._SCHEME_REGEX = new RegExp("^[" + URI.ALPHA + "][\\-\\.\\+" + URI.ALPHA + "]*\\:");

  URI_prototype._source = null;

  URI_prototype._scheme = null;

  URI_prototype._ssp = null;

  URI_prototype._fragment = null;

  URI_prototype._authority = null;

  URI_prototype._path = null;

  URI_prototype._query = null;

  URI_prototype._userinfo = null;

  URI_prototype._host = null;

  URI_prototype._port = null;

  URI.fromParts = function(scheme, userInfo, host, port, path, query, fragment) {
    var uri = URI.jsxclass.bless();
    var a = arguments;

    var authorityraw = null, sspraw = null;

    // RFC 2396 allows escaped octets to appear in the user-info, path, query, and fragment components.
    if (a.length == 3) {
      uri._scheme = a[0];
      sspraw = URI.encode(a[1], URI.UNRESERVED + URI.RESERVED + URI.ESCAPED);
      uri._ssp = URI.decode(a[1]);
      uri._fragment = URI.decode(a[2]);
    } else if (a.length == 7) {
      uri._scheme = a[0];
      uri._userinfo = URI.decode(a[1]);
      uri._host = a[2];
      uri._port = a[3];
      uri._path = URI.decode(a[4]);
      uri._query = URI.decode(a[5]);
      uri._fragment = URI.decode(a[6]);
    } else {
      throw new jsx3.IllegalArgumentException("arguments", jsx3.Method.argsAsArray(a));
    }

    if (uri._authority == null && uri._host != null) {
      uri._authority = authorityraw = uri._host;
      if (uri._userinfo) {
        uri._authority = uri._userinfo + "@" + uri._authority;
        authorityraw = URI.encode(uri._userinfo, URI.UNRESERVED + URI.PUNCT + URI.ESCAPED) + "@" + authorityraw;
      }
      if (uri._port) {
        uri._authority = uri._authority + ":" + uri._port;
        authorityraw = authorityraw + ":" + uri._port;
      }
    }

    if (uri._ssp == null) {
      uri._ssp = sspraw = "";
      if (uri._path) {
        uri._ssp = uri._path;
        sspraw = URI.encode(uri._path, URI.UNRESERVED + URI.PUNCT + URI.ESCAPED + "/@");
      }
      if (uri._authority != null) {
        uri._ssp = "//" + uri._authority + uri._ssp;
        sspraw = "//" + authorityraw + sspraw;
      }
      if (uri._query) {
        uri._ssp = uri._ssp + "?" + uri._query;
        sspraw = sspraw + "?" + URI.encode(uri._query, URI.UNRESERVED + URI.PUNCT + URI.ESCAPED);
      }
    }

    if (uri._source == null) {
      uri._source = sspraw;
      if (uri._scheme)
        uri._source = uri._scheme + ":" + uri._source;
      if (uri._fragment != null)
        uri._source = uri._source + "#" + URI.encode(uri._fragment, URI.UNRESERVED + URI.RESERVED + URI.ESCAPED);
    }

    return uri;
  };

  URI_prototype.init = function(strURI) {
    if (strURI == null) strURI = "";
    if (typeof(strURI) != "string") strURI = strURI.toString();

    this._source = strURI;

    // PARSE [scheme:]scheme-specific-part[#fragment]
    var ssp = strURI;
    var index;
    if (URI._SCHEME_REGEX.test(ssp)) {
      var match = RegExp.lastMatch;
      this._scheme = ssp.substring(0, match.length - 1);
      ssp = ssp.substring(match.length);
    }
    if ((index = ssp.indexOf("#")) >= 0) {
      this._fragment = URI.decode(ssp.substring(index+1));
      ssp = ssp.substring(0, index);
    }
    this._ssp = ssp;

    // we know whether it's absolute/relative and opaque/hierarchical
    var bAbsolute = this._scheme != null;
    var bOpaque = bAbsolute && ssp.indexOf("/") != 0;

    if (!bOpaque) {
      // PARSE [scheme:][//authority][path][?query][#fragment]
      if (ssp.indexOf("//") == 0) {
        index = ssp.indexOf("/", 2);
        this._authority = ssp.substring(2, index >= 0 ? index : ssp.length);
        ssp = index >= 0 ? ssp.substring(index) : "";
      }
      if ((index = ssp.indexOf("?")) >= 0) {
        this._query = URI.decode(ssp.substring(index+1));
        ssp = ssp.substring(0, index);
      }
      this._path = URI.decode(ssp);

      // PARSE [user-info@]host[:port]
      var host = this._authority;
      if (host) {
        if ((index = host.indexOf("@")) >= 0) {
          this._userinfo = URI.decode(host.substring(0, index));
          host = host.substring(index+1);
        }
        if ((index = host.indexOf(":")) >= 0) {
          this._port = parseInt(host.substring(index+1));
          host = host.substring(0, index);
        }
      }

      this._host = host;
    }
  };

  URI_prototype.normalize = function() {
    if (jsx3.util.strEmpty(this._path)) return this;

    var tokens = this._path.split("/");
    URI.normalizeTokens(tokens);

    var path = tokens.join("/");

    return path == this._path ? this :
        URI.fromParts(this._scheme, this._userinfo, this._host, this._port, path, this._query, this._fragment);
  };

  URI.normalizeTokens = function(tokens) {
    var bRel = tokens[0] !== "";

    //  1. All "." segments are removed.
    for (var i = tokens.length -1; i >= 0; i--)
      if (tokens[i] == ".")
        tokens.splice(i, 1);

    //  2. If a ".." segment is preceded by a non-".."  segment then both of these segments are removed.
    //     This step is repeated until it is no longer applicable.
    for (var i = 0; i < tokens.length; i++) {
      if (i > 0 && tokens[i] == ".." && tokens[i-1] != "..") {
        tokens.splice(i-1, 2);
        i -= 2;
      }
    }

    //  3. If the path is relative, and if its first segment contains a colon character (':'), then a "." segment is
    //     prepended. This prevents a relative URI with a path such as "a:b/c/d" from later being re-parsed as an
    //     opaque URI with a scheme of "a" and a scheme-specific part of "b/c/d".
    if (bRel && tokens[0] != null && tokens[0].indexOf(":") >= 0)
      tokens.unshift(".");
  };

  URI_prototype.resolve = function(uri) {
    uri = URI.valueOf(uri);

    // efficiency
    if (this._source == "") return uri;

    // I. If the given URI is already absolute, or if this URI is opaque, then the given URI is returned.
    if (uri.isAbsolute() || this.isOpaque()) return uri;

    // II. If the given URI's fragment component is defined, its path component is empty, and its scheme, authority, and
    // query components are undefined, then a URI with the given fragment but with all other components equal to those
    // of this URI is returned.
    if (uri._fragment && !uri._path && !uri._scheme && !uri._authority && !uri._query)
      return URI.fromParts(this._scheme, this._userinfo, this._host, this._port, this._path, this._query, uri._fragment);

    // 1. A new URI is constructed with this URI's scheme and the given URI's query and fragment components.
    var scheme = this._scheme;
    var query = uri._query;
    var fragment = uri._fragment;

    var userInfo = null, host = null, port = null, path = null;
    // 2. If the given URI has an authority component then the new URI's authority and path are taken from the given URI.
    if (uri._authority != null) {
      userInfo = uri._userinfo;
      host = uri._host;
      port = uri._port;
      path = uri._path;
    }
    // 3. Otherwise the new URI's authority component is copied from this URI, and its path is computed as follows:
    else {
      userInfo = this._userinfo;
      host = this._host;
      port = this._port;
      // 1. If the given URI's path is absolute then the new URI's path is taken from the given URI.
      if (uri._path.indexOf("/") == 0) {
        path = uri._path;
      }
      // 2. Otherwise the given URI's path is relative, and so the new URI's path is computed by resolving the path
      //    of the given URI against the path of this URI. This is done by concatenating all but the last segment of
      //    this URI's path, if any, with the given URI's path and then normalizing the result as if by invoking the
      //    normalize method.
      else {
        var tokens = this._path.split("/");
        tokens.pop(); // remove last segment
        tokens.push.apply(tokens, uri._path.split("/"));
        URI.normalizeTokens(tokens);
        path = tokens.join("/");
      }
    }

    return URI.fromParts(scheme, userInfo, host, port, path, query, fragment);
  };

  URI_prototype.relativize = function(uri) {
    uri = URI.valueOf(uri);

    // efficiency
    if (this._source == "") return uri;

    // 1. If either this URI or the given URI are opaque, or if the scheme and authority components of the two URIs
    //    are not identical, or if the path of this URI is not a prefix of the path of the given URI, then the given URI
    //    is returned.
    if (this.isOpaque() || uri.isOpaque()) return uri;
    if (this._scheme != uri._scheme) return uri;
    var a1 = this._authority != null ? this._authority : "";
    var a2 = uri._authority != null ? uri._authority : "";
    if (a1 != a2) return uri;

    // 2. Otherwise a new relative hierarchical URI is constructed with query and fragment components taken from the
    //    given URI and with a path component computed by removing this URI's path from the beginning of the given
    //    URI's path.
    var thisPath = this._path || "";
    var thatPath = uri._path || "";

    var thisTokens = thisPath.split("/");
    thisTokens.pop();
    var thatTokens = thatPath.split("/");
    var newTokens = [];

    var i = 0;
    while (i < thisTokens.length && i < thatTokens.length) {
      if (thisTokens[i] != thatTokens[i]) break;
      i++;
    }

    var newPath = null;

    if (i < 2 && thisPath.indexOf("/") == 0) {
      newPath = thatPath;
    } else {
      for (var j = i; j < thisTokens.length; j++)
        newTokens[newTokens.length] = "..";

      for (var j = i; j < thatTokens.length; j++)
        newTokens[newTokens.length] = thatTokens[j];

      newPath = newTokens.join("/");
    }

    return URI.fromParts(null, null, null, null, newPath, uri._query, uri._fragment);
  };

  URI_prototype.getAuthority = function() {
    return this._authority;
  };

  URI_prototype.getFragment = function() {
    return this._fragment;
  };

  URI_prototype.getHost = function() {
    return this._host;
  };

  URI_prototype.getPath = function() {
    return this._path;
  };

  URI_prototype.getPort = function() {
    return this._port;
  };

  URI_prototype.getQuery = function() {
    return this._query;
  };

  URI_prototype.getQueryParam = function(strParam) {
    var query = this._query;
    if (query) {
      var from = 0;
      var nameLength = strParam.length;

      var index = null;
      while ((index = query.indexOf(strParam, from)) >= 0) {
        if (index == 0 || query.charAt(index-1) == "&") {
          var followingChar = query.charAt(index + nameLength);
          if (followingChar == "&" || jsx3.util.strEmpty(followingChar)) {
            return true;
          } else if (followingChar == "=") {
            var nextIndex = query.indexOf("&", index + nameLength + 1);
            return nextIndex >= 0 ? query.substring(index + nameLength + 1, nextIndex) :
                query.substring(index + nameLength + 1);
          }
        }
        from = index + nameLength;
      }
    }
    return null;
  };

  URI_prototype.getQueryParams = function() {
    var map = {};
    if (this._query) {
      var tokens = this._query.split("&");
      for (var i = 0; i < tokens.length; i++) {
        var token = tokens[i];
        var equalsIndex = token.indexOf("=");
        if (equalsIndex >= 0) {
          map[token.substring(0, equalsIndex)] = token.substring(equalsIndex + 1);
        } else {
          map[token] = true;
        }
      }
    }
    return map;
  };

  URI_prototype.getScheme = function() {
    return this._scheme;
  };

  URI_prototype.getSchemeSpecificPart = function() {
    return this._ssp;
  };

  URI_prototype.getUserInfo = function() {
    return this._userinfo;
  };

  URI_prototype.isAbsolute = function() {
    return this._scheme != null;
  };

  URI_prototype.isOpaque = function() {
    return this._scheme != null && this._ssp.indexOf("/") != 0;
  };

  URI_prototype.equals = function(obj) {
    if (this === obj) return true;
    if (!(obj instanceof jsx3.net.URI)) return false;

    // For two URIs to be considered equal requires that either both are opaque or both are hierarchical.
    // Their schemes must either both be undefined or else be equal without regard to case. Their fragments must
    // either both be undefined or else be equal.
    var s1 = this._scheme;
    var s2 = obj._scheme;
    if ((s1 == null && s2 != null) || (s1 != null && s2 == null)) return false;
    if (s1 != null && s1.toLowerCase() != s2.toLowerCase()) return false;
    if (this._fragment != obj._fragment) return false;

    // When testing the user-information, path, query, fragment, authority, or scheme-specific parts of two
    // URIs for equality, the raw forms rather than the encoded forms of these components are compared and the
    // hexadecimal digits of escaped octets are compared without regard to case.

    if (this.isOpaque()) {
      // For two opaque URIs to be considered equal, their scheme-specific parts must be equal.
      if (! obj.isOpaque()) return false;
      return this._ssp == obj._ssp;
    } else {
      // For two hierarchical URIs to be considered equal, their paths must be equal and their queries must either
      // both be undefined or else be equal. Their authorities must either both be undefined, or both be registry-based,
      // or both be server-based. If their authorities are defined and are registry-based, then they must be equal.
      // If their authorities are defined and are server-based, then their hosts must be equal without regard to case,
      // their port numbers must be equal, and their user-information components must be equal.
      return this._path == obj._path &&
          this._query == obj._query &&
          this._authority == obj._authority;
    }
  };

  URI_prototype.toString = function() {
    return this._source;
  };

  URI.encode = function(strText, strChars) {
    if (strText == null) return null;
    if (strChars == null) strChars = URI.UNRESERVED;

    var regex = new RegExp("^[" + strChars.replace(/(\W)/g, "\\$1") + "]*$");
    if (strText.match(regex)) return strText;

    var length = strText.length;
    var encoded = new Array(length);

    for (var i = 0; i < length; i++) {
      var chr = strText.charAt(i);

      if (strChars.indexOf(chr) < 0) {
        var code = chr.charCodeAt(0);

        if (code < 16) {
          encoded[i] = "%" + "0" + code.toString(16).toUpperCase();
        } else if (code < 256) {
          encoded[i] = "%" + code.toString(16).toUpperCase();
        } else {
          encoded[i] = chr;
        }
      } else {
        encoded[i] = chr;
      }
    }

    return encoded.join("");
  };

  URI.decode = function(strText) {
    if (strText == null) return null;
    if (strText.indexOf("%") < 0) return strText;

    var length = strText.length;
    var decoded = new Array(length);
    var j = 0;

    for (var i = 0; i < strText.length; i++) {
      var chr = strText.charAt(i);
      if (chr == "%") {
        var octet = strText.substring(i+1, i+3);
        if (octet.match(/[^a-fA-F0-9]/)) {
          decoded[j++] = chr;
        } else {
          decoded[j++] = String.fromCharCode(parseInt(octet, 16));
          i += 2;
        }
      } else {
        decoded[j++] = chr;
      }
    }

    return decoded.join("");
  };

  URI.valueOf = function(strURI) {
    if (jsx3.util.strEmpty(strURI)) return URI.EMPTY_URI;
    return strURI instanceof URI ? strURI : new URI(strURI);
  };

  URI.EMPTY_URI = new URI();

});

// @jsxobf-clobber  _jsxfxcb _jsxclone

jsx3.Class.defineClass("jsx3.gui.Event", null, null, function(Event, Event_prototype) {

  // the following are JavaScript native event types

  Event.BEFOREUNLOAD = "beforeunload";

  Event.BLUR = "blur";

  Event.CHANGE = "change";

  Event.CLICK = "click";

  Event.DOUBLECLICK = "dblclick";

  Event.ERROR = "error";

  Event.FOCUS = "focus";

  Event.KEYDOWN = "keydown";

  Event.KEYPRESS = "keypress";

  Event.KEYUP = "keyup";

  Event.LOAD = "load";

  Event.MOUSEDOWN = "mousedown";

  Event.MOUSEMOVE = "mousemove";

  Event.MOUSEOUT = "mouseout";

  Event.MOUSEOVER = "mouseover";

  Event.MOUSEUP = "mouseup";

  Event.MOUSEWHEEL = "mousewheel";

  Event.UNLOAD = "unload";

  Event.RESIZE = "resize";

  Event.KEY_ALT = 18;

  Event.KEY_ARROW_DOWN = 40;

  Event.KEY_ARROW_LEFT = 37;

  Event.KEY_ARROW_RIGHT = 39;

  Event.KEY_ARROW_UP = 38;

  Event.KEY_BACKSPACE = 8;

  Event.KEY_CONTROL = 17;

  Event.KEY_DELETE = 46;

  Event.KEY_END = 35;

  Event.KEY_ENTER = 13;

  Event.KEY_ESCAPE = 27;

  Event.KEY_HOME = 36;

  Event.KEY_INSERT = 45;

  Event.KEY_META = 224;

  Event.KEY_PAGE_DOWN = 34;

  Event.KEY_PAGE_UP = 33;

  Event.KEY_SHIFT = 16;

  Event.KEY_SPACE = 32;

  Event.KEY_TAB = 9;

  Event.KEY_0 = 48;

  Event.KEY_9 = 57;

  Event.KEY_A = 65;

  Event.KEY_Z = 90;

  Event.KEY_NP0 = 96;

  Event.KEY_NP9 = 105;

  Event.KEY_NPDIV = 111;

  Event.KEY_NPMUL = 106;

  Event.KEY_NPSUB = 109;

  Event.KEY_NPADD = 107;

  Event.KEY_NPDEC = 110;

  Event.KEY_F1 = 112;

  Event.KEY_F15 = 126;

  Event._WINDOWS = [];

  Event._WINDOW_EVENTS = [];

  Event._DISPATCHER = jsx3.util.EventDispatcher.jsxclass.newInnerClass();

  Event._SUBSCRIBED = [];

  var Logger = null;

  Event._getLog = function() {};

  Event._registerWindow = function(objWindow) {};

  Event._isWindowRegistered = function(objWindow) {};

  Event._deregisterWindow = function(objWindow) {};

  Event._registerWindow(window);

  Event.subscribe = function(strEventId, objHandler, objFunction) {};

 if (jsx3.CLASS_LOADER.IE) {

  Event.subscribeLoseFocus = function(objHandler, objParentGUI, objFunction) {};

  Event.unsubscribeLoseFocus = function(objHandler) {};

  Event.preventSelection = function(objDocument) {};

 } else {

  Event._FOCUSREGS = [];

  Event._focusHandler = function(e) {};

  Event.subscribeLoseFocus = function(objHandler, objParentGUI, objFunction) {};

  Event.unsubscribeLoseFocus = function(objHandler) {};

  Event.preventSelection = function(objDocument) {};

 }

  Event.unsubscribe = function(strEventId, objHandler) {};

  Event.unsubscribeAll = function(strEventId) {};

  Event.publish = function(objEvent) {};

  Event._publish = function(objEDEvent) {};

  Event._eventHandler = function(evt) {};

  Event._restoreWindowEvent = function(strEventId) {};

  Event._getHandlerOwner = function(w, strEventId) {};

  Event._isAttachable = function(strEventId) {};

  Event._isListenable = function(strEventId) {};

  Event._isMainWindowEvent = function(strEventId) {};

  Event_prototype.init = function(e, bCopy) {};

  Event_prototype.persistEvent = function() {};

  Event.wrap = function(objEvent, bCopy) {};

  Event.getCurrent = function(bCopy) {};

 if (jsx3.CLASS_LOADER.IE) {

  Event_prototype._event = function() {};

 } else if (jsx3.CLASS_LOADER.SAF) {

  Event_prototype._event = function() {};

 } else {

  Event_prototype._event = function() {};

 }

  Event_prototype.event = function() {};

  Event_prototype.getType = function(){ return this._event().type; };

  Event_prototype.srcElement = function(){var e = this._event(); return e.target || e.srcElement;};

  Event_prototype.toElement = function(){

 if (jsx3.CLASS_LOADER.IE) {
   return e.toElement;
 } else {
   return e.type == "mouseout" ? e.relatedTarget : e.target;
 }
  };

  Event_prototype.fromElement = function(){

 if (jsx3.CLASS_LOADER.IE) {
   return e.fromElement;
 } else {
   return e.type == "mouseover" ? e.relatedTarget : e.target;
//   return e.relatedTarget;
 }
  };

  Event_prototype.isMouseEvent = function() {};

  Event_prototype.isKeyEvent = function() {};

  Event_prototype.setCapture = function(objGUI){
 if (jsx3.CLASS_LOADER.IE) {

 } else {

 }
  };

  Event_prototype.releaseCapture = function(objGUI){
 if (jsx3.CLASS_LOADER.IE) {

 } else {

 }
  };

  Event_prototype.keyCode = function(){var e = this._event(); return e.keyCode;};

  Event_prototype.clientX = function(){var e = this._event(); return e ? e.clientX : Number.NaN;};

  Event_prototype.clientY = function(){var e = this._event(); return e ? e.clientY : Number.NaN;};

  Event_prototype.getOffsetX = function() {
 if (jsx3.CLASS_LOADER.IE) {

 } else {

 }
  };

  Event_prototype.getOffsetY = function() {
 if (jsx3.CLASS_LOADER.IE) {

 } else {

 }
  };

  Event_prototype.getScreenX = function() {return this._event().screenX;};

  Event_prototype.getScreenY = function() {return this._event().screenY;};

  Event_prototype.getTrueX = function() {return this._event().clientX;};//screenX - window.screenLeft;};

  Event_prototype.getTrueY = function() {return this._event().clientY;};//.screenY - window.screenTop;};

  Event_prototype.getWheelDelta = function() {
 if (jsx3.CLASS_LOADER.IE || jsx3.CLASS_LOADER.SAF) {

 } else {

 }

  };

  Event_prototype.shiftKey = function(){var e = this._event(); return e.shiftKey;};

  Event_prototype.ctrlKey = function(){var e = this._event(); return e.ctrlKey;};

  Event_prototype.altKey = function(){var e = this._event(); return e.altKey;};

 if (jsx3.CLASS_LOADER.IE) {
  Event_prototype.metaKey = function(){return false;};
 } else {
  Event_prototype.metaKey = function(){var e = this._event(); return e.metaKey;};
 }

  Event_prototype.enterKey = function(){return this._event().keyCode == Event.KEY_ENTER;};

  Event_prototype.spaceKey = function(){return this._event().keyCode == Event.KEY_SPACE;};

  Event_prototype.tabKey = function(){return this._event().keyCode == Event.KEY_TAB;};

  Event_prototype.rightArrow = function(){return this._event().keyCode == Event.KEY_ARROW_RIGHT;};

  Event_prototype.leftArrow = function(){return this._event().keyCode == Event.KEY_ARROW_LEFT;};

  Event_prototype.upArrow = function(){return this._event().keyCode == Event.KEY_ARROW_UP;};

  Event_prototype.downArrow = function(){return this._event().keyCode == Event.KEY_ARROW_DOWN;};

  Event_prototype.deleteKey = function(){return this._event().keyCode == Event.KEY_DELETE;};

  Event_prototype.backspaceKey = function(){return this._event().keyCode == Event.KEY_BACKSPACE;};

  Event_prototype.insertKey = function(){return this._event().keyCode == Event.KEY_INSERT;};

  Event_prototype.homeKey = function(){return this._event().keyCode == Event.KEY_HOME;};

  Event_prototype.endKey = function(){return this._event().keyCode == Event.KEY_END;};

  Event_prototype.pageUpKey = function(){return this._event().keyCode == Event.KEY_PAGE_UP;};

  Event_prototype.pageDownKey = function(){return this._event().keyCode == Event.KEY_PAGE_DOWN;};

  Event_prototype.escapeKey = function(){return this._event().keyCode == Event.KEY_ESCAPE;};

  Event_prototype.exists = function(){ return this._event() != null;};

  Event_prototype.cancelBubble = function() {

 if (jsx3.CLASS_LOADER.IE) {

 } else {

 }
  };

  Event_prototype.cancelReturn = function(){this._event().returnValue = false;};

  Event_prototype.cancelKey = function(){

 if (jsx3.CLASS_LOADER.IE) {

 } else {

 }
  };

  Event_prototype.cancelAll = function() {};

  Event_prototype.leftButton = function() {

 if (jsx3.CLASS_LOADER.IE) {

 } else {

 }

  };

  Event_prototype.rightButton = function() {};

  Event_prototype.button = function(){var e = this._event(); return e.button;};

  Event_prototype.setReturn = function(strReturn){this._event().returnValue = strReturn;};

  Event_prototype.setKeyCode = function(intKeyCode){
 if (jsx3.CLASS_LOADER.IE) {

 } else {

 }
  };

  Event_prototype.isModifierKey = function(){};

  Event_prototype.hasModifier = function(bIgnoreShift) {};

  Event_prototype.isArrowKey = function() {};

  Event_prototype.isFunctionKey = function() {};

 if (jsx3.CLASS_LOADER.IE) {

  Event_prototype.getAttribute = function(strName) {};

  Event_prototype.setAttribute = function(strName, strValue) {};

  Event_prototype.removeAttribute = function(strName) {};

  Event.dispatchMouseEvent = function(objTarget, strType, objParams) {};

  Event.dispatchKeyEvent = function(objTarget, strType, intKey, bShift, bCtrl, bAlt, objParams) {};

 } else {

  Event_prototype.getAttribute = function(strName) {};

  Event_prototype.setAttribute = function(strName, strValue) {};

  Event_prototype.removeAttribute = function(strName) {};

  Event.dispatchMouseEvent = function(objTarget, strType, objParams) {};

  Event.dispatchKeyEvent = function(objTarget, strType, intKey, bShift, bCtrl, bAlt, objParams) {};

 }
 if (jsx3.CLASS_LOADER.FX) {

  // HACK: to get onmousewheel to work with Fx
  window.addEventListener("DOMMouseScroll", function(e) {}, false);

 }
 if (jsx3.CLASS_LOADER.SAF) {

  // HACK: to focus to work on div and span, etc
  // Should be fixed in some future (to 3.1) version of Safari since it's fixed in WebKit as of 4/08.
  if (jsx3.CLASS_LOADER.SAF3) {}

 }

  Event_prototype.isFakeOut = function(objRoot) {};

  Event_prototype.isFakeOver = function(objRoot) {};

  Event_prototype.toString = function() {};

});

jsx3.gui.Event.subscribe(jsx3.gui.Event.UNLOAD, jsx3.destroy);

 if (jsx3.CLASS_LOADER.IE) {

jsx3.Class.defineClass("jsx3.EVT", null, [jsx3.util.EventDispatcher], function(EVT, EVT_prototype) {

  EVT_prototype.init = function(e) {
    // clone the event object because keeping a JS reference to it is not enough to make it available after subsequent events
    if (e)
      this.e = jsx3.clone(e);
  };

  EVT_prototype.handleEvent = function(strType, bReturn) {
    var objEvent = jsx3.gui.Event.getCurrent();

    if (objEvent == null) {
      jsx3.util.Logger.getLogger(EVT.jsxclass.getName()).warn("handleEvent called when current event null: " + strType);
      return;
    }

    if (objEvent.getType() != strType.substring(2))
      jsx3.util.Logger.getLogger(EVT.jsxclass.getName()).warn("handleEvent called for type that does not match the current event's type: " + objEvent.getType() + " " + strType);

    jsx3.gui.Event.publish(objEvent);
  };

  EVT_prototype.registerEvent = function(EVENTTYPE, strCode) {
    if (EVENTTYPE.indexOf("on") == 0)
      EVENTTYPE = EVENTTYPE.substring(2);

    jsx3.gui.Event.subscribe(EVENTTYPE, function(){ jsx3.eval(strCode); } );
  };

  EVT_prototype.event = function(){return this.e || window.event;};

  EVT_prototype._event = function(){return this.e || window.event;};

  EVT_prototype.srcElement = function(){var e = this._event(); return e && e.srcElement;};

  EVT_prototype.toElement = function(){var e = this._event(); return e && e.toElement;};

  EVT_prototype.fromElement = function(){var e = this._event(); return e && e.fromElement;};

  EVT_prototype.keyCode = function(){var e = this._event(); return e && e.keyCode;};

  EVT_prototype.clientX = function(){var e = this._event(); return e ? e.clientX : Number.NaN;};

  EVT_prototype.clientY = function(){var e = this._event(); return e ? e.clientY : Number.NaN;};

  EVT_prototype.getTrueX = function() {return this._event().screenX - window.screenLeft;};

  EVT_prototype.getTrueY = function() {return this._event().screenY - window.screenTop;};

  EVT_prototype.shiftKey = function(){var e = this._event(); return e && e.shiftKey;};

  EVT_prototype.ctrlKey = function(){var e = this._event(); return e && e.ctrlKey;};

  EVT_prototype.altKey = function(){var e = this._event(); return e && e.altKey;};

  EVT_prototype.enterKey = function(){return this._event().keyCode == 13;};

  EVT_prototype.spaceKey = function(){return this._event().keyCode == 32;};

  EVT_prototype.tabKey = function(){return this._event().keyCode == 9;};

  EVT_prototype.rightArrow = function(){return this._event().keyCode == 39;};

  EVT_prototype.leftArrow = function(){return this._event().keyCode == 37;};

  EVT_prototype.upArrow = function(){return this._event().keyCode == 38;};

  EVT_prototype.downArrow = function(){return this._event().keyCode == 40;};

  EVT_prototype.deleteKey = function(){return this._event().keyCode == 46;};

  EVT_prototype.backspaceKey = function(){return this._event().keyCode == 8;};

  EVT_prototype.insertKey = function(){return this._event().keyCode == 45;};

  EVT_prototype.homeKey = function(){return this._event().keyCode == 36;};

  EVT_prototype.endKey = function(){return this._event().keyCode == 35;};

  EVT_prototype.pageUpKey = function(){return this._event().keyCode == 33;};

  EVT_prototype.pageDownKey = function(){return this._event().keyCode == 34;};

  EVT_prototype.escapeKey = function(){return this._event().keyCode == 27;};

  EVT_prototype.exists = function(){return this._event() != null;};

  EVT_prototype.cancelBubble = function(){this._event().cancelBubble = true;};

  EVT_prototype.cancelReturn = function(){this._event().returnValue = false;};

  EVT_prototype.cancelKey = function(){this._event().keyCode = 0;};

  EVT_prototype.leftButton = function(){var e = this._event(); return e && e.button == 0;};

  EVT_prototype.rightButton = function(){var e = this._event(); return e && e.button == 2;};

  EVT_prototype.button = function(){var e = this._event(); return (e) ? e.button : null;};

  EVT_prototype.setReturn = function(RETURN){this._event().returnValue = RETURN;};

  EVT_prototype.setKeyCode = function(intKeyCode){this._event().keyCode = intKeyCode;};

  EVT_prototype.isModifierKey = function(){
    var e = this._event();
    return e.keyCode == 16 || e.keyCode == 17 || e.keyCode == 18;
  };

  EVT_prototype.toString = function() {
    var s = "";
    var e = this._event();
    if (e == null) return "jsx3.EVT <empty>";

    var fields = [];
    for (var f in e)
      fields.push(f);
    fields.sort();

    for (var i=0; i < fields.length; i++)
      s += fields[i] + ":" + e[fields[i]] + " ";

    return s;
  };

});

jsx3.EVENT = new jsx3.EVT();

//primitives; all on <properties> tag
jsx3.EVENT.MOUSEOVER = "onmouseover";
jsx3.EVENT.MOUSEOUT = "onmouseout";
jsx3.EVENT.MOUSEDOWN = "onmousedown";
jsx3.EVENT.MOUSEUP = "onmouseup";
jsx3.EVENT.MOUSEMOVE = "onmousemove";
jsx3.EVENT.CLICK = "onclick";
jsx3.EVENT.DOUBLECLICK = "ondblclick";
jsx3.EVENT.KEYPRESS = "onkeypress";
jsx3.EVENT.KEYUP = "onkeyup";
jsx3.EVENT.KEYDOWN = "onkeydown";
jsx3.EVENT.FOCUS = "onfocus";
jsx3.EVENT.ACTIVATE = "onactivate";
jsx3.EVENT.BLUR = "onblur";
jsx3.EVENT.SCROLL = "onscroll";
jsx3.EVENT.UNLOAD = "onunload";
jsx3.EVENT.BEFOREUNLOAD = "onbeforeunload";

//view events handled in model context as well as system events; all on <events> tag
jsx3.EVENT.JSXKEYUP = "jsxkeyup";
jsx3.EVENT.JSXKEYDOWN = "jsxkeydown";
jsx3.EVENT.JSXKEYUP = "jsxkeyup";
jsx3.EVENT.JSXKEYPRESS = "jsxkeypress";
jsx3.EVENT.JSXBLUR = "jsxblur";
jsx3.EVENT.JSXCLICK = "jsxclick";
jsx3.EVENT.JSXDOUBLECLICK = "jsxdblclick";
jsx3.EVENT.JSXMOUSEDOWN = "jsxmousedown";

jsx3.EVENT.SPYGLASS = "jsxspy";    //when the spyglass is about to show
jsx3.EVENT.DROP = "jsxdrop";      //after a drop event (one of: ondrop, canceldrop, beforedrop)
jsx3.EVENT.BEFOREDROP = "jsxbeforedrop";  //before a drop event (a mouseover)
jsx3.EVENT.CANCELDROP = "jsxcanceldrop";  //canceling a drop event (a mouseout)
jsx3.EVENT.CTRLDROP = "jsxctrldrop";    //after a ctrl drop event
jsx3.EVENT.DRAG = "jsxdrag";      //before a drag
jsx3.EVENT.ADOPT = "jsxadopt";     // when a record is adopted from this CDF object
jsx3.EVENT.SHOW = "jsxshow";      //when a menu or select or some other ephemeral VIEW element is about to be displayed
jsx3.EVENT.HIDE = "jsxhide";      //opposite of show
jsx3.EVENT.MENU = "jsxmenu";      //before a bound menu is shown
jsx3.EVENT.SELECT = "jsxselect";    //select, menu, tree, listview
jsx3.EVENT.TOGGLE = "jsxtoggle";    //treeview node open/close
jsx3.EVENT.EXECUTE = "jsxexecute";    //execute event as in a menu click or tree node click, or listview dbl-click; enter key; spacebar for button
jsx3.EVENT.BEFORERESIZE = "jsxbeforeresize";  //before a resize; typically a dialog or alert
jsx3.EVENT.AFTERRESIZE = "jsxafterresize";  //after resize; typically a dialog or alert
jsx3.EVENT.BEFOREMOVE = "jsxbeforemove";  //before a move event (fired by mouse down for any object that has been made "moveable")
jsx3.EVENT.AFTERMOVE = "jsxaftermove";  //after a move event
jsx3.EVENT.DESTROY = "jsxdestroy";    //when an object is removed from the JSX DOM
jsx3.EVENT.SORT = "jsxsort";      //NOT IMPLEMENTED: on a sort event
jsx3.EVENT.BEFORESORT = "jsxbeforesort";  //before a sort event
jsx3.EVENT.AFTERSORT = "jsxaftersort";  //after a sort event
jsx3.EVENT.PAINT = "jsxpaint";    //after repaint/insertHTML have been called
jsx3.EVENT.PAGE = "jsxpage";      //equivalent to 'onscroll'; superset category that also includes lazy fetch (paging) through large collections
jsx3.EVENT.INTERVAL = "jsxinterval";    //wraps "window.setInterval"; allows a timed event to fire every 'n' milliseconds; has a corresponding prop called 'jsxinterval' (interval)
jsx3.EVENT.DRAW = "jsxdraw";      //after 'redraw' has been called for a data client
jsx3.EVENT.DATA = "jsxdata";      //called when a data object (D.O.) has just acquired data; the D.O. will call this method to allow it to do any pre-processing or actual handling of the data
jsx3.EVENT.BEFOREEDIT = "jsxbeforeedit";       //called before showing an edit mask
jsx3.EVENT.AFTEREDIT = "jsxafteredit";         //called after showing an edit mask
jsx3.EVENT.CHANGE = "jsxchange";               //form value changed, tab changed
jsx3.EVENT.INCCHANGE = "jsxincchange";               //incremental change in text area, slider, etc
jsx3.EVENT.BEFOREAPPEND = "jsxbeforeappend";   //before a new CDF record and corresponding on-screen TR are added to a jsx3.gui.List instance or relevant subclass
jsx3.EVENT.AFTERAPPEND = "jsxafterappend";     //after a new CDF record and corresponding on-screen TR are added to a jsx3.gui.List instance or relevant subclass

 }

jsx3.Class.defineClass('jsx3.app.Browser', null, null, function(Browser, Browser_prototype) {

  Browser.WIN32 = "win32";

  Browser.LINUX = "linux";

  Browser.MACOSX = "macosx";

  Browser.OTHER = "other";

  Browser.getLocaleString = function() {
 if (jsx3.CLASS_LOADER.IE) {
    var nativeValue = window.navigator.userLanguage;
 } else {
    var nativeValue = window.navigator.language;
 }
    var tokens = nativeValue.split(/[_-]/);
    if (tokens.length > 0) {
      tokens[0] = tokens[0].toLowerCase();
      if (tokens.length > 1) {
        tokens[1] = tokens[1].toUpperCase();
      }
    }
    return tokens.join("_");
  };

  Browser.isTableMoveBroken = function(w) {
    //[3.2] firefox won't crash, but the screen repaint is too taxing and therefore would be better if not shown until a better solution is found
    return true;
  };

  Browser._STYLE_CACHE = null;

  Browser.getStyleClass = function(strName) {
    if (Browser._STYLE_CACHE == null) {
      Browser._STYLE_CACHE = {};

   if (jsx3.CLASS_LOADER.IE) {
      for (var i = 0; i < document.styleSheets.length; i++) {
        var sheet = document.styleSheets[i];
        for (var j = 0; j < sheet.rules.length; j++) {
          var style = sheet.rules[j];
          Browser._STYLE_CACHE[style.selectorText] = style.style;
        }
      }
 } else {
      for (var i = 0; i < document.styleSheets.length; i++) {
        var sheet = document.styleSheets[i];
        for (var j = 0; j < sheet.cssRules.length; j++) {
          var style = sheet.cssRules[j];
          Browser._STYLE_CACHE[style.selectorText] = style.style;
        }
      }
 }
    }

    return Browser._STYLE_CACHE[strName];
  };

  Browser.getLocation = function() {
    if (Browser._LOC_URI == null)

      Browser._LOC_URI = new jsx3.net.URI(window.location.href);
    return Browser._LOC_URI;
  };

  Browser.getSystem = function() {
    if (Browser._SYSTEM == null) {
      var np = navigator.platform;
      var ua = navigator.userAgent;
      var sys = Browser.OTHER;

      if (np.indexOf("Win") == 0)
        sys = Browser.WIN32;
      else if (np.indexOf("Linux") == 0)
        sys = Browser.LINUX;
      else if (ua.indexOf("Mac OS X") != -1)
        sys = Browser.MACOSX;

      Browser._SYSTEM = sys;
    }
    return Browser._SYSTEM;
  };

  Browser[Browser.getSystem()] = true;

});

// @jsxobf-clobber  _jsxtodo

jsx3.Class.defineClass("jsx3.app.Settings", null, null, function(Settings, Settings_prototype) {

  Settings_prototype.init = function(objXML) {

    this._doc = objXML || jsx3.xml.CDF.newDocument();

    this._root = this._doc.getRootNode();
  };

  Settings_prototype.get = function(strKey) {
    var value = this._getCachedValue(arguments);
    if (typeof(value) == "undefined") {
      var node = this.getNode.apply(this, arguments);
      if (node == null) return Settings.UNDEF;
      value = Settings._getRecordValue(node);
      this._cacheValue(value, arguments);
    }
    return value;
  };

  Settings_prototype.getNode = function(strKey) {
    var node = this._root;

    var query = "/data";
    for (var i = 0; node && i < arguments.length; i++) {
      query += "/record[@jsxid='" + arguments[i] + "']";
    }

    return node.selectSingleNode(query);
  };

  Settings_prototype._cacheValue = function(objValue, arrPath) {
    if (arrPath.length == 0) {

      this._cache = objValue;
    } else {
      if (!this._cache) this._cache = {_jsxtodo:true};
      var node = this._cache;
      for (var i = 0; i < arrPath.length - 1; i++) {
        var path = arrPath[i];
        if (node[path] == null) {
          node[path] = {_jsxtodo:true};
        }
        node = node[path];
      }
      node[arrPath[arrPath.length-1]] = objValue;
    }
  };

  Settings_prototype._getCachedValue = function(arrPath) {
    var node = this._cache;
    for (var i = 0; node && i < arrPath.length; i++) {
      node = node[arrPath[i]];
    }
    return (node && node._jsxtodo) ? Settings.UNDEF : node;
  };

  Settings_prototype._resetCache = function() {
    delete this._cache;
  };

  Settings._VALUE_GETTERS = {
    array: function(record) {
      var i = record.selectNodeIterator("./record");
      var a = [];
      while (i.hasNext()) {
        var x = i.next();
        var getter = Settings._VALUE_GETTERS[x.getAttribute("type")];
        a[a.length] = getter ? getter(x) : x.getValue();
      }
      return a;
    },
    map: function(record) {
      var i = record.selectNodeIterator("./record");
      var o = {};
      while (i.hasNext()) {
        var x = i.next();
        var getter = Settings._VALUE_GETTERS[x.getAttribute("type")];
        o[x.getAttribute('jsxid')] = getter ? getter(x) : x.getValue();
      }
      return o;
    },
    "number": function(record) { return Number(record.getValue()); },
    "boolean": function(record) { return record.getValue() === "true"; },
    "null": function(record) { return null; },
    "string": function(record) { return record.getValue(); },
    "eval": function(record) {
      try {
        return jsx3.eval(record.getValue());
      } catch (e) {
        return null;
      }
    }
  };

  Settings._getRecordValue = function(record) {
    var type = record.getNodeName() == "data" ? "map" : record.getAttribute("type");
    var getter = Settings._VALUE_GETTERS[type];
    return getter ? getter(record) : record.getValue();
  };

  Settings_prototype.set = function(strKey, value) {
    var node = this._root;
    for (var i = 0; i < arguments.length - 2; i++) {
      var child = node.selectSingleNode("./record[@jsxid='" + arguments[i] + "']");

      if (child && child.getAttribute('type') != 'map') {
        node.removeChild(child);
        child = null;
      }

      if (! child) {
        child = node.createNode(jsx3.xml.Entity.TYPEELEMENT, "record");
        child.setAttribute("jsxid", arguments[i]);
        child.setAttribute("type", 'map');
        node.appendChild(child);
      }
      node = child;
    }

    Settings._setRecord(node, arguments[arguments.length - 2], arguments[arguments.length - 1]);
    this._resetCache();
  };

  Settings_prototype.remove = function(strKey) {
    var parent = null;
    var node = this._root;

    for (var i = 0; node && i < arguments.length; i++) {
      parent = node;
      node = node.selectSingleNode("./record[@jsxid='" + arguments[i] + "']");
    }

    if (node && parent) {
      parent.removeChild(node);
      this._resetCache();
    }
  };

  Settings._setRecord = function(parent, strKey, value) {
    var record = Settings._getOrCreateRecord(strKey, parent);
    record.removeChildren();
    var type = typeof(value);

    if (value == null || type == "undefined") {
      record.setAttribute("type", "null");
      record.setValue(null);
    } else if (type == "string" || type == "number") {
      record.setAttribute("type", type);
      record.setValue(value);
    } else if (type == "boolean") {
      record.setAttribute("type", "boolean");
      record.setValue(value ? "true" : "false");
    } else if (type == "object") {
      if (value instanceof Array) {
        record.setAttribute("type", "array");
        for (var i = 0; i < value.length; i++) {
          Settings._setRecord(record, i.toString(), value[i]);
        }
      } else {
        record.setAttribute("type", "map");
        for (var f in value) {
          Settings._setRecord(record, f, value[f]);
        }
      }
    } else if (type == "function") {
      ;
    } else {
      jsx3.ERROR.doLog("idPR02", "Cannot persist object of type " + type, 5);
    }
  };

  Settings._getOrCreateRecord = function(strKey, parent) {
    var node = parent.selectSingleNode("./record[@jsxid='" + strKey + "']");
    if (!node) {
      node = parent.createNode(jsx3.xml.Entity.TYPEELEMENT, "record");
      node.setAttribute("jsxid", strKey);
      parent.appendChild(node);
    }
    return node;
  };

});

jsx3.Settings = jsx3.app.Settings;

// @jsxobf-clobber-shared  _EP _PERM _jsxselectionns _jsxselectionnsobj serializeNamespacesMap

jsx3.Class.defineClass("jsx3.xml.Entity", null, null, function(Entity, Entity_prototype) {

  Entity.TYPEELEMENT = 1;

  Entity.TYPEATTRIBUTE = 2;

  Entity.TYPETEXT = 3;

  Entity.TYPECDATA = 4;

  Entity.TYPECOMMENT = 8;

  Entity._SUPPORTED = {1:true, 2:true, 3:true, 4:true, 7:true, 8:true};

  Entity_prototype.init = function(objEntity) {
    //bind reference to the MSXML parser node that this classes APIs will wrap

    this._entity = objEntity;

    //for now only types 1 - 4 are supported

    this._nodeType = objEntity.nodeType;

    //check the type of entity - if not valid modify the error object
    if (!(Entity._SUPPORTED[this._nodeType])) {
      this.setError(300, jsx3._msg("xml.wrap_type", this._nodeType));
    } else if (this._error) {
      this.setError(0);
    }
  };

  Entity_prototype.createNode = function(intType, strNodeName, strNS) {
    //get handle to the document object (this has the ability to create nodes)
    var objDoc = this._getNativeDoc();
    var objNode = null;

 if (jsx3.CLASS_LOADER.IE) {
    if (strNS == null) strNS = "";
    if (intType == 3) {
      objNode = objDoc.createTextNode(strNodeName);
    } else if (intType == 4) {
      objNode = objDoc.createCDATASection(strNodeName);
    } else if (intType == 8) {
      objNode = objDoc.createComment(strNodeName);
    } else {
      objNode = objDoc.createNode(intType, strNodeName, strNS);
    }
 } else {
    // NOTE: see http://bugs.webkit.org/show_bug.cgi?id=14835
    if (strNS == null) strNS = null;
    if (intType == 2) {
      objNode = objDoc.createAttributeNS(strNS, strNodeName);
    } else if (intType == 3) {
      objNode = objDoc.createTextNode(strNodeName);
    } else if (intType == 4) {
      objNode = objDoc.createCDATASection(strNodeName);
    } else if (intType == 8) {
      objNode = objDoc.createComment(strNodeName);
    } else {
      objNode = objDoc.createElementNS(strNS, strNodeName);
    }
 }

    //return wrapped node
    return new Entity(objNode);
  };

  Entity_prototype.cloneNode = function(bDeep) {
    //make sure our wrapped node isn't null and user is passing the correct object type
    if (this._nodeType == 1) {
      var objMSXMLNode = this._entity.cloneNode(bDeep);
      return (new Entity(objMSXMLNode));
    } else {
      this.setError(301, jsx3._msg("xml.clone_tp", this._nodeType));
    }
  };

  Entity_prototype.appendChild = function(objEntity) {
    var e = objEntity._entity;
 if (jsx3.CLASS_LOADER.SAF || jsx3.CLASS_LOADER.FX) {
    var docChange = e.ownerDocument != this._entity.ownerDocument;
    if (docChange) e = this._entity.ownerDocument.importNode(e, true);
 }

    //make sure our wrapped node isn't null and user is passing the correct object type
    if (this._entity != null && e != null && this._nodeType == 1) {
      this._entity.appendChild(e);

 if (jsx3.CLASS_LOADER.SAF || jsx3.CLASS_LOADER.FX) {
      if (docChange && objEntity._entity.parentNode)
        objEntity._entity.parentNode.removeChild(objEntity._entity);
      objEntity._entity = e;
 }
    } else {
      this.setError(302, jsx3._msg("xml.err_append", objEntity));
    }
    return this;
  };

  Entity_prototype.insertBefore = function(objEntityNew, objEntityRef) {
    if (objEntityRef == null) {
      if (this._nodeType == 1) {
        this.appendChild(objEntityNew);
        return objEntityNew;
      }
    } else {
      var e = objEntityNew._entity;
 if (jsx3.CLASS_LOADER.SAF || jsx3.CLASS_LOADER.FX) {
      var docChange = e.ownerDocument != this._entity.ownerDocument;
      if (docChange) e = this._entity.ownerDocument.importNode(e, true);
 }

      if (this._nodeType == 1 && objEntityRef._nodeType != 2 && objEntityNew._nodeType != 2) {
        if (objEntityRef.getParent() != null && objEntityRef.getParent().equals(this)) {
          var retVal = (new Entity(this._entity.insertBefore(e, objEntityRef._entity)));

 if (jsx3.CLASS_LOADER.SAF || jsx3.CLASS_LOADER.FX) {
          if (docChange && objEntityNew._entity.parentNode) {
            objEntityNew._entity.parentNode.removeChild(objEntityNew._entity);
          }
          objEntityNew._entity = e;
 }

          return retVal;
        }
      }
      return null;
    }
  };

  Entity_prototype.replaceNode = function(objEntityNew, objEntityOld) {
    var e = objEntityNew._entity;
 if (jsx3.CLASS_LOADER.SAF || jsx3.CLASS_LOADER.FX) {
    var docChange = e.ownerDocument != this._entity.ownerDocument;
    if (docChange) e = this._entity.ownerDocument.importNode(e, true);
 }

    if (this._nodeType == 1 && objEntityOld._nodeType == 1 && objEntityNew._nodeType == 1) {
      if (objEntityOld.getParent() != null && objEntityOld.getParent().equals(this) && objEntityOld.getParent() != null && objEntityOld.getParent().equals(this)) {
        var retVal = (new Entity(this._entity.replaceChild(e, objEntityOld._entity)));

 if (jsx3.CLASS_LOADER.SAF || jsx3.CLASS_LOADER.FX) {
        if (docChange && objEntityNew._entity.parentNode)
          objEntityNew._entity.parentNode.removeChild(objEntityNew._entity);
        objEntityNew._entity = e;
 }

        return retVal;
      }
    }
    return null;
  };

  Entity_prototype.setAttribute = function(strName, strValue) {
    //make sure our wrapped node isn't null and user is passing the correct object type
    if (strValue != null)
      // HACK: IE's XML conversion to String is incompatible with JavaScript, so explicit String conversion
      this._entity.setAttribute(strName, String(strValue));
    else
      this.removeAttribute(strName);
    return this;
  };

  Entity_prototype.getAttribute = function(strName) {
    //return as simple string; no need to wrap
    return this._entity ? this._entity.getAttribute(strName) : null;
  };

  Entity_prototype.getAttributeNode = function(strName) {
    //make sure our wrapped node isn't null and user is passing the correct object type
    if (this._entity != null && this._nodeType == 1) {
      var objAtt = this._entity.getAttributeNode(strName);
      if (objAtt != null) return (new Entity(objAtt));
    }
  };

  Entity_prototype.setAttributeNode = function(objAtt) {
    var e = objAtt._entity;
 if (jsx3.CLASS_LOADER.SAF) {
    //3.6:  LUKE:  Removed FX from the conditional above:   (|| jsx3.CLASS_LOADER.FX)
    //             This same code worked in Fx 1.5 and 2.  I believe the transformiix processor was updated in all versions
    //             Validate against Fx release notes for both hot fixes and major releases to see if this should be changed or additional
    //             Firefox exceptions need to be noted per version, release, etc
    //I cannot find public DOM methods for setting the namespace as an axis (not attribute); there has to be something (or is this a bug to file for them)
    if(!jsx3.util.strEmpty(objAtt.getPrefix()))
      this.setAttribute("xmlns:" + objAtt.getPrefix(),objAtt.getNamespaceURI());
 }

   if (jsx3.CLASS_LOADER.SAF  || jsx3.CLASS_LOADER.FX) {
     var docChange = e.ownerDocument != this._entity.ownerDocument;
    if (docChange) {
      e = this._entity.ownerDocument.createAttribute(e.nodeName);
      e.nodeValue = objAtt._entity.nodeValue;
      objAtt._entity = e;
    }
 }

 if (jsx3.CLASS_LOADER.IE) {
    this._entity.setAttributeNode(e);
 } else {
    this._entity.setAttributeNodeNS(e);
 }
    return this;
  };

  Entity_prototype.getAttributes = function() {
    //make sure our wrapped node isn't null and user is passing the correct object type
    if (this._entity != null && this._nodeType == 1)
      return new Entity.List(this._entity.attributes);
    else
      return null;
  };

  Entity_prototype.getAttributeNames = function() {
    var att = this._entity.attributes;
    var names = new Array(att.length);
    for (var i = 0; i < names.length; i++)
      names[i] = att[i].nodeName;
    return names;
  };

  Entity_prototype.getRootNode = function() {
    return this._entity ? (new Entity(this._getNativeDoc(1))) : null;
  };

  Entity_prototype.getParent = function() {
    //return the parent ref; return null if na
    return (this._entity != this._getNativeDoc(1)) ? (new Entity(this._entity.parentNode)) : null;
  };

  Entity_prototype.getChildIterator = function(bIncludeText) {
    return new Entity.ChildIterator(this._entity ? this._entity.childNodes : [], bIncludeText);
  };

  Entity_prototype.getChildNodes = function(bIncludeText) {
    if (! this._entity) return new Entity.List([]);
    var nodes = this._entity.childNodes;
    var children = [];
    for (var i = 0; i < nodes.length; i++) {
      var node = nodes[i];
      if (node.nodeType == 1 ||
          (bIncludeText && (node.nodeType == 3 || node.nodeType == 4)))
        children[children.length] = node;
    }
    return new Entity.List(children);
  };

  Entity_prototype.removeChild = function(objChildEntity) {
    //make sure acutal parent according to native relationships
    var p = objChildEntity.getParent();
    return p != null && p.equals(this) ?
        new Entity(this._entity.removeChild(objChildEntity._entity)) : null;
  };

  Entity_prototype.removeChildren = function() {
    var children = this._entity.childNodes;
    for (var i = children.length - 1; i >= 0; i--) {
      this._entity.removeChild(children[i]);
    }
  };

  Entity_prototype.removeAttribute = function(strAttName) {
    //make sure acutal parent according to native relationships
    if (this._nodeType == 1) this._entity.removeAttribute(strAttName);
  };

  Entity_prototype.removeAttributeNode = function(objAtt) {
    this._entity.removeAttributeNode(objAtt._entity);
    return this;
  };

  Entity_prototype.equals = function(objEntity) {
    //make sure acutal parent according to native relationships
    return (objEntity._entity == this._entity);
  };

  Entity_prototype.getNodeType = function() {
    //nodeType was set at instantiation and can be referenced as a property on this JS class directly
    return this._nodeType;
  };

  Entity_prototype.getNodeName = function() {
    return this._entity.nodeName;
  };

  Entity_prototype.getNamespaceURI = function() {
    //return as simple string; no need to wrap
    //TO DO: there seeems to be an inconsistency with the signature in firefox (bugzilla). make sure an empty string is returned
    var sns = this._entity.namespaceURI;
    if(sns == null) sns = "";
    return sns;
  };

  Entity_prototype.selectSingleNode = function(strQuery, strNS) {
    if (! this._entity) return null;
    return this._selectNodeOrNodes(strQuery, strNS, 0);
  };

  Entity_prototype.selectNodes = function(strQuery, strNS) {
    if (! this._entity) return new Entity.List([]);
    return this._selectNodeOrNodes(strQuery, strNS, 1);
  };

  Entity_prototype.selectNodeIterator = function(strQuery, strNS) {
    if (! this._entity) return new Entity.SelectIterator();
    return this._selectNodeOrNodes(strQuery, strNS, 2);
  };

 if (jsx3.CLASS_LOADER.IE) {

  Entity_prototype.getBaseName = function() {
    //return as simple string; no need to wrap
    return this._entity.baseName;
  };

  Entity_prototype.getPrefix = function() {
    //return as simple string; no need to wrap
    return this._entity.prefix;
  };

  Entity_prototype.getXML = function() {
    return this._entity.xml;
  };

  Entity_prototype.toString = function() {
    var typeToken = "@" + this.getClass().getName();
    if (this._entity != null && !this.hasError()) {
      return (this._entity.xml) ? this._entity.xml :
          (this._entity.outerHTML ? this._entity.outerHTML : jsx3._msg("xml.str_unk", typeToken));
    } else {
      return this.hasError() ?
          jsx3._msg("xml.str_err", typeToken, this.getError()) :
          jsx3._msg("xml.str_empty", typeToken);
    }
  };

  Entity_prototype.getValue = function() {
    return (this._nodeType == 1) ? this._entity.text : this._entity.nodeValue;
  };

  Entity_prototype.setValue = function(strValue) {
    if (strValue == null) strValue = "";
    else strValue = String(strValue);

    if (this._nodeType == 1) {
      this._entity.text = strValue;
    } else {
      this._entity.nodeValue = strValue;
    }
    return this;
  };

  Entity_prototype._selectNodeOrNodes = function(strQuery, strNS, intMode) {
    if (typeof(strNS) == "object") strNS = jsx3.xml.Document.serializeNamespacesMap(strNS);

    //resolve the declaration as a selection namespace
    var strPrevNS, objDoc = null;
    if (strNS != null) {
      objDoc = this._entity.ownerDocument;
      strPrevNS = objDoc.getProperty("SelectionNamespaces");
      objDoc.setProperty("SelectionNamespaces", strNS);
    }

    var retVal = null, objNodes;
    if (intMode) {
      try {
        objNodes = this._entity.selectNodes(strQuery);
      } catch (e) {
        objNodes = [];
      }
      retVal = intMode == 2 ? new Entity.SelectIterator(objNodes) : new Entity.List(objNodes);
    } else {
      try {
        var objNode = this._entity.selectSingleNode(strQuery);
      } catch (e) {;}
      retVal = objNode ? new Entity(objNode) : null;
    }

    if (objDoc) objDoc.setProperty("SelectionNamespaces", strPrevNS);

    return retVal;
  };

 } else {

  Entity_prototype.getBaseName = function() {
    //return as simple string; no need to wrap
    var strNodeName = this.getNodeName();
    var index = strNodeName.indexOf(":");
    return index >= 0 ? strNodeName.substring(index+1) : strNodeName;
  };

  Entity_prototype.getPrefix = function() {
    //return as simple string; no need to wrap
    var strNodeName = this.getNodeName();
    var index = strNodeName.indexOf(":");
    return index >= 0 ? strNodeName.substring(0, index) : "";
  };

  Entity_prototype.getXML = function() {
    return this.toString();
  };

  Entity_prototype.toString = function() {
    var typeToken = "@" + this.getClass().getName();

    if (this._entity != null && !this.hasError()) {
      if (this.getNodeType() == 2) {
        return this.getNodeName() + '="' + this.getValue() + '"';
      } else {
        return (new XMLSerializer()).serializeToString(this._entity);
      }
    } else {
      return this.hasError() ?
          jsx3._msg("xml.str_err", typeToken, this.getError()) :
          jsx3._msg("xml.str_empty", typeToken);
    }
  };

  Entity_prototype.getValue = function() {
    if (this._nodeType == 1) {
      var tokens = new Array(this._entity.childNodes.length);
      for (var i = 0; i < this._entity.childNodes.length; i++) {
        var child = this._entity.childNodes[i];
        if (child.nodeType == Entity.TYPETEXT || child.nodeType == Entity.TYPECDATA)
          tokens[i] = child.nodeValue;
        else
          tokens[i] = child.textContent;
      }
      return tokens.join("");
    } else {
      return this._entity.nodeValue;
    }
  };

  Entity_prototype.setValue = function(strValue) {
    if (strValue == null) strValue = "";
    if (this._nodeType == 1) {
      this.removeChildren();
      this.appendChild(this.createNode(3, strValue));
    } else {
      this._entity.nodeValue = strValue;
    }
    return this;
  };

  Entity._XPE = new XPathEvaluator();

  Entity._RESULT_TYPES = [XPathResult.FIRST_ORDERED_NODE_TYPE,
      XPathResult.ORDERED_NODE_ITERATOR_TYPE,
      XPathResult.ORDERED_NODE_SNAPSHOT_TYPE];

  Entity_prototype._selectNodeOrNodes = function(strQuery, strNS, intMode) {
    if (typeof(strNS) == "object") strNS = jsx3.xml.Document.serializeNamespacesMap(strNS);

    var doc = this._entity.ownerDocument;
    var root = doc.documentElement;
    var nsResolver = strNS ? Entity._createNSResolver(strNS, root) :
        (Entity._getDocNSResolver(doc) || Entity._XPE.createNSResolver(root));

    var objResult = null;
    try {
      objResult = Entity._XPE.evaluate(strQuery, this._entity, nsResolver, Entity._RESULT_TYPES[intMode], null);
    } catch (e) {
      ; // QUESTION: what if this is a real error?
    }

    if (intMode == 1) {
      var itm = null;
      var objNodes = [];
      if (objResult)
        while (itm = objResult.iterateNext()) objNodes[objNodes.length] = itm;

      return new Entity.List(objNodes);
    } else if (intMode == 2) {
      return new Entity.SelectIterator(objResult);
    } else {
      return objResult && objResult.singleNodeValue ? new Entity(objResult.singleNodeValue) : null;
    }
  };

  Entity._getDocNSResolver = function(doc) {
    if (! doc._jsxselectionnsobj) {
      if (doc._jsxselectionns)
        doc._jsxselectionnsobj = Entity._createNSResolver(doc._jsxselectionns);
    }
    return doc._jsxselectionnsobj;
  };

  Entity._nsResCache = {}; // TODO: limit the size of this cache

  Entity._createNSResolver = function(ns) {
    var resolver = Entity._nsResCache[ns];
    if (!resolver) {
      var nsDoc = (new DOMParser()).parseFromString('<foo ' + ns + '/>', "text/xml");
      resolver = Entity._nsResCache[ns] = Entity._XPE.createNSResolver(nsDoc.documentElement);
    }
    return resolver;
  };

 }

  Entity_prototype._getNativeDoc = function(intType) {
    if (intType == null) {
      return this._entity.ownerDocument;
    } else if (intType == 1) {
      var doc = this._entity.ownerDocument;
      return doc != null ? doc.documentElement : null;
    } else if (intType == 2) {
      return this._entity.documentElement;
    }
  };

  Entity_prototype.getNative = function() {
    //returns the entire MSXML instance
    return this._entity;
  };

  Entity_prototype.getFirstChild = function() {
    if (this._nodeType == 1) {
      var objNode = this._entity.firstChild;

      // only return elements
      while (objNode != null && objNode.nodeType != 1)
        objNode = objNode.nextSibling;

      if (objNode != null) return (new Entity(objNode));
    }
    return null;
  };

  Entity_prototype.getLastChild = function() {
    if (this._nodeType == 1) {
      var objNode = this._entity.lastChild;

      // only return elements
      while (objNode != null && objNode.nodeType != 1)
        objNode = objNode.previousSibling;

      if (objNode != null) return (new Entity(objNode));
    }
    return null;
  };

  Entity_prototype.getPreviousSibling = function() {
    if (this._nodeType == 1) {
      var objNode = this._entity.previousSibling;

      // only return elements
      while (objNode != null && objNode.nodeType != 1)
        objNode = objNode.previousSibling;

      if (objNode != null) return (new Entity(objNode));
    }
    return null;
  };

  Entity_prototype.getNextSibling = function() {
    if (this._nodeType == 1) {
      var objNode = this._entity.nextSibling;

      // only return elements
      while (objNode != null && objNode.nodeType != 1)
        objNode = objNode.nextSibling;

      if (objNode != null) return (new Entity(objNode));
    }
    return null;
  };

  Entity_prototype.transformNode = function(objEntityFilter, objParams, bObject) {
    throw fit;
  };

  Entity._Error = function() {};
  Entity._Error.prototype.toString = function() {
    return "[" + this.code + "]" + (typeof(this.description) != "undefined" ? " " + this.description : "");
  };

  Entity_prototype.setError = function(strCode, strDescription) {
    if (this._error == null) {

      this._error = new Entity._Error();
    }
    this._error.code = strCode;
    this._error.description = strDescription;
  };

  Entity_prototype.getError = function() {
    if (!this._error) this.setError(0);
    return this._error;
  };

  Entity_prototype.hasError = function() {
    return this._error != null && this._error.code != 0;
  };

  Entity_prototype.getOwnerDocument = function() {
    return this._entity ? new jsx3.xml.Document(this._getNativeDoc()) : null;
  };

  Entity.getVersion = function() {
    return "3.0.0";
  };

});

jsx3.Entity = jsx3.xml.Entity;

jsx3.Class.defineClass("jsx3.xml.Entity.List", jsx3.util.List, null, function(List, List_prototype) {

  var Exception = jsx3.Exception;

  List_prototype.init = function(arrSrc) {
    this.jsxsuper(null, true);

    this._src = arrSrc; // some node lists are not instanceof Array
  };

  List_prototype.get = function(intIndex) {
    var o = this._src[intIndex];
    return o != null ? new jsx3.xml.Entity(o) : o;
  };

  var exMessage = "Not implemented";
  List_prototype.add = function() { throw new Exception(exMessage); };
  List_prototype.addAll = function() { throw new Exception(exMessage); };
  List_prototype.set = function() { throw new Exception(exMessage); };
  List_prototype.remove = function() { throw new Exception(exMessage); };
  List_prototype.removeAt = function() { throw new Exception(exMessage); };
  List_prototype.sort = function() { throw new Exception(exMessage); };

  List_prototype.slice = function(intStart, intEnd) {
    return new List(arguments.length > 1 ? this._src.slice(intStart, intEnd) : this._src.slice(intStart));
  };

  List_prototype.toString = function() {
    return "[" + this.toArray() + "]";
  };

  List_prototype.clone = function() {
    return new List(this._src.concat());
  };

  List_prototype.toArray = function() {
    var size = this.size();
    var a = new Array(size);
    for (var i = 0; i < size; i++)
      a[i] = this.get(i);
    return a;
  };

});

// @jsxobf-clobber  _nodes _index _text _prepNext _entity

jsx3.Class.defineClass("jsx3.xml.Entity.ChildIterator", null, [jsx3.util.Iterator], function(Iterator, Iterator_prototype) {

  Iterator_prototype.init = function(arrChildren, bText) {
    this._nodes = arrChildren;
    this._index = 0;
    this._text = bText;
    this._prepNext();
    this._entity = null;
  };

  Iterator_prototype.next = function() {
    if (!this._next) return null;

    if (this._entity) {
      this._entity.init(this._next);
    } else {
      this._entity = new jsx3.xml.Entity(this._next);
    }
    this._prepNext();
    return this._entity;
  };

  Iterator_prototype.hasNext = function() {
    return this._next != null;
  };

  Iterator_prototype._prepNext = function() {
    this._next = null;
    var nodes = this._nodes;
    var max = nodes.length;
    while (this._next == null && this._index < max) {
      var node = nodes[this._index];
      if (node.nodeType == 1 || (this._text && (node.nodeType == 3 || node.nodeType == 4)))
        this._next = node;
      this._index++;
    }
  };

});

// @jsxobf-clobber  _i _n _entity

jsx3.Class.defineClass("jsx3.xml.Entity.SelectIterator", null, [jsx3.util.Iterator], function(Iterator, Iterator_prototype) {

  Iterator_prototype.init = function(i) {
    this._i = i;
    this._n = 0;
    this._entity = null;
  };

 if (jsx3.CLASS_LOADER.IE) {

  Iterator_prototype.next = function() {
    var next = this._i[this._n++];
    if (!next) return null;

    if (this._entity) {
      this._entity.init(next);
    } else {
      this._entity = new jsx3.xml.Entity(next);
    }

    return this._entity;
  };

  Iterator_prototype.hasNext = function() {
    return this._i && this._n < this._i.length;
  };

 } else {

  Iterator_prototype.next = function() {
    var next = this._i.snapshotItem(this._n++);
    if (!next) return null;

    if (this._entity) {
      this._entity.init(next);
    } else {
      this._entity = new jsx3.xml.Entity(next);
    }

    return this._entity;
  };

  Iterator_prototype.hasNext = function() {
    return this._i && this._n < this._i.snapshotLength;
  };

 }

});

jsx3.Collection = jsx3.xml.Entity.List;

jsx3.util.Collection = jsx3.Collection;

// @jsxobf-clobber-shared  _initFromReq

jsx3.Class.defineClass("jsx3.net.Request", null, [jsx3.util.EventDispatcher], function(Request, Request_prototype) {

  Request.STATUS_OK = 200;

  Request.STATUS_ERROR = 400;

  Request.EVENT_ON_RESPONSE = "response";

  Request.EVENT_ON_TIMEOUT = "timeout";

  Request.trackArray = {};

  Request_prototype.init = function(id) {

    if (id != null)
      Request.trackArray[id] = this;

 if (jsx3.CLASS_LOADER.IE) {
    try {

      this._request = jsx3.getHttpInstance();
    } catch (e) {
      throw new jsx3.Exception(jsx3._msg("req_inst"), jsx3.NativeError.wrap(e));
    }
 } else {
    try {
      this._request = new XMLHttpRequest();
    } catch (e) {
      throw new jsx3.Exception(jsx3._msg("req_inst"), jsx3.NativeError.wrap(e));
    }
 }
  };

  Request_prototype.abort = function() {
    if (this._timeoutto) {
      window.clearTimeout(this._timeoutto);
      delete this._timeoutto;
    }

    this._request.onreadystatechange = new Function();

    //call the native abotr
    this._request.abort();
    return this;
  };

  Request_prototype.getAllResponseHeaders = function() {
    return this._request.getAllResponseHeaders();
  };

  Request_prototype.getResponseHeader = function(strName) {
    try {
      return this._request.getResponseHeader(strName);
    } catch (e) {
      return null;
    }
  };

  Request_prototype.getStatusText = function() {
    return this._request.statusText;
  };

  Request_prototype.getStatus = function() {
    var s = this._status != null ? this._status : this._request.status;
 if (jsx3.CLASS_LOADER.SAF) {
    // HACK: http://bugs.webkit.org/show_bug.cgi?id=14831
    if (s < 0 || s == 112 || s >= 600) s = Request.STATUS_ERROR;
 }

    return s == 0 ? Request.STATUS_OK : s;
  };

  Request_prototype.getResponseText = function() {
    return this._request.responseText;
  };

  Request_prototype.getResponseXML = function() {
    var objDoc = new jsx3.xml.Document();
    objDoc._initFromReq(this);

    if (!objDoc.hasError()) {
      return objDoc;
    } else {
      Request._log(2, jsx3._msg("req.bad_xml", this._url, objDoc.getError()));
      return null;
    }
  };

  Request_prototype.getNative = function() {
    return this._request;
  };

  Request_prototype.setRequestHeader = function(strName, strValue) {
    this._request.setRequestHeader(strName, String(strValue));
    return this;
  };

  Request_prototype.getReadyState = function() {
    //get handle to the XMLHTTP object associated with the SOAPSocket instance
    return this._request.readyState;
  };

  Request.open = function(strMethod, strURL, bAsync, strUser, strPass) {
    var url = jsx3.net.URI.valueOf(strURL);
    var scheme = url.getScheme();
    var handler = Request._HANDLERS[scheme] || Request.jsxclass;
    return (handler.newInstance()).open(strMethod, url, bAsync, strUser, strPass);
  };

  Request._HANDLERS = {};

  Request.addSchemeHandler = function(scheme, handler) {
    Request._HANDLERS[scheme] = handler;
  };

  Request.getSchemeHandler = function(scheme) {
    return Request._HANDLERS[scheme];
  };

  Request_prototype.open = function(strMethod, strURL, bAsync, strUser, strPass) {
//    if (!bAsync) {
//      Request._log(3, "Synchronous request to: " + strURL);
////      if (Request._LOG)
////        Request._LOG.logStack(4, "");
//    }

    this._status = 0;

    this._async = Boolean(bAsync);

    this._method = strMethod;

    this._url = jsx3.net.URIResolver.DEFAULT.resolveURI(strURL);

 if (! jsx3.CLASS_LOADER.IE) {
      try {
        if (window.netscape && netscape.security)
          netscape.security.PrivilegeManager.enablePrivilege('UniversalBrowserRead');
      } catch (e) {
        Request._log(5, jsx3._msg("req.netsc", jsx3.NativeError.wrap(e)));
      }
 }

    //open the request, passing in relevant info and return object ref
    try {
      Request._log(6, jsx3._msg("req.open", this._url));
      this._request.open(strMethod, this._url.toString(), this._async, strUser, strPass);
    } catch (e) {
      this._status = Request.STATUS_ERROR; // communicate failure to client
      Request._log(2, jsx3._msg("req.err_open", strURL, jsx3.NativeError.wrap(e)));
    }

    return this;
  };

  Request.cancelRequest = function(strRequestId) {
    var r = Request.trackArray[strRequestId];
    if (r) r.abort();
  };

  Request.getRequest = function(strRequestId) {
    return Request.trackArray[strRequestId];
  };

  Request_prototype.getURL = function() {
    return this._url && this._url.toString();
  };

  Request_prototype.setTimeouts = function(intResolveTimeout,intConnectTimeout,intSendTimeout,intReceiveTimeout) {
 if (jsx3.CLASS_LOADER.IE) {
    try {
      this._request.setTimeouts(intResolveTimeout,intConnectTimeout,intSendTimeout,intReceiveTimeout);
    } catch (e) {
      Request._log(3, "The HTTP ActiveX object does not appear to support setting timeouts.");
    }
 }
    return this;
  };

  Request_prototype.send = function(strContent, intTimeout) {
    if (this._status == Request.STATUS_ERROR)
      throw new jsx3.Exception(jsx3._msg("req.err_state"));

    var t1 = new jsx3.util.Timer(Request.jsxclass, this._url);

    var bError = false;

    try {
      this._request.send(strContent);

      if (this._async)

        this._status = 0;
      else
        delete this._status;

    } catch (e) {
      // TODO: communicate failure to client
      this._status = Request.STATUS_ERROR; // Firefox seems to still report status as 0 when error on local file access.
      Request._log(2, jsx3._msg("req.err_send", this._url, jsx3.NativeError.wrap(e)));
      bError = this;
    }

    // if this async, add the request object to the array of
    if (this._async) {
      if (bError || this._request.readyState == 4) {
        // If async, events should always be published asynchronously.
        jsx3.sleep(function() {

          t1.log("load.async");

          this.publish({subject:Request.EVENT_ON_RESPONSE});
        }, null, this);
      } else {
        var me = this;
        this._request.onreadystatechange = function() {
          if (me._request.readyState == 4) {

            t1.log("load.async");

            me._onReadyStateChange();
          }
        };

        if (!isNaN(intTimeout) && intTimeout > 0) {
          //set timeout to fire if the response doesn't happen in time
          this._timeoutto = window.setTimeout(function() {

            t1.log("timeout");

            me._onTimeout();
          }, intTimeout);
        }
      }
    }

    else {
      t1.log("load.sync");
    }

    return this;
  };

  Request_prototype._onTimeout = function() {
    delete this._timeoutto;
    this.abort();
    this._status = 408; // request timeout
    this.publish({subject:Request.EVENT_ON_TIMEOUT});
  };

  Request_prototype._onReadyStateChange = function() {
    delete this._status;

    if (this._timeoutto) {
      window.clearTimeout(this._timeoutto);
      delete this._timeoutto;
    }

    this._request.onreadystatechange = new Function();

    this.publish({subject:Request.EVENT_ON_RESPONSE});
  };

  Request_prototype.toString = function() {
    return this.jsxsuper() + " " + this._method + " " + this.getStatus() + " " + this._url;
  };

  Request._log = function(intLevel, strMessage) {
    if (Request._LOG == null) {
      if (jsx3.util.Logger) {

        Request._LOG = jsx3.util.Logger.getLogger(Request.jsxclass.getName());
        if (Request._LOG == null) return;
      } else {
        return;
      }
    }
    Request._LOG.log(intLevel, strMessage);
  };

  Request.getVersion = function() {
    return "3.00.00";
  };

});

// @jsxobf-clobber-shared  setError _jsxselectionns _jsxselectionnsobj
// @jsxobf-clobber  _document _jsx_sn_hash

jsx3.Class.defineClass("jsx3.xml.Document", jsx3.xml.Entity, [jsx3.util.EventDispatcher], function(Document, Document_prototype) {

  var Entity = jsx3.xml.Entity;

  Document.ON_RESPONSE = "response";

  Document.ON_ERROR = "error";

  Document.ON_TIMEOUT = "timeout";

  Document.SEARCHABLE_NAMESPACE = "http://xsd.tns.tibco.com/gi/cxf/2006";

  Document.SEARCHABLE_PREFIX = "jsx_xmlns";

  Document.SEARCHABLE_REGEXP = /xmlns:([^=]*)=['"]([^"^']*)['"]/g;

 if (jsx3.CLASS_LOADER.IE) {
  try {
    // HACK: turns out that calling this once and then cloning the document is 3x faster on IE6

    var p = Document._PROTO = jsx3.getXmlInstance();
    p.setProperty("SelectionLanguage", "XPath");
    p.async = false;
    p.validateOnParse = false;
    p.resolveExternals = false;
    p.preserveWhiteSpace = true;
    p.setProperty("ForcedResync", false); // Lets IE use cached version of file.
  } catch (e) {
    window.alert(jsx3.NativeError.wrap(e));
  }
 }

  Document_prototype.init = function(objDoc) {
    var bEnt = objDoc instanceof Entity;
    if (!objDoc || bEnt) {
      try {
 if (jsx3.CLASS_LOADER.IE) {
        if (Document._PROTO == null) {
          this.setError(100, jsx3._msg("xml.parser", null));
          return;
        }

        this._document = Document._PROTO.cloneNode(true);

        //3.2 update: as of the 4.0 version of the msxml parser, the following settings were defaulted to 'true' (as opposed to false for the 3.0 version).
        //this is being explicitly set to provide consistency
 } else {
        //TODO: need to see if Safari has a setting or call to use here that won't create a document that defaults to the xhtml namespace (or the namespace of the browser document)
        this._document = window.document.implementation.createDocument("", "", null);
 }
      } catch (e) {
        this.setError(101, jsx3._msg("xml.parser", jsx3.NativeError.wrap(e)));
        delete this._document;
      }

      if (objDoc) {
        this._document.appendChild(objDoc.getNative().cloneNode(true));
        this.jsxsuper(this._document.documentElement);
      }
    } else {
      this._document = objDoc;
      this.jsxsuper(objDoc.documentElement);
    }
  };

  Document_prototype.load = function(strURL, intTimeout) {
    __jtolog += "loading document: " + strURL + "\n";
    var net = jsx3.net;
    var Request = net.Request;

    this._url = strURL.toString();

    //reset error state (used by hasError)
    this.setError(0);

    //set whether or not the doc should load synchronously; if an error is thrown and mode is firefox, probably due to document.domain issue
    var bAsync = Boolean(this.getAsync());

    var req = Request.open("GET", strURL, bAsync);

    if (req.getStatus() != Request.STATUS_ERROR) {
      if (bAsync)
        req.subscribe("*", this, "_onRequestEvent");

      req.send(null, intTimeout);
    }

    if (!bAsync)
      this._initFromReq(req);

    return this;
  };

  Document_prototype._initFromReq = function(objReq) {
    var url = this._url;
    this._initFromReq2(objReq);
    this._url = url;

    if (this.hasError())
      this.publish({subject:Document.ON_ERROR});
    else
      this.publish({subject:Document.ON_RESPONSE});
  };

  Document_prototype._initFromReq2 = function(objReq) {
    //LUKE (3.6.2/3.7): the following is an attempt to determine if an XML document should even be loaded via getResponseXML
    //Since the document class now uses the request class to load content, missing documents are returned as XHTML 404 Web pages.
    //This causes a regression where an HTML document is returned instead of null. To bypass, the HTTP status and the content-type
    //can be used to better limit if an XML was actually located.  Since NOT returning a document is a restrictive
    //act, the conditional below attempts to load the document if any one of three conditions is met:
    // 1) running from the file system, 2) content-type contains the string, 'xml', or 3) the status code is 200-299
    var status = objReq.getStatus() + "";
    var strCT = objReq.getResponseHeader("content-type");
    if(jsx3.util.strEmpty(strCT) ? true : (/xml/i.test(strCT) || /^2[0-9]+[0-9]+/.test(status))) {
      this.loadXML(objReq.getResponseText());
    } else {
      //TODO: I want a different error message here
      this.setError(102, jsx3._msg("xml.doc_status", this._url, status));
    }
  };

  Document_prototype._onRequestEvent = function(objEvent) {
    var Request = jsx3.net.Request;
    var req = objEvent.target;
    var strSubject = objEvent.subject;

    req.unsubscribe("*", this, "_onRequestEvent");

    if (strSubject == Request.EVENT_ON_RESPONSE) {
      this._initFromReq(req);
    } else if (strSubject == Request.EVENT_ON_TIMEOUT) {
      this.setError(111, jsx3._msg("xml.timeout"));
      this.publish({subject:Document.ON_TIMEOUT});
    } else {
      Document._log();
    }
  };

 if (jsx3.CLASS_LOADER.IE) {

  Document_prototype._initEntity = function(objElm) {
    Entity.prototype.init.call(this, objElm);

    var ns = [];
    var attr = this.getAttributeNames();
    for (var i = 0; i < attr.length; i++) {
      var a = attr[i];
      if (a.indexOf("xmlns:") == 0)
        ns[ns.length] = a + '="' + this.getAttribute(a) + '"';
    }
    this.setSelectionNamespaces(ns.join(" "));
  };

  Document_prototype.loadXML = function(strXML) {
    this._url = null;
    this.setError(0);

    try {

      var t1 = new jsx3.util.Timer(Document.jsxclass, strXML != null ? jsx3.util.strTruncate(strXML, 30) : "", 5);

      this._document.loadXML(strXML);

      if (! this._setErrorFromParser(this._document))
        this._initEntity(this._document.documentElement);

      t1.log("parse");

    } catch (e) {
      this._setErrorFromParser(this._document, jsx3.NativeError.wrap(e));
    }
    return this;
  };

 } else if (jsx3.CLASS_LOADER.SAF) {

  Document_prototype._initEntity = function(objElm) {
    Entity.prototype.init.call(this, objElm);
  };

  Document_prototype.loadXML = function(strXML) {
    this._url = null;
    this.setError(0);

    try {

      var t1 = new jsx3.util.Timer(Document.jsxclass, strXML != null ? jsx3.util.strTruncate(strXML, 30) : "", 5);

      this._document = (new DOMParser()).parseFromString(strXML, "text/xml");

      if (! this._setErrorFromParser(this._document))
        this._initEntity(this._document.documentElement);

      t1.log("parse");

    } catch (e) {
      this._setErrorFromParser(this._document, jsx3.NativeError.wrap(e));
    }

    return this;
  };

 } else if (jsx3.CLASS_LOADER.FX) {

  Document_prototype._initEntity = function(objElm) {
    Entity.prototype.init.call(this, objElm);
  };

  Document_prototype.loadXML = function(strXML) {
    this._url = null;
    this.setError(0);

    try {

      var t1 = new jsx3.util.Timer(Document.jsxclass, strXML != null ? jsx3.util.strTruncate(strXML, 30) : "", 5);

      this._document = (new DOMParser()).parseFromString(strXML, "text/xml");

      if (! this._setErrorFromParser(this._document))
        this._initEntity(this._document.documentElement);

      t1.log("parse");

    } catch (e) {
      this._setErrorFromParser(this._document, jsx3.NativeError.wrap(e));
    }

    return this;
  };

 }

  Document_prototype.getSourceURL = function() {
    return this._url;
  };

  Document_prototype._setErrorFromParser = function(parser, ex) {
    if (parser != null) {
      // QUESTION: I have no idea if this applies to Fx
      var parseError = parser.parseError;
      if (parseError != null && parseError.errorCode != "0") {
        var strMessage = jsx3._msg("xml.err_fmt", parseError.errorCode, parseError.line, parseError.linepos,
            jsx3.util.strTrim(String(parseError.reason)), jsx3.util.strTruncate(parseError.srcText), parseError.url);
        this.setError(parseError.errorCode, strMessage);
        return true;
      }
 if (jsx3.CLASS_LOADER.SAF) {
      var docElement = parser.documentElement;
      if (docElement == null) {
        if (ex)
          this.setError(156, jsx3._msg("xml.doc_bad_ex", ex));
        else
          this.setError(106, jsx3._msg("xml.doc_bad"));
        return true;
      } else {
        var xpe = new XPathEvaluator();
        var nsr = jsx3.CLASS_LOADER.GOG ?
                xpe.createNSResolver((new DOMParser()).parseFromString('<x xmlns:x="http://www.w3.org/1999/xhtml"/>', "text/xml")) :
                function(prefix) {
                  if (prefix == "x") return "http://www.w3.org/1999/xhtml";
                  return null;
                };

        var objResult = xpe.evaluate("//x:parsererror//x:div", parser, nsr);
        var descNode = objResult.iterateNext();
        if (descNode) {
          this.setError(107, descNode.textContent.replace(/[\n\r]/g, " "));
          return true;
        }
      }
 } else if (! jsx3.CLASS_LOADER.IE) {
      var docElement = parser.documentElement;
      if (docElement == null) {
        if (ex)
          this.setError(158, jsx3._msg("xml.doc_bad_ex", ex));
        else
          this.setError(108, jsx3._msg("xml.doc_bad"));
        return true;
      } else if (docElement.tagName == "parsererror" && docElement.namespaceURI &&
          docElement.namespaceURI.match(/^http:\/\/www\.mozilla\.org\/(.+\/)?parsererror.xml/i)) {
        this.setError(109, docElement.textContent.replace(/[\n\r]/g, " "));
        return true;
      }
 }
    }

    if (ex != null) {
      this.setError(110, jsx3._msg("xml.unknown", jsx3.NativeError.wrap(ex)));
      return true;
    }

    return false;
  };

  Document_prototype.getValidateOnParse = function() {
    //TO DO: validate the analagous method for fx
    return this._document.validateOnParse;
  };

  Document_prototype.setValidateOnParse = function(bValidate) {
    this._document.validateOnParse = bValidate;
  };

  Document_prototype.getResolveExternals = function() {
    //TO DO: validate the analagous method for fx
    return this._document.resolveExternals;
  };

  Document_prototype.setResolveExternals = function(bResolve) {
    this._document.resolveExternals = bResolve;
  };

 if (jsx3.CLASS_LOADER.IE) {

  Document_prototype.toString = function() {
    if (this._document != null && !this.hasError()) {
      var s = this._document.xml;
      // HACK: remove trailing line break to match Fx behavior
      if (s.charCodeAt(s.length - 1) == 10 && s.charCodeAt(s.length - 2) == 13)
        s = s.substring(0, s.length - 2);
      return s;
    } else {
      return this.jsxsuper();
    }
  };

  Document_prototype.getXmlVersion = function() {
    return this._getXmlDeclAttr("version");
  };

  Document_prototype.getXmlEncoding = function() {
    return this._getXmlDeclAttr("encoding");
  };

  Document_prototype.getXmlStandalone = function() {
    return this._getXmlDeclAttr("standalone") == "yes";
  };

  Document_prototype._getXmlDeclAttr = function(strAttr) {
    var pi = this._document.childNodes[0];
    if (pi.nodeType == 7 && pi.nodeName == "xml") {
      var regexp = new RegExp("\\b" + strAttr + '="(.*?)"', "i");
      if (pi.nodeValue.match(regexp))
        return RegExp.$1;
    }
    return null;
  };

  Document_prototype.cloneDocument = function() {
    return new Document(this._document.cloneNode(true));
  };

 } else if (jsx3.CLASS_LOADER.SAF) {

  Document_prototype.cloneDocument = function() {
    var clone = new Document();
    clone.loadXML(this.getXML());
    return clone;
  };

 } else {

  Document_prototype.cloneDocument = function() {
    try {
      netscape.security.PrivilegeManager.enablePrivilege("UniversalBrowserRead");
    } catch (e) {;}

    try {
      var objDoc = new Document(this._document.cloneNode(true));
    } catch(e) {
      var objDoc = new Document();
      objDoc.loadXML(this.getXML());
    }
    return objDoc;
  };

 }

 if (! jsx3.CLASS_LOADER.IE) {

  Document_prototype.toString = function() {
    if (this._document != null && !this.hasError()) {
      return (new XMLSerializer()).serializeToString(this._document);
    } else {
      return this.jsxsuper();
    }
  };

  Document_prototype.getXmlVersion = function() {
    return this._document.xmlVersion;
  };

  Document_prototype.getXmlEncoding = function() {
    return this._document.xmlEncoding;
  };

  Document_prototype.getXmlStandalone = function() {
    return this._document.xmlStandalone;
  };

 }

  Document_prototype.serialize = function(strVersion, strEncoding, bStandalone) {
    if (strVersion === true) strVersion = this.getXmlVersion() || "1.0";
    if (strEncoding === true) strEncoding = this.getXmlEncoding();

    var clobberPI = strVersion || strEncoding || bStandalone;

    if (clobberPI) {
      var pi = '<?xml';
      if (strVersion) pi += ' version="' + strVersion + '"';
      if (strEncoding) pi += ' encoding="' + strEncoding + '"';
      if (bStandalone != null) pi += ' standalone="' + (bStandalone ? "yes" : "no") + '"';
      pi += '?>\n';

      var tokens = new Array(this._document.childNodes.length + 1);
      tokens[0] = pi;

      for (var i = 0; i < this._document.childNodes.length; i++) {
        var node = this._document.childNodes[i];
        if (node.nodeType != 7 || node.nodeName != "xml") {
          var wrapped = new Entity(node);
          tokens[i+1] = wrapped.hasError() ? "<!-- " + wrapped + " -->" : wrapped.toString();
        }
      }
    } else {
      var tokens = new Array(this._document.childNodes.length);

      for (var i = 0; i < this._document.childNodes.length; i++) {
        var node = this._document.childNodes[i];
        var wrapped = new Entity(node);
        tokens[i] = wrapped.hasError() ? "<!-- " + wrapped + " -->" : wrapped.toString();
        if (node.nodeType == 7 || node.nodeName == "xml")
          tokens[i] += "\n";
      }
    }

    return tokens.join("");
  };

  Document_prototype.createDocumentElement = function(strNodeName, strNSURI) {
 if (jsx3.CLASS_LOADER.IE) {
    if (strNSURI) {
      var objRoot = this._document.createNode(jsx3.xml.Entity.TYPEELEMENT,strNodeName,strNSURI);
    } else {
      var objRoot = this._document.createElement(strNodeName);
    }
 } else {
    // NOTE: see http://bugs.webkit.org/show_bug.cgi?id=14835
    if (strNSURI == null) strNSURI = null;
    var objRoot = this._document.createElementNS(strNSURI, strNodeName);
 }

    if (this._document.documentElement != null)
      this._document.replaceChild(objRoot, this._document.documentElement);
    else
      this._document.appendChild(objRoot);

    //bind expected references to the root node as the jsx3.xml.Document class implements the methods of the jsx3.xml.Entity class, meaning all methods that one can expect from the jsx3.xml.Entity class should apply to this class as well
    this._initEntity(this._document.documentElement);

    //return wrapped node
    return (new jsx3.xml.Entity(objRoot));
  };

  Document_prototype.createProcessingInstruction = function(strTarget, strData) {
    // TODO: Mozilla
    //create, append, and wrap
    var objRoot = this._document.createProcessingInstruction(strTarget, strData);
    this._document.appendChild(objRoot);
  };

  Document_prototype.setAsync = function(bAsync) {

    this._jsxasync = bAsync;
    return this;
  };

  Document_prototype.getAsync = function(strName) {
    return Boolean(this._jsxasync);
  };

  Document_prototype.setSelectionLanguage = function(strLanguage) {
 if (jsx3.CLASS_LOADER.IE) {
    this._document.setProperty("SelectionLanguage", strLanguage);
 }
    return this;
  };

  Document_prototype.getSelectionLanguage = function() {
 if (jsx3.CLASS_LOADER.IE) {
    return this._document.getProperty("SelectionLanguage");
 } else {
    return "XPath";
 }
  };

  Document.serializeNamespacesMap = function(map) {
    var a = [];
    for (var p in map)
      a[a.length] = "xmlns:" + map[p] + "='" + p + "'";
    return a.join(" ");
  };

  Document_prototype.setSelectionNamespaces = function(declaration) {
    //convert object to string (per IE format constraints)
    if(typeof(declaration) == "object") declaration = Document.serializeNamespacesMap(declaration);

 if (jsx3.CLASS_LOADER.IE) {
    try {
      this._document.setProperty("SelectionNamespaces", declaration);
    } catch (e) {
      this.setError(113, jsx3._msg("xml.selns", declaration, jsx3.NativeError.wrap(e)));
    }
 } else {
    this._document._jsxselectionns = declaration;
    this._document._jsxselectionnsobj = null;
 }
    return this;
  };

  Document_prototype.getSelectionNamespaces = function(strName) {
 if (jsx3.CLASS_LOADER.IE) {
    return this._document.getProperty("SelectionNamespaces");
 } else {
    //3.2 fix: updated signature to return empty string in FF as would be returned in IE
    return (this._document._jsxselectionns) ? this._document._jsxselectionns : "";
 }
  };

  Document_prototype.createNamespaceAxis = function() {
    var objNode = this.getRootNode();
    var strXML = objNode.toString();
    var intIncr = "";
    do {
      var re = new RegExp("xmlns:" + Document.SEARCHABLE_PREFIX + intIncr + "([^=]*)=['\"]([^\"^']*)['\"]","g");
      var intPos = strXML.search(re);
      if(intPos >= 0) intIncr = (intIncr == "") ? 0 : intIncr + 1;
    } while(intPos >= 0);

    this._createNamespaceAxis(objNode,Document.SEARCHABLE_PREFIX + intIncr);

 if (! jsx3.CLASS_LOADER.IE) {
    //how to add a new namespace???? reparse to commit...
    this.loadXML(this.getXML());
 }

    return Document.SEARCHABLE_PREFIX + intIncr;
  };

  Document_prototype._createNamespaceAxis = function(objElement,strPre) {
    //get the entity as string without descendants
    var strXML = objElement.cloneNode(false).getXML();

    //parse out all instances of the 'namespace' (xmlns) axis, and create a searchable equivalent belonging to the 'attribute' namespace
    var myArr;
    while(myArr = Document.SEARCHABLE_REGEXP.exec(strXML)) {
      if(RegExp.$1 != strPre && RegExp.$1 != "xml") {
        var objAtt = objElement.createNode( jsx3.xml.Entity.TYPEATTRIBUTE, (strPre + ":" + RegExp.$1), Document.SEARCHABLE_NAMESPACE);
        objAtt.setValue(RegExp.$2);
        objElement.setAttributeNode(objAtt);
      } else if( RegExp.$1 == "xml") {
        jsx3.log(strXML);
      }
    }

    //recurse to locate other xmlns declarations among descendant elements
    for (var i = objElement.getChildIterator(); i.hasNext(); )
      this._createNamespaceAxis(i.next(), strPre);
  };

  Document_prototype.getDeclaredNamespaces = function(objMap) {
    //reset the hash
    this._jsx_sn_hash = {};

    //get the root (start point)
    var objNode = this.getRootNode();
    if(objNode) this._getDeclaredNamespaces(objNode,{index:0},objMap);

    //return the final map (user can use to resolve namespaces with--effectively creates a QName)
    return this._jsx_sn_hash;
  };

  Document_prototype._getDeclaredNamespaces = function(objNode,oCounter,objMap) {
    //add a new namespace if unique
    var sQ = objNode.getNamespaceURI();
    if(sQ != "" && sQ != "http://www.w3.org/XML/1998/namespace") {
      var mypfx;
      if(!this._jsx_sn_hash[sQ] || (objMap && (mypfx = objNode.getPrefix()) != "" && typeof(objMap[mypfx]) != "undefined")) {
        if(mypfx) {
          this._jsx_sn_hash[sQ] = mypfx;
        } else {
          oCounter.index += 1;
          this._jsx_sn_hash[sQ] = "jsx" + oCounter.index;
        }
      }
    }

    //recurse if objNode is an element
    if (objNode.getNodeType() == jsx3.xml.Entity.TYPEELEMENT) {
      for (var i = objNode.selectNodeIterator("attribute::* | child::*"); i.hasNext(); ) {
        var objChild = i.next();
        if (objChild.getNodeType() == jsx3.xml.Entity.TYPEELEMENT ||
            objChild.getNodeType() == jsx3.xml.Entity.TYPEATTRIBUTE)
          this._getDeclaredNamespaces(objChild, oCounter, objMap);
      }
    }
  };

  Document_prototype.getNativeDocument = function() {
    //returns the xml parser instance
    return this._document;
  };

  Document._log = function(intLevel, strMessage) {
    if (Document._LOG == null) {
      if (jsx3.util.Logger) {

        Document._LOG = jsx3.util.Logger.getLogger(Document.jsxclass.getName());
        if (Document._LOG == null) return;
      } else {
        return;
      }
    }
    Document._LOG.log(intLevel, strMessage);
  };

  Document.getVersion = function() {
    return "3.0.0";
  };

});

jsx3.Document = jsx3.xml.Document;

// @jsxobf-clobber-shared  setError

jsx3.Class.defineClass("jsx3.xml.Processor", null, null, function(Processor, Processor_prototype) {

  Processor.DISABLE_OUTPUT_ESCAPING = 1;

  Processor.supports = function(strKey) {
    throw fit;
  };

  Processor_prototype.init = function(objXML, objXSL, objParams) {

    this._xml = objXML;

    this._xsl = objXSL;

    this._params = objParams;
  };

  Processor_prototype.setXML = function(objXML) {
    this._xml = objXML;
    return this;
  };

  Processor_prototype.setXSL = function(objXSL) {
    this._xsl = objXSL;
    return this;
  };

  Processor_prototype.setParams = function(objParams) {
    this._params = objParams;
    return this;
  };

  Processor_prototype.transformToObject = function() {
    return this.transform(true);
  };

  Processor_prototype.transform = function(bObject) {
    throw fit;
  };

});

jsx3.xml.Entity.jsxclass.mixin(jsx3.xml.Processor.prototype, true, ["getError", "hasError", "setError"]);

jsx3.Class.defineClass('jsx3.util.Logger', null, null, function(Logger, Logger_prototype) {

  var Method = jsx3.Method;
  var Exception = jsx3.Exception;

  Logger.OFF = 0;

  Logger.FATAL = 1;

  Logger.ERROR = 2;

  Logger.WARN = 3;

  Logger.INFO = 4;

  Logger.DEBUG = 5;

  Logger.TRACE = 6;

  Logger.MAX_LEVEL = Logger.FATAL;

  Logger.MIN_LEVEL = Logger.TRACE;

  Logger.GLOBAL = null;

  Logger.getLogger = function(strName) {
    var manager = Logger.Manager.getManager();
    if (manager == null) return null;

    var logger = manager.getLogger(strName);
    if (logger == null) {
      logger = new Logger(strName);
      manager.addLogger(logger);
    }
    return logger;
  };

  Logger._LEVELS = [null, "FATAL", "ERROR", "WARN", "INFO", "DEBUG", "TRACE"];

  Logger.levelAsString = function(intLevel) {
    return Logger._LEVELS[intLevel] || "";
  };

  Logger_prototype._name = null;

  Logger_prototype._handlers = null;

  Logger_prototype._mylevel = null;

  Logger_prototype._level = Logger.INFO;

  Logger_prototype._parent = null;

  Logger_prototype._useParent = true;

  Logger_prototype._children = null;

  Logger_prototype.init = function(strName) {
    this._name = strName;
  };

  // bean methods

  Logger_prototype.getName = function() {
    return this._name;
  };

  Logger_prototype.addHandler = function(objHandler) {
    if (!this._handlers)
      this._handlers = jsx3.$A();
    this._handlers.push(objHandler);
  };

  Logger_prototype.removeHandler = function(objHandler) {
    if (this._handlers)
      this._handlers.remove(objHandler);
  };

  Logger_prototype.getLevel = function() {
    return this._mylevel;
  };

  Logger_prototype.getEffectiveLevel = function() {
    return this._level;
  };

  Logger_prototype.setLevel = function(intLevel) {
    intLevel = Math.max(Logger.OFF, Math.min(Logger.MIN_LEVEL, intLevel));
    this._mylevel = intLevel;
    this._updateLevel();
  };

  Logger_prototype._updateLevel = function() {
    var newValue = null;

    if (this._mylevel != null) {
      newValue = this._mylevel;
    } else if (this._parent != null) {
      newValue = this._parent._level;
    } else {
      newValue = Logger_prototype._level;
    }

    if (newValue != this._level) {
      this._level = newValue;
      if (this._children) {
        for (var i = 0; i < this._children.length; i++)
          this._children[i]._updateLevel();
      }
    }
  };

  Logger_prototype.getParent = function() {
    return this._parent;
  };

  Logger_prototype.setParent = function(objParent) {
    // remove from old parent's children
    if (this._parent != null)
      this._parent._children.remove(this);

    this._parent = objParent;
    // add to new parent's children
    if (this._parent != null) {
      if (!this._parent._children)
        this._parent._children = jsx3.$A();
      this._parent._children.push(this);
    }

    this._updateLevel();
  };

  Logger_prototype.getUseParentHandlers = function() {
    return this._useParent;
  };

  Logger_prototype.setUseParentHandlers = function(bUseParent) {
    this._useParent = bUseParent;
  };

  // log methods

  Logger_prototype._dispatch = function(objRecord) {
    var logger = this;
    var recordLevel = objRecord.getLevel();

    while (logger) {
      var handlers = logger._handlers;
      if (handlers) {
        for (var i = 0; i < handlers.length; i++) {
          // check handler level here instead of in Handler.handle() method
          var handler = handlers[i];
          if (handler.isLoggable(recordLevel)) {
            try {
              handler.handle(objRecord);
            } catch (e) {
              e = jsx3.NativeError.wrap(e);
              Logger.getLogger(Logger.jsxclass.getName()).error(jsx3._msg("logr.err_hand", handler.getName(), e), e);
            }
          }
        }
      }

      if (! logger.getUseParentHandlers())
        break;
      logger = logger.getParent();
    }
  };

  Logger_prototype.log = function(intLevel, strMessage, strArgs) {
    intLevel = Math.max(intLevel, Logger.MAX_LEVEL);
    if (this._level < intLevel) return;

    var arrParams = strArgs instanceof Array ? strArgs : Method.argsAsArray(arguments, 2);
    var record = new Logger.Record(strMessage, arrParams, intLevel, this.getName(), jsx3.lang.getCaller(1), null);
    this._dispatch(record);
  };

  Logger_prototype.logError = function(intLevel, strMessage, objError) {
    intLevel = Math.max(intLevel, Logger.MAX_LEVEL);
    if (this._level < intLevel) return;

    var record = new Logger.Record(strMessage, null, intLevel, this.getName(), jsx3.lang.getCaller(1), objError);
    this._dispatch(record);
  };

  Logger_prototype.logStack = function(intLevel, strMessage, intSkip) {
    intLevel = Math.max(intLevel, Logger.MAX_LEVEL);
    if (this._level < intLevel) return;

    var record = new Logger.Record(strMessage, null, intLevel, this.getName(),
        jsx3.lang.getStack(intSkip != null ? intSkip : 0), null);
    this._dispatch(record);
  };

  Logger_prototype.isLoggable = function(intLevel) {
    intLevel = Math.max(intLevel, Logger.MAX_LEVEL);
    return this._level >= intLevel;
  };

  Logger_prototype.fatal = function(strMessage, strArgs) {
    if (strArgs == null || strArgs instanceof Array)
      this.log(Logger.FATAL, strMessage, strArgs);
    else if (strArgs instanceof Exception)
      this.logError(Logger.FATAL, strMessage, strArgs);
    else if (this._level >= Logger.FATAL)
      this.log(Logger.FATAL, strMessage, Method.argsAsArray(arguments, 1));
  };

  Logger_prototype.error = function(strMessage, strArgs) {
    if (strArgs == null || strArgs instanceof Array)
      this.log(Logger.ERROR, strMessage, strArgs);
    else if (strArgs instanceof Exception)
      this.logError(Logger.ERROR, strMessage, strArgs);
    else if (this._level >= Logger.ERROR)
      this.log(Logger.ERROR, strMessage, Method.argsAsArray(arguments, 1));
  };

  Logger_prototype.warn = function(strMessage, strArgs) {
    if (strArgs == null || strArgs instanceof Array)
      this.log(Logger.WARN, strMessage, strArgs);
    else if (strArgs instanceof Exception)
      this.logError(Logger.WARN, strMessage, strArgs);
    else if (this._level >= Logger.WARN)
      this.log(Logger.WARN, strMessage, Method.argsAsArray(arguments, 1));
  };

  Logger_prototype.info = function(strMessage, strArgs) {
    if (strArgs == null || strArgs instanceof Array)
      this.log(Logger.INFO, strMessage, strArgs);
    else if (strArgs instanceof Exception)
      this.logError(Logger.INFO, strMessage, strArgs);
    else if (this._level >= Logger.INFO)
      this.log(Logger.INFO, strMessage, Method.argsAsArray(arguments, 1));
  };

  Logger_prototype.debug = function(strMessage, strArgs) {
    if (strArgs == null || strArgs instanceof Array)
      this.log(Logger.DEBUG, strMessage, strArgs);
    else if (strArgs instanceof Exception)
      this.logError(Logger.DEBUG, strMessage, strArgs);
    else if (this._level >= Logger.DEBUG)
      this.log(Logger.DEBUG, strMessage, Method.argsAsArray(arguments, 1));
  };

  Logger_prototype.trace = function(strMessage, strArgs) {
    if (strArgs == null || strArgs instanceof Array)
      this.log(Logger.TRACE, strMessage, strArgs);
    else if (strArgs instanceof Exception)
      this.logError(Logger.TRACE, strMessage, strArgs);
    else if (this._level >= Logger.TRACE)
      this.log(Logger.TRACE, strMessage, Method.argsAsArray(arguments, 1));
  };

  Logger_prototype.toString = function() {
    return this.jsxsuper() + " " + this.getName();
  };

  // DEPRECATED: remove later

  Logger.reset = function() {};

  Logger.doLog = function(strErrorNumber, strMessage, PRIORITY, bTrace) {
    //if no priority is set, make this a low priority
    if (PRIORITY == null) PRIORITY = Logger.INFO;
    else if (PRIORITY < Logger.INFO) PRIORITY = Logger.INFO;
    else PRIORITY = Logger.DEBUG;

    // QUESTION: should we somehow notify that the message has not gone to out?
    if (Logger.GLOBAL) {
      var message = strMessage != null ? "(" + strErrorNumber + ") " + strMessage : strErrorNumber;
      if (bTrace || bTrace == null)
        Logger.GLOBAL.logStack(PRIORITY, message, 1);
      else
        Logger.GLOBAL.log(PRIORITY, message);
    }
  };

  Logger.logError = function(e, PRIORITY) {
    var message = "";
    for (var f in e) {
      if (message) message += " ";
      message += f + ":" + e[f];
    }
    Logger.doLog("ERRO01", message, PRIORITY, false);
  };

  Logger.getMinPriority = function() {
    return 3;
  };

  Logger.getLog = function() {
    return [];
  };

  Logger.errorToString = function(error) {
    var s = "";
    s+= "TIME: " + new Date(error.timestamp) + "\n";
    s+= "CODE: " + error.code + "\n";
    s+= "DESC: " + error.description + "\n";
    return s;
  };

  Logger.toString = function() {
    return "";
  };

});

jsx3.Class.defineClass('jsx3.util.Logger.Manager', null, null, function(Manager, Manager_prototype) {

  var Exception = jsx3.Exception;
  var Logger = jsx3.util.Logger;

  Manager.DEFAULT_CONFIG_FILE = "jsx:/../logger.xml";

  Manager.ROOT_KEY = "global";

  Manager.INSTANCE = null;

  Manager.LAZY_HANDLER = -1;

  Manager_prototype.initialize = function(objXML) {
    if (!objXML) {
      objXML = new jsx3.xml.Document();
      objXML.load(jsx3.getEnv("jsx_logger_config") || Manager.DEFAULT_CONFIG_FILE);
    }

    // check error, causes a window.alert() but lets the program continue
    if (objXML.hasError()) {
      window.alert(jsx3._msg("logr.err_conf", objXML.getError(), jsx3.resolveURI(objXML.getSourceURL())));
      objXML.loadXML("<configuration/>");
    }

    this._config = objXML;

    this._initHandlers();

    for (var f in this._loggers)
      this.addLogger(this._loggers[f]);
  };

  Manager.getManager = function() {
    if (Manager.INSTANCE == null) {
      Manager.INSTANCE = new Manager();
      Logger.GLOBAL = new Logger(Manager.ROOT_KEY);
      Manager.INSTANCE.addLogger(Logger.GLOBAL);
    }
    return Manager.INSTANCE;
  };

  Manager_prototype._config = null;

  Manager_prototype._loggers = null;

  Manager_prototype._handlers = null;

  Manager_prototype.init = function(objXML) {
    this._loggers = {};
    this._handlers = {};
  };

  Manager_prototype._handlerClassDidLoad = function(objClass) {
    var loaded = this._initHandlers("[@lazy='true' and @class='" + objClass.getName() + "']");
    this._wireNewHandlers(loaded);
  };

  Manager_prototype._wireNewHandlers = function(handlerNames) {
    for (var i = 0; i < handlerNames.length; i++) {
      var handlerName = handlerNames[i];
      var handler = this.getHandler(handlerName);

      var j = this._config.selectNodeIterator("/configuration/logger[handler-ref/@name='" + handlerName + "']");
      while (j.hasNext()) {
        var node = j.next();
        var loggerName = node.getAttribute('name');
        var logger = this.getLogger(loggerName);
        if (logger != null) {
          logger.addHandler(handler);
        }
      }
    }
  };

  Manager_prototype._initHandlers = function(strClause) {
    var initedNames = [];
    if (! this._config) return initedNames;

    var i = this._config.selectNodeIterator("/configuration/handler" + (strClause != null ? strClause : ""));

    var bNeedsJob = this._classesToLoad == null;

    while (i.hasNext()) {
      var node = i.next();
      var strName = node.getAttribute("name");
      if (this.getHandler(strName) != null) continue;

      var strClass = node.getAttribute("class");
      var bLazy = node.getAttribute("lazy") == "true";
      var bRequire = node.getAttribute("require") == "true";

      var objClass = jsx3.Class.forName(strClass);
      if (objClass == null && bRequire) {
        if (this._classesToLoad == null) {

          this._classesToLoad = [];
        }
        this._classesToLoad.push(strClass);
        this._handlers[strName] = Manager.LAZY_HANDLER;
        continue;
      }

      if (objClass) {
        var handler = objClass.newInstance(strName);
        this._initBean(handler, node);
        handler.onAfterInit();

        var strLevel = node.getAttribute('level');
        if (strLevel && typeof(Logger[strLevel]) == "number")
          handler.setLevel(Logger[strLevel]);

        this.addHandler(handler);
        initedNames[initedNames.length] = strName;
      } else if (!bLazy && !bRequire) {
        window.alert(jsx3._msg("logr.no_class", strClass));
      } else {
        this._handlers[strName] = Manager.LAZY_HANDLER;
      }
    }

    if (bNeedsJob && this._classesToLoad != null) {
      var me = this;
      var job = new jsx3.util.Job("logger.require");
      job.run = function() {
        // make this asynchronous to prevent race conditions from causing double-registration of required handlers
        jsx3.sleep(function() {this._onClassLoaderRest();}, null, me);
      };
      jsx3.CLASS_LOADER.addJob(job, "jsx.js");
    }

    return initedNames;
  };

  Manager_prototype._onClassLoaderRest = function(objEvent) {
    for (var i = 0; i < this._classesToLoad.length; i++)
      jsx3.require(this._classesToLoad[i]);

    delete this._classesToLoad;

    var loaded = this._initHandlers("[@require='true']");
    this._wireNewHandlers(loaded);
  };

  Manager_prototype._initBean = function(obj, objNode) {
    var objClass = obj.getClass();

    for (var i = objNode.selectNodeIterator("./property"); i.hasNext(); ) {
      var child = i.next();

      var strName = child.getAttribute("name");
      var strValue = child.getAttribute("value");
      var bEval = child.getAttribute("eval") == "true";

      var objSetter = objClass.getSetter(strName);
      if (objSetter != null) {
        if (bEval) {
          try {
            strValue = isNaN(strValue) ? obj.eval(strValue) : Number(strValue);
          } catch (e) {
            throw new Exception(jsx3._msg("logr.bn_eval", strName, strValue, obj), jsx3.NativeError.wrap(e));
          }
        }
        objSetter.apply(obj, [strValue]);
      } else {
        throw new Exception(jsx3._msg("logr.bn_setr", strName, objClass));
      }
    }
  };

  Manager_prototype.addLogger = function(objLogger) {
    var strName = objLogger.getName();
    this._loggers[strName] = objLogger;

    if (this._config) {
      var loggerNode = this._config.selectSingleNode("/configuration/logger[@name='" + strName + "']");

      // configure new logger from its own node
      if (loggerNode != null) {
        var strLevel = loggerNode.getAttribute('level');
        if (strLevel && typeof(Logger[strLevel]) == "number")
          objLogger.setLevel(Logger[strLevel]);

        var bUseParent = loggerNode.getAttribute('useParent') != "false";
        objLogger.setUseParentHandlers(bUseParent);

        var i = loggerNode.selectNodeIterator("./handler-ref");
        while (i.hasNext()) {
          var handlerNode = i.next();
          var strId = handlerNode.getAttribute('name');
          var handler = this.getHandler(strId);
          if (handler != null) {
            objLogger.addHandler(handler);
          } else if (this._handlers[strId] != Manager.LAZY_HANDLER) {
            throw new Exception(jsx3._msg("logr.no_hand", strName, strId));
          }
        }

        this._initBean(objLogger, loggerNode);
      }
    }

    // find its parent
    if (strName != Manager.ROOT_KEY) {
      var index = strName.lastIndexOf(".");
      var parentName = index >= 0 ? strName.substring(0, index) : Manager.ROOT_KEY;
      // recursive call to create the parent
      objLogger.setParent(Logger.getLogger(parentName));
    }

    // no need to find children among existing loggers, because parents are always initialized with children
  };

  Manager_prototype.addHandler = function(objHandler) {
    this._handlers[objHandler.getName()] = objHandler;
  };

  Manager_prototype.getLogger = function(strName) {
    return this._loggers[strName];
  };

  Manager_prototype.getHandler = function(strName) {
    var handler = this._handlers[strName];
    return handler == Manager.LAZY_HANDLER ? null : handler;
  };

  Manager_prototype.getHandlerNames = function() {
    var keys = [];
    for (var f in this._handlers)
      keys[keys.length] = f;
    return keys;
  };

});

jsx3.Class.defineClass('jsx3.util.Logger.Record', null, null, function(Record, Record_prototype) {

  Record.SERIAL = 1;

  Record_prototype._serial = null;

  Record_prototype._date = null;

  Record_prototype._message = null;

  Record_prototype._params = null;

  Record_prototype._level = null;

  Record_prototype._logger = null;

  Record_prototype._stack = null;

  Record_prototype._error = null;

  Record_prototype.init = function(strMessage, arrParams, intLevel, strLogger, arrStack, objError) {
    this._serial = Record.SERIAL++;
    this._date = new Date();
    this._message = strMessage;
    this._params = arrParams;
    this._level = intLevel;
    this._logger = strLogger;
    this._stack = arrStack;
    this._error = objError;
  };

  Record_prototype.getSerial = function() {
    return this._serial;
  };

  Record_prototype.getDate = function() {
    return this._date;
  };

  Record_prototype.getMessage = function() {
    return this._message;
  };

  Record_prototype.getParameters = function() {
    return this._params;
  };

  Record_prototype.getLevel = function() {
    return this._level;
  };

  Record_prototype.getLoggerName = function() {
    return this._logger;
  };

  Record_prototype.getFunction = function() {
    return typeof(this._stack) == "function" ? this._stack : null;
  };

  Record_prototype.getStack = function() {
    return this._stack instanceof Array ? this._stack : null;
  };

  Record_prototype.getError = function() {
    return this._error;
  };

});

jsx3.Class.defineClass('jsx3.util.Logger.Handler', null, null, function(Handler, Handler_prototype) {

  var Logger = jsx3.util.Logger;
  var Manager = jsx3.util.Logger.Manager;

  Handler.registerHandlerClass = function(objClass) {
    Manager.getManager()._handlerClassDidLoad(objClass);
  };

  Handler_prototype._name = "";

  Handler_prototype._level = null;

  Handler_prototype.init = function(strName) {
    this._name = strName;
  };

  Handler_prototype.onAfterInit = function() {};

  Handler_prototype.getName = function() {
    return this._name;
  };

  Handler_prototype.getLevel = function() {
    return this._level;
  };

  Handler_prototype.setLevel = function(intLevel) {
    intLevel = Math.max(Logger.OFF, Math.min(Logger.MIN_LEVEL, intLevel));
    this._level = intLevel;
  };

  Handler_prototype.isLoggable = function(intLevel) {
    return this._level == null || this._level >= intLevel;
  };

  Handler_prototype.handle = jsx3.Method.newAbstract('objRecord');

});

jsx3.Class.defineClass('jsx3.util.Logger.MemoryHandler', jsx3.util.Logger.Handler, null, function(MemoryHandler, MemoryHandler_prototype) {

  MemoryHandler_prototype._buffer = null;

  MemoryHandler_prototype._bufferSize = 100;

  MemoryHandler_prototype.init = function(strName) {
    this.jsxsuper(strName);
    this._buffer = [];
  };

  MemoryHandler_prototype.handle = function(objRecord) {
    // TODO: make more efficient, is Array implementation a linked list? probably not
    this._buffer[this._buffer.length] = objRecord;

    if (this._buffer.length > this._bufferSize)
      this._buffer.shift();
  };

  MemoryHandler_prototype.clearBuffer = function() {
    this._buffer = [];
  };

  MemoryHandler_prototype.getBufferSize = function() {
    return this._bufferSize;
  };

  MemoryHandler_prototype.setBufferSize = function(intBufferSize) {
    this._bufferSize = Math.max(1, intBufferSize);

    if (this._buffer.length > this._bufferSize)
      this._buffer.splice(0, this._buffer.length - this._bufferSize);
  };

  MemoryHandler_prototype.getRecords = function(intCount) {
    if (intCount == null) intCount = this._buffer.length;
    return this._buffer.slice(this._buffer.length - intCount);
  };

});

jsx3.Class.defineClass('jsx3.util.Logger.FormatHandler', jsx3.util.Logger.Handler, null, function(FormatHandler, FormatHandler_prototype) {

  FormatHandler_prototype._format = "%d %t %n (%l) - %M";

  FormatHandler_prototype._dynaPropUrls = "";

  FormatHandler_prototype.init = function(strName) {
    this.jsxsuper(strName);
  };

  FormatHandler_prototype.format = function(objRecord) {
    var date = objRecord.getDate();
    var funct = objRecord.getFunction();
    var message = objRecord.getMessage() || ""; // TODO: need to do message format

    var mf = this._getMessageFormat();
    var levelString = jsx3.util.Logger.levelAsString(objRecord.getLevel());
    // mf may be null if the MessageFormat class is not available
    var output = mf ? mf.format(
        objRecord.getSerial(),
        objRecord.getLoggerName(),
        levelString,
        message,
        funct != null ? (funct.jsxmethod != null ? funct.jsxmethod.toString() : funct.toString()) : "",
        date
      ) : date + " " + objRecord.getLoggerName() + " (" + levelString + ") " + message;
    var error = objRecord.getError();
    var stack = objRecord.getStack();

    if (error != null) {
      output += "\n" + error.printStackTrace();
    } else if (stack != null) {
      output += "\n" + jsx3.Exception.formatStack(stack);
    }

    return output;
  };

  FormatHandler_prototype.getFormat = function() {
    return this._format;
  };

  FormatHandler_prototype.setFormat = function(strFormat) {
    this._format = strFormat;
    this._messageformat = null;
  };

  FormatHandler_prototype._getMessageFormat = function() {
    // jsx3.util.MessageFormat class is optional, should work without it
    if (this._messageformat == null && jsx3.util.MessageFormat) {
      var f = this._format || "";
      f = f.replace(/\%s/g, "{0}");
      f = f.replace(/\%n/g, "{1}");
      f = f.replace(/\%l/g, "{2}");
      f = f.replace(/\%M/g, "{3}");
      f = f.replace(/\%f/g, "{4}");
      f = f.replace(/\%d/g, "{5,date,yyyy-MM-dd}");
      f = f.replace(/\%t/g, "{5,date,HH:mm:ss.SSS}");

      this._messageformat = new jsx3.util.MessageFormat(f);
    }
    return this._messageformat;
  };

  FormatHandler_prototype.getResourceUrls = function() {
    return this._dynaPropUrls;
  };

  FormatHandler_prototype.setResourceUrls = function(strURLs) {
    this._dynaPropUrls = strURLs;
  };

});

jsx3.Class.defineClass('jsx3.util.Logger.AlertHandler', jsx3.util.Logger.FormatHandler, null,
    function(AlertHandler, AlertHandler_prototype) {

  AlertHandler_prototype._interval = 10;

  AlertHandler_prototype._counter = 0;

  AlertHandler_prototype._disabled = false;

  AlertHandler_prototype.handle = function(objRecord) {
    if (this._disabled) return;
    this._counter++;

    try {
      if (this._interval > 0 && (this._counter % this._interval) == 0) {
        if (! window.confirm(jsx3._msg("logr.alrt_ctd", this.getName()))) {
          this._disabled = true;
          return;
        }
      }

      window.alert(this.format(objRecord));
    } catch (e) {
      window.alert(jsx3._msg("logr.alrt_err", jsx3.NativeError.wrap(e)));
    }
  };

  AlertHandler_prototype.getConfirmInterval = function() {
    return this._interval;
  };

  AlertHandler_prototype.setConfirmInterval = function(intInterval) {
    this._interval = intInterval;
  };

});

jsx3.ERROR = jsx3.util.Logger;

jsx3.Class.defineClass('jsx3.util.Locale', null, null, function(Locale, Locale_prototype) {

  Locale_prototype.init = function(strLanguage, strCountry) {

    this._lang = strLanguage ? strLanguage.toLowerCase() : "";

    this._country = strCountry ? strCountry.toUpperCase() : "";
  };

  Locale.ENGLISH = new Locale("en");

  Locale.US = new Locale("en", "US");

  Locale.UK = new Locale("en", "GB");

  Locale_prototype.getLanguage = function() {
    return this._lang;
  };

  Locale_prototype.getCountry = function() {
    return this._country;
  };

  Locale_prototype.getDisplayLanguage = function(objLocale) {
    return jsx3.System.getLocaleProperties(objLocale).get("string.lang." + this._lang) || "";
  };

  Locale_prototype.getDisplayCountry = function(objLocale) {
    return jsx3.System.getLocaleProperties(objLocale).get("string.terr." + this._country) || "";
  };

  Locale_prototype.getDisplayName = function(objLocale) {
    var language = this.getDisplayLanguage(objLocale);
    var country = this.getDisplayCountry(objLocale);
    if (! language) return country;
    if (! country) return language;

    var format = jsx3.System.getLocaleProperties(objLocale).get("format.locale.displayname");
    return (new jsx3.util.MessageFormat(format)).format(language, country);
  };

  Locale_prototype.getSearchPath = function() {
    var path = [this];
    if (this._country != "" || this._lang != "") {
      if (this._country != "" && this._lang != "")
        path.push(new Locale(this._lang));
      path.push(new Locale(""));
    }
    return path;
  };

  Locale_prototype.equals = function(obj) {
    return this === obj || (obj instanceof Locale && obj._lang == this._lang && obj._country == this._country);
  };

  Locale_prototype.toString = function() {
    if (this._country)
      return this._lang + "_" + this._country;
    else
      return this._lang;
  };

  Locale.valueOf = function(strKey) {
    var tokens = strKey.split(/[\-_]/);
    return new Locale(tokens[0], tokens[1]);
  };

});

jsx3.Class.defineClass('jsx3.util.NumberFormat', null, null, function(NumberFormat, NumberFormat_prototype) {

  NumberFormat.NUMBER = 1;

  NumberFormat.INTEGER = 2;

  NumberFormat.CURRENCY = 3;

  NumberFormat.getInstance = function(intType, objLocale) {};

  NumberFormat.getIntegerInstance = function(objLocale) {};

  NumberFormat.getNumberInstance = function(objLocale) {};

  NumberFormat.getCurrencyInstance = function(objLocale) {};

  NumberFormat.getPercentInstance = function(objLocale) {};

  NumberFormat._getInstance = function(objLocale, type) {};

  NumberFormat_prototype.grouping = 0;

  NumberFormat_prototype.posprefix = "";

  NumberFormat_prototype.possuffix = "";

  NumberFormat_prototype.negprefix = null;

  NumberFormat_prototype.negsuffix = null;

  NumberFormat_prototype.showdec = false;

  NumberFormat_prototype.maxintdigit = Number.MAX_VALUE;

  NumberFormat_prototype.minintdigit = 0;

  NumberFormat_prototype.maxdecdigit = 0;

  NumberFormat_prototype.mindecdigit = 0;

  NumberFormat_prototype.multiplier = 1;

  NumberFormat_prototype.currency = false;

  NumberFormat_prototype.init = function(strFormat, objLocale) {};

  NumberFormat_prototype.getLocale = function() {};

  NumberFormat_prototype.setLocale = function(objLocale) {};

  NumberFormat_prototype.format = function(number) {};

  NumberFormat._FMT = /\-?(\d+(\.\d*)?|\d*\.\d+)([eE]\-?\d+)?/;

  NumberFormat_prototype.parse = function(s) {};

  NumberFormat_prototype._getGrouping = function(bCur) {};

  NumberFormat_prototype._getDecimal = function(bCur) {};

  NumberFormat._zeroCode = "0".charCodeAt(0);

  NumberFormat._digitCode = ".".charCodeAt(0);

  NumberFormat._numToDigitArray = function(number) {};

  NumberFormat._constrainDigitArray = function(digits, max, min, front) {};

  NumberFormat._roundDigits = function(digits, remainder) {};

  NumberFormat._localizeDigits = function(digits, zero) {};

  NumberFormat.NUMBER_PART_CHARS = "0#,.";

  NumberFormat_prototype._initFormat = function() {};

  NumberFormat_prototype._parseNumberPart = function(numberPart) {};

  NumberFormat._getProps = function(l) {};

  NumberFormat_prototype._getProps = function() {};

  NumberFormat_prototype._preSufStr = function(s, props) {};

  NumberFormat_prototype._preSufChar = function(chr, props) {};

  NumberFormat_prototype.toString = function() {};

});

jsx3.Class.defineClass('jsx3.util.DateFormat', null, null, function(DateFormat, DateFormat_prototype) {

  DateFormat.SHORT = 1;

  DateFormat.MEDIUM = 2;

  DateFormat.LONG = 3;

  DateFormat.FULL = 4;

  DateFormat.DEFAULT = DateFormat.MEDIUM;

  DateFormat._TYPE_KEYS = [null, "short", "medium", "long", "full"];

  DateFormat.getDateInstance = function(intType, objLocale) {};

  DateFormat.getTimeInstance = function(intType, objLocale) {};

  DateFormat.getDateTimeInstance = function(intDateType, intTimeType, objLocale) {};

  // Formatting Data and Functions

  DateFormat._LETTER_FORMAT = {};

  DateFormat._formatYear = function(value, length) {};

  DateFormat._formatNumber = function(value, length) {};

  DateFormat._formatText = function(value, length) {};

  DateFormat._formatMonth = function(f, value, length) {};

  DateFormat._getTimeZoneBits = function(date, format) {};

  // Parsing Data and Functions

  DateFormat._LETTER_PARSE = {};

  DateFormat._parseText = function(input, pos, match) {};

  DateFormat._parseNumber = function(input, pos, minDigit, maxDigit, nextToken) {};

  DateFormat._parseTextEnums = function(input, pos, arrEnums, length, caseSensitive, nextToken) {};

  DateFormat._parseTextEnum = function(input, pos, enums, length, caseSensitive, nextToken) {};

  DateFormat._setParsedField = function(token, field, state) {};

  DateFormat._charIsDigit = function(s, i) {};

  // Public Interface

  DateFormat_prototype.init = function(strFormat, objLocale) {};

  DateFormat_prototype.getLocale = function() {};

  DateFormat_prototype.setLocale = function(objLocale) {};

  DateFormat_prototype.getTimeZoneOffset = function(objDate) {};

  DateFormat_prototype.setTimeZoneOffset = function(intMinutes) {};

  DateFormat_prototype._getLProp = function(strProp) {};

  DateFormat_prototype._initTokens = function() {};

  DateFormat_prototype.format = function(objDate) {};

  DateFormat_prototype.parse = function(strDate) {};

  DateFormat_prototype.getFormat = function() {};

  DateFormat_prototype.toString = function() {};

});

jsx3.Class.defineClass('jsx3.util.MessageFormat', null, null, function(MessageFormat, MessageFormat_prototype) {

  var NumberFormat = jsx3.util.NumberFormat;
  var DateFormat = jsx3.util.DateFormat;

  MessageFormat_prototype.init = function(strFormat, objLocale) {};

  MessageFormat_prototype.getLocale = function() {};

  MessageFormat_prototype.setLocale = function(objLocale) {};

  MessageFormat_prototype.format = function(args) {};

  MessageFormat_prototype._initFormat = function() {};

  MessageFormat._DTMAP = {date: "getDateInstance", time: "getTimeInstance", datetime: "getDateTimeInstance"};

  MessageFormat_prototype._parseFormat = function(strFormat) {};

  MessageFormat_prototype.toString = function() {};

});

jsx3.Package.definePackage('jsx3.html', function(html) {

  var Event = jsx3.gui.Event;

  html.MODE_IE_QUIRKS = 0;

  html.MODE_FF_QUIRKS = 1;

  html.MODE_IE_STRICT = 2;

  html.MODE_FF_STRICT = 3;

 if (jsx3.CLASS_LOADER.IE) {
  html._UNSEL = ' unselectable="on"';
  html._CLPSE = 'overflow:hidden;';
 } else if (jsx3.CLASS_LOADER.SAF) {
  html._UNSEL = '';
  html._CLPSE = 'overflow:hidden;font-size:0px;';
 } else {
  html._UNSEL = '';
  html._CLPSE = 'overflow:hidden;';
 }

  html.getMode = function(objGUI) {};

  html.emptyToClosed = function(strHTML) {};

  html.restoreScrollPosition = function(objGUI) {
 if (jsx3.CLASS_LOADER.FX) {

 }
  };

  html.persistScrollPosition = function(objGUI) {
 if (jsx3.CLASS_LOADER.FX) {

 }
  };

 if (jsx3.CLASS_LOADER.IE) {

  html.getScrollSizeOffset = function(intSize,strCSS) {};

  html.addEventListener = function(objDOM, strName, objFn) {};

  html.removeEventListener = function(objDOM, strName, objFn) {};

  html.createRule = function(selector,declaration,objDocument) {};

  html.getRuleByName = function(strRuleName) {};

  html.scrollIntoView = function(objGUI, objRoot, intPaddingX, intPaddingY) {};

  html.getOuterHTML = function(objElement) {};

  html.setOuterHTML = function(objElement, strHTML) {};

  html.removeNode = function(objElement) {};

  html.setInnerText = function(objElement, strText) {};

  html.insertAdjacentHTML = function(objElement, strWhere, strHTML) {};

  html._FOCUSABLE = {input:true, textarea:true, select:true, body:true, a:true, img:true, button:true, frame:true,
      iframe:true, object:true};

  html.isFocusable = function(objGUI) {};

 } else {

  html.getScrollSizeOffset = function(intSize,strCSS) {};

  html.addEventListener = function(objDOM, strName, objFn) {};

  html.removeEventListener = function(objDOM,strName,objFn) {};

  html._FOCUSABLE = {input:true, textarea:true, select:true, body:true, a:true, img:true, button:true, frame:true,
      iframe:true, object:true};

  html.isFocusable = function(objGUI) {};

  html.createRule = function(selector,declaration,objDocument) {};

  html.getRuleByName = function(strRuleName) {};

  html.scrollIntoView = function(objGUI, objRoot, intPaddingX, intPaddingY) {};

  html.getOuterHTML = function(objElement) {};

  html.setOuterHTML = function(objElement, strHTML) {};

  html.removeNode = function(objElement) {};

  html.setInnerText = function(objElement, strText) {};

  html.insertAdjacentHTML = function(objElement, strWhere, strHTML) {};

 }

 if (jsx3.CLASS_LOADER.IE) {

  html.updateCSSOpacity = function(objGUI, fltOpacity) {};

  html.getCSSOpacity = function(dblPct) {};

  html.getRelativePosition = function(objRoot, objGUI) {};

 } else if (jsx3.CLASS_LOADER.FX) {

  html.updateCSSOpacity = function(objGUI, fltOpacity) {};

  html.getCSSOpacity = function(dblPct) {};

  html.getRelativePosition = function(objRoot, objGUI) {};

 } else {

  html.updateCSSOpacity = function(objGUI, fltOpacity) {};

  html.getCSSOpacity = function(dblPct) {};

  html.getRelativePosition = function(objRoot, objGUI) {};

 }

 if (jsx3.CLASS_LOADER.FX) {

  html.copy = function(strText) {};

  html.paste = function() {};

 } else {

  html.copy = function(strText) {};

  html.paste = function() {};

 }

  html._FADEH = jsx3.resolveURI("jsx:///images/icons/h.png");

  html._FADEV = jsx3.resolveURI("jsx:///images/icons/v.png");

  html.getCSSFade = function(bLeftRight) {};

 if (jsx3.CLASS_LOADER.IE6) {

  html.getCSSPNG = function(strResolvedURL) {};

 } else {

  html.getCSSPNG = function(strResolvedURL) {};

 }

  html.getJSXParent = function(objGUI, objServer) {};

  html.removeOutputEscaping = function(objGUI) {};

  html.removeOutputEscapingSpan = function(strHTML) {};

  html._ENT_MAP = {};

  html._entNameToCode = function(strMatch, strName) {};

  html._IMAGE_LOADER_ID = "jsx_image_loader";

  html.loadImages = function(varImages) {};

  html.updateRule = function(strRuleName, strStyleName, strValue) {};

  html.getElementById = function(objRoot, strId, bDepthFirst) {};

  html.getElementByTagName = function(objRoot, strTagName, bDepthFirst) {};

  html.getElementsByTagName = function(objRoot, strTagName, bDepthFirst) {};

  html.findElements = function(objRoot, fctTest, bDepthFirst, bMultiple, bShallow, bIncludeSelf) {};

  html.getElmUpByTagName = function(objStart, strTagName, bIncludeSelf) {};

  html.findElementUp = function(objStart, fctTest, bIncludeSelf) {};

  html.selectSingleElm = function(objRoot, args) {};

  html.nodesToArray = function(nodes) {};

  html.getSelection = function(objTextElm) {};

  html.focusNext = function(objGUI, objEvent) {

//      jsx3.log("focusing next of: " + html.getOuterHTML(last));

  };

  html.focusPrevious = function(objGUI, objEvent) {

//      jsx3.log("focusing previous of: " + html.getOuterHTML(first));

  };

 if (jsx3.CLASS_LOADER.SAF) {

  html._CANTAB = " A AREA BUTTON INPUT OBJECT SELECT TEXTAREA ";

  html.focus = function(elm) {};

 } else {

  html.focus = function(elm) {};

 }

  html.addClass = function(elm, c) {};

  html.removeClass = function(elm, c) {};

});

jsx3.Class.defineClass('jsx3.html.Selection', null, null, function(Selection, Selection_prototype) {

 if (jsx3.CLASS_LOADER.IE) {

  Selection_prototype.init = function(objTextElm) {};

  Selection_prototype.getStartIndex = function() {};

  Selection_prototype.getEndIndex = function() {};

  Selection_prototype.setRange = function(intStart, intEnd) {

//    jsx3.log("set range to {" + intStart + "," + intEnd + "} " +
//        value.substring(intStart-10, intStart) + "|" + value.substring(intStart, intEnd) +  "|" +
//        value.substring(intEnd, intEnd + 10));

//    jsx3.log("adjust range to {" + intStart + "," + intEnd + "}");

  };

  Selection_prototype.getOffsetLeft = function() {};

  Selection_prototype.getOffsetTop = function() {};

  Selection_prototype.getText = function() {};

  Selection_prototype.setText = function(strText) {};

  Selection_prototype.insertCaret = function(strWhere) {};

 } else {

  Selection_prototype.init = function(objTextElm) {};

  Selection_prototype.getStartIndex = function() {};

  Selection_prototype.getEndIndex = function() {};

  Selection_prototype.setRange = function(intStart, intEnd) {};

  Selection_prototype.getOffsetLeft = function() {};

  Selection_prototype.getOffsetTop = function() {};

  Selection_prototype.getText = function() {};

  Selection_prototype.setText = function(strText) {};

  Selection_prototype.insertCaret = function(strWhere) {};

 }

});

jsx3.Class.defineClass("jsx3.app.Cache", null, [jsx3.util.EventDispatcher], function(Cache, Cache_prototype) {

  var Document = jsx3.xml.Document;

  Cache.REMOVE = "remove";

  Cache.ADD = "add";

  Cache.CHANGE = "change";

  Cache.ASYNC_TIMEOUT = 60000;

  Cache.XSDNS = "http://xsd.tns.tibco.com/gi/cache";

  Cache._LOADING_DOC = new Document().loadXML('<loading xmlns="' + Cache.XSDNS + '"/>');

  Cache._TIMEOUT_DOC = new Document().loadXML('<timeout xmlns="' + Cache.XSDNS + '"/>');

  Cache._ERROR_DOC = new Document().loadXML('<error xmlns="' + Cache.XSDNS + '"/>');

  Cache_prototype.init = function() {
    // declare an object array to hold all cache documents

    this._index = {};

    this._parents = [];
  };

  Cache_prototype.addParent = function(objParent) {
    this._parents.push(objParent);
  };

  Cache_prototype.clearById = function(strId) {
    var objRecord = this._index[strId];
    if (objRecord) {
      delete this._index[strId];
      this.publish({subject:strId, action:Cache.REMOVE});
      this.publish({subject:Cache.CHANGE, id:strId, action:Cache.REMOVE});
      return objRecord.jsxdocument;
    }
  };

  Cache_prototype.isSystem = function(strId) {
    return false;
//    return this._index[strId] != null && this._index[strId].jsxsystem;
  };

  Cache_prototype.clearByTimestamp = function(intTimestamp) {
    if (intTimestamp instanceof Date) intTimestamp = intTimestamp.getTime();

    var changed = false;
    var ids = [];

    for (var p in this._index) {
      var record = this._index[p];
      if (record.jsxtimestamp < intTimestamp) {
        delete this._index[p];
        this.publish({subject:p, action:Cache.REMOVE});
        ids.push(p);
      }
    }

    if (ids.length > 0)
      this.publish({subject:Cache.CHANGE, ids:ids, action:Cache.REMOVE});

    return ids;
  };

  Cache_prototype.getDocument = function(strId) {
    if (this._index[strId] != null)
      return this._index[strId].jsxdocument;

    for (var i = 0; i < this._parents.length; i++) {
      var doc = this._parents[i].getDocument(strId);
      if (doc != null) return doc;
    }

    return null;
  };

  Cache_prototype.getOrOpenDocument = function(strURL, strId, objClass) {
    if (strId == null) strId = strURL.toString();
    return this.getDocument(strId) || this._openDocument(strURL, strId, objClass, false);
  };

  Cache_prototype.openDocument = function(strURL, strId, objClass) {
    return this._openDocument(strURL, strId, objClass, false);
  };

  Cache_prototype.getOrOpenAsync = function(strURL, strId, objClass) {
    if (strId == null) strId = strURL.toString();
    return this.getDocument(strId) || this._openDocument(strURL, strId, objClass, true);
  };

  Cache_prototype._openDocument = function(strURL, strId, objClass, bAsync) {
    if (objClass == null) objClass = Document.jsxclass;
    if (strId == null) strId = strURL.toString();

    var objXML = objClass.newInstance();
    objXML.setAsync(bAsync);

    if (bAsync) {
      objXML.subscribe("*", this, "_onAsyncDone");
      objXML._jsxcacheid = strId;
      objXML.load(strURL, Cache.ASYNC_TIMEOUT);
      objXML = Cache._LOADING_DOC.cloneDocument();
    } else {
      objXML.load(strURL);
    }

    this.setDocument(strId, objXML);
    return objXML;
  };

  Cache_prototype._onAsyncDone = function(objEvent) {
    var objXML = objEvent.target;
    var strEvtType = objEvent.subject;
    var strId = objXML._jsxcacheid;

    delete objXML._jsxcacheid;
    objXML.unsubscribe("*", this);

    if (this._index) {
      if (strEvtType == Document.ON_RESPONSE) {
        this.setDocument(strId, objXML);
      } else if (strEvtType == Document.ON_TIMEOUT) {
        this.setDocument(strId, Cache._TIMEOUT_DOC.cloneDocument());
      } else if (strEvtType == Document.ON_ERROR) {
        var d = Cache._ERROR_DOC.cloneDocument();
        d.setAttribute("error", objXML.getError().toString());
        this.setDocument(strId, d);
      }
    }
  };

  Cache_prototype.setDocument = function(strId, objDocument) {
    if (strId == null) throw new jsx3.IllegalArgumentException("strId", strId);
    if (objDocument == null) throw new jsx3.IllegalArgumentException("objDocument", objDocument);

    //create a new cache object
    var record = {};

    record.jsxtimestamp = (new Date()).getTime();

    record.jsxdocument = objDocument;

    // check whether a document already exists in the cache
    var evtAction = this._index[strId] ? Cache.CHANGE : Cache.ADD;

    //persist to cache
    this._index[strId] = record;

    this.publish({subject:strId, action:evtAction});
    this.publish({subject:Cache.CHANGE, action:evtAction, id:strId});
  };

  Cache_prototype.getTimestamp = function(strId) {
    var record = this._index[strId];
    return record != null ? record.jsxtimestamp : null;
  };

  Cache_prototype.keys = function() {
    var keys = [];
    for (var f in this._index)
      keys[keys.length] = f;
    return keys;
  };

  Cache_prototype.destroy = function() {
    delete this._index;
    delete this._parents;
  };

});

jsx3.Cache = jsx3.app.Cache;

jsx3.Class.defineClass("jsx3.app.Properties", null, null, function(Properties, Properties_prototype) {

  var LOG = jsx3.util.Logger.getLogger(Properties.jsxclass.getName());

  Properties.GLOBAL_KEY = "_global";

  Properties_prototype.init = function() {

    this._parents = [];

    this._children = [];

    this._order = [Properties.GLOBAL_KEY];

    this._docs = {};
    this._docs[Properties.GLOBAL_KEY] = {};

    this._master = {};

    this._masterDirty = false;

    this._parentsMaster = {};

    this._parentsDirty = false;
  };

  Properties_prototype.loadXML = function(objXML, strId) {

    var t1 = new jsx3.util.Timer(Properties.jsxclass, strId ||
        (objXML instanceof jsx3.xml.Document ? objXML.getSourceURL() : objXML.getNodeName()));

    if (strId == null) {
      strId = Properties.GLOBAL_KEY;
    } else if (jsx3.util.arrIndexOf(this._order, strId) < 0) {
      this._order.splice(1, 0, strId);
    }

    var doc = this._docs[strId];
    if (doc == null)
      doc = this._docs[strId] = {};

    for (var i = objXML.selectNodeIterator("./record"); i.hasNext(); ) {
      var next = i.next();

      var id = next.getAttribute("jsxid");
      var eval = next.getAttribute("eval");
      var text = next.getAttribute("jsxtext");

      if (eval == "1" || eval == "true") {
        try {
          text = isNaN(text) ? jsx3.eval(text) : Number(text);
        } catch (e) {
          LOG.warn(jsx3._msg("props.eval", id, text), jsx3.NativeError.wrap(e));
        }
      }
      doc[id] = text;
    }

    // The cache and the parent cache of each child are dirty
    this._masterDirty = true;

    t1.log("load");

  };

  Properties_prototype.addParent = function(objParent) {
    this._parents.splice(0, 0, objParent);
    objParent._children.push(this);

    // Parent cache is dirty
    this._setChildrenDirty(true);
  };

  Properties_prototype.removeParent = function(objParent) {
    var index = jsx3.util.arrIndexOf(this._parents, objParent);
    if (index >= 0) {
      this._parents.splice(index, 1);
      objParent._removeChild(this);

      // Parent cache is dirty
      this._setChildrenDirty(true);
    }
  };

  Properties_prototype._removeChild = function(objChild) {
    var index = jsx3.util.arrIndexOf(this._children, objChild);
    if (index >= 0)
      this._children.splice(index, 1);
  };

  Properties_prototype.removeAllParents = function() {
    if (this._parents.length > 0) {
      for (var i = 0; i < this._parents.length; i++)
        this._parents[i]._removeChild(this);
      this._parents = [];

      this._parentsDirty = false;
      this._parentsMaster = {};
    }
  };

  Properties_prototype.getParents = function() {
    return this._parents.concat();
  };

  Properties_prototype.containsKey = function(strKey) {
    if (this._masterDirty)
      this._reconstructMaster();

    return typeof(this._master[strKey]) != "undefined";
  };

  Properties_prototype.getKeys = function() {
    if (this._masterDirty)
      this._reconstructMaster();

    var keys = [];
    for (var f in this._master) keys[keys.length] = f;
    return keys;
  };

  Properties_prototype.get = function(strKey) {
    if (this._masterDirty)
      this._reconstructMaster();

    if (typeof(this._master[strKey]) != "undefined")
      return this._master[strKey];

    if (this._parentsDirty)
      this._reconstructParentsMaster();

    return this._parentsMaster[strKey];
  };

  Properties_prototype.set = function(strKey, strValue) {
    if (typeof(strValue) == "undefined") throw new jsx3.IllegalArgumentException("strValue", strValue);
    // 1. set the value in the memory space
    this._docs[Properties.GLOBAL_KEY][strKey] = strValue;

    // 2. update the cache
    this._master[strKey] = strValue;

    // 3. tell children that a parent cache is dirty
    this._setChildrenDirty();
  };

  Properties_prototype.remove = function(strKey) {
    // 1. remove the value from all memory spaces
    for (var key in this._docs)
      delete this._docs[key][strKey];

    // 2. update the cache
    delete this._master[strKey];

    // 3. tell children that a parent cache is dirty
    this._setChildrenDirty();
  };

  Properties_prototype._reconstructMaster = function() {
    this._masterDirty = false;
    var master = this._master = {};

    for (var i = this._order.length - 1; i >= 0; i--) {
      var doc = this._docs[this._order[i]];
      for (var f in doc)
        master[f] = doc[f];
    }
  };

  Properties_prototype._reconstructParentsMaster = function() {
    this._parentsDirty = false;
    var master = this._parentsMaster = {};

    for (var i = this._parents.length - 1; i >= 0; i--) {
      var p = this._parents[i];
      if (p._masterDirty)
        p._reconstructMaster();
      if (p._parentsDirty)
        p._reconstructParentsMaster();

      var m1 = p._master;
      var m2 = p._parentsMaster;

      for (var f in m2)
        master[f] = m2[f];
      for (var f in m1)
        master[f] = m1[f];
    }
  };

  Properties_prototype._setChildrenDirty = function(bMe) {
    var stack = bMe ? [this] : this._children.concat();

    while (stack.length > 0) {
      var p = stack.shift();
      if (!p._parentsDirty) {
        p._parentsDirty = true;
        stack.push.apply(stack, p._children);
      }
    }
  };

});

// @jsxobf-clobber  _locale _path

jsx3.Class.defineClass("jsx3.app.PropsBundle", jsx3.app.Properties, null, function(PropsBundle, PropsBundle_prototype) {

  var LOG = jsx3.util.Logger.getLogger(PropsBundle.jsxclass.getName());
  var Job = jsx3.util.Job;

  PropsBundle.PATH_SEP = ".";

  PropsBundle.ERROR = -1;

  PropsBundle._PATH_TO_LOCALES = {};

  PropsBundle._KEY_TO_PROPS = {};

  PropsBundle._GRAPH = new jsx3.util.JobGraph();

  PropsBundle._EMPTY = new PropsBundle();

  PropsBundle.getProps = function(strBasePath, objLocale, objCache) {
    if (!objLocale) objLocale = jsx3.System.getLocale();
    var key = strBasePath + "::" + objLocale;

    if (!PropsBundle._KEY_TO_PROPS[key]) {
      var graph = PropsBundle._GRAPH;

      if (graph.node(strBasePath))
        return PropsBundle._EMPTY;

      var job = new Job(strBasePath);
      PropsBundle._getProps(strBasePath, objLocale, objCache, false, job);
    }

    var p = PropsBundle._KEY_TO_PROPS[key];
    if (p == PropsBundle.ERROR)
      throw new jsx3.Exception(jsx3._msg("propbn.err_key", strBasePath, objLocale));

    return p;
  };

  PropsBundle.getPropsAsync = function(strBasePath, objLocale, fctCallback, objCache) {
    if (!objLocale) objLocale = jsx3.System.getLocale();
    var key = strBasePath + "::" + objLocale;
    var job = new Job(null, function() {
      var p = PropsBundle._KEY_TO_PROPS[key];
      fctCallback(p != PropsBundle.ERROR ? p : null);
    });
    PropsBundle._getProps(strBasePath, objLocale, objCache, true, job);
  };

  PropsBundle._getProps = function(strBasePath, objLocale, objCache, bAsync, objDoneJob) {
    var graph = PropsBundle._GRAPH;
    strBasePath = strBasePath.toString();

    graph.pause();

    graph.add(objDoneJob); // NOTE: graph must be paused

    var nextJob = objDoneJob;
    var searchPath = objLocale.getSearchPath();

    // For each locale to load, en_US, en, root...
    for (var i = 0; i < searchPath.length; i++) {
      var thisLocale = searchPath[i];
      var thisKey = strBasePath + "::" + thisLocale;

      // Check if the locale is already loaded, if so, we're done
      if (PropsBundle._KEY_TO_PROPS[thisKey])
        break;

      // Check if the locale is already queued
      var thisJob = graph.node(thisKey);

      if (! thisJob) {
        // If not, queue loading the locale
        thisJob = PropsBundle._makeJob(thisKey, strBasePath, thisLocale, objCache, bAsync);
        graph.add(thisJob);
        thisJob.add(nextJob);
      } else {
        // Otherwise, just create the dependency, and we're done
        thisJob.add(nextJob);
        break;
      }

      nextJob = thisJob;
    }

    graph.start();
  };

  PropsBundle._makeJob = function(thisKey, strBasePath, thisLocale, objCache, bAsync) {
    return new Job(thisKey, function() {
      var me = this;
      PropsBundle._loadBundle(thisKey, strBasePath, thisLocale, objCache, bAsync, function() {
        me.finish();
      });
      return Job.WAIT; // Ok for sync too since finish() is called before this returns WAIT.
    });
  };

  PropsBundle._loadBundle = function(strKey, strBasePath, objLocale, objCache, bAsync, fctCallback) {
    var propsCache = PropsBundle._KEY_TO_PROPS, localeCache = PropsBundle._PATH_TO_LOCALES;
    var bRoot = false, bDone = false;

    if (propsCache[strKey]) {
      bDone = true;
    } else {
      if (objLocale.toString() == "") {
        bRoot = true;
      } else {
        if (! localeCache[strBasePath][objLocale]) {
          var searchPath = objLocale.getSearchPath();
          for (var i = 1; !propsCache[strKey] && i < searchPath.length; i++) {
            var ancestorLocale = searchPath[i];
            var ancestorKey = strBasePath + "::" + ancestorLocale;
            propsCache[strKey] = propsCache[ancestorKey];
          }
          bDone = true;
        }
      }
    }

    if (bDone) {
      // QUESTION: timeout for async?
      fctCallback();
      return;
    }

    var strUrl;
    if (bRoot) {
      localeCache[strBasePath] = {};
      strUrl = strBasePath;
    } else {
      var index = strBasePath.lastIndexOf(".");
      strUrl = strBasePath.substring(0, index) + PropsBundle.PATH_SEP + objLocale + strBasePath.substring(index);
    }

    var doc = null, bAlreadyLoaded = false;

    if (objCache)
      doc = objCache.getDocument(strUrl);

    if (doc) {
      bAlreadyLoaded = true;
    } else {
      doc = new jsx3.xml.Document();

      if (bAsync) {
        doc.setAsync(true);
        doc.subscribe("*", PropsBundle, function(objEvent) {
          PropsBundle._loadBundle2(strKey, strBasePath, objLocale, objCache, objEvent.target, fctCallback);
        });
      } else {
        bAlreadyLoaded = true;
      }

      doc.load(strUrl);
    }

    if (bAlreadyLoaded)
      PropsBundle._loadBundle2(strKey, strBasePath, objLocale, objCache, doc, fctCallback);
  };

  PropsBundle._loadBundle2 = function(strKey, strBasePath, objLocale, objCache, objDoc, fctCallback) {
    var strUrl = objDoc.getSourceURL();
    if (! objDoc.hasError()) {
      if (objCache)
        objCache.setDocument(strUrl, objDoc);
      PropsBundle._addLocaleRefs(strBasePath, objDoc);
      PropsBundle._loadInlineLocales(strBasePath, objLocale, objDoc);
    } else {
      LOG.error(jsx3._msg("propbn.err_file", strUrl, objDoc.getError()));
      PropsBundle._KEY_TO_PROPS[strKey] = PropsBundle.ERROR;
    }

    fctCallback();
  };

  PropsBundle._loadInlineLocales = function(strBasePath, objLocale, objXML) {
    for (var i = objXML.selectNodeIterator("/data/locale"); i.hasNext(); ) {
      var lNode = i.next();
      var localeKey = lNode.getAttribute("key") || "";

      PropsBundle._setLocaleDoc(strBasePath, localeKey, lNode);
      PropsBundle._PATH_TO_LOCALES[strBasePath][localeKey] = true;
    }

    // Default to loading the entire external file for the requested locale.
    if (! PropsBundle._KEY_TO_PROPS[strBasePath + "::" + objLocale]) {
      PropsBundle._setLocaleDoc(strBasePath, objLocale.toString(), objXML);
    }
  };

  PropsBundle._setLocaleDoc = function(strBasePath, strLocale, objXML) {
    var propsCache = PropsBundle._KEY_TO_PROPS;

    var props = new PropsBundle();
    props.loadXML(objXML);
    props._path = strBasePath;
    props._locale = jsx3.util.Locale.valueOf(strLocale);

    propsCache[strBasePath + "::" + strLocale] = props;

    // If not the root locale, then add a reference to the parent locale, according to the locale search path.
    // This requires the the parent locale always be loaded before the descendant locale.
    if (strLocale) {
      var path = props._locale.getSearchPath();
      for (var i = 1; i < path.length; i++) {
        var parent = propsCache[strBasePath + "::" + path[i]];
        if (parent) {
          props.addParent(parent);
          return;
        }
      }

      LOG.error("Parent of bundle " + strBasePath + " (" + strLocale + ") is null.");
    }
  };

  PropsBundle._addLocaleRefs = function(strBasePath, objXML) {
    var localeString = objXML.getAttribute("locales");

    if (PropsBundle._PATH_TO_LOCALES[strBasePath] == null)
      PropsBundle._PATH_TO_LOCALES[strBasePath] = {};

    if (localeString != null) {
      var localeKeys = localeString.split(/\s*,\s*/);
      for (var i = 0; i < localeKeys.length; i++)
        if (localeKeys[i])
          PropsBundle._PATH_TO_LOCALES[strBasePath][localeKeys[i]] = true;
    }
  };

  PropsBundle_prototype.getLocale = function() {
    return this._locale;
  };

  PropsBundle_prototype.getPath = function() {
    return this._path;
  };

  PropsBundle.clearCache = function(strPath, objCache) {
    if (strPath) {
      delete PropsBundle._PATH_TO_LOCALES[strPath];

      var prefix = strPath + "::";
      for (var f in PropsBundle._KEY_TO_PROPS) {
        if (f.indexOf(prefix) == 0)
          delete PropsBundle._KEY_TO_PROPS[f];
      }

      if (objCache) {
        var cacheKeys = objCache.keys();
        for (var i = 0; i < cacheKeys.length; i++) {
          if (cacheKeys[i].indexOf(strPath) == 0)
            objCache.clearById(cacheKeys[i]);
        }
      }
    } else {
      PropsBundle._PATH_TO_LOCALES = {};
      PropsBundle._KEY_TO_PROPS = {};
    }
  };

});

jsx3.Class.defineClass("jsx3.lang.System", null, null, function(System, System_prototype) {

  System.LJSS = new jsx3.app.Properties();

  System.JSS = new jsx3.app.Properties();
  System.JSS.addParent(System.LJSS);

  System.APPS = {};

  System.getProperty = function(strKey) {
    return System.JSS.get(strKey);
  };

  System.getLocale = function() {
    // Locale is optional
    if (System._locale == null && jsx3.util.Locale) {
      var localeString = jsx3.app.Browser.getLocaleString();
      if (localeString) {
        var tokens = localeString.split("_");
        System._locale = new jsx3.util.Locale(tokens[0], tokens[1]);
      } else {
        System._locale = jsx3.util.Locale.US;
      }
    }
    return System._locale;
  };

  System.setLocale = function(objLocale) {
    if (objLocale != System._locale) {
      System.JSS.removeParent(System.getLocaleProperties());

      System._locale = objLocale;
      System.JSS.addParent(System.getLocaleProperties());
    }
  };

  System.reloadLocalizedResources = function() {
    var PropsBundle = jsx3.app.PropsBundle;

    if (PropsBundle) {
      var p = System.LJSS.getParents();
      System.LJSS.removeAllParents();

      for (var i = 0; i < p.length; i++)
        System.LJSS.addParent(jsx3.app.PropsBundle.getProps(p[i].getPath(), System.getLocale(), jsx3.getSystemCache()));
    }
  };

  System._locdocurl = jsx3.resolveURI("jsx:///locale/locale.xml");

  System.getLocaleProperties = function(objLocale) {
    return jsx3.app.PropsBundle.getProps(System._locdocurl, objLocale, jsx3.getSystemCache());
  };

  System.getMessage = function(strKey, strTokens) {
    var value = System.LJSS.get(strKey);
    var suffix = "";

    // jsx3.util.MessageFormat class is optional, should work without it
    if (arguments.length > 1) {
      var args = jsx3.Method.argsAsArray(arguments, 1);
      if (value != null && jsx3.util.MessageFormat) {
        try {
          var format = new jsx3.util.MessageFormat(value);
          return format.format(args);
        } catch (e) {;}
      } else {
        suffix = " " + args.join(" ");
      }
    }

    if (value == null) value = strKey;
    return value + suffix;
  };

  System.GO = function(strIdName, strNS) {
    var objJSX = null;
    if (strIdName != null) {
      // check for argument like jsxid, only check by id
      if (strIdName.indexOf("_jsx_") == 0) {
        var appKey = jsx3.app.DOM.getNamespaceForId(strIdName);

        // namespace argument does not match the namespace encoded in the id
        if (strNS && strNS != appKey) return null;

        if (System.APPS[appKey])
          objJSX = System.APPS[appKey].getJSXById(strIdName);
      }
      // it must be a name, we'll check APPS, then all servers
      else {
        // namespace specified
        if (strNS) {
          if (System.APPS[strNS])
            objJSX = System.APPS[strNS].getJSXByName(strIdName);
        } else {
          for (var i in System.APPS)
            if ((objJSX = System.APPS[i].getJSXByName(strIdName)) != null) return objJSX;
        }
      }
    }
    return objJSX;
  };

  System.getApp = function(strAppKey) {
    return System.APPS[strAppKey];
  };

  System.getAllApps = function() {
    var apps = [];
    for (var f in System.APPS)
      apps.push(System.APPS[f]);
    return apps;
  };

  System.registerApp = function(objServer) {
    var ns = objServer.getEnv('namespace');

    jsx3.lang.setVar(ns, objServer);

    // add this server instance to the collection indexed and managed by the JSX controller
    System.APPS[ns] = objServer;
  };

  System.deregisterApp = function(objServer) {
    var ns = objServer.getEnv('namespace');

    var s = jsx3.lang.getVar(ns);
    if (objServer == s)
      jsx3.lang.setVar(objServer.getEnv('namespace'), null);

    if (System.APPS[ns] == objServer)
      delete System.APPS[ns];
  };

  System.activateApp = function(objServer) {
    jsx3.registerApp(objServer);
  };

  System.getAppByPath = function(strPath) {
    for (var ns in System.APPS) {
      var app = System.APPS[ns];
      if (app.getEnv("apppathrel") == strPath || app.getEnv("apppath") == strPath)
        return app;
    }
    return null;
  };

  System._ADDINS = [];

  System._ADDIN_MAP = {};

  System.registerAddin = function(strVar, objAddin) {
    jsx3.lang.setVar(strVar, objAddin);
    System._ADDINS.push(objAddin);
    System._ADDIN_MAP[objAddin.getKey()] = objAddin;
  };

  System.getAddins = function() {
    return System._ADDINS.concat();
  };

  System.getAddin = function(strKey) {
    return System._ADDIN_MAP[strKey];
  };

  System.getVersion = function() {
    var v = "@build.gi.version@.@build.version.buildno@";
    return v.match(/\d/) ? v : "3.7.0"; // fallback for uncompiled version
  };

});

// jsx3.lang.System
jsx3.GO =            jsx3.lang.System.GO;
jsx3.getApp =        jsx3.lang.System.getApp;
jsx3.registerApp =   jsx3.lang.System.registerApp;
jsx3.activateApp =   jsx3.lang.System.activateApp;
jsx3.deregisterApp = jsx3.lang.System.deregisterApp;
jsx3.getVersion =    jsx3.lang.System.getVersion;

jsx3.Class.defineInterface("jsx3.xml.CDF", null, function(CDF, CDF_prototype) {

  CDF._LOG = jsx3.util.Logger.getLogger(CDF.jsxclass.getName());

  CDF.DELETE = 0;

  CDF.INSERT = 1;

  CDF.UPDATE = 2;

  CDF.INSERTBEFORE = 3;

  CDF.ELEM_ROOT = "data";

  CDF.ELEM_RECORD = "record";

  CDF.ATTR_ID = "jsxid";

  CDF.ATTR_TEXT = "jsxtext";

  CDF.ATTR_EXECUTE = "jsxexecute";

  CDF.ATTR_DISABLED = "jsxdisabled";

  CDF.ATTR_SELECTED = "jsxselected";

  CDF.ATTR_UNSELECTABLE = "jsxunselectable";

  CDF.ATTR_IMG = "jsximg";

  CDF.ATTR_TIP = "jsxtip";

  CDF.ATTR_KEYCODE = "jsxkeycode";

  CDF.PROPERTY_ATTR = [CDF.ATTR_TEXT, CDF.ATTR_TIP, CDF.ATTR_IMG, CDF.ATTR_KEYCODE, "jsxstyle", "jsxclass"];

  CDF._SERIAL = 1;

  CDF_prototype.insertRecord = function(objRecord, strParentRecordId, bRedraw) {};

  CDF_prototype.insertRecordNode = function(objRecordNode, strParentRecordId, bRedraw) {};

  CDF_prototype.insertRecordProperty = function(strRecordId,strPropName,strPropValue,bRedraw) {};

  CDF_prototype.deleteRecordProperty = function(strRecordId,strPropName,bRedraw) {};

  CDF_prototype.redrawRecord = jsx3.Method.newAbstract("strRecordId", "intAction");

  CDF_prototype.adoptRecord = function(strSourceId, strRecordId, strParentRecordId, bRedraw) {};

  CDF_prototype.insertRecordBefore = function(objRecord, strSiblingRecordId, bRedraw) {};

  CDF_prototype.adoptRecordBefore = function(strSourceId, strRecordId, strSiblingRecordId, bRedraw) {

//          for (var i = objRecordNode.getChildIterator(); i.hasNext(); )
//            this.redrawRecord(i.next().getAttribute("jsxid"), CDF.INSERT);

  };

  CDF_prototype.deleteRecord = function(strRecordId,bRedraw) {

//        for (var i = objNode.getChildIterator(); i.hasNext(); )
//          this.redrawRecord(i.next().getAttribute("jsxid"), CDF.DELETE);

  };

  CDF_prototype.getRecord = function(strRecordId) {};

   CDF_prototype.getRecordIds = function() {};

  CDF_prototype.getRecordNode = function(strRecordId) {};

  CDF_prototype._getSelectionQuery = function(strRecordId) {};

  CDF_prototype.resetData = function(bRepaint) {};

  CDF_prototype.reloadFromSource = function(bSystem) {};

  CDF_prototype.assignIds = function() {};

  CDF._INDEXEDPROP_REGEX = /\[(\w+)\]$/;

  CDF_prototype.convertProperties = function(objProps, arrProps, bUnion) {};

  CDF.newDocument = function() {};

  CDF.getKey = function() {};

  CDF.getVersion = function() {};

});

jsx3.Class.defineClass("jsx3.xml.CDF.Document", jsx3.xml.Document, [jsx3.xml.CDF], function(Document, Document_prototype) {

  Document_prototype.getXML = function() {};

  Document_prototype.redrawRecord = function(strRecordId, intAction) {};

  Document_prototype.cloneDocument = function() {};

  Document.newDocument = function() {};

  Document.wrap = function(objXML) {};

});

jsx3.CDF = jsx3.xml.CDF;

jsx3.Class.defineClass("jsx3.app.DOM", null, [jsx3.util.EventDispatcher], function(DOM, DOM_prototype) {

  DOM._INC = {};

  DOM._LOOKUP = {};

  DOM._LOOKUP_REVERSE = {};

  DOM._LOOKUP_COUNT = 0;

  DOM.TYPEADD = 0;

  DOM.TYPEREMOVE = 1;

  DOM.TYPEREARRANGE = 2;

  DOM.EVENT_CHANGE = "change";

  DOM.newId = function(strNameSpace) {
    var nsKey = DOM._getNamespaceKey(strNameSpace);
    return "_jsx_" + nsKey + "_" + DOM._getNamespaceSerial(nsKey).toString(36);
  };

  DOM._getNamespaceKey = function(strNS) {
    if (DOM._LOOKUP[strNS] == null) {
      var key = (DOM._LOOKUP_COUNT++).toString(36);
      DOM._LOOKUP[strNS] = key;
      DOM._LOOKUP_REVERSE[key] = strNS;
    }

    return DOM._LOOKUP[strNS];
  };

  DOM._getNamespaceSerial = function(strNSKey) {
    if (DOM._INC[strNSKey] == null)
      DOM._INC[strNSKey] = 0;

    return ++DOM._INC[strNSKey];
  };

  DOM.getNamespaceForId = function(strId) {
    var key = strId.substring(5, strId.indexOf("_", 5));
    return DOM._LOOKUP_REVERSE[key];
  };

  DOM_prototype.init = function() {
    // holds index of of all GUI objects for this server instance, indexed via their system-assigned ID

    this.SYSTEMHASH = {};

    // holds index of all GUI objects for this server instance, indexed via the developer-assigned NAME

    this.USERHASH = {};
  };

  DOM_prototype.destroy = function() {
    delete this.SYSTEMHASH;
    delete this.USERHASH;
  };

  DOM_prototype.get = function(strId) {
    return this.SYSTEMHASH[strId] || this.getByName(strId);
  };

  DOM_prototype.getByName = function(strName) {
    var nameBucket = this.USERHASH[strName];
    return nameBucket != null ? nameBucket.get(0) : null;
  };

  DOM.EMPTY_LIST = [];

  DOM_prototype.getAllByName = function(strName) {
    var nameBucket = this.USERHASH[strName];
    return nameBucket != null ? nameBucket.toArray() : DOM.EMPTY_LIST;
  };

  DOM_prototype.getById = function(strId) {
    return this.SYSTEMHASH[strId];
  };

  DOM_prototype.add = function(objJSX) {
    this.SYSTEMHASH[objJSX.getId()] = objJSX;
    var name = objJSX.getName();
    if (name != null && name !== "") {
      if (this.USERHASH[name] == null)
        this.USERHASH[name] = jsx3.util.List.wrap([objJSX]);
      else
        this.USERHASH[name].add(objJSX, 0);
    }
  };

  DOM_prototype.remove = function(objJSX) {
    delete this.SYSTEMHASH[objJSX.getId()];

    var nameBucket = this.USERHASH[objJSX.getName()];
    if (nameBucket != null)
      nameBucket.remove(objJSX);
  };

  DOM_prototype.onNameChange = function(objJSX, oldName) {
    var oldBucket = this.USERHASH[oldName];
    if (oldBucket != null)
      oldBucket.remove(objJSX);

    var name = objJSX.getName();
    if (name != null && name !== "") {
      if (this.USERHASH[name] == null)
        this.USERHASH[name] = jsx3.util.List.wrap([objJSX]);
      else
        this.USERHASH[name].add(objJSX, 0);
    }
  };

  DOM_prototype.onChange = function(TYPE, JSXPARENTID, JSXID) {
    this.publish({subject:DOM.EVENT_CHANGE, type:TYPE, parentId:JSXPARENTID, jsxId:JSXID});
  };

});

jsx3.DOM = jsx3.app.DOM;

// @jsxobf-clobber-shared  _jsxns _jsxroots

jsx3.Class.defineClass("jsx3.app.Server", null, [jsx3.util.EventDispatcher, jsx3.net.URIResolver],
    function(Server, Server_prototype) {

  jsx3.util.EventDispatcher.jsxclass.mixin(Server);

  var Event = jsx3.gui.Event;
  var URIResolver = jsx3.net.URIResolver;
  var Browser = jsx3.app.Browser;
  var Block = null;

  var LOG = jsx3.util.Logger.getLogger(Server.jsxclass.getName());

  Server.Z_DIALOG = 2;

  Server.Z_DRAG = 3;

  Server.Z_MENU = 4;

  Server.INITED = "inited";

  Server.HELP = "help";

  Server._DIVID = "JSX";

  Server._INSTANCES = new jsx3.util.List();

  Server_prototype.JSXROOT = null;

  Server_prototype.JSXBODY = null;

  Server_prototype.Cache = null;

  Server_prototype.ENVIRONMENT = null;

  Server_prototype.DOM = null;

  Server_prototype.JSS = null;

  Server_prototype.init = function(strAppPath, objGUI, bPaint, objEnv) {
    //instance a new DOM controller for this server instance that will track and manage JSX GUI and Data objects
    this.DOM = new jsx3.app.DOM();

    //instance the cache controller -- although this object is little-changed, its recommended use is much more limited and can merely be thought of as a simplified way to cache an XML document or system XSLT
    this.Cache = new jsx3.app.Cache();
    this.Cache.addParent(jsx3.getSharedCache());

    if (objEnv != null && objEnv.jsxsettings != null) {
      this._jsxsettings = objEnv.jsxsettings;
      delete objEnv.jsxsettings;
    }

    this.ENVIRONMENT = objEnv = objEnv != null ? jsx3.clone(objEnv) : {};
    objEnv.apppath = strAppPath.replace(/\/*$/, "");

    //load the application config file, so we know which resource files (JS, CSS, XML, etc) to load
    var objSettings = this.getSettings();

    var settingsTree = objSettings.get();

    for (var f in settingsTree) {
      var key = f.toLowerCase();
      if (typeof(objEnv[key]) == "undefined" && typeof(settingsTree[f]) != "object") {
        objEnv[key] = settingsTree[f];
      }
    }

    // figure out path to resources, support for environment variable jsxappbase which is a relative (or absolute)
    // path from the config.xml file to the content root of the application
    objEnv.apppathuri = new jsx3.net.URI(objEnv.apppath + "/");
    if (objEnv.jsxappbase)
      objEnv.apppathuri = objEnv.apppathuri.resolve(objEnv.jsxappbase);

    var i = objEnv.apppath.indexOf(jsx3.APP_DIR_NAME);
    if (i >= 0)
      objEnv.apppathrel = objEnv.apppath.substring(i + jsx3.APP_DIR_NAME.length + 1);
    objEnv.apppathabs = Browser.getLocation().resolve(objEnv.apppathuri);

    if (objEnv['liquid'] == null) objEnv['liquid'] = true;

    if (objEnv['eventsvers'] == null) objEnv['eventsvers'] = 3.0;

    if (objEnv['jsxversion'] == null) objEnv['jsxversion'] = "3.1";

    objEnv.abspath = jsx3.getEnv("jsxabspath");
    objEnv.guiref = objGUI;            //object ref to on-screen containing object (div, td, span, etc)
    objEnv.namespace = objEnv.jsxappns || objEnv.namespace;

    if (objEnv.namespace == null)
      throw new jsx3.Exception(jsx3._msg("serv.no_ns", strAppPath));

    if (objGUI && this.getEnv("caption"))
      objGUI.ownerDocument.title = this.getEnv("caption");

    // implicitly cancel (trap) all right-click events unless explictly told not to
    if (objGUI && this.getEnv("cancelrightclick"))
      objGUI.ownerDocument.oncontextmenu = new Function("return false;");

    // implicitly cancel (trap) all browser-native errors unless explictly told not to
    if (this.getEnv("cancelerror"))
      jsx3.NativeError.initErrorCapture();

    // add this to the list of all instances
    Server._INSTANCES.add(this);

    //bind a reference to this jsxserver instance to the top-level window, using the declared namespace for this server; this provides a global handle to the server by name and is critical to backwards compatibility
    jsx3.registerApp(this);

    //create JSS MODEL CONTAINER (the dynamic properties object array)
    this.JSS = new jsx3.app.Properties();
    this.LJSS = new jsx3.app.Properties();
    this.JSS.addParent(this.LJSS); // add localized properties to the tree
    this.JSS.addParent(jsx3.System.JSS); // copy system JSS properties into this server

    Server.publish({subject: Server.INITED, target:this});

    //7) if specified, immediately render the view (typically only happens if the user chooses to initialize a new server AFTER the document BODY has fully loaded
    if (bPaint) this.paint();
  };

  Server_prototype._createRootAndBody = function() {
    jsx3.require("jsx3.gui.HotKey");
    Block = jsx3.gui.Block;

    if (this.JSXROOT) return;

    // always create root and body; even though the app might not have a VIEW, it still may want access to the MODEL --
    // even for GUI objects
    var root = this.JSXROOT = this._createRoot("JSXROOT");
    root.setDynamicProperty("jsxbgcolor","@Solid DarkShadow");
    root.setRelativePosition(Block.ABSOLUTE);
    root.setOverflow(Block.OVERFLOWEXPAND);
    root.setAlwaysCheckHotKeys(true);
    root.setIndex(1);

    var body = this.JSXBODY = new Block("JSXBODY",0,0,"100%","100%","");
    body.setDynamicProperty("jsxbgcolor","@Solid Light");
    body.setRelativePosition(Block.ABSOLUTE);
    body.setZIndex(1);
    body.setOverflow(Block.OVERFLOWEXPAND).setIndex(0);
    root.setChild(body);
  };

  Server_prototype.onResize = function() {
 if (jsx3.CLASS_LOADER.IE) {
    //use delay in IE to stop CPU thrashing
    window.clearTimeout(this.resize_timeout_id);
    var my = this;
    this.resize_timeout_id = window.setTimeout(function() { my._onResizeDelay(); }, 250);
 } else {
    this._onResizeDelay();
 }
  };

  Server_prototype._onResizeDelay = function() {
    //jsx3.util.Logger.getLogger("jsx3.boxmodel").trace("RESIZE " + this.getClass() + ": [" + this.getEnv("NAMESPACE") + "]");

    //get the HTML element that contains this server instance
    var objGUI = this.getEnv("GUIREF");

    //tell the root block to update its profile
    if(objGUI) {
      this.getRootBlock().syncBoxProfile({left:0,top:0,parentwidth:objGUI.clientWidth,parentheight:objGUI.clientHeight}, true);
    }
  };

  Server_prototype.getNextZIndex = function(intType) {
    if (this.ZRANGE == null) {

      this.ZRANGE = [];
      this.ZRANGE[0] = 0;
      this.ZRANGE[1] = 1000;
      this.ZRANGE[Server.Z_DIALOG] = 5000;
      this.ZRANGE[Server.Z_DRAG] = 7500;
      this.ZRANGE[Server.Z_MENU] = 10000;
      this.ZRANGE[5] = 25000;
    }

    return this.ZRANGE[intType]++;
  };

  Server.allServers = function() {
    return Server._INSTANCES.toArray();
  };

  Server_prototype._createRoot = function(strName) {
    if (this._jsxroots == null) this._jsxroots = [];

    var root = new Block(strName, 0, 0, "100%", "100%", "");
    root._jsxns = this.getEnv("NAMESPACE");
    root._jsxid = jsx3.app.DOM.newId(this.getEnv("NAMESPACE"));
    root._jsxserver = this;
    this.DOM.add(root);

    this._jsxroots.push(root);
    return root;
  };

  Server_prototype.getInvisibleRoot = function() {
    if (this.INVISIBLE == null)
      this.INVISIBLE = this._createRoot("JSXINVISIBLE");
    return this.INVISIBLE;
  };

  Server_prototype.getEnv = function(strEnvKey) {
    return this.ENVIRONMENT[strEnvKey.toLowerCase()];
  };

  Server._showEnv = function(objEvent) {
    //get the relevant variables to profile
    var s = ['<div class="jsx30block jsx30env">'];
    s.push('<b>Version:</b> ', '@gi.version.full@', '<br/>');
    s.push('<b>XML Version:</b> ', jsx3.getXmlVersion(), '<br/>');
    s.push('<b>System Locale:</b> ', jsx3.System.getLocale().getDisplayName(), '<br/>');
    s.push('<b>Browser:</b> ', jsx3.CLASS_LOADER + '<br/>');
    s.push('<b>Operating System:</b> ', jsx3.app.Browser.getSystem() + " (" + navigator.userAgent + ")");
    s.push('<hr/>');

    var root = null;

    var servers = Server.allServers();
    for (var i = 0; i < servers.length; i++) {
      var server = servers[i];
      s.push("<b>", server.getEnv("namespace"), "</b>", "<div>");
      s.push('<b>Path:</b> ', server.getAppPath(), '<br/>');
      s.push('<b>Version:</b> ', server.getEnv("version"), '<br/>');
      s.push("</div>");

      if (root == null) {
        root = server.getRootBlock();
        if (root.getRendered() == null) root = null;
      }
    }

    s.push('</div>');
    s = s.join("");

    if (root)
      root.showSpy(s, Math.round(root.getRendered().clientWidth/2), Math.round(root.getRendered().clientHeight/2-100));
    else window.alert(s);
  };

  Server_prototype.getSettings = function() {
    if (this._jsxsettings == null) {
      var objXML = this.getCache().getOrOpenDocument(jsx3.resolveURI(this.getAppPath() + "/" + jsx3.CONFIG_FILE), "JSX_SETTINGS");
      if (objXML.hasError()) {
        LOG.error(jsx3._msg("serv.err_set", this, objXML.getError()));
        objXML = null;
      }

      this._jsxsettings = new jsx3.app.Settings(objXML);
    }
    return this._jsxsettings;
  };

  Server_prototype.getAppPath = function() {
    return this.getEnv("apppath");
  };

  Server._taskBarFinder = function(obj) {
    return (obj instanceof jsx3.gui.WindowBar) && obj.getType() == jsx3.gui.WindowBar.TYPETASK;
  };

  Server_prototype.getTaskBar = function(objJSX) {
    if (! jsx3.gui.WindowBar) return null;
    if (objJSX == null) objJSX = this.JSXROOT;
    return objJSX.findDescendants(Server._taskBarFinder, false, false, false, true);
  };

  Server_prototype.destroy = function() {
    var unloadScript = this.getEnv("onunload");
    if (unloadScript) {
      try {
        this.eval(unloadScript);
      } catch (e) {
        LOG.error(jsx3._msg("serv.err_onun", this), jsx3.NativeError.wrap(e));
      }
    }

    //unsubscribe self from the box profiler
    if (jsx3.Class.forName("jsx3.gui.Painted"))
      jsx3.gui.Painted.Box.unregisterServer(this,this.getEnv("LIQUID"));

    //destroy root view (JSXROOT)
    if (this.JSXROOT) {
      var objGUI = this.JSXROOT.getRendered();
      if (objGUI) {
        //depending upon the server mode (ide or runtime), the outer container may or may not be present
        if (objGUI.parentNode.id == Server._DIVID)
          objGUI = objGUI.parentNode;
        jsx3.html.removeNode(objGUI);
      }
    }

    //free-up GUI objects belonging to the various roots
    if (this._jsxroots) {
      for (var i = 0; i < this._jsxroots.length; i++) {
        var root = this._jsxroots[i];
        root.removeChildren();
      }
    }
    delete this._jsxroots;

    //shut down subscriptions to dom and cache
    this.DOM.unsubscribeAllFromAll();
    this.DOM.destroy();

    //free-up xml resources
    this.Cache.unsubscribeAll(jsx3.app.Cache.CHANGE);
    this.Cache.destroy();

    //remove ref to this server
    jsx3.deregisterApp(this);

    // remove instance from list of all Server instances
    Server._INSTANCES.remove(this);

    // uncapture BODY keydown
    Event.unsubscribe(Event.KEYDOWN, this, "checkHotKeys");

    this.ENVIRONMENT = {};
  };

  Server_prototype.paint = function(objXML) {
    jsx3.require("jsx3.gui.HotKey");
    Block = jsx3.gui.Block;

    //3) register the browser mode
    jsx3.html.getMode(this.getEnv("GUIREF"));

    //4) generate the initial DOM structure (JSXROOT AND JSXBODY)
    this._createRootAndBody();

    //5) register the server with the box manager; pass the liquid mode (true or false)
    jsx3.gui.Painted.Box.registerServer(this, this.getEnv("LIQUID"));

    if (this.getEnv("BODYHOTKEYS"))
      Event.subscribe(Event.KEYDOWN, this, "checkHotKeys");

    // Register ctrl+alt+shift+j to show the server environment
    var showEnv = "_showEnv";
    this.registerHotKey(new Function("jsx3.app.Server." + showEnv + "();"), 74, true, true, true);
    // Register the esc key to abort DnD
    this.registerHotKey(new Function("if (jsx3.EventHelp.isDragging()) jsx3.EventHelp.reset();"), Event.KEY_ESCAPE, false, false, false);
    // Register context-sensitive help system
    this._regHelpKey();

    //validate that the GUI container to place our app inside is not a null reference
    var objGUI = this.getEnv("GUIREF");

    if (objGUI) {
      //derive overflow settings for the outermost app container
      var strOverflow = "";
      var of = this.getEnv("OVERFLOW");
      if (of == Block.OVERFLOWSCROLL) {
        strOverflow = "overflow:auto;";
      } else if (of == Block.OVERFLOWHIDDEN) {
        strOverflow = "overflow:hidden;";
      }

      //derive position settings
      var strPosition, strLeft = "", strTop = "";
      if (this.getEnv("POSITION") == 0) {
        strPosition = "relative";
      } else {
        strPosition = "absolute";
        strLeft = "left:" + this.getEnv("LEFT") + ";";
        strTop = "top:" + this.getEnv("TOP") + ";";
      }
      var strWidth = "width:" + this.getEnv("WIDTH") + ";";
      var strHeight = "height:" + this.getEnv("HEIGHT") + ";";

      //generate initial application container
      objGUI.innerHTML = '<div id="' + Server._DIVID + '" style="position:' + strPosition + ';' + strOverflow +
          strLeft + strTop + strWidth + strHeight + '"></div>';
      objGUI = objGUI.lastChild;

      //initialize the box profile for root (this is how the box profiling is first initiated); basically pass the drawspace that root should live within
      this.JSXROOT.syncBoxProfileSync({left:0,top:0,parentwidth:objGUI.clientWidth,parentheight:objGUI.clientHeight});

      if (objGUI)
        objGUI.innerHTML = this.JSXROOT.paint();
    }

    try {
      //call _doLoad (regardless of whether or not there is a view component for this server instance, still try to initialize the environment
      this._doLoad(objXML);
    } catch (e) {
      LOG.fatal(jsx3._msg("serv.err_paint", this), jsx3.NativeError.wrap(e));
    }

    try {
      //initialize the on load script now that all files, includes, and object sets have been loaded
      this.eval(this.getEnv("onload"));
    } catch (e) {
      LOG.fatal(jsx3._msg("serv.err_onload", this), jsx3.NativeError.wrap(e));
    }
  };

  Server_prototype._regHelpKey = function() {
    var helpKey = this.getDynamicProperty("jsx3.app.Server.help." + jsx3.app.Browser.getSystem()) ||
                  this.getDynamicProperty("jsx3.app.Server.help");
    if (helpKey)
      this.registerHotKey(jsx3.gui.HotKey.valueOf(helpKey, jsx3.makeCallback("_onHelpKey", this)));
  };

  Server_prototype._doLoad = function(objXML) {
    var child = null;

    if (objXML) {
      child = this.JSXBODY.loadXML(objXML, true);
    } else {
      var strComponentURL = this.getEnv("objectseturl");

      if (strComponentURL)
        child = this.JSXBODY.load(strComponentURL, true);
    }

    if (child)
      child.setPersistence(jsx3.app.Model.PERSISTEMBED);
  };

  Server_prototype.setDimensions = function(left, top, width, height) {
    //convert array to ints
    if (left instanceof Array) {
      top = left[1];
      width = left[2];
      height = left[3];
      left = left[0];
    }

    var objGUI = this.JSXROOT.getRendered();
    if (objGUI) {
      if (left) objGUI.parentNode.style.left = left + "px";
      if (top) objGUI.parentNode.style.top = top + "px";
      if (width) objGUI.parentNode.style.width = width + "px";
      if (height) objGUI.parentNode.style.height = height + "px";
    }
  };

  Server_prototype.loadInclude = function(strSrc, strId, strType, bReload) {
    //resolve id to an empty string if not passed
    if (strId == null) strId = "";

    //create query string to force the browser to reload this resource from the remote server unless set to never reload
    var strAppend = (bReload) ? ((((strSrc+"").indexOf("?") == -1)?"?":"&") + (new Date()).valueOf()) : "";

    //branch based on file type
    if (strType == "css") {
      jsx3.CLASS_LOADER.loadResource(strSrc + strAppend, strId, strType);
    } else if (strType == "jss" || (strType == "ljss" && !jsx3.app.PropsBundle)) {
      var jssDoc = this.Cache.openDocument(strSrc, strId);

      if (jssDoc.hasError()) {
        jsx3.util.Logger.GLOBAL.error(jsx3._msg("serv.err_jss", + strSrc, jssDoc.getError()));
      } else {
        this.getProperties().loadXML(jssDoc, strId);
      }
    } else if (strType == "ljss") {
      var objCache = this.getCache();
      if (bReload) {
        var p = this.LJSS.getParents();
        for (var i = 0; i < p.length; i++) {
          if (p[i].getPath() == strSrc)
            this.LJSS.removeParent(p[i]);
        }

        jsx3.app.PropsBundle.clearCache(strSrc, objCache);
      }

      this.LJSS.addParent(jsx3.app.PropsBundle.getProps(strSrc, this.getLocale(), objCache));
    } else if (strType == "xml" || strType == "xsl") {
      return this.Cache.openDocument(strSrc, strId);
    } else if (strType == "script") {
      //try to remove existing script
      this.unloadInclude(strId);
      jsx3.CLASS_LOADER.loadResource(strSrc + strAppend, strId, strType);
    } else {
      throw new jsx3.IllegalArgumentException('strType', strType);
    }
  };

  Server_prototype.unloadInclude = function(strId) {
    var objInclude = this.getRootDocument().getElementById(strId);
    try {
      if (objInclude) objInclude.parentNode.removeChild(objInclude);
    } catch (e) {
      LOG.warn(jsx3._msg("serv.err_unload", strId, this), jsx3.NativeError.wrap(e));
    }
  };

  Server_prototype.loadResource = function(strId) {
    var objSettings = this.getSettings();
    var includes = jsx3.util.List.wrap(objSettings.get('includes')).filter(function(x) { return x.id == strId; }).toArray(true);

    var lastInclude;
    for (var i = 0; i < includes.length; i++) {
      var include = includes[i];
      lastInclude = this.loadInclude(this.resolveURI(include.src), include.id, include.type);
    }

    if (includes.length == 0)
      LOG.warn(jsx3._msg("serv.err_badid", strId));

    return lastInclude;
  };

  Server_prototype.setDynamicProperty = function(strPropName, vntValue) {
    var jss = this.getProperties();
    jss.set(strPropName, vntValue);
  };

  Server_prototype.getDynamicProperty = function(strPropName, strToken) {
    var value = this.getProperties().get(strPropName);

    // jsx3.util.MessageFormat class is optional, should work without it
    if (arguments.length > 1 && jsx3.util.MessageFormat) {
      try {
        var format = new jsx3.util.MessageFormat(value);
        var args = new Array(arguments.length - 1);
        for (var i = 1; i < arguments.length; i++)
          args[i-1] = arguments[i];
        return format.format(args);
      } catch (e) {;}
    }

    return value;
  };

  Server_prototype.setCookie = function(name, value, expires, path, domain, secure, bRaw) {
    this.getRootDocument().cookie = name + "=" + (bRaw ? value : escape(value)) +
        ((expires) ? "; expires=" + expires.toGMTString() : "") +
        ((path) ? "; path=" + path : "") +
        ((domain) ? "; domain=" + domain : "") +
        ((secure) ? "; secure" : "");
  };

  Server_prototype.getCookie = function(name, bRaw) {
    var doc = this.getRootDocument();

    var dc = doc.cookie;
    var prefix = name + "=";
    var begin = dc.indexOf("; " + prefix);
    if (begin == -1) {
      begin = dc.indexOf(prefix);
      if (begin != 0) return null;
    } else {
      begin += 2;
    }

    var end = doc.cookie.indexOf(";", begin);
    if (end == -1) {
      end = dc.length;
    }

  var raw = dc.substring(begin + prefix.length, end);
    return bRaw ? raw : unescape(raw);
  };

  Server_prototype.deleteCookie = function(name, path, domain) {
    this.setCookie(name, "", new Date(1970,0,1), path, domain);
  };

  Server_prototype.getRootBlock = function() {
    if (this.JSXROOT == null) this._createRootAndBody();
    return this.JSXROOT;
  };

  Server_prototype.getBodyBlock = function() {
    if (this.JSXROOT == null) this._createRootAndBody();
    return this.JSXBODY;
  };

  Server_prototype.getRootObjects = function() {
    return this.JSXBODY.getChildren().concat();
  };

  Server_prototype.getCache = function() {
    return this.Cache;
  };

  Server_prototype.getProperties = function() {
    return this.JSS;
  };

  Server_prototype.getDOM = function() {
    return this.DOM;
  };

  Server_prototype.getJSX = function(strId) {
    return this.DOM.get(strId);
  };

  Server_prototype.getJSXByName = function(strId) {
    return this.DOM.getByName(strId);
  };

  Server_prototype.getJSXById = function(strId) {
    return this.DOM.getById(strId);
  };

  Server_prototype.beep = function() {
    if (! jsx3.gui.WindowBar) return;

    var windowBar = this.JSXROOT.findDescendants(
      function(x) {return (x instanceof jsx3.gui.WindowBar)
          && x.getType() == jsx3.gui.WindowBar.TYPEMENU;}, false, false);
    if (windowBar != null)
      windowBar.beep();
  };

  Server_prototype.createAppWindow = function(strName) {
    jsx3.require("jsx3.gui.HotKey");

    if (this.WINDOWS == null)
      this.WINDOWS = this._createRoot("JSXWINDOWS");

    if (this.WINDOWS.getChild(strName) != null)
      throw new jsx3.IllegalArgumentException("strName", strName);

    var w = new jsx3.gui.Window(strName);
    this.WINDOWS.setChild(w);
    return w;
  };

  Server_prototype.loadAppWindow = function(strSource, objResolver) {
    jsx3.require("jsx3.gui.HotKey");

    if (this.WINDOWS == null)
      this.WINDOWS = this._createRoot("JSXWINDOWS");

    var component = null;
    if (strSource instanceof jsx3.xml.Entity)
      component = this.WINDOWS.loadXML(strSource, false, objResolver);
    else
      component = this.WINDOWS.load(strSource, false, objResolver);

    if (component == null)
      throw new jsx3.Exception(jsx3._msg("serv.win_err", strSource));
    if (!(component instanceof jsx3.gui.Window)) {
      component.getParent().removeChild(component);
      throw new jsx3.Exception(jsx3._msg("serv.win_notwin", strSource, component.getClass()));
    }

    if (this.WINDOWS.getChild(component.getName()) != component) {
      component.getParent().removeChild(component);
      throw new jsx3.Exception(jsx3._msg("serv.win_name", strSource, component.getName()));
    }

    return component;
  };

  Server_prototype.getAppWindow = function(strName) {
    if (this.WINDOWS != null)
      return this.WINDOWS.getChild(strName);
    return null;
  };

  Server_prototype.getDocumentOf = function(objJSX) {
    var parent = objJSX;
    while (parent != null) {
      if (jsx3.gui.Window && parent instanceof jsx3.gui.Window)
        return parent.getDocument();
      if (parent._jsxserver != null)
        return this.getRootDocument();

      parent = parent.getParent();
    }
    return this.getRootDocument();
  };

  Server_prototype.getRootDocument = function() {
    var rootGUI = this.getEnv('GUIREF');
    return rootGUI != null ? rootGUI.ownerDocument : null;
  };

  Server_prototype.getRenderedOf = function(objJSX) {
    var id = objJSX.getId();
    var rootDoc = this.getRootDocument();
    if (rootDoc == null) return null;

    var objGUI = rootDoc.getElementById(id);

    if (objGUI == null && this.WINDOWS != null) {
      var windows = this.WINDOWS.getChildren();
      for (var i = 0; objGUI == null && i < windows.length; i++) {
        var doc = windows[i].getDocument();
        if (doc)
          objGUI = doc.getElementById(id);
      }
    }

    return objGUI;
  };

  Server_prototype.registerHotKey = function(vntCallback, vntKey, bShift, bControl, bAlt) {
    return this.getRootBlock().registerHotKey(vntCallback, vntKey, bShift, bControl, bAlt);
  };

  Server_prototype.checkHotKeys = function(objEvent) {
    return this.getRootBlock().checkHotKeys(objEvent.event);
  };

  Server_prototype.getServer = function() {
    return this;
  };

  Server_prototype.isAtLeastVersion = function(strVersion) {
    return jsx3.util.compareVersions(this.getEnv('jsxversion'), strVersion) >= 0;
  };

  Server_prototype.resolveURI = function(strURI) {
    var uri = jsx3.net.URI.valueOf(strURI);

    if (this.isAtLeastVersion("3.2") && !URIResolver.isAbsoluteURI(uri)) {
      var appPathUri = this.getEnv("apppathuri");
      uri = appPathUri.resolve(uri);
    }

    return URIResolver.DEFAULT.resolveURI(uri);
  };

  Server_prototype.getUriPrefix = function() {
    return this.getEnv("apppathuri").toString();
  };

  Server_prototype.relativizeURI = function(strURI, bRel) {
    var loc = Browser.getLocation();
    var appPathUri = this.getEnv("apppathabs");
    var relative = appPathUri.relativize(loc.resolve(strURI));

    if (relative.isAbsolute() || bRel) {
      return relative;
    } else {
      var relPath = this.getEnv("apppathrel");
      if (relPath) {
        return jsx3.net.URI.fromParts("jsxapp", null, relPath.replace(/\//g, "!"), null,
            "/" + relative.getPath(), relative.getQuery(), relative.getFragment());
      } else {
        // special handling for GI_Builder/
        return jsx3.net.URI.fromParts(null, null, null, null,
            this.getEnv("apppath") + "/" + relative.getPath(), relative.getQuery(), relative.getFragment());
      }
    }
  };

  URIResolver.register("jsxapp", function(uri) {
    var host = uri.getHost();
    if (host) {
      var appPath = host.replace(/!/g, "/");
      var loadedApp = jsx3.System.getAppByPath(appPath);
      return loadedApp || new Server.Resolver(appPath);
    }
    return URIResolver.DEFAULT;
  });

  Server_prototype.getLocale = function() {
    if (this._locale == null)
      this._locale = this.getDefaultLocale();

    return this._locale != null ? this._locale : jsx3.System.getLocale();
  };

  Server_prototype.setLocale = function(objLocale) {

    this._locale = objLocale;
  };

  Server_prototype.getDefaultLocale = function() {
    var localeKey = this.getSettings().get("default_locale");
    if (localeKey == null) return null;
    localeKey = jsx3.util.strTrim(localeKey.toString());
    // Locale is optional
    return localeKey.length > 0 && jsx3.util.Locale ? jsx3.util.Locale.valueOf(localeKey) : null;
  };

  Server_prototype.reloadLocalizedResources = function() {
    var p = this.LJSS.getParents();
    this.LJSS.removeAllParents();

    for (var i = 0; i < p.length; i++) {
      var props = jsx3.app.PropsBundle.getProps(p[i].getPath(), this.getLocale(), this.getCache());
      this.LJSS.addParent(props);
    }
  };

  Server_prototype._onHelpKey = function(objEvent) {
    var objJSX = jsx3.html.getJSXParent(objEvent.srcElement(), this);
    if (!objJSX) objJSX = this.JSXROOT;
    return objJSX ? this.invokeHelp(objJSX) : false;
  };

  Server_prototype.invokeHelp = function(objJSX) {
    var strId = null;
    while (objJSX && !strId) {
      strId = objJSX.getHelpId();
      objJSX = objJSX.getParent();
    }

    if (strId)
      this.publish({subject:Server.HELP, helpid:strId, model:objJSX});

    return Boolean(strId);
  };

  Server_prototype.getAddins = function() {
    var a = [];
    var names = this.getSettings().get("addins");
    if (names) {
      for (var i = 0; i < names.length; i++) {
        var addin = jsx3.System.getAddin(names[i]);
        if (addin) a.push(addin);
      }
    }
    return a;
  };

  Server_prototype.toString = function() {
    return this.jsxsuper() + " " + this.getAppPath() + ":" + this.getEnv("namespace");
  };

  Server.getVersion = function() {
    return "3.00.00";
  };

});

jsx3.Server = jsx3.app.Server;

jsx3.Class.defineClass("jsx3.app.Server.Resolver", null, [jsx3.net.URIResolver],
    function(ServerURIResolver, ServerURIResolver_prototype) {

  var URIResolver = jsx3.net.URIResolver;

  ServerURIResolver_prototype.init = function(strHost) {
    this._host = strHost;
    this._uri = new jsx3.net.URI(jsx3.getEnv("jsxhomepath") + jsx3.APP_DIR_NAME + "/" + strHost.replace(/!/g, "/") + "/");
  };

  ServerURIResolver_prototype.resolveURI = function(strURI) {
    var uri = jsx3.net.URI.valueOf(strURI);

    if (! URIResolver.isAbsoluteURI(uri))
      uri = URIResolver.DEFAULT.resolveURI(this._uri.resolve(uri));

    return URIResolver.DEFAULT.resolveURI(uri);
  };

  ServerURIResolver_prototype.getUriPrefix = function() {
    return this._uri.toString();
  };

  ServerURIResolver_prototype.relativizeURI = function(strURI, bRel) {
    var relative = this._uri.relativize(strURI);

    if (relative.isAbsolute() || bRel)
      return relative;
    else
      return jsx3.net.URI.fromParts("jsxapp", null, this._host, null,
          "/" + relative.getPath(), relative.getQuery(), relative.getFragment());
  };

  ServerURIResolver_prototype.toString = function() {
    return this._uri.toString();
  };

});

// @jsxobf-clobber-shared  _jsxevents _jsxtempdynamic _jsxdynamic _jsxloading _applyId

jsx3.Class.defineClass("jsx3.app.Model", null, [jsx3.util.EventDispatcher], function(Model, Model_prototype) {

  var Entity = jsx3.xml.Entity;
  var Document = jsx3.xml.Document;

  Model.PERSISTNONE = 0;

  Model.PERSISTEMBED = 1;

  Model.PERSISTREF = 2;

  Model.PERSISTREFASYNC = 3;

  Model.LT_NORMAL = 0;

  Model.LT_SLEEP_PAINT = 1;

  Model.LT_SLEEP_DESER = 2;

  Model.LT_SLEEP_PD = 3;

  Model.LT_SHOW_PAINT = 4;

  Model.LT_SHOW_DESER = 5;

  Model.CURRENT_VERSION = "urn:tibco.com/v3.0";

  Model.CIF_VERSION =  "http://xsd.tns.tibco.com/gi/cif/2006";

  Model.FRAGMENTNS = "JSXFRAG";

  Model.ASYNC_LOAD_TIMEOUT = 60000;

  Model._CIFPROCESSORURL = jsx3.resolveURI("jsx:///xsl/cif_resolver.xsl");

  // TODO: eventually it would be nice to be able to clobber all of the following

  Model_prototype._jsxid = null;

  Model_prototype._jsxparent = null;

  Model_prototype._jsxchildren = null;

  Model_prototype._jsxns = null;

  Model_prototype._jsxserver = null;

  Model_prototype._jsxfragment = null;

  Model_prototype._jsxpersistence = null;

  Model_prototype._jsxmeta = null;

  Model_prototype._jsxshowstate = true;

  Model_prototype.init = function(strName, strInstanceOf) {
    //call constructor for super class just in case a global mod needs to be communicated on down from the top-most jsx class, inheritance
    this.jsxsuper();

    //initialize and define common properties shared by all subclasses of jsx3.app.Model

    // DEPRECATED: remove strInstanceOf parameter and references
    this.jsxinstanceof = (strInstanceOf == null) ? "jsx3.app.Model" : strInstanceOf;

    this.jsxname = strName;
  };

  Model_prototype.getChild = function(vntIndexOrName) {
    var intIndex = null;

    if (this._jsxchildren != null) {
      if (typeof(vntIndexOrName) == "string" || isNaN(vntIndexOrName)) {
        var index = -1;
        var childArray = this.getChildren();
        var maxLen = childArray.length;
        for (var i = 0; i < maxLen; i++) {
          if (vntIndexOrName == childArray[i].getName()) {
            intIndex = i;
            break;
          }
        }
      } else {
        //calling function passed an index (integer), so just set to local variable
        intIndex = vntIndexOrName;
      }

      if (intIndex >= 0 && intIndex < this._jsxchildren.length)
        return this._jsxchildren[intIndex];
    }

    return null;
  };

  Model_prototype.getFirstChild = function() {
    return this.getChild(0);
  };

  Model_prototype.getLastChild = function() {
    return this.getChild(this.getChildren().length-1);
  };

  Model_prototype.getNextSibling = function() {
    if (! this._jsxparent) return null;
    return this._jsxparent.getChild(this.getChildIndex() + 1);
  };

  Model_prototype.getPreviousSibling = function() {
    if (! this._jsxparent) return null;
    return this._jsxparent.getChild(this.getChildIndex() - 1);
  };

  Model_prototype.getChildren = function() {
    if (this._jsxchildren == null) this._jsxchildren = [];
    return this._jsxchildren;
  };

  Model_prototype.getPersistence = function() {
    return this._jsxpersistence;
  };

  Model_prototype.getPersistenceUrl = function() {
    return this.getMetaValue("url");
  };

  Model_prototype.setPersistence = function(intPersist) {
    this._jsxpersistence = intPersist;
    return this;
  };

  Model_prototype.setChild = function __Model_prototype_setChild(objChild, intPersist, strSourceURL, strNS) {
    //find out the server that will own this object instance
    var bFragment = false;
    if (strNS == null && this._jsxns == null) {
      strNS = Model.FRAGMENTNS;
    } else if (strNS != null) {
      bFragment = true;
    } else {
      strNS = this._jsxns;
    }

    var objServer = this.getServer();

    //only add this item to a server instance if not part of the 'fragment' ns
    if (strNS != Model.FRAGMENTNS && objServer && this._jsxns == strNS) {
      //all items are fragments until added to a valid DOM.  Some fragments already have nested descendants that also need to be bound and registered
      this._bindFragment(objChild, strNS, objChild._jsxfragment != null, objServer);
    } else {
      //the parent ('this') does not yet belong to a DOM (its a fragment); set a flag that lets us know, so when it is finally added to a DOM, its descendant _jsxns props are updated and name/id are applied
      this._jsxfragment = 1;
    }

    //create an array to hold child if not yet created
    var children = this._jsxchildren;
    if (!children) children = this._jsxchildren = [];

    //increment the array and reference the new object
    children[children.length] = objChild;
    objChild._jsxparent = this;

    //set persistent type and urls if applicable
    if (intPersist == null) intPersist = Model.PERSISTNONE;
    objChild._jsxpersistence = intPersist;
    if (strSourceURL && (intPersist == Model.PERSISTREF || intPersist == Model.PERSISTREFASYNC))
      objChild.setMetaValue("url", strSourceURL.toString());

    //issue a DOM onChange call to reflect the update; pass the id of this object as well as the newly-added child;
    if (!bFragment && strNS != Model.FRAGMENTNS)
      objServer.getDOM().onChange(jsx3.app.DOM.TYPEADD, this.getId(), objChild.getId());

    return this;
  };

  Model_prototype.onSetChild = function(objChild) {
    return true;
  };

  Model_prototype.onSetParent = function(objParent) {
    return true;
  };

  Model_prototype.onRemoveChild = function(objChild, intIndex) {};

  Model_prototype.onChildAdded = function(objChild) {};

  //TODO: need method in model independent of how items are painted--otherwise the DOM is worthless without a view
  Model_prototype.hasPaintProfile = function() {
    //no-op; used by the new model
    return false;
  };

  Model_prototype._bindFragment = function(objChild, strNS, bDeep, objServer) {
    //update the namespace property for the child to match that of the parent objChild._jsxns = strNS;
    objChild._jsxns = strNS;
    objChild._applyId(strNS);

    //assign the system Id to @objChild and add a pointer to @objChild to the systemhash
    objServer.getDOM().add(objChild);

    //recurse through descendant of @objChild if @objChild is a 'deep' fragment -- one with descendants
    if (bDeep) {
      //remove the fragment flag, since now a valid DOM object
      delete objChild._jsxfragment;
      //iterate through descendants
      var objKids = objChild.getChildren();
      var maxLen = objKids.length;
      for (var i = 0; i < maxLen; i++)
        objChild._bindFragment(objKids[i], strNS, true, objServer);
    }
  };

  Model_prototype._applyId = function(strNS) {
    this._jsxid = jsx3.app.DOM.newId(strNS);
  };

  Model_prototype.removeChild = function(vntItem) {};

  Model_prototype._removeChildRecurse = function(intIndex, objServer, bAll) {};

  Model_prototype.removeChildren = function(arrChildren) {};

  Model_prototype.getServer = function() {
    var node = this;
    while (node) {
      if (node._jsxserver) return node._jsxserver;
      node = node._jsxparent;
    }
    return null;
  };

  Model_prototype._getLocale = function() {
    var objServer = this.getServer();
    return objServer != null ? objServer.getLocale() : jsx3.System.getLocale();
  };

  Model_prototype._getLocaleProp = function(strProp) {
    return jsx3.System.getLocaleProperties(this._getLocale()).get(strProp);
  };

  Model_prototype.adoptChild = function(objChild, bRepaint, bForce) {
    this._adoptChild(objChild.getChildIndex(), objChild, bRepaint, bForce, false);
  };

  Model_prototype.adoptChildrenFrom = function(objParent, arrChildren, bRepaint, bForce) {
    if (!arrChildren) arrChildren = objParent.getChildren().concat();
    if (arrChildren.length > 0) {
      for (var i = 0; i < arrChildren.length; i++)
        this._adoptChild(arrChildren[i].getChildIndex(), arrChildren[i], bRepaint, bForce, true);
      objParent.onRemoveChild(arrChildren, null);
      for (var i = 0; i < arrChildren.length; i++)
        this.onChildAdded(arrChildren[i]);
    }
  };

  Model_prototype._insertBefore = function(intMoveIndex,intPrecedeIndex) {
    //exit early if the move wouldn't occur
    if(intMoveIndex == intPrecedeIndex || intMoveIndex == intPrecedeIndex-1) return false;

    //reassemble the child array
    var objChildren = this.getChildren();
    var intAdjustedP = (intMoveIndex < intPrecedeIndex) ? intPrecedeIndex - 1 : intPrecedeIndex;
    var objMove = objChildren.splice(intMoveIndex, 1);
    var objStart = objChildren.splice(0, intAdjustedP);
    this._jsxchildren = objStart.concat(objMove,objChildren);

    this.onChildAdded(objMove[0]);
    //fire the DOM onchange event since we affected the MODEL directly
    this.getServer().getDOM().onChange(jsx3.app.DOM.TYPEREARRANGE,this.getId(),intPrecedeIndex);

    return true;
  };

  Model_prototype.insertBefore = function(objMoveChild,objPrecedeChild,bRepaint) {
    //adopt first if not common parent
    var bSuccess = true;
    if (!objMoveChild._jsxparent || !objPrecedeChild) {
      //user is inserting a fragment
      bSuccess = this.setChild(objMoveChild);
    } else if(objMoveChild._jsxparent != this) {
      //user is adopting
      bSuccess = this._adoptChild(objMoveChild.getChildIndex(),objMoveChild,false,true,true);
    }

    if (bSuccess) {
      //now do the reorder
      if (objPrecedeChild)
        bSuccess = this._insertBefore(objMoveChild.getChildIndex(), objPrecedeChild.getChildIndex());

      //check for suppress and return
      if (bRepaint !== false)
        this.repaint();
    }

    return bSuccess;
  };

  Model_prototype._adoptChild = function(intIndex, objChild, bRepaint, bForce, bMulti) {
    //make sure the adoption is allowed
    if (bForce) {
      this.onSetChild(objChild);
      objChild.onSetParent(this);
    } else {
      if (!this.onSetChild(objChild) || !objChild.onSetParent(this))
        return false;
    }

    //(1) get handle to parent, since we're about to lose the ref
    var objParent = objChild._jsxparent;

// JCG: I don't think that this is necessary ... was causing box model reconstruction before the adoption
//    //destroy the box profile. the new parent will determine it (this is a MODEL method for the Box profile)
//    objChild.recalc();

    //(2) remove circular reference from child (objChild) to the former parent(this)
    delete objChild._jsxparent;

    //(2b) remove box profile (allow it to be reconstructed in context of the new parent)
    objChild.clearBoxProfile(true);

    //(3) restack the former parent's child array to remove a reference to the now-obsolete item
    if (objParent._jsxchildren != null) objParent._jsxchildren.splice(intIndex, 1);

    //(4) destroy the existing view for the child (the user has no choice in this; they can choose to not paint the new, but the old has to be removed)
    objChild.destroyView(objParent);

    // send old parent onRemove message
    if (! bMulti)
      objParent.onRemoveChild(objChild, intIndex);

    //persist ref to servers involved
    var curServer = objParent.getServer();
    var newServer = this.getServer();
    var bServerChange = curServer != newServer;

    //(5) call recursive fn for child if the new parent belongs to a different server (they can't access the cache where they once stored their data, etc, and other server-specific resources that may no longer be accessible)

    if (bServerChange)
      this._adoptChildRecurse(objChild, objParent, curServer, newServer);

    //fire the onChange for the old server (we just removed a child)
    curServer.getDOM().onChange(jsx3.app.DOM.TYPEREMOVE, objParent.getId(), objChild.getId());

    //INSERT OBJCHILD INTO THE CHILD ARRAY FOR THE NEW PARENT
    var children = this._jsxchildren;
    if (!children) children = this._jsxchildren = [];
    children[children.length] = objChild;
    objChild._jsxparent = this;

    if (! bMulti)
      this.onChildAdded(objChild);

    //update the VIEW immediately to match the model unless explicitly told to wait
    if (bRepaint !== false) this.viewUpdateHook(objChild, bMulti && objParent._jsxchildren.length > 0);

    //fire the onChange for the new server (we just added a child)
    newServer.getDOM().onChange(jsx3.app.DOM.TYPEADD, this.getId(), objChild.getId());

    //return a handle to this
    return this;
  };

  Model_prototype.viewUpdateHook = function(objChild, bGroup) {};

  Model_prototype.destroyView = function(objParent) {
    var objGUI = objParent.getServer().getRenderedOf(this);
    if (objGUI)
      jsx3.html.removeNode(objGUI);
  };

  Model_prototype._adoptChildRecurse = function(objChild, objFormerParent, curServer, newServer) {
    //dereference the object by removing it from the global arrays that point to the object
    curServer.getDOM().remove(objChild);
    // reset the child's server namespace
    objChild._jsxns = this._jsxns;
    // insert pointers into the new server's hash to ref the child
    newServer.getDOM().add(objChild);

    objChild.onChangeServer(newServer, curServer);

    var children = objChild.getChildren();
    for (var i = 0; i < children.length; i++)
      objChild._adoptChildRecurse(children[i], null, curServer, newServer);
  };

  Model_prototype.onChangeServer = function(objNewServer, objOldServer) {};

  Model_prototype.doClone = function(intPersist, intMode) {
    var objLoadInto = intMode == 2 ? this.getServer().getRootBlock() : this._jsxparent;

    if (objLoadInto) {
      // Clone by serializing to XML and then deserializing, which ensures only valid structures get cloned
      var objJSXClone = objLoadInto._loadObject(
          this.toXMLDoc(), intMode < 1, intPersist, null, null, intMode == 2 ? Model.FRAGMENTNS : null);
      return objJSXClone ? objJSXClone[0] : null;
    } else {
      throw new jsx3.Exception(jsx3._msg("model.clone_frag", this));
    }
  };

  Model_prototype.getDescendantOfName = function(strName, bDepthFirst, bChildOnly) {
    return this.findDescendants(function(x){ return x.getName() == strName; },
        bDepthFirst, false, bChildOnly, false);
  };

  Model_prototype.getFirstChildOfType = function(strType, bExact) {
    if (bExact) {
      var objClass = null;
      if (typeof(strType) == "string") objClass = jsx3.Class.forName(strType);
      else if (typeof(strType) == "function" && strType.jsxclass instanceof jsx3.Class) objClass = strType.jsxclass;
      else if (strType instanceof jsx3.Class) objClass = strType;

      return this.findDescendants(function(x){ return x.getClass().equals(objClass); },
          false, false, true, false);
    } else {
      return this.findDescendants(function(x){ return x.instanceOf(strType); },
          false, false, true, false);
    }
  };

  Model_prototype.getDescendantsOfType = function(strType, bShallow) {
    return this.findDescendants(function(x){ return x.instanceOf(strType); },
        false, true, bShallow, false);
  };

  Model_prototype.findDescendants = function(fctTest, bDepthFirst, bMultiple, bShallow, bIncludeSelf) {
    var fctPush = bDepthFirst ? 'unshift' : 'push';
    var matches = bMultiple ? [] : null;
    var list = bIncludeSelf ? [this] : this.getChildren().concat();

    while (list.length > 0) {
      var node = list.shift();

      if (fctTest.call(null, node)) {
        if (bMultiple)
          matches[matches.length] = node;
        else
          return node;
      }

      if (! bShallow)
        list[fctPush].apply(list, node.getChildren());
    }

    return matches;
  };

  Model_prototype.onDestroy = function(objParent) {
    // This method should be overridden by classes with an on-screen view represented by a TD object.
    //always remove the on-screen instance for this object (assuming it's been painted already)
  };

  Model_prototype.getId = function() {
    return this._jsxid;
  };

  Model_prototype.getChildIndex = function() {
    var objParent = this._jsxparent;
    if (objParent != null)
      return jsx3.util.arrIndexOf(objParent.getChildren(), this);
    return -1;
  };

  Model_prototype.getName = function() {
    return this.jsxname;
  };

  Model_prototype.setName = function(strName) {
    if (strName != null) {
      // update name and add object reference via new name
      var oldName = this.jsxname;
      this.jsxname = strName;

      var objServer = this.getServer();
      if (objServer) objServer.getDOM().onNameChange(this, oldName);
    }
    return this;
  };

  Model_prototype.getHelpId = function() {
    return this.jsxhelpid;
  };

  Model_prototype.setHelpId = function(strId) {
    this.jsxhelpid = strId;
  };

  Model_prototype.getLoadType = function() {
    return this.jsxloadtype || Model.LT_NORMAL;
  };

  Model_prototype.setLoadType = function(intLoadType) {
    this.jsxloadtype = intLoadType;
  };

  Model_prototype._getShowState = function() {
    return this._jsxshowstate;
  };

  Model_prototype._setShowState = function(bShow) {
    if (this._jsxshowstate != bShow) {
      this._jsxshowstate = bShow;
      if (bShow) {
        var objGUI = this.getRendered();
        //3.6: added the following to repaint the domholder object if it is in fact the domholder (don't just check content existence)
        if (objGUI && (!objGUI.firstChild || objGUI.getAttribute("jsxdomholder") == "1"))
          this.repaint();
      }
    }
  };

  Model_prototype.getParent = function() {
    return this._jsxparent;
  };

   Model_prototype.getAncestorOfType = function(strType) {
     return this.findAncestor(function(x){ return x.instanceOf(strType); }, false);
   };

   Model_prototype.getAncestorOfName = function(strName) {
     return this.findAncestor(function(x){ return x.getName() == strName; }, false);
   };

  Model_prototype.findAncestor = function(fctTest, bIncludeSelf) {
    var parent = bIncludeSelf ? this : this._jsxparent;
    while (parent != null) {
      if (fctTest.call(null, parent))
        return parent;
      parent = parent._jsxparent;
    }
    return null;
  };

  Model_prototype.toXML = function(objProperties) {
    return this.toXMLDoc(objProperties).serialize(true, objProperties != null ? objProperties.charset : null);
  };

  Model_prototype.toXMLDoc = function(objProperties) {
    if (objProperties == null) {
      objProperties = this._jsxmeta;
      if (objProperties == null) objProperties = {};
    } else {
      if (this._jsxmeta != null) {
        objProperties = jsx3.clone(objProperties);
        for (var f in this._jsxmeta) {
          if (typeof(objProperties[f]) == "undefined")
            objProperties[f] = this._jsxmeta[f];
        }
      }
    }

    var ns = Model.CURRENT_VERSION;
    var objXML = new jsx3.xml.Document();
    var objRoot = objXML.createDocumentElement("serialization", ns);
    objRoot.setAttribute("jsxversion", Model._getComponentAuthorVersion());

    for (var f in Model._META_MAP) {
      if (typeof(objProperties[f]) != "undefined") {
        var nodeName = Model._META_MAP[f];
        var elem = objXML.createNode(Entity.TYPEELEMENT, nodeName, ns);
        elem.appendChild(objXML.createNode(Entity.TYPECDATA, objProperties[f], ns));
        objRoot.appendChild(elem);
      }
    }

    if (objProperties.children) {
      var maxLen = this.getChildren().length;
      for (var i = 0; i < maxLen; i++) {
        objRoot.appendChild(this.getChild(i)._doSerialize(objXML, objProperties));
      }
    } else {
      objRoot.appendChild(this._doSerialize(objXML, objProperties));
    }

    return objXML;
  };

  Model._getComponentAuthorVersion = function() {
    var tokens = jsx3.System.getVersion().split(".");
    return tokens[0] + "." + tokens[1];
  };

  Model._OBJ_ARRAYS =
      {_jsxdynamic:"dynamics", jsxcustom:"properties", _jsxevents:"events", jsxxslparams:"xslparameters"};

  Model._boolnumber = {"boolean":1, "number":1};

  Model_prototype._doSerialize = function(objXML, objProperties) {
    // create <object>
    var ns = Model.CURRENT_VERSION;
    var objNode = objXML.createNode(Entity.TYPEELEMENT, "object", ns);

    // set the object type
    var objClass = this.getClass();
    var strType = objClass != null ? objClass.getName() : null;

    // DEPRECATED: should eventually only consult getClass()
    if (strType == null)
      strType = this.jsxinstanceof;

    objNode.setAttribute("type", strType);

    // declare variable to persist string and number/booleam properties
    var objVars = objXML.createNode(Entity.TYPEELEMENT, "variants", ns);
    var objStrings = objXML.createNode(Entity.TYPEELEMENT, "strings", ns);
    objNode.appendChild(objVars);
    objNode.appendChild(objStrings);

    // serialize events, dynamic properties, and attributes
    for (var f in Model._OBJ_ARRAYS) {
      var a = this[f];
      if (a != null && typeof(a) == "object") {
        var objDynNode = Model._serializeObjectArray(objXML, Model._OBJ_ARRAYS[f], a);
        if (objDynNode != null) {
          objNode.appendChild(objDynNode);
          //3.7: added the following to remove any temporary dynamic properties
          if(Model._OBJ_ARRAYS[f] == "dynamics" && this._jsxtempdynamic)
            for(var p in this._jsxtempdynamic)
              objDynNode.removeAttribute(p);
        }
      }
    }

    // serialize the children
    var children = this._jsxchildren;
    if (children) {
      if (children instanceof Array) {
        var numChildren = children.length;
        if (numChildren > 0) {
          for (var i = 0; i < numChildren; i++) {
            //recurse through descendants
            var child = children[i];
            var intPersist = child._jsxpersistence;

            if (intPersist == Model.PERSISTREF || intPersist == Model.PERSISTREFASYNC) {
              if (intPersist == Model.PERSISTREFASYNC && (i != numChildren-1)) {
                jsx3.util.Logger.GLOBAL.warn(jsx3._msg("model.async_convt", this));
                intPersist = child._jsxpersistence = Model.PERSISTREF;
              }

              var objInclude = objXML.createNode(Entity.TYPEELEMENT, "include", ns);
              objInclude.setAttribute("src", child.getPersistenceUrl());
              objInclude.setAttribute("async", intPersist == Model.PERSISTREFASYNC ? "true" : "false");
              objNode.appendChild(objInclude);
            } else if (intPersist == Model.PERSISTEMBED || objProperties.persistall) {
              objNode.appendChild(child._doSerialize(objXML, objProperties));
            }
          }
        }
      } else {
        jsx3.util.Logger.GLOBAL.error(jsx3._msg("model.child_notarr", this, this[p]));
      }
    }

    // NOTE: this is pretty slow in IE6, since jsx3.gui.Block has >250 fields to iterate over
    // serialize all arrays, string, boolean, and number properties
    for (var p in this) {
      var val = this[p];
      var type = typeof(val);

      // only act upon properties/attributes of the object, not its functions
      if (type == "function" || p.indexOf("_jsx") == 0 || val == null) {
        ;
      } else if (val instanceof Array) {
        var asString = new Array(val.length);
        for (var i = 0; i < val.length; i++) {
          var aval = val[i];
          asString[i] = Model._boolnumber[typeof(aval)] ? aval : "'" + aval + "'";
        }
        objVars.setAttribute(p, "[" + asString.join(",") + "]");
      } else if (type == "object") {
        ;
      } else {
        if (this._jsxdynamic == null || this._jsxdynamic[p] == null) {
          //ensure that this property gets evaluated during deserialization if it is a number or boolean
          if (Model._boolnumber[type]) {
            objVars.setAttribute(p, String(val));
          } else {
            objStrings.setAttribute(p, val);
          }
        }
      }
    }

    return objNode;
  };

  Model._serializeObjectArray = function(objXML, strTagName, objArray) {
    var objNode = null;
    for (var f in objArray) {
      if (objNode == null)
        objNode = objXML.createNode(Entity.TYPEELEMENT, strTagName, Model.CURRENT_VERSION);
      objNode.setAttribute(f, String(objArray[f]));
    }
    return objNode;
  };

  Model_prototype.getNS = function() {
    return this._jsxns;
  };

  Model_prototype.getUriResolver = function() {
    var node = this;
    while (node != null) {
      if (node._jsxloadcontext && node._jsxloadcontext.resolver) return node._jsxloadcontext.resolver;
      if (node._jsxserver != null) return node._jsxserver;
      node = node._jsxparent;
    }
    return null;
  };

  Model_prototype.load = function(strURL, bRepaint, objResolver) {
    //parse xml and pass to common handler
    var rsURL = (objResolver || this.getUriResolver()).resolveURI(strURL);
    var objXML = (new Document()).load(rsURL);

    if (objXML.hasError())
      throw new jsx3.Exception(jsx3._msg("model.bad_comp", rsURL, objXML.getError()));

    return this._loadObject(objXML, bRepaint, null, rsURL, strURL, null, null, objResolver, null)[0];
  };

  Model_prototype.loadXML = function(strXML, bRepaint, objResolver) {
    //parse xml and pass to common handler
    var objXML = strXML instanceof Document ? strXML : (new Document()).loadXML(strXML);

    if (objXML.hasError()) {
      var strSourceURL = objXML.getSourceURL();
      var msgId = strSourceURL ? "model.bad_comp" : "model.bad_compobj";
      throw new jsx3.Exception(jsx3._msg(msgId, strSourceURL, objXML.getError()));
    }

    return this._loadObject(objXML, bRepaint, null, objXML.getSourceURL(), objXML.getSourceURL(), null, null, objResolver, null)[0];
  };

  Model_prototype.loadAndCache = function(strURL, bRepaint, objCache, objResolver) {
    if (objCache == null) objCache = this.getServer().getCache();
    var rsURL = (objResolver || this.getUriResolver()).resolveURI(strURL);
    var objXML = objCache.getOrOpenDocument(rsURL);

    if (objXML.hasError())
      throw new jsx3.Exception(jsx3._msg("model.bad_comp", rsURL, objXML.getError()));

    return this._loadObject(objXML, bRepaint, null, rsURL, strURL, null, objCache, objResolver, null)[0];
  };

  Model._META_MAP = {name:"name", icon:"icon", description:"description", onbefore:"onBeforeDeserialize",
    onafter:"onAfterDeserialize"};

  Model_prototype._loadObject = function(objXML, bRepaint, intPersist, strSourceURL, strRawURL, strNS,
                                        objCache, objResolver, objServer) {

    if (! objServer || intPersist == Model.PERSISTREFASYNC)
      var t1 = new jsx3.util.Timer(Model.jsxclass, strSourceURL);

    if (objXML == null)
      throw new jsx3.IllegalArgumentException("objXML", objXML);

    // determine which deserialization routine to use based upon the xmlns attribute for the serialization file
    if (objXML.getRootNode().getNamespaceURI().indexOf(Model.CIF_VERSION) == 0) {
      throw fit;
    }

    // determine which deserialization routine to use based upon the xmlns attribute for the serialization file
    if (objXML.getRootNode().getNamespaceURI().indexOf(Model.CURRENT_VERSION) != 0) {
      throw new jsx3.Exception(jsx3._msg("model.bad_vers", strSourceURL, objXML.getRootNode().getAttribute("xmlns")));
    } else {
      var v = objXML.getRootNode().getAttribute("jsxversion");
      if (v && jsx3.util.compareVersions(v, jsx3.System.getVersion()) > 0)
        throw new jsx3.Exception(jsx3._msg("model.future_vers", strSourceURL, v));
    }

    var bFragment = strNS == Model.FRAGMENTNS;
    var serPath = "/jsx1:serialization/";

    objXML.setSelectionNamespaces("xmlns:jsx1='" + Model.CURRENT_VERSION + "'");
    var strOnBeforeDeserializeNode = objXML.selectSingleNode(serPath + "jsx1:onBeforeDeserialize");
    if (strOnBeforeDeserializeNode != null) {
      var strOnBeforeDeserialize = strOnBeforeDeserializeNode.getValue();
      if (strOnBeforeDeserialize && !objXML._jsxdidbeforedsrlz) {
        try {
          jsx3.eval(strOnBeforeDeserialize, {objPARENT:this, objXML:objXML});

          objXML._jsxdidbeforedsrlz = true;
        } catch (e) {
          jsx3.util.Logger.GLOBAL.error(jsx3._msg("model.onbefore", strSourceURL), jsx3.NativeError.wrap(e));
        }
      }
    }

    //derive the namespace that should be used (infer if not explicitly passed)
    if (strNS == null) strNS = this._jsxns;

    var previousResolver = this.getUriResolver() || objServer;

    if (objResolver == null) {
      // if the resolver is not explicitly provided and the raw URI implies a resolver, we need to store that
      // resolver at this point in the DOM
      objResolver = jsx3.net.URIResolver.getResolver(strRawURL);
    } else if (strRawURL) {
      if (objResolver.getUriPrefix() != previousResolver.getUriPrefix()) {
        // if the resolver is provided and the raw URI is relative to that resolver, we need to store the absolute
        // URI relative to that resolver.
        strRawURL = jsx3.net.URI.valueOf(strRawURL);
        if (! jsx3.net.URIResolver.isAbsoluteURI(strRawURL))
          strRawURL = objResolver.relativizeURI(strRawURL);
      }
    }

    var attachedServer = this.getServer();

    // this resolver will be used for any includes found from this point down
    if (objServer == null)
      objServer = attachedServer;
    var branchResolver = objResolver || previousResolver;

    //deserialize and bind new component as a child this instance
    var i = objXML.selectNodeIterator(serPath + "jsx1:object | " + serPath + "jsx1:objects/jsx1:object | /jsx1:object");
    var objToInsert = [];

    var loadContext = {uri:strSourceURL, resolver:objResolver, nameIndex:{}, varNameIndex:{}};

    while (i.hasNext()) {
      //get node descriptor in the XML serializatoin file and deserialize the node as a child of 'this' object
      var objNode = i.next();
      var objJSX = this._doLoad(objNode, strSourceURL, strNS, objServer, objCache, branchResolver, loadContext);

      //if a valid child resulted (was the serialzation file valid and the referenced GUI object type a valid class?)
      if (objJSX != null) {
        //this item is a valid JSX GUI object will be added as a child to the MODEL; track it so it can auto-inserted (as DHTML) into the VIEW
        objToInsert[objToInsert.length] = objJSX;

        //set the current child
        if (!bFragment)
          var success = this.setChild(objJSX, intPersist, strSourceURL, strNS);
        if (success === false) return false;

        //profile the current child with information about where it came from
        if (objToInsert.length == 1) {
          if (strRawURL)
            objJSX.setMetaValue("url", strRawURL.toString());
          for (var f in Model._META_MAP) {
            var node = objXML.selectSingleNode(serPath + "jsx1:" + Model._META_MAP[f]);
            if (node != null)
              objJSX.setMetaValue(f, node.getValue());
          }
        }

        if (attachedServer != null)
          objJSX.onAfterAttach();
      }
    }

    //fire the onChange event for the dom controller managing this server (setChild would have fired this, but due to fragment ns this is the safer method)
    if (!bFragment && objToInsert.length > 0 && attachedServer)
      attachedServer.getDOM().onChange(jsx3.app.DOM.TYPEADD, this.getId(), objToInsert[0].getId());

    if (t1) t1.log("load", true);

    //update the view by iterating through all GUI objects that were just added to the model by adding their DHTML directly into the view
    if (bRepaint !== false) {
      for (var j = 0; j < objToInsert.length; j++)
        this.viewUpdateHook(objToInsert[j], j < objToInsert.length - 1);

      if (t1) t1.log("paint");

    }

    //return handle to last item deserialized
    return objToInsert;
  };

  Model.META_FIELDS = {url: 1, name: 1, icon: 1, description: 1, onafter: 1, onattach: 1, onbefore: 1, unicode: 1};

  Model_prototype.getMetaValue = function(strKey) {
    if (Model.META_FIELDS[strKey])
      return this._jsxmeta ? this._jsxmeta[strKey] : "";
    else
      throw new jsx3.IllegalArgumentException("strKey", strKey);
  };

  Model_prototype.setMetaValue = function(strKey, strValue) {
    if (Model.META_FIELDS[strKey]) {
      if (this._jsxmeta == null) this._jsxmeta = {};
      this._jsxmeta[strKey] = strValue;
    } else {
      throw new jsx3.IllegalArgumentException("strKey", strKey);
    }
  };

  Model_prototype._doLoad = function(objXML, strSourceURL, strNS, objServer, objCache, objResolver, loadContext) {
    if (objXML == null) return null;

    // Check the load type
    if (! objXML._jsxloading) {
      var loadType = objXML.selectSingleNode("jsx1:variants/@jsxloadtype");
      loadType = loadType ? parseInt(loadType.getValue()) : Model.LT_NORMAL;
      if (loadType == Model.LT_SLEEP_DESER || loadType == Model.LT_SLEEP_PD || loadType == Model.LT_SHOW_DESER) {
        jsx3.require("jsx3.gui.HotKey"); // this class defines jsx3.app.Model.Loading
        var objInstance = new Model.Loading(objXML, loadType, [strSourceURL, strNS, objServer, objCache, objResolver, loadContext]);
        objInstance._jsxns = strNS;
        return objInstance;
      }
    }

    //get the JSX foundation class that the object will be an instance of
    var strType = objXML.getAttribute("type");
    var objClass = jsx3.Class.forName(strType);

    // DEPRECATED: check for un-registered class
    if (objClass == null)
      objClass = jsx3.getClass(strType);

    // support for loading classes as needed
    if (objClass == null) {
      try {
        objClass = jsx3.CLASS_LOADER.loadClass(strType);
      } catch (e) {
        jsx3.util.Logger.GLOBAL.error(jsx3._msg("model.load_cls", strType), jsx3.NativeError.wrap(e));
      }
    }

    //log error if the class isn't supported
    if (objClass == null) {
      //errors occur if class definition file doesn't exist for the object
      jsx3.util.Logger.GLOBAL.error(jsx3._msg("model.bad_type", strSourceURL, strType));
      return null;
    }

    //create the object instance of the given class and set its 'jsxtype' property
    var objInstance = null;
    if (objClass instanceof jsx3.Class) {
      objInstance = objClass.bless();
    } else {

      // DEPRECATED: old style instantiation
      objInstance = new objClass(jsx3.DESERIALIZE);
      objInstance.jsxinstanceof = strType;

    }

    // attach the URI resolver to this DOM node

    objInstance._jsxloadcontext = loadContext;

    objInstance._jsxns = strNS;
    objInstance.onBeforeAssemble(this, objServer);

    //call functions that will extract variant, dynamic, and string data types and apply to the object instance
    for (var i = objXML.selectNodeIterator("jsx1:strings | jsx1:variants | jsx1:dynamics | jsx1:properties | jsx1:events | jsx1:xslparameters"); i.hasNext(); ) {
      var n = i.next();
      var name = n.getBaseName();
      if (name == "strings")
        Model._applyStringAttributes(objInstance, n);
      else if (name == "variants")
        Model._applyVariantAttributes(objInstance, n);
      else if (name == "dynamics")
        Model._bindObjectProperty(objInstance, n, "_jsxdynamic");
      else if (name == "properties")
        Model._bindObjectProperty(objInstance, n, "jsxcustom");
      else if (name == "events")
        Model._bindObjectProperty(objInstance, n, "_jsxevents");
      else if (name == "xslparameters")
        Model._bindObjectProperty(objInstance, n, "jsxxslparams");
    }

    var strName = objInstance.getName();
    if (strName) {
      loadContext.nameIndex[strName] = objInstance;
      if (strName.match(/^[\\$_a-zA-Z][\w\\$]*$/)) // only put names that are valid variable names into this index
        loadContext.varNameIndex[strName] = objInstance;
    }

    //recurse to bind children
    var i = objXML.selectNodeIterator("jsx1:object | jsx1:include | jsx1:children/jsx1:object | jsx1:children/jsx1:include");

    while (i.hasNext()) {
      var objItem = i.next();

      if (objItem.getBaseName() == "object") {
        //during recursion all descendants are embedded, since this is how they exist in the serialization file
        var objNewChild = objInstance._doLoad(objItem, strSourceURL, strNS, objServer, objCache, objResolver, loadContext);
        if (objNewChild) {
	  objInstance.setChild(objNewChild, Model.PERSISTEMBED, null, strNS);
	}
      } else if (objItem.getBaseName() == "include") {
        // resolver the referenced component file relative to this DOM node
        var rawURL = objItem.getAttribute("src");
        var strMyURL = objResolver.resolveURI(rawURL);
        var refSync = true;

        //branch based on async or not
        if (objItem.getAttribute("async") == "true") {
          refSync = false;

          if (i.hasNext()) {
            jsx3.util.Logger.GLOBAL.warn(jsx3._msg("model.async_convt", objInstance));
            refSync = true;
          }
        }

        if (refSync) {
          //this is a synchronouns load; just request the resource
          var objRefXML = objCache != null ? objCache.getOrOpenDocument(strMyURL) : (new Document()).load(strMyURL);

          if (objRefXML.hasError())
            throw new jsx3.Exception(jsx3._msg("model.bad_comp", strMyURL, objXML.getError()));

          objInstance._loadObject(objRefXML, false, Model.PERSISTREF, strMyURL, rawURL, strNS, objCache, null, objServer);
        } else {
          objInstance._doLoadAsync(strMyURL, rawURL, strNS, objCache, objServer);
        }
      } else {
        throw new jsx3.Exception();
      }
    }

    objInstance.onAfterAssemble(this, objServer);
    //return the object instance
    return objInstance;
  };

  Model_prototype.onBeforeAssemble = function(objParent, objServer) {};

  Model_prototype.onAfterAssemble = function(objParent, objServer) {};

  Model_prototype.onAfterAttach = function() {
    // NOTE: DOM nodes are notified of attachment from the deepest to the root
    // defensive backup prevents double execution of this method per node if the DOM is modified by the onafter script
    var children = this.getChildren().concat();
    for (var i = children.length - 1; i >= 0; i--) {
      if (children[i]._jsxparent == this)
        children[i].onAfterAttach();
    }

    //3.6 Templating language udpate: this is a no-op for pre-migrated controls; ensures that all dynprops are run after attachment--
    //(this ensures that they are not redundantly re-run each time paint is called)
    if(this.hasPaintProfile())
      this.applyDynamicProperties();

    var onAfter = this.getMetaValue("onafter");
    if (onAfter) {
      try {
        var loadContext = this._jsxloadcontext;
        var objContext = loadContext ? jsx3.$O(loadContext.varNameIndex).clone() : {};
        objContext.objJSX = this;
        this.eval(onAfter, objContext);
      } catch (e) {
        var strSourceUrl = this.getMetaValue("url");
        jsx3.util.Logger.GLOBAL.error(jsx3._msg("model.onafter", strSourceUrl), jsx3.NativeError.wrap(e));
      }
    }
  };

  Model_prototype._doLoadAsync = function(strURL, rawURL, strNS, objCache, objServer) {
    var me = this;

    if (objCache != null && objCache.getDocument(strURL.toString()) != null) {
      var objXML = objCache.getDocument(strURL.toString());
      jsx3.sleep(function() {
        this._loadObject(objXML, true, Model.PERSISTREFASYNC, strURL, rawURL, strNS, objCache, null, objServer);
      }, null, this);
    } else {
      var objXML = new Document();
      objXML.setAsync(true);

      objXML.subscribe(Document.ON_RESPONSE, function(objEvent) {
        if (objCache != null)
          objCache.setDocument(strURL, objEvent.target);

        me._loadObject(objEvent.target, true, Model.PERSISTREFASYNC, strURL, rawURL, strNS, objCache, null, objServer);
      });
      objXML.subscribe([Document.ON_ERROR, Document.ON_TIMEOUT], function(objEvent) {
        throw new jsx3.Exception(jsx3._msg("model.bad_comp", strURL, objEvent.target.getError()));
      });

      objXML.load(strURL, Model.ASYNC_LOAD_TIMEOUT);
    }
  };

  Model._applyStringAttributes = function(objInstance, objXML) {
    var names = objXML.getAttributeNames();
    for (var i = 0; i < names.length; i++) {
      var name = names[i];
      objInstance[name] = objXML.getAttribute(name);
    }
  };

  Model._applyVariantAttributes = function(objInstance, objXML) {};

  Model._bindObjectProperty = function(objInstance,objXML,strObjName) {};

  Model_prototype.toString = function() {
    return "@" + this.getClass().getName() + " " + this.getId() + "/" + this.getName();
  };

  Model.getVersion = function() {
    return "3.00.00";
  };
});

jsx3.Model = jsx3.app.Model;

// *** jsx3 non-system scripts
// === jsx3/gui/HotKey.js

jsx3.Class.defineClass("jsx3.gui.HotKey", null, [jsx3.util.EventDispatcher], function(HotKey, HotKey_prototype) {
  var Event = jsx3.gui.Event;

  HotKey.WAS_INVOKED = "invoked";
  HotKey_prototype._callback = null;
  HotKey_prototype._keycode = null;
  HotKey_prototype._shift = false;
  HotKey_prototype._ctrl = false;
  HotKey_prototype._meta = false;
  HotKey_prototype._alt = false;
  HotKey_prototype._enabled = true;
  HotKey_prototype._destroyed = false;

  HotKey.valueOf = function(strKey, fctCallback) {};
  HotKey_prototype.init = function(callback, key, shift, control, alt, meta) {};
  HotKey_prototype.getKey = function() {};
  HotKey_prototype.getKeyCode = function() {};
  HotKey_prototype.isMatch = function(objEvent) {};
  HotKey_prototype.invoke = function(objThis, arrArgs) {};
  HotKey_prototype.isEnabled = function() {};
  HotKey_prototype.setEnabled = function(bEnabled) {};
  HotKey_prototype.isDestroyed = function() {};
  HotKey_prototype.destroy = function() {};
  HotKey_prototype.getFormatted = function() {};
  HotKey.KEY_NAMES_MACOS = {};
  HotKey.KEY_NAMES = {};
  HotKey_prototype.toString = function() {};
  HotKey.MISC_KEY_CODES = {};
  HotKey.keyDownCharToCode = function(strChar) {};
  HotKey.keyDownCodeToChar = function(intCode, bSystem) {};
});

// === jsx3/gui/Painted.js

jsx3.Class.defineClass("jsx3.gui.Painted", jsx3.app.Model, null, function(Painted, Painted_prototype) {
  var html = jsx3.html;

  Painted.MASK_NO_EDIT = {NN: false, EE: false, SS: false, WW: false, MM: false};

  Painted.MASK_ALL_EDIT = {NN: true, EE: true, SS: true, WW: true, MM: true};

  Painted_prototype.init = function(strName) {};
  Painted_prototype.getAbsolutePosition = function(objRoot, objGUI) {};
  Painted_prototype.applyDynamicProperties = function() {};
  Painted_prototype.setDynamicProperty = function(strName, strValue, bNoSave) {};
  Painted_prototype.getDynamicProperty = function(strName) {};
  Painted_prototype.setAttribute = function(strName, strValue) {};
  Painted_prototype.getAttribute = function(strName) {};
  Painted_prototype.getAttributes = function() {};
  Painted_prototype.renderAttributes = function(objExclude, bSkipEvents) {};
  Painted_prototype.removeAttribute = function(strName) {};
  Painted_prototype.removeAttributes = function() {};
  Painted_prototype.focus = function() {};
  Painted_prototype.getMaskProperties = function() {};
  Painted_prototype.getRendered = function(objGUI) {};
  Painted_prototype.containsHtmlElement = function(objElement) {};
  Painted_prototype.getDocument = function() {};
  Painted_prototype.getAncestorRootBlock = function() {};

  Painted.RECALC_TOID = null;

  Painted.REPAINT_MAP = new jsx3.util.WeakMap();

  Painted_prototype.repaint = function() {};

  Painted_prototype.paint = jsx3.Method.newAbstract();

  Painted_prototype.onAfterPaint = function(objGUI) {};
  Painted._onAfterPaintCascade = function(objRoot, objGUI) {};
  Painted_prototype.onAfterRestoreView = function(objGUI) {};
  Painted._onAfterRestoreViewCascade = function(objRoot, objGUI) {};
  Painted_prototype.isDomPaint = function() {};
  Painted_prototype.paintDom = function() {};
  Painted_prototype.paintDomHolder = function() {};

  Painted.DOM_PAINT_QUEUE = [];

  Painted.addToDomPaintQueue = function(objJSX) {};
  Painted.onAfterPaintTimeout = function() {};
  Painted_prototype.paintChild = function(objChild, bGroup, objGUI, bCascadeOnly) {};
  Painted_prototype.viewUpdateHook = function(objChild, bGroup) {};
  Painted_prototype.insertHTML = function(objChild) {};
  Painted_prototype.paintChildren = function(c) {};
  Painted_prototype._conditionalPaint = function() {};
  Painted_prototype.getBoxProfile = function(bCreate, objDimension) {};
  Painted_prototype.setBoxProfile = function(boxProfile) {};
  Painted_prototype.setBoxDirty = function() {};
  Painted_prototype.clearBoxProfile = function(bRecurse) {};
  Painted.convertStyleToStyles = function(objDOM,strValue,csstype) {};
  Painted_prototype.recalcBox = function(properties) {};
  Painted_prototype.getClientDimensions = function() {};

  Painted_prototype.getCachedClientDimensions = function(intIndex) {

  };

  Painted_prototype.setCachedClientDimensions = function(intIndex, objDim) {};
  Painted_prototype.flushCachedClientDimensions = function(strId) {};
  Painted_prototype.createBoxProfile = function(objDimension) {};
  Painted_prototype.updateBoxProfile = function(objImplicit, objGUI, objQueue) {};

  Painted_prototype.updateBoxProfileImpl = function(objImplicit, objGUI, objQueue, intType) {

  };

  Painted_prototype.syncBoxProfile = function(objImplicit, objGUI) {};
  Painted._SYNCQ = {};
  Painted._SYNCQ.add = function(a, b, c) {};
  Painted._SYNCQ.addRepaint = function(a) {};
  Painted_prototype.syncBoxProfileSync = function(objImplicit, objGUI) {};

  Painted.UPDATE_MAP = new jsx3.util.WeakMap();

  Painted_prototype._updateBoxFromQueue = function(objQueue, objImplicit, objGUI) {};

});

jsx3.Class.defineClass("jsx3.gui.Painted.Queue", jsx3.lang.Object, [jsx3.util.EventDispatcher], function(Queue, Queue_prototype) {

  Queue.CHUNK_MAX = 250;

  Queue._SERIAL = 0;

  Queue._ACTIVE = new jsx3.util.List();

  Queue._CHUNK = true;

  Queue._LOCK = false;

  Queue.enableChunking = function(bEnable) {};
  Queue._start = function() {};

  Queue.doChunk = function() {

  };

  Queue_prototype.init = function() {};
  Queue_prototype.add = function(objJSX, objImplicit, objGUI, bStack) {};
  Queue_prototype.addRepaint = function(objJSX, bStack) {};
  Queue_prototype.start = function() {};
  Queue_prototype.destroy = function() {};
  Queue_prototype.toString = function() {};

});

jsx3.Class.defineClass("jsx3.gui.Painted.Box", jsx3.lang.Object, null, function(Box, Box_prototype) {

  var html = jsx3.html;

  //used to convert/parse a CSS string defining border, padding, and margin to a four-element array

  Box.REGEX =  /[^\d-]*([-]*[\d]*)[^\d-]*([-]*[\d]*)[^\d-]*([-]*[\d]*)[^\d-]*([-]*[\d]*)/;

  Box.BREGEX = /\b(\d*)px/g;
  //list of all properties on the implicit object that will be converted to an explicit equivalent

  Box._PROPERTIES = ['boxtype','tagname','margin','padding','border','left','top','width','height','empty','container'];

  Box._RECALC_FIELDS = ['boxtype','left','top','width','height'];

  Box._PROPS_SETTER = {width: "_addPropWidth", height: "_addPropHeight", top: "_addPropTop", left: "_addPropLeft",
      padding: "_addPropPadding", border: "_addPropBorder", margin: "_addPropMargin", tagname: "_addPropTagname"};

  //order (clockwise) of css position (border-left, padding-left, margin-left, *-left, etc)

  Box.COMPASS = ["top","right","bottom","left"];

  Box.SCROLL_SIZE = null;

  // These static strings improve performance on IE6. The obfuscator currently would make these string literals static
  // anyway. However, leaving them here improves painting performance in the uncompiled build.

  Box._str = {pad:"padding", mar:"margin", e:"", box:"box", zpx:"0px", str:"string", num:"number", obj:"object",
      pct:"%", semi:";", px:"px", pxs:"px;", pxc:"px ", c:":", rbox:"relativebox", bor:"border"};

  Box._stm = {hph:{height:1, parentheight:1}, wpw:{width:1, parentwidth:1}};

  Box._pa = ['<', ' ', 'width:', 'height:', '"/>', '">', 'left:0px', 'left:', 'top:0px', 'top:', 'position:absolute;',
      ' style="', 'position:relative;', '</', '>', ''];

  Box.getCssFix = function() {};

  Box_prototype._lastbordervalue = "";

  Box_prototype._lastmarginvalue = "";

  Box_prototype._lastpaddingvalue = "";

  Box_prototype._new = true;

  Box_prototype.styles = "";
  Box_prototype.attributes = "";

  Box_prototype.init = function(profile) {};
  Box_prototype.reset = function() {};
  Box_prototype.paint = function() {};
  Box_prototype.setStyles = function(styles) {};
  Box_prototype.setAttributes = function(atts) {};
  Box_prototype._getCSSFix = function() {};
  Box_prototype._isParentIndependent = function() {};

  Box._RECALC_VALS = [[[[{n:1},{h:1}],[{w:1},{w:1,h:1}]],[[{t:1},{t:1,h:1}],[{t:1,w:1},{t:1,w:1,h:1}]]],
      [[[{l:1},{l:1,h:1}],[{l:1,w:1},{l:1,w:1,h:1}]],[[{l:1,t:1},{l:1,t:1,h:1}],[{l:1,t:1,w:1},{l:1,t:1,w:1,h:1,a:1}]]]];

  Box_prototype.recalculate = function(profile, objGUI) {

  };

  Box._LT_PROPS = {left:1, top:1};

  Box._Expl = function() {};
  Box._Expl.prototype = {padding:"", margin:"", border:"", bwidth:0, bheight:0, btop:0, bleft:0,
      pwidth:0, pheight:0, ptop:0, pleft:0};

  Box_prototype.calculate = function(arrFields) {};
  Box.registerServer = function(server,bLiquid) {};
  Box.unregisterServer = function(server, bLiquid) {};
  Box_prototype._addPropWidth = function(value) {};
  Box_prototype._addPropHeight = function(value) {};
  Box_prototype._addPropLeft = function(value) {};
  Box_prototype._addPropTop = function(value) {};
  Box_prototype._addPropTagname = function(value) {};

  Box_prototype._addPropBorder = function(value) {

  };

  Box_prototype._addPropMargin = function(value) {

  };

  Box_prototype._addPropPadding = function(value) {};
  Box_prototype.addChildProfile = function(objProfile) {};
  Box_prototype.getChildProfile = function(intIndex) {};
  Box_prototype.getClientLeft = function() {};
  Box_prototype.getClientTop = function() {};
  Box_prototype.getClientWidth = function() {};
  Box_prototype.getClientHeight = function() {};
  Box_prototype.getOffsetWidth = function() {};
  Box_prototype.getOffsetHeight = function() {};
  Box_prototype.getBorderWidth = function() {};
  Box_prototype.getBorderHeight = function() {};

  Box_prototype.getPaintedWidth = function() {

 if (jsx3.CLASS_LOADER.SAF) {

 } else {

 }

  };

  Box_prototype.getPaintedHeight = function() {};
  Box_prototype.getPaintedLeft = function() {};
  Box_prototype.getPaintedTop = function() {};
  Box_prototype.getBoxType = function() {};
  Box_prototype.paintMargin = function() {};
  Box_prototype.paintPadding = function() {};
  Box_prototype.paintBorder = function() {};
  Box.getBody = function() {};
  Box.getScrollSize = function(objServerContainer) {};
  Box.getScrollSizeOffset = function(strCSS) {};
  Box.cssToJsx = function(strInput,cssEl) {};
  Box.cssBorderToJsx = function(myCSS) {};
  Box_prototype.toString = function() {};

});

jsx3.Class.defineClass("jsx3.app.Model.Loading", jsx3.gui.Painted, null, function(Loading, Loading_prototype) {

  Loading_prototype.init = function(objXML, intLoadType, arrParams) {};
  Loading_prototype._deserialize = function() {};
  Loading_prototype.getName = function() {};
  Loading_prototype.getType = function() {};
  Loading_prototype._doSerialize = function(objXML, objProperties) {};
  Loading_prototype._repaint = function() {};
  Loading_prototype.paint = function() {};
  Loading_prototype.getRendered = function() {};
  Loading_prototype._setShowState = function(bShow) {};

});

// === jsx3/gui/Interactive.js

// @jsxobf-clobber-shared  _jsxloadcontext

//jsx3.require("jsx3.gui.HotKey");

jsx3.Class.defineInterface("jsx3.gui.Interactive", null, function(Interactive, Interactive_prototype) {

  var Event = jsx3.gui.Event;

  // the following are JSX model events that wrap primitive JavaScript events

  Interactive.JSXBLUR = "jsxblur";

  Interactive.JSXCHANGE = "jsxchange";

  Interactive.JSXCLICK = "jsxclick";

  Interactive.JSXDOUBLECLICK = "jsxdblclick";

  Interactive.JSXFOCUS = "jsxfocus";

  Interactive.JSXKEYDOWN = "jsxkeydown";

  Interactive.JSXKEYPRESS = "jsxkeypress";

  Interactive.JSXKEYUP = "jsxkeyup";

  Interactive.JSXLOAD = "jsxload";

  Interactive.JSXMOUSEDOWN = "jsxmousedown";

  Interactive.JSXMOUSEOUT = "jsxmouseout";

  Interactive.JSXMOUSEOVER = "jsxmouseover";

  Interactive.JSXMOUSEUP = "jsxmouseup";

  Interactive.JSXMOUSEWHEEL = "jsxmousewheel";

  Interactive.FOCUS_STYLE = "text-decoration:underline";

  // the following are JSX model events

  Interactive.ADOPT = "jsxadopt";     // when a record is adopted from this CDF object

  Interactive.AFTER_APPEND = "jsxafterappend";     //after a new CDF record and corresponding on-screen TR are added to a jsx3.gui.List instance or relevant subclass

  Interactive.AFTER_COMMIT = "jsxaftercommit";

  Interactive.AFTER_EDIT = "jsxafteredit";         //called after showing an edit mask

  Interactive.AFTER_MOVE = "jsxaftermove";  //after a move event

  Interactive.AFTER_REORDER = "jsxafterreorder";    //after children have been reordered

  Interactive.AFTER_RESIZE = "jsxafterresize";  //after resize; typically a dialog or alert

  Interactive.AFTER_RESIZE_VIEW = "jsxafterresizeview";  //after the on-screen VIEW for the jsx3.gui.Block instance has been updated by box model controller, an event will be published with the following named properties: <code>native</code>: the native browser HTML element that was just resized--this can be queried for all relevant information such as clientWidth/clientHeight, etc and <code>target</code>: the jsx3.gui.Block instance that was just resized by by box model controller

  Interactive.AFTER_SORT = "jsxaftersort";  //after a sort event

  Interactive.BEFORE_APPEND = "jsxbeforeappend";   //before a new CDF record and corresponding on-screen TR are added to a jsx3.gui.List instance or relevant subclass

  Interactive.BEFORE_DROP = "jsxbeforedrop";  //before a drop event (a mouseover)

  Interactive.BEFORE_EDIT = "jsxbeforeedit";       //called before showing an edit mask

  Interactive.BEFORE_MOVE = "jsxbeforemove";  //before a move event (fired by mouse down for any object that has been made "moveable")

  Interactive.BEFORE_RESIZE = "jsxbeforeresize";  //before a resize; typically a dialog or alert

  Interactive.BEFORE_SELECT = "jsxbeforeselect"; // vetoable select before a non-vetoable select

  Interactive.BEFORE_SORT = "jsxbeforesort";  //before a sort event

  Interactive.CANCEL_DROP = "jsxcanceldrop";  //canceling a drop event (a mouseout)

  Interactive.CHANGE = "jsxchange";               //form value changed, tab changed

  Interactive.CTRL_DROP = "jsxctrldrop";    //after a ctrl drop event

  Interactive.DESTROY = "jsxdestroy";    //when an object is removed from the JSX DOM

  Interactive.DATA = "jsxdata";

  Interactive.DRAG = "jsxdrag";      //before a drag

  Interactive.DROP = "jsxdrop";      //after a drop event (one of: ondrop, canceldrop, beforedrop)

  Interactive.EXECUTE = "jsxexecute";    //execute event as in a menu click or tree node click, or listview dbl-click; enter key; spacebar for button

  Interactive.HIDE = "jsxhide";      //opposite of show

  Interactive.INCR_CHANGE = "jsxincchange";               //incremental change in text area, slider, etc

  Interactive.INPUT = "jsxinput";

  Interactive.MENU = "jsxmenu";      //before a bound menu is shown

  Interactive.SCROLL = "jsxscroll";    //fires during a scroll event

  Interactive.SELECT = "jsxselect";    //select, menu, tree, listview

  Interactive.SHOW = "jsxshow";      //when a menu or select or some other ephemeral VIEW element is about to be displayed

  Interactive.SPYGLASS = "jsxspy";    //when the spyglass is about to show

  Interactive.TOGGLE = "jsxtoggle";    //treeview node open/close

  // default HTML->JSX bridge event handlers

  Interactive_prototype._ebBlur = function(objEvent, objGUI) {};
  Interactive_prototype._ebChange = function(objEvent, objGUI) {};
  Interactive_prototype._ebClick = function(objEvent, objGUI) {};
  Interactive_prototype._ebDoubleClick = function(objEvent, objGUI) {};
  Interactive_prototype._ebFocus = function(objEvent, objGUI) {};
  Interactive_prototype._ebKeyDown = function(objEvent, objGUI) {};
  Interactive_prototype._ebKeyPress = function(objEvent, objGUI) {};
  Interactive_prototype._ebKeyUp = function(objEvent, objGUI) {};
  Interactive_prototype._ebMouseDown = function(objEvent, objGUI) {};
  Interactive_prototype._ebMouseOut = function(objEvent, objGUI) {};
  Interactive_prototype._ebMouseOver = function(objEvent, objGUI) {};
  Interactive_prototype._ebMouseUp = function(objEvent, objGUI) {};
  Interactive_prototype._ebMouseWheel = function(objEvent, objGUI) {};

  // getters and setters

  Interactive_prototype.setEvent = function(strScript, strType) {};
  Interactive_prototype.getEvents = function() {};
  Interactive_prototype.getEvent = function(strType) {};
  Interactive_prototype.hasEvent = function(strType) {};

  Interactive_prototype.doEvent = function(strType, objContext) {

  };

  Interactive_prototype._getEvtContext = function(objContext) {};
  Interactive_prototype.removeEvent = function(strType) {};
  Interactive_prototype.removeEvents = function() {};
  Interactive_prototype.setCanMove = function(bMovable) {};
  Interactive_prototype.getCanMove = function() {};
  Interactive_prototype.setCanDrag = function(bDrag) {};
  Interactive_prototype.getCanDrag = function() {};
  Interactive_prototype.setCanDrop = function(bDrop) {};
  Interactive_prototype.getCanDrop = function() {};
  Interactive_prototype.setCanSpy = function(bSpy) {};
  Interactive_prototype.getCanSpy = function() {};
  Interactive_prototype.getMenu = function() {};
  Interactive_prototype.setMenu = function(strMenu) {};

  // fields and methods related to the HTML->JSX event bridge

  Interactive.BRIDGE_EVENTS = [Event.BLUR, Event.CHANGE, Event.CLICK, Event.DOUBLECLICK,
      Event.FOCUS, Event.KEYDOWN, Event.KEYPRESS, Event.KEYUP, Event.MOUSEDOWN, Event.MOUSEMOVE,
      Event.MOUSEOUT, Event.MOUSEOVER, Event.MOUSEUP, Event.MOUSEWHEEL];

  Interactive.BRIDGE_EVENTS_MAP = {};
  Interactive.BRIDGE_EVENTS_MAP[Event.BLUR] = "_ebBlur";
  Interactive.BRIDGE_EVENTS_MAP[Event.CHANGE] = "_ebChange";
  Interactive.BRIDGE_EVENTS_MAP[Event.CLICK] = "_ebClick";
  Interactive.BRIDGE_EVENTS_MAP[Event.DOUBLECLICK] = "_ebDoubleClick";
  Interactive.BRIDGE_EVENTS_MAP[Event.FOCUS] = "_ebFocus";
  Interactive.BRIDGE_EVENTS_MAP[Event.KEYDOWN] = "_ebKeyDown";
  Interactive.BRIDGE_EVENTS_MAP[Event.KEYPRESS] = "_ebKeyPress";
  Interactive.BRIDGE_EVENTS_MAP[Event.KEYUP] = "_ebKeyUp";
  Interactive.BRIDGE_EVENTS_MAP[Event.MOUSEDOWN] = "_ebMouseDown";
  Interactive.BRIDGE_EVENTS_MAP[Event.MOUSEMOVE] = "_ebMouseMove";
  Interactive.BRIDGE_EVENTS_MAP[Event.MOUSEOUT] = "_ebMouseOut";
  Interactive.BRIDGE_EVENTS_MAP[Event.MOUSEOVER] = "_ebMouseOver";
  Interactive.BRIDGE_EVENTS_MAP[Event.MOUSEUP] = "_ebMouseUp";
  Interactive.BRIDGE_EVENTS_MAP[Event.MOUSEWHEEL] = "_ebMouseWheel";

  Interactive.isBridgeEventHandler = function(strHandler) {};

  Interactive._BRIDGE = "_bridge";

  Interactive._EB = "_eb";

  Interactive_prototype.renderHandlers = function(objMap, useId) {};
  Interactive_prototype.renderHandler = function(eventType, strMethod, useId) {};
  Interactive_prototype._bridge = function(objEvent, objElement, strMethod) {};
  jsx3._eb = function(objEvent, objGUI, strMethod, intUp) {};
  Interactive._beginMove = function(objEvent, objGUI, bCX, bCY) {};
  Interactive._beginMoveConstrained = function(objEvent, objGUI, functRounder) {};

  Interactive_prototype.doBeginMove = function(objEvent, objGUI) {

  };

  Interactive_prototype.doEndMove = function(objEvent, objGUI) {};
  Interactive_prototype.doDrag = function(objEvent, objGUI, fctRenderer, objContext) {};
  Interactive_prototype.doDrop = function(objEvent, objGUI, DROPTYPE) {};
  Interactive_prototype.doSpyOver = function(objEvent, objGUI, objContext) {};
  Interactive_prototype.doSpyOut = function(objEvent, objGUI) {};
  Interactive_prototype.showSpy = function(strHTML,intLeft,intTop) {};
  Interactive.hideSpy = function() {};
  Interactive_prototype.getSpyStyles = function(strDefault) {};
  Interactive_prototype.setSpyStyles = function(strCSS) {};
  Interactive_prototype._resolveSpyStyle = function() {};
  Interactive_prototype.applySpyStyle = function(objGUI) {};
  Interactive_prototype.removeSpyStyle = function(objGUI) {};

///////////////////////////// Methods for convenient handling of hot-key capturing /////////////////////////////////

  Interactive_prototype.checkHotKeys = function(objEvent) {};
  Interactive_prototype.registerHotKey = function(vntCallback, vntKey, bShift, bControl, bAlt) {};
  Interactive_prototype.hasHotKey = function() {};
  Interactive_prototype.setAlwaysCheckHotKeys = function(bCheck) {};
  Interactive_prototype.getAlwaysCheckHotKeys = function() {};
  Interactive_prototype.clearHotKeys = function() {};
  Interactive.getVersion = function() {};
  Interactive_prototype.isOldEventProtocol = function() {};
  Interactive_prototype._onInterDestroy = function(objParent) {};

  jsx3.app.Model.jsxclass.addMethodMixin("onDestroy", Interactive.jsxclass, "_onInterDestroy");

});

jsx3.Event = jsx3.gui.Interactive;

jsx3.Class.defineClass("jsx3.EventHelp", null, null, function(EventHelp, EventHelp_prototype) {

  EventHelp.ONBEFOREDROP = 0;
  EventHelp.ONDROP = 1;
  EventHelp.ONCANCELDROP = 2;

  EventHelp.DRAGICONINDEX = 32000;
  EventHelp.DEFAULTSPYLEFTOFFSET = 5;
  EventHelp.DEFAULTSPYTOPOFFSET = 5;
  EventHelp.SPYDELAY = 300;
  EventHelp.FLAG = 0;

  EventHelp.yOff = 0;
  EventHelp.xOff = 0;

  EventHelp.curDragObject = null;

  EventHelp.beginTrackMouse = function(objEvent) {};
  EventHelp.endTrackMouse = function() {};
  EventHelp.mouseTracker = function(objEvent) {};
  EventHelp.mouseUpTracker = function(objEvent) {};
  EventHelp.drag = function(objGUI, objJSXTarget, strDragType, strDragItemId) {};
  EventHelp.doMouseMove = function(objEvent) {};
  EventHelp.reset = function() {};
  EventHelp.isDragging = function() {};
  EventHelp.getDragIcon = function() {};
  EventHelp.getDragSource = function() {};
  EventHelp.getDragType = function() {};
  EventHelp.getDragId = function() {};
  EventHelp.getDragIds = function() {};

});

// === jsx3/gui/Block.js

//jsx3.require("jsx3.gui.Painted", "jsx3.gui.Interactive");

jsx3.Class.defineClass("jsx3.gui.Block", jsx3.gui.Painted, [jsx3.gui.Interactive], function(Block, Block_prototype) {
  var Event = jsx3.gui.Event;
  var Interactive = jsx3.gui.Interactive;

  Block.SCROLLSIZE = 16;
  Block.OVERFLOWSCROLL = 1;
  Block.OVERFLOWHIDDEN = 2;
  Block.OVERFLOWEXPAND = 3;
  Block.DEFAULTFONTNAME = "Verdana";
  Block.DEFAULTFONTSIZE = 10;
  Block.DEFAULTCOLOR = "#000000";
  Block.DEFAULTTEXT = "&#160;";
  Block.DEFAULTCLASSNAME = "jsx30block";
  Block.DEFAULTTAGNAME = "span";
  Block.FONTBOLD = "bold";
  Block.FONTNORMAL = "normal";
  Block.DISPLAYBLOCK = "";
  Block.DISPLAYNONE = "none";
  Block.VISIBILITYVISIBLE = "";
  Block.VISIBILITYHIDDEN = "hidden";
  Block.NULLSTYLE = -1;
  Block.ALIGNLEFT = "left";
  Block.ALIGNCENTER = "center";
  Block.ALIGNRIGHT = "right";
  Block.ABSOLUTE = 0;
  Block.RELATIVE = 1;
  Block.MASK_NO_EDIT = jsx3.gui.Painted.MASK_NO_EDIT;
  Block.MASK_ALL_EDIT = jsx3.gui.Painted.MASK_ALL_EDIT;
  Block.MASK_MOVE_ONLY = {MM: true};
  Block.MASK_EAST_ONLY = {NN: false, EE: true, SS: false, WW: false, MM: false};
  Block.SPACE = jsx3.resolveURI("jsx:///images/spc.gif");

  jsx3.html.loadImages(Block.SPACE);

   Block_prototype.init = function(strName,vntLeft,vntTop,vntWidth,vntHeight,strHTML) {};
  Block_prototype.getBackgroundColor = function() {};
  Block_prototype.setBackgroundColor = function(strColor,bUpdateView) {};
  Block_prototype.getBackground = function() {};
  Block_prototype.setBackground = function(strBG) {};
  Block_prototype.getBorder = function() {};
  Block_prototype.setBorder = function(strCSS,bUpdateView) {};
  Block_prototype.getColor = function() {};
  Block_prototype.setColor = function(strColor,bUpdateView) {};
  Block_prototype.getCursor = function() {};
  Block_prototype.setCursor = function(strCursor,bUpdateView) {};
  Block_prototype.getCSSOverride = function() {};
  Block_prototype.setCSSOverride = function(strCSS) {};
  Block_prototype.getClassName = function() {};
  Block_prototype.setClassName = function(strClassName) {};
  Block_prototype.getDisplay = function() {};
  Block_prototype.setDisplay = function(DISPLAY, bUpdateView) {};
  Block_prototype.getFontName = function() {};
  Block_prototype.setFontName = function(strFontName) {};
  Block_prototype.getFontSize = function() {};
  Block_prototype.setFontSize = function(intPixelSize) {};
  Block_prototype.getFontWeight = function() {};
  Block_prototype.setFontWeight = function(FONTWEIGHT) {};
  Block_prototype.getHeight = function() {};
  Block_prototype.setHeight = function(vntHeight,bUpdateView) {};
  Block_prototype.getIndex = function() {};
  Block_prototype.setIndex = function(intIndex,bUpdateView) {};
  Block.getJSXParent = function(objGUI) {};
  Block_prototype.getLeft = function() {};
  Block_prototype.setLeft = function(vntLeft,bUpdateView) {};
  Block_prototype.setDimensions = function(left, top, width, height, bUpdateView) {};
  Block_prototype.getDimensions = function() {};
  Block_prototype.getMargin = function() {};
  Block_prototype.setMargin = function(strCSS,bUpdateView) {};
  Block_prototype.getMaskProperties = function() {};
  Block_prototype.doBeginMove = function(objEvent, objGUI) {};
  Block_prototype.doEndMove = function(objEvent) {};
  Block_prototype.getDragIcon = function(objGUI, objJSXTarget, strDragType, strDragItemId) {};
  Block_prototype.doBeginDrag = function(objEvent, objGUI) {};
  Block_prototype.getOverflow = function() {};
  Block_prototype.setOverflow = function(OVERFLOW) {
    return this;
  };
  Block_prototype.getPadding = function() {};
  Block_prototype.setPadding = function(strCSS,bUpdateView) {};
  Block_prototype.getPropertiesPath = function() {};
  Block_prototype.getModelEventsPath = function() {};
  Block_prototype.getRelativePosition = function() {};
  Block_prototype.setRelativePosition = function(intRelative, bUpdateView) {};
  Block_prototype.getTagName = function() {};
  Block_prototype.setTagName = function(strTagName) {};
  Block_prototype.getText = function() {};
  Block_prototype.setText = function(strText, bRepaint) {};
  Block_prototype.getTextAlign = function() {};
  Block_prototype.setTextAlign = function(ALIGN) {};
  Block_prototype.getTip = function() {};
  Block_prototype.setTip = function(strTip) {};
  Block_prototype.getTop = function() {};
  Block_prototype.setTop = function(vntTop,bUpdateView) {};
  Block_prototype._findGUI = function(strCSSName) {};
  Block_prototype.updateGUI = function(strCSSName,strCSSValue) {};
  Block_prototype.getVisibility = function() {};
  Block_prototype.setVisibility = function(VISIBILITY,bUpdateView) {};
  Block_prototype.getWidth = function() {};
  Block_prototype.setWidth = function(vntWidth, bUpdateView) {};
  Block_prototype.getZIndex = function() {};
  Block_prototype.setZIndex = function(intZIndex, bUpdateView) {};
  Block_prototype.updateBoxProfile = function(objImplicit, objGUI, objQueue) {

  };
  Block_prototype.createBoxProfile = function(objImplicit) {};
  Block_prototype.setCDFId = function(strCDFId) {};
  Block_prototype.getCDFId = function() {};
  Block_prototype.setCDFAttribute = function(strAttName) {};
  Block_prototype.getCDFAttribute = function() {};
  Block_prototype.paint = function(strData) {

  };
  Block_prototype._ebMouseOver = function(objEvent, objGUI) {};
  Block_prototype._ebMouseOut = function(objEvent, objGUI) {};
  Block_prototype._ebMouseUp = function(objEvent, objGUI) {};
  Block_prototype.paintLabel = function() {};
  Block_prototype.paintBackgroundColor = function() {};
  Block_prototype.paintBackground = function() {};
  Block_prototype.paintColor = function() {

  };
  Block_prototype.paintCursor = function() {};
  Block_prototype.paintCSSOverride = function() {};
  Block_prototype.paintClassName = function() {};
  Block_prototype.paintBlockDisplay = function() {};
  Block_prototype.paintDisplay = function() {};
  Block_prototype.paintFontName = function() {};
  Block_prototype.paintFontSize = function() {};
  Block_prototype.paintFontWeight = function() {};
  Block_prototype.paintIndex = function(intIndex) {};
  Block_prototype.paintOverflow = function() {};
  Block_prototype.paintText = function() {};
  Block_prototype.paintTextAlign = function() {};
  Block_prototype.paintTip = function() {};
  Block_prototype.paintVisibility = function() {};
  Block_prototype.paintZIndex = function() {};
  Block_prototype.showMask = function(strMessage) {};
  Block._focusMask = function(evt) {};
  Block_prototype.hideMask = function() {};
  Block.getVersion = function() {};
});
jsx3.Block = jsx3.gui.Block;

// === jsx3/gui/Heavyweight.js
// @jsxobf-clobber  _viewsize _vieworigin _point _pixel
jsx3.Class.defineClass("jsx3.gui.Heavyweight", null, null, function(Heavyweight, Heavyweight_prototype) {
  var LOG = jsx3.util.Logger.getLogger(Heavyweight.jsxclass.getName());
  var Event = jsx3.gui.Event;

  Heavyweight._INSTANCES = {};
  Heavyweight._SERIAL = 1;
  Heavyweight._IMAGESCROLLUP = jsx3.resolveURI("jsx:///images/menu/scroll_up.gif");
  Heavyweight._IMAGESCROLLDOWN = jsx3.resolveURI("jsx:///images/menu/scroll_down.gif");
  Heavyweight._SCROLL_INTERVAL = 75;
  Heavyweight._SCROLL_AMOUNT = 12;
  Heavyweight._SCROLL_HEIGHT = 18;
  Heavyweight.DEFAULTZINDEX = 32000;
  Heavyweight._PADDING = 10;
  Heavyweight_prototype.init = function(strId, objOwner) {};
  Heavyweight._getKey = function() {};
  Heavyweight._hideAll = function() {};
  Event.subscribe(Event.RESIZE, Heavyweight._hideAll);
  Heavyweight_prototype._getBody = function() {};
  Heavyweight.GO = function(strId) {};
  Heavyweight_prototype.show = function(bDisplay) {

  };
  Heavyweight_prototype._ebMouseWheel = function(objEvent, objGUI) {};
  Heavyweight_prototype._adjustVerticalScrollers = function(objHwGUI) {

  };
  Heavyweight_prototype._showHideVerticalScrollers = function(objHwGUI) {

  };
  Heavyweight_prototype._scrollUpOver = function(objEvent, objGUI) {};
  Heavyweight_prototype._scrollDownOver = function(objEvent, objGUI) {};
  Heavyweight_prototype._scrollOut = function(objEvent, objGUI) {};
  Heavyweight_prototype._scrollOver = function(objEvent, objGUI, intOffset) {};
  Heavyweight_prototype._scroll = function(intOffset) {};
  Heavyweight_prototype.scrollTo = function(objGUI) {

  };
  Heavyweight_prototype._renderHandler = function(eventType, strMethod) {};
  Heavyweight_prototype._bridge = function(objEvent, objElement, strMethod) {};
  Heavyweight_prototype.applyRatio = function(objGUI) {};
  Heavyweight_prototype._getContentNode = function(objGUI) {};
  Heavyweight_prototype.applyRules = function(strAxis, intSize) {};
  Heavyweight_prototype.hide = function() {};
  Heavyweight_prototype._onOwnerDestroyed = function(objEvent) {};
  Heavyweight_prototype.destroy = function() {};
  Heavyweight_prototype.getRendered = function(objGUI) {};
  Heavyweight_prototype.containsHtmlElement = function(objElement) {};
  Heavyweight_prototype.getId = function() {};
  Heavyweight_prototype._setId = function(strId) {};
  Heavyweight_prototype.getHTML = function() {};
  Heavyweight_prototype.setHTML = function(strHTML, bRepaint) {};
  Heavyweight_prototype.getDomParent = function() {};
  Heavyweight_prototype.setDomParent = function(objGUI) {};
  Heavyweight_prototype.getRatio = function() {};
  Heavyweight_prototype.setRatio = function(vntRatio) {};
  Heavyweight_prototype.getOverflow = function() {};
  Heavyweight_prototype.setOverflow = function(strOverflow) {};
  Heavyweight_prototype.setScrolling = function(bScrolling) {};
  Heavyweight_prototype.setVisibility = function(strVisibility) {};
  Heavyweight_prototype.getZIndex = function() {};
  Heavyweight_prototype.setZIndex = function(intZIndex) {};
  Heavyweight_prototype.getWidth = function() {};
  Heavyweight_prototype.setWidth = function(intWidth) {};
  Heavyweight_prototype.getHeight = function() {};
  Heavyweight_prototype.setHeight = function(intHeight) {};
  Heavyweight_prototype.addXRule = function(objAnchor,strAnchorPoint,strPoint,intOff) {};
  Heavyweight_prototype.addYRule = function(objAnchor,strAnchorPoint,strPoint,intOff) {};
  Heavyweight_prototype.addRule = function(intPixel, strPoint, intOff, strAxis) {};
  Heavyweight_prototype.getPositionRule = function(intIndex,strAxis) {};
  Heavyweight_prototype.getPositionRules = function() {};
  Heavyweight_prototype.getPoint = function(objGUI, strPoint) {};
  Heavyweight_prototype.toString = function() {};
  Heavyweight.getVersion = function() {};
});

jsx3.Heavyweight = jsx3.gui.Heavyweight;

// === jsx3/xml/Cacheable.js

jsx3.Class.defineInterface("jsx3.xml.Cacheable", null, function(Cacheable, Cacheable_prototype) {
  var Document = jsx3.xml.Document;
  var LOG = jsx3.util.Logger.getLogger(Cacheable.jsxclass.getName());

  Cacheable.DEFAULTSTYLESHEET = jsx3.resolveURI("jsx:///xsl/xml.xsl");

  Cacheable.DEFAULTXSLCACHEID = "JSX_XML_XSL";

  Cacheable.CLEANUPRESOURCES = 0;

  Cacheable.SHARERESOURCES = 1;

  Cacheable_prototype.doTransform = function(objParams) {};
  Cacheable_prototype._removeFxWrapper = function(strXML) {};
  Cacheable_prototype.getXSLParams = function() {};
  Cacheable_prototype.setXSLParam = function(strName, strValue) {};
  Cacheable_prototype.removeXSLParam = function(strName) {};
  Cacheable_prototype.removeXSLParams = function() {};
  Cacheable_prototype.getNodeSet = function() {};
  Cacheable_prototype.setNodeSet = function(objNodeSet) {};
  Cacheable_prototype.resetCacheData = function(objServer) {};
  Cacheable_prototype.resetXmlCacheData = function(objServer) {};
  Cacheable_prototype.resetXslCacheData = function(objServer) {};
  Cacheable_prototype.clearXmlData = function() {};
  Cacheable_prototype.getShareResources = function() {};
  Cacheable_prototype.setShareResources = function(intShare) {};
  Cacheable_prototype.getXML = function() {};
  Cacheable_prototype.setSourceXML = function(objDoc, objCache) {};
  Cacheable_prototype._setDocNoEvent = function(objCache, strId, objDoc) {};
  Cacheable_prototype.getXMLId = function() {};
  Cacheable_prototype.setXMLId = function(strXMLId) {};
  Cacheable_prototype.getXMLString = function() {};
  Cacheable_prototype.setXMLString = function(strXML) {};
  Cacheable_prototype.getXMLURL = function() {};
  Cacheable_prototype.setXMLURL = function(strXMLURL) {};
  Cacheable_prototype.getXmlAsync = function() {};
  Cacheable_prototype.setXmlAsync = function(bAsync) {};
  Cacheable_prototype.getXmlBind = function() {};
  Cacheable_prototype.setXmlBind = function(bBind) {};
  Cacheable_prototype.onXmlBinding = function(objEvent) {};
  Cacheable_prototype._onCacheableServerChange = function(objNewServer, objOldServer) {};
  jsx3.app.Model.jsxclass.addMethodMixin("onChangeServer", Cacheable.jsxclass, "_onCacheableServerChange");

  Cacheable_prototype._onCacheableAttach = function() {};
  jsx3.app.Model.jsxclass.addMethodMixin("onAfterAttach", Cacheable.jsxclass, "_onCacheableAttach");

  Cacheable_prototype._onDestroyCached = function(objParent) {};
  jsx3.app.Model.jsxclass.addMethodMixin("onDestroy", Cacheable.jsxclass, "_onDestroyCached");

  Cacheable_prototype._registerForXML = function(bReg, objXML, objServer) {};
  Cacheable_prototype.getXSL = function() {};
  Cacheable_prototype._getSharedXSL = function(strDefaultUrl, strDefaultContent) {};
  Cacheable_prototype.getXSLId = function() {};
  Cacheable_prototype.setXSLId = function(strXSLId) {};
  Cacheable_prototype.getXSLString = function() {};
  Cacheable_prototype.setXSLString = function(strXSL) {};
  Cacheable_prototype.getXSLURL = function() {};
  Cacheable_prototype.setXSLURL = function(strXSLURL) {};
  Cacheable_prototype.getXMLTransformers = function() {};
  Cacheable_prototype.setXMLTransformers = function(arrTrans) {};
  Cacheable_prototype._runTransformers = function(objXML) {};
  Cacheable.getVersion = function() {};

});

jsx3.xml.Cacheable.prototype.resetData = jsx3.xml.Cacheable.prototype.clearXmlData;

// === jsx3/gui/Form.js
jsx3.Class.defineInterface("jsx3.gui.Form", null, function(Form, Form_prototype) {
  var Event = jsx3.gui.Event;

  Form.DEFAULTDISABLEDCOLOR = "#a8a8b5";
  Form.DEFAULTDISABLEDBACKGROUNDCOLOR = "#d8d8e5";
  Form.STATEINVALID = 0;
  Form.STATEVALID = 1;
  Form.STATEDISABLED = 0;
  Form.STATEENABLED = 1;
  Form.OPTIONAL = 0;
  Form.REQUIRED = 1;
  Form_prototype.doKeyBinding = function(fctCallback, strKeys) {};
  Form_prototype.getHotKeyContext = function() {};
  Form_prototype.getKeyBinding = function() {};
  Form_prototype.setKeyBinding = function(strSequence) {};
  Form_prototype.getDisabledBackgroundColor = function() {};
  Form_prototype.setDisabledBackgroundColor = function(strColor) {};
  Form_prototype.paintBackgroundColor = function() {};
  Form_prototype.getDisabledColor = function() {};
  Form_prototype.setDisabledColor = function(strColor) {};
  Form_prototype.getEnabled = function() {};
  Form_prototype.getValue = function() {};
  Form_prototype.setValue = function(vntValue) {};
  Form_prototype.setEnabled = function(intEnabled, bRepaint) {};
  Form_prototype.paintColor = function() {};
  Form_prototype.paintEnabled = function() {};
  Form_prototype.paintIndex = function() {};
  Form_prototype.paintCursor = function(bForm) {};
  Form_prototype.getRequired = function() {};
  Form_prototype.setRequired = function(required) {};
  Form_prototype.getValidationState = function() {};
  Form_prototype.setValidationState = function(intState) {};
  Form_prototype.doValidate = jsx3.Method.newAbstract();
  Form_prototype.doReset = function() {};
  Form.validate = function(objJSXContainer, objHandler) {};
  Form.reset = function(objJSXContainer) {};
  Form.getVersion = function() {};
  Form_prototype.emInit = function(objColumn) {};
  Form_prototype.emGetType = function() {};
  Form_prototype.emPaintTemplate = function() {};
  Form_prototype.emGetTemplate = function(strEnabled, strDisabled) {};
  Form_prototype.emBeginEdit = function(strValue, objTdDim, objPaneDim, objMatrix, objColumn, strRecordId, objTD) {};
  Form_prototype.emEndEdit = function() {};
  Form_prototype.emSetValue = function(strValue) {};
  Form_prototype.emGetValue = function() {};
  Form_prototype.emUpdateDisplay = function(objTdDim, objPaneDim) {};
  Form_prototype.emRestoreDisplay = function() {};
  Form_prototype.emFocus = function() {};
});
jsx3.Form = jsx3.gui.Form;

// === jsx3/app/UserSettings.js
jsx3.Class.defineClass("jsx3.app.UserSettings", null, null, function(UserSettings, UserSettings_prototype) {
  var Entity = jsx3.xml.Entity;
  var LOG = jsx3.util.Logger.getLogger(UserSettings.jsxclass.getName());

  UserSettings.PERSIST_SESSION = 1;
  UserSettings.PERSIST_INDEFINITE = 2;

  UserSettings_prototype.server = null;
  UserSettings_prototype.persist = null;
  UserSettings_prototype.value = null;

  UserSettings_prototype.init = function(objServer, intPersistence) {
    if (intPersistence == null)
      intPersistence = UserSettings.PERSIST_INDEFINITE;

    this.server = objServer;
    this.persist = intPersistence;

    var cookie = this.getCookieValue();
    this.value = UserSettings.deserialize(cookie);
  };

  UserSettings_prototype.get = function(strKey) {
    var obj = this.value;

    for (var i = 0; i < arguments.length; i++) {
      if (typeof(obj) != 'object' || (obj instanceof Array))
        return null;

      obj = obj[arguments[i]];
    }

    return obj;
  };

  UserSettings_prototype.set = function(strKey, value) {
    var obj = this.value;

    for (var i = 0; i < arguments.length - 2; i++) {
      var child = obj[arguments[i]];

      if (typeof(child) != 'object' || (child instanceof Array)) {
        child = obj[arguments[i]] = null;
      }

      if (child == null) {
        child = obj[arguments[i]] = {};
      }

      obj = child;
    }

    obj[arguments[arguments.length - 2]] = arguments[arguments.length - 1];

    return obj;
  };

  UserSettings_prototype.remove = function(strKey) {
    var obj = this.value;

    for (var i = 0; i < arguments.length - 1; i++) {
      var child = obj[arguments[i]];

      if (child == null || typeof(child) != 'object' || (child instanceof Array))
        return;

      obj = child;
    }

    delete obj[arguments[arguments.length - 1]];
  };

  UserSettings_prototype.clear = function() {
    this.value = {};
    var name = this.getCookieName();
    var settings = this.server.getSettings();
    var domain = settings.get('user-settings','domain');
    var path = settings.get('user-settings','path');
    this.server.deleteCookie(name, path, domain);
  };

  UserSettings_prototype.save = function() {
  };

  UserSettings_prototype.getCookieName = function() {
    return this.server.getEnv('NAMESPACE') +
        (this.persist == UserSettings.PERSIST_SESSION ? "_ses" : "_ind");
  };

  UserSettings_prototype.getCookieValue = function() {
    var name = this.getCookieName();
    var value = this.server.getCookie(name, true);

    if (value) {
      // undo custom escaping
      value = value.replace(/\*/g, '<');
      value = value.replace(/\+/g, '>');
      value = unescape(value);
    }

    return value;
  };

  UserSettings.deserialize = function(strValue) {
    return {};
  };

  UserSettings.serialize = function(objValue) {
    var doc = new jsx3.xml.Document();
    doc.loadXML('<m/>');
    var node = doc.getRootNode();

    for (var f in objValue)
      UserSettings.serializeValue(objValue[f], f, node);

    return node.getXML();
  };

  UserSettings.serializeValue = function(objValue, strName, objParent) {
  };

  UserSettings_prototype.toString = function() {
    return this.jsxsuper() + this.server.getAppPath();
  };

});

jsx3.UserSettings = jsx3.app.UserSettings;

// === jsx3/gui/Button.js
//jsx3.require("jsx3.gui.Form", "jsx3.gui.Block");

jsx3.Class.defineClass("jsx3.gui.Button", jsx3.gui.Block, [jsx3.gui.Form], function(Button, Button_prototype) {
  var Event = jsx3.gui.Event;
  var Form = jsx3.gui.Form;

  Button.DEFAULTBACKGROUNDCOLOR = "#e8e8f5";
  Button.DEFAULTHIGHLIGHT = "#f6f6ff";
  Button.DEFAULTSHADOW = "#a6a6af";
  Button.DEFAULTHEIGHT = 17;
  Button_prototype._jsxhotkey = null;
  Button.DEFAULTCLASSNAME = "jsx30button";
  Button_prototype.init = function(strName,intLeft,intTop,intWidth,strText) {};
  Button_prototype.doValidate = function() {};
  Button_prototype._ebKeyDown = function(objEvent, objGUI) {};
  Button_prototype.doClick = function() {};
  Button_prototype.focus = function() {};
  Button_prototype.doExecute = function(objEvent) {};
  Button_prototype._doClick = function(objEvent, objGUI) {};
  Button_prototype._ebMouseDown = function(objEvent, objGUI) {};
  Button_prototype._ebMouseUp = function(objEvent, objGUI) {

  };
  Button_prototype._ebMouseOut = function(objEvent, objGUI) {};
  Button_prototype.getValue = function() {};
  Button_prototype.setEnabled = function(intEnabled, bRepaint) {};
  Button.BRIDGE_EVENTS = {};
  Button.BRIDGE_EVENTS[Event.CLICK] = "_doClick";
  Button.BRIDGE_EVENTS[Event.KEYDOWN] = true;
  Button.BRIDGE_EVENTS[Event.MOUSEDOWN] = true;
  Button.BRIDGE_EVENTS[Event.MOUSEUP] = true;
  Button.BRIDGE_EVENTS[Event.MOUSEOUT] = true;
  Button_prototype.updateBoxProfile = function(objImplicit, objGUI, objQueue) {};
  Button_prototype.createBoxProfile = function(objImplicit) {};
  Button_prototype.paint = function() {};
  Button_prototype.setRelativePosition = function(intRelative, bUpdateView) {};
  Button_prototype.setWidth = function(vntWidth, bUpdateView) {};
  Button_prototype.paintBackgroundColor = function() {};
  Button_prototype.paintClassName = function() {};
  Button.getVersion = function() {};
  Button_prototype.emGetType = function() {};
  Button_prototype.emInit = function(objColumn) {};
  Button_prototype.emSetValue = function(strValue) {};
  Button_prototype.emGetValue = function() {};
  Button_prototype.emBeginEdit = function(strValue, objTdDim, objPaneDim, objMatrix, objColumn, strRecordId, objTD) {};
  Button_prototype.emPaintTemplate = function() {};
  Button_prototype._emOnExecute = function(objEvent) {

  };
});
jsx3.Button = jsx3.gui.Button;

// === jsx3/gui/Dialog.js
//jsx3.require("jsx3.gui.Block");

// @jsxobf-clobber  _jsxmaxstate _jsxmoving _jsxcurgui _jsxcurintx _jsxcurinty
// @jsxobf-clobber-shared  repaintTaskBar

jsx3.Class.defineClass("jsx3.gui.Dialog", jsx3.gui.Block, [], function(Dialog, Dialog_prototype) {
  var Event = jsx3.gui.Event;
  var Interactive = jsx3.gui.Interactive;
  var LOG = jsx3.util.Logger.getLogger(Dialog.jsxclass.getName());

  Dialog.MINIMIZED = 0;
  Dialog.MAXIMIZED = 1;
  Dialog.DEFAULTBACKGROUNDCOLOR = "#e8e8f5";
  Dialog.FIXED = 0;
  Dialog.RESIZEABLE = 1;
  Dialog.RESIZABLE = 1;
  Dialog.RESIZEICON = jsx3.resolveURI("jsx:///images/dialog/resize.gif");
  Dialog.MODAL = 1;
  Dialog.NONMODAL = 0;
  Dialog.MINIMUM_SHOWING = [null,32,32,32];
  Dialog.CONSTRAIN_PADDING = [10,10,10,10];
  Dialog._RESIZE_DIM = 10;
  Dialog.TASKBAR_BUTTON_PREFIX = "JSXTBB_";

  Dialog_prototype.init = function(strName,vntWidth,vntHeight,strTitle) {};
  Dialog_prototype.onAfterAssemble = function(objParent, objServer) {};
  Dialog_prototype.getMaskProperties = function() {};
  Dialog_prototype.doToggleState = function(STATE) {};
  Dialog_prototype.setDisplay = function(DISPLAY, bRepaint) {};
  Dialog_prototype._findGUI = function(strCSSName) {};
  Dialog_prototype.focus = function(bTimeout) {};
  Dialog_prototype.isFront = function() {};
  Dialog_prototype._bringForward = function(objEvent, objGUI) {};
  Dialog_prototype._getDialogContent = function() {};
  Dialog_prototype.getTaskButton = function(objTaskBar) {};
  Dialog_prototype.paintChild = function(objJSX, bGroup) {};
  Dialog_prototype.doClose = function() {};
  Dialog_prototype.onSetParent = function(objNewParent) {};
  Dialog_prototype.onSetChild = function(objChild) {};
  Dialog_prototype._removeFromTaskBar = function(objServer) {};
  Dialog_prototype.onDestroy = function(objParent) {};
  Dialog_prototype.getWindowState = function() {};
  Dialog_prototype.setWindowState = function(STATE) {};
  Dialog_prototype.getZMultiplier = function() {};
  Dialog_prototype.setZMultiplier = function(intMultiplier) {};
  Dialog_prototype.getModal = function() {};
  Dialog_prototype.setModal = function(intModal) {};
  Dialog_prototype.doBeginMove = function(objEvent, objGUI) {};
  Dialog_prototype._doResetMove = function(objDragProxy) {};
  Dialog_prototype.doEndMove = function(objEvent) {};
  Dialog_prototype._getRenderedDialog = function() {};
  Dialog_prototype.getAbsolutePosition = function(objRoot) {};
  Dialog_prototype.setLeft = function(intLeft,bRepaint) {};
  Dialog_prototype.setTop = function(intTop, bRepaint) {};
  Dialog_prototype.setWidth = function(intWidth,bRepaint) {};
  Dialog_prototype.setHeight = function(intHeight,bRepaint) {};
  Dialog_prototype.doMaximize = function(objTBB) {

  };
  Dialog_prototype.getResize = function() {};
  Dialog_prototype.setResize = function(RESIZE) {};
  Dialog_prototype.setResizeParameters = function(RESIZE,intMinX,intMinY,intMaxX,intMaxY,strAfterResizeFunction) {};
  Dialog_prototype._constrainWidthHeight = function(intWidth, intHeight) {};
  Dialog_prototype.getCaptionBar = function() {};
  Dialog._captionBarFinder = function(x) {};
  Dialog_prototype._doBeginResize = function(objEvent, objGUI) {};
  Dialog_prototype._doResize = function(x, y) {};
  Dialog_prototype._getMinWidth = function() {};
  Dialog_prototype._getMinHeight = function() {};
  Dialog_prototype._doEndResize = function(objEvent) {

  };
  Dialog_prototype._setLTWHDirect = function(l, t, w, h) {};
  Dialog_prototype.recalcBox = function() {};
  Dialog_prototype.getClientDimensions = function(objChild) {};
  Dialog_prototype._updateDialogProfile = function(objImplicit, bRebalance) {};
  Dialog_prototype.createBoxProfile = function(objImplicit) {};
  Dialog_prototype.updateBoxProfile = function(objImplicit, objGUI, objQueue) {};
  Dialog_prototype.paint = function() {};
  Dialog_prototype._doModalKeyDown = function(objEvent, objGUI) {};
  Dialog_prototype._doModalMaskMouseDown = function(objEvent, objGUI) {};
  Dialog_prototype._doModalMaskMouseUp = function(objEvent, objGUI) {};
  Dialog_prototype.repaintTaskBar = function() {};
  Dialog_prototype.paintIndex = function() {};
  Dialog_prototype.paintOverflow = function() {};
  Dialog_prototype.paintClassName = function() {};
  Dialog_prototype.constrainPosition = function(arg) {};
  Dialog_prototype.onRemoveChild = function(objChild, intIndex) {};
  Dialog_prototype.beep = function() {};
  Dialog_prototype.getAlwaysCheckHotKeys = function() {};
  Dialog_prototype.getContentBorder = function(strDefault) {};
  Dialog_prototype.setContentBorder = function(strCSS) {};
  Dialog_prototype.getBorder = function(strDefault) {};
  Dialog_prototype.setBorder = function(strCSS) {};
  Dialog_prototype.getBuffer = function(strDefault) {};
  Dialog_prototype.setBuffer = function(intBuffer) {};
  Dialog.getVersion = function() {};
});
jsx3.Dialog = jsx3.gui.Dialog;

// === jsx3/gui/Image.js

//jsx3.require("jsx3.gui.Block");

jsx3.Class.defineClass("jsx3.gui.Image", jsx3.gui.Block, [], function(Image, Image_prototype) {

  Image_prototype.paint = function() {};
  Image_prototype.onSetChild = function(objChild) {};
  Image_prototype.updateBoxProfile = function(objImplicit, objGUI, objQueue) {};
  Image_prototype.getRenderedWidth = function() {};
  Image_prototype.getRenderedHeight = function() {};

  Image_prototype.getSrc = function() { return this.jsxsrc; };

  Image_prototype.setSrc = function(srcSrc) { this.jsxsrc = srcSrc; return this; };

});

// === jsx3/gui/LayoutGrid.js

//jsx3.require("jsx3.gui.Block");

jsx3.Class.defineClass("jsx3.gui.LayoutGrid", jsx3.gui.Block, null, function(LayoutGrid, LayoutGrid_prototype) {

  LayoutGrid.ORIENTATIONCOL = 0;

  LayoutGrid.ORIENTATIONROW = 1;

  LayoutGrid.DEFAULTORIENTATION = 0;

  LayoutGrid.DEFAULTREPEAT = 3;

  LayoutGrid.DEFAULTDIMENSIONS = ["33%","33%","34%"];

  LayoutGrid.ABSOLUTE = 0;

  LayoutGrid.ADAPTIVE = 1;

  LayoutGrid_prototype.init = function(strName) {};
  LayoutGrid_prototype.onAfterAttach = function() {};
  LayoutGrid_prototype.onRemoveChild = function(objChild, intIndex) {};
  LayoutGrid_prototype.paintChild = function(objJSXChild, bGroup) {};
  LayoutGrid_prototype.getOrientation = function() {};
  LayoutGrid_prototype.setOrientation = function(ORIENTATION) {};
  LayoutGrid_prototype.getBestGuess = function() {};
  LayoutGrid_prototype.setBestGuess = function(LAYOUT) {};
  LayoutGrid_prototype.getRepeat = function() {};
  LayoutGrid_prototype.setRepeat = function(intCellCount) {};
  LayoutGrid_prototype.getDimensionArray = function() {};
  LayoutGrid_prototype.setDimensionArray = function(objArray, bRepaint) {};
  LayoutGrid_prototype.getCols = function() {};
  LayoutGrid_prototype.setCols = function(strCols, bRepaint) {};
  LayoutGrid_prototype.getRows = function() {};
  LayoutGrid_prototype.setRows = function(strRows, bRepaint) {};
  LayoutGrid_prototype._bRepaint = function() {};
  LayoutGrid_prototype._getTrueSizeArray = function(bRow, intSize) {};
  LayoutGrid_prototype.getClientDimensions = function(objChild, intIndex) {};
  LayoutGrid_prototype._cacheAllClientDims = function() {};
  LayoutGrid_prototype.updateBoxProfile = function(objImplicit, objGUI, objQueue) {};
  LayoutGrid_prototype._clearCaches = function(objBox) {};
  LayoutGrid_prototype.createBoxProfile = function(objImplicit) {};
  LayoutGrid_prototype.paint = function() {};
  LayoutGrid.getVersion = function() {};

});

jsx3.LayoutGrid = jsx3.gui.LayoutGrid;

// === jsx3/gui/WindowBar.js

//jsx3.require("jsx3.gui.Block");

// @jsxobf-clobber-shared  repaintTaskBar

jsx3.Class.defineClass("jsx3.gui.WindowBar", jsx3.gui.Block, null, function(WindowBar, WindowBar_prototype) {

  var Block = jsx3.gui.Block;

  WindowBar.DEFAULTHEIGHT = 26;

  WindowBar.DEFAULTBACKGROUND = jsx3.html.getCSSFade(false);

  WindowBar.DEFAULTBG = "#c8c8d5";

  WindowBar.DEFAULTBGCAPTION = "#aaaacb";

  WindowBar.DEFAULTBORDER = "solid 1px #e8e8f5;solid 0px;solid 1px #a8a8b5;solid 0px;";

  WindowBar.DEFAULTBORDERCAPTION = "solid 1px #9898a5";

  WindowBar.DEFAULTFONTWEIGHT = Block.FONTBOLD;

  WindowBar.DEFAULTFONTSIZE = 11;

  WindowBar.TYPECAPTION = 0;

  WindowBar.TYPETOOL = 1;

  WindowBar.TYPEMENU = 2;

  WindowBar.TYPETASK = 3;

  WindowBar_prototype.init = function(strName,TYPE) {};
  WindowBar_prototype.getMaskProperties = function() {};
  WindowBar_prototype.getType = function() {};
  WindowBar_prototype.setType = function(TYPE) {};
  WindowBar_prototype.setText = function(strText, bRepaint) {};
  WindowBar_prototype.doBeginMove = function(objEvent, objGUI) {};
  WindowBar.BRIDGE_EVENTS = {};
  WindowBar.BRIDGE_EVENTS[jsx3.gui.Event.MOUSEDOWN] = "doBeginMove";

  WindowBar_prototype.updateBoxProfile = function(objImplicit, objGUI, objQueue) {};
  WindowBar_prototype.createBoxProfile = function(objImplicit) {};
  WindowBar_prototype.paint = function() {};
  WindowBar_prototype.paintIndex = function() {};
  WindowBar_prototype.paintBackgroundColor = function() {};
  WindowBar_prototype.paintBackground = function() {};
  WindowBar_prototype.getHeight = function() {};
  WindowBar_prototype.paintFontWeight = function() {};
  WindowBar_prototype.paintFontSize = function() {};
  WindowBar_prototype.paintTextAlign = function() {};
  WindowBar_prototype.paintText = function() {};
  WindowBar_prototype.beep = function() {};
  WindowBar.getVersion = function() {};

});

jsx3.WindowBar = jsx3.gui.WindowBar;

// === jsx3/gui/ToolbarButton.js

//jsx3.require("jsx3.gui.Form", "jsx3.gui.Block");

jsx3.Class.defineClass("jsx3.gui.ToolbarButton", jsx3.gui.Block, [jsx3.gui.Form], function(ToolbarButton, ToolbarButton_prototype) {

  var Form = jsx3.gui.Form;
  var Interactive = jsx3.gui.Interactive;
  var Event = jsx3.gui.Event;

  ToolbarButton.TYPENORMAL = 0;

  ToolbarButton.TYPECHECK = 1;

  ToolbarButton.TYPERADIO = 2;

  ToolbarButton.STATEOFF = 0;

  ToolbarButton.STATEON = 1;

  ToolbarButton.IMAGEDOWN = jsx3.resolveURI("jsx:///images/tbb/down.gif");

  ToolbarButton.IMAGEON = jsx3.resolveURI("jsx:///images/tbb/on.gif");

  ToolbarButton.IMAGEOVER = jsx3.resolveURI("jsx:///images/tbb/over.gif");

  ToolbarButton.DEFAULTIMAGE = jsx3.resolveURI("jsx:///images/tbb/default.gif");

  ToolbarButton.BORDERCOLOR = "#9B9BB7";

  jsx3.html.loadImages(ToolbarButton.IMAGEDOWN, ToolbarButton.IMAGEON, ToolbarButton.IMAGEOVER,
      ToolbarButton.DEFAULTIMAGE);

  ToolbarButton_prototype.init = function(strName, intType, strTip) {};
  ToolbarButton_prototype.getDisabledImage = function() {};
  ToolbarButton_prototype.setDisabledImage = function(strURL) {};
  ToolbarButton_prototype.doValidate = function() {};
  ToolbarButton_prototype.getImage = function() {};
  ToolbarButton_prototype.setImage = function(strURL) {};
  ToolbarButton_prototype.getType = function() {};
  ToolbarButton_prototype.setType = function(TYPE) {};
  ToolbarButton_prototype._ebKeyDown = function(objEvent, objGUI) {};
  ToolbarButton_prototype.getMaskProperties = function() {};
  ToolbarButton_prototype._ebMouseDown = function(objEvent, objGUI) {};
  ToolbarButton_prototype._ebMouseUp = function(objEvent, objGUI) {};
  ToolbarButton_prototype._ebMouseOver = function(objEvent, objGUI) {};
  ToolbarButton_prototype._ebMouseOut = function(objEvent, objGUI) {};
  ToolbarButton_prototype.doExecute = function(objEvent) {};
  ToolbarButton_prototype.doClick = function() {};
  ToolbarButton_prototype._doClick = function(objEvent, objGUI) {};
  ToolbarButton_prototype.getGroupName = function() {};
  ToolbarButton_prototype.setGroupName = function(strGroupName) {};
  ToolbarButton_prototype.getDivider = function() {};
  ToolbarButton_prototype.setDivider = function(intDivider, bRecalc) {};
  ToolbarButton_prototype.getState = function() {};
  ToolbarButton_prototype.setState = function(intState) {};
  ToolbarButton_prototype._setState = function(STATE, objEvent, objGUI) {};
  ToolbarButton_prototype.setEnabled = function(ENABLED, bRepaint) {};
  ToolbarButton.BRIDGE_EVENTS = {};
  ToolbarButton.BRIDGE_EVENTS[Event.CLICK] = "_doClick";
  ToolbarButton.BRIDGE_EVENTS[Event.KEYDOWN] = true;
  ToolbarButton.BRIDGE_EVENTS[Event.MOUSEDOWN] = true;
  ToolbarButton.BRIDGE_EVENTS[Event.MOUSEUP] = true;
  ToolbarButton.BRIDGE_EVENTS[Event.MOUSEOUT] = true;
  ToolbarButton.BRIDGE_EVENTS[Event.MOUSEOVER] = true;
  ToolbarButton.BRIDGE_EVENTS[Event.BLUR] = "_ebMouseOut";
  ToolbarButton.BRIDGE_EVENTS[Event.FOCUS] = "_ebMouseOver";

  ToolbarButton_prototype.updateBoxProfile = function(objImplicit, objGUI, objQueue) {};
  ToolbarButton_prototype.createBoxProfile = function() {};
  ToolbarButton_prototype.paint = function() {};
  ToolbarButton.getVersion = function() {};
  ToolbarButton_prototype.emGetType = function() {};
  ToolbarButton_prototype.emInit = function(objColumn) {};
  ToolbarButton_prototype.emSetValue = function(strValue) {};
  ToolbarButton_prototype.emGetValue = function() {};
  ToolbarButton_prototype.emBeginEdit = function(strValue, objTdDim, objPaneDim, objMatrix, objColumn, strRecordId, objTD) {};
  ToolbarButton_prototype.emPaintTemplate = function() {};

  ToolbarButton_prototype._emOnExecute = function(objEvent) {

//      jsx3.log("execute for record id " + es.recordId);

  };

});

jsx3.ToolbarButton = jsx3.gui.ToolbarButton;

// === jsx3/gui/Menu.js

//jsx3.require("jsx3.xml.Cacheable", "jsx3.gui.Form", "jsx3.gui.Heavyweight", "jsx3.gui.Block",
//    "jsx3.gui.ToolbarButton", "jsx3.util.MessageFormat");

// @jsxobf-clobber-shared  _registerForXML _getDisplayedChildren
jsx3.Class.defineClass("jsx3.gui.Menu", jsx3.gui.Block, [jsx3.xml.Cacheable, jsx3.xml.CDF, jsx3.gui.Form], function(Menu, Menu_prototype) {
  var LOG = jsx3.util.Logger.getLogger(Menu.jsxclass.getName());
  var Event = jsx3.gui.Event;
  var Interactive = jsx3.gui.Interactive;
  var html = jsx3.html;
  Menu.DEFAULTBACKGROUND = "background-image:url(" + jsx3.resolveURI("jsx:///images/menu/bg.gif") + ");background-repeat:repeat-y;";
  Menu.DEFAULTBACKGROUNDCOLOR = "#ffffff";

  Menu.DEFAULTCONTEXTLEFTOFFSET = 10;
  Menu.NODATAMESSAGE = "<div tabIndex='0' class='jsx30menu_0_list' onmousedown='var e = jsx3.gui.Event.wrap(event); jsx3.gui.Event.publish(e); e.cancelBubble(); e.cancelReturn();'>- no data -</div>";
  Menu._NODATAFORMAT = new jsx3.util.MessageFormat('<div tabIndex="0" class="jsx30menu_{0}_item"' +
      ' onmousedown="var e = jsx3.gui.Event.wrap(event); jsx3.gui.Event.publish(e); e.cancelBubble(); e.cancelReturn();">' +
      '<div class="jsx30menu_{0}_kc"><table class="jsx30menu_{0}_kct"><tr><td class="name">{1}</td>' +
      '<td class="keycode"></td></tr></table></div></div>');
  Menu._STATEOFF = 0;
  Menu._STATEON = 1;
  Menu.DEFAULTCONTEXTTOPOFFSET = 12;
  Menu._IMAGESUBMENU = jsx3.resolveURI("jsx:///images/menu/submenuarrow.gif");
  Menu._IMAGEOVER = jsx3.resolveURI("jsx:///images/menu/selectover.gif");
  Menu._IMAGESELECTED = jsx3.resolveURI("jsx:///images/menu/selected.gif");
  Menu._IMAGEDOWNMENU = jsx3.resolveURI("jsx:///images/menu/down_menu.gif");
  Menu._IMAGEOFFMENU = jsx3.resolveURI("jsx:///images/menu/off_menu.gif");
  Menu._IMAGEONMENU = jsx3.resolveURI("jsx:///images/menu/on_menu.gif");
  Menu._IMAGEOVERMENU = jsx3.resolveURI("jsx:///images/menu/over_menu.gif");
  Menu._IMAGEDOWN = jsx3.resolveURI("jsx:///images/tbb/down.gif");
  Menu._IMAGEON = jsx3.resolveURI("jsx:///images/tbb/on.gif");
  html.loadImages("jsx:///images/menu/bg.gif", Menu._IMAGEDOWNMENU, Menu._IMAGEOFFMENU, Menu._IMAGEONMENU,
      Menu._IMAGEOVERMENU, Menu._IMAGESELECTED, Menu._IMAGEOVER, Menu._IMAGESUBMENU, Menu._IMAGEDOWN, Menu._IMAGEON);
  Menu.BORDERCOLOR = "#9B9BB7";
  Menu._ACTIVE_MENU = null;
  Menu._ACTIVE_HWS = [];
  Menu._ACTIVE_ITEMS = [];
  Menu._ON_MENU = null;
  Menu._SHOWID = null;
  Menu._BLURID = null;
  Menu.SHOW_DELAY = 250;
  Menu.BLUR_DELAY = 150;
  Menu.HW_ID_PREFIX = "jsx30curvisiblemenu_";
  Menu.SPYDELAY = 1000;
  Menu_prototype.init = function(strName, strText) {};
  Menu_prototype.getImage = function() {};
  Menu_prototype.setImage = function(strURL) {};
  Menu_prototype.disableItem = function(strRecordId) {};
  Menu_prototype.enableItem = function(strRecordId, bEnabled) {};
  Menu_prototype.isItemEnabled = function(strRecordId) {};
  Menu_prototype.selectItem = function(strRecordId, bSelected) {};
  Menu_prototype.deselectItem = function(strRecordId) {};
  Menu_prototype.isItemSelected = function(strRecordId) {};
  Menu_prototype._focusItem = function(objEvent, itemGUI, intLevel) {};
  Menu_prototype._limitToMenuLevel = function(intLevel, bNow) {};
  Menu_prototype._isActiveRecord = function(strRecordId) {};
  Menu_prototype._pushActiveRecord = function(intLevel, strRecordId) {};
  Menu_prototype._ebKeyDown = function(objEvent, objGUI) {};
  Menu_prototype._ebMouseDown = function(objEvent, objGUI) {};
  Menu_prototype._ebMouseOver = function(objEvent, objGUI) {};
  Menu_prototype._ebMouseOut = function(objEvent, objGUI) {};
  Menu_prototype._doKeyDownItem = function(objEvent, objGUI) {};
  Menu_prototype._focusSiblingMenu = function(bNext) {};
  Menu_prototype._doMouseDownItem = function(objEvent, objGUI) {};
  Menu_prototype._doMouseUpItem = function(objEvent, objGUI) {};
  Menu_prototype._doMouseOverItem = function(objEvent, objGUI) {};
  Menu_prototype._showMenuSpy = function(objEvent, strRecordId, bHasMenu) {};
  Menu._hideMenuSpy = function() {};
  Menu._getItemGUI = function(objEvent, objGUI) {};
  Menu_prototype._doClickItem = function(objEvent, objGUI) {};
  Menu_prototype._onLoseFocus = function(objEvent) {};
  Menu_prototype._hideMenu = function(intIndex, bNoFocus) {};
  Menu_prototype.showContextMenu = function(objEvent, objParent, strRecordId, objOffset) {};
  Menu_prototype.getContextParent = function() {};
  Menu_prototype.getContextRecordId = function() {};
  Menu_prototype.showMenu = function(objEvent, objAnchor, intIndex, strParentId, objOffset) {};
  Menu_prototype._showMenu2 = function(objEvent, objAnchor, intIndex, strParentId, objOffset) {};
  Menu_prototype.repaint = function() {};
  Menu._getMode = function() {};
  Menu_prototype._getMenuContent = function(strParentId, intIndex) {};
  Menu_prototype._getFormattedKeycodes = function(strRootId) {};
  Menu_prototype.clearCachedContent = function() {};
  Menu_prototype.getState = function() {};
  Menu_prototype._setState = function(STATE, objGUI) {};
  Menu_prototype._doKeyBindings = function() {};
  Menu_prototype._executeRecordHotKey = function(objEvent, strRecordId) {};
  Menu.BRIDGE_EVENTS = {};
  Menu.BRIDGE_EVENTS[Event.KEYDOWN] = true;
  Menu.BRIDGE_EVENTS[Event.MOUSEDOWN] = true;
  Menu.BRIDGE_EVENTS[Event.MOUSEOUT] = true;
  Menu.BRIDGE_EVENTS[Event.MOUSEOVER] = true;
  Menu.BRIDGE_EVENTS[Event.BLUR] = "_ebMouseOut";
  Menu.BRIDGE_EVENTS[Event.FOCUS] = "_ebMouseOver";
  Menu_prototype.updateBoxProfile = function(objImplicit, objGUI, objQueue) {};
  Menu_prototype.createBoxProfile = function() {};
  Menu_prototype.paint = function() {};
  Menu_prototype.onXmlBinding = function(objEvent) {};
  Menu_prototype.paintBackgroundColor = function() {};
  Menu_prototype.paintBackground = function() {};
  Menu_prototype.executeRecord = function(strRecordId) {};
  Menu_prototype._executeRecord = function(objEvent, strRecordId) {};
  Menu_prototype.redrawRecord = function() {};
  Menu_prototype.getValue = function() {};
  Menu_prototype.doValidate = function() {};
  Menu_prototype.beep = function() {};
  Menu.getVersion = function() {};
  Menu_prototype.emGetSession = function(objEvent) {};
  Menu_prototype.emGetType = function() {};
  Menu_prototype.emInit = function(objColumn) {};
  Menu_prototype.emSetValue = function(strValue) {};
  Menu_prototype.emGetValue = function() {};
  Menu_prototype.emBeginEdit = function(strValue, objTdDim, objPaneDim, objMatrix, objColumn, strRecordId, objTD) {};
  Menu_prototype.emPaintTemplate = function() {};
  Menu_prototype._emOnExecute = function(objEvent) {};
  Menu_prototype.containsHtmlElement = function(objElement) {};
  Menu_prototype.getDivider = function() {};
  Menu_prototype.setDivider = function(intDivider, bRecalc) {};
  Menu_prototype.emCollapseEdit = function(objEvent) {};
});
// import ToolbarButton methods for brevity
jsx3.gui.Menu.prototype._tbbDoMouseDown = jsx3.gui.ToolbarButton.prototype._ebMouseDown;
jsx3.gui.Menu.prototype._tbbDoMouseOver = jsx3.gui.ToolbarButton.prototype._ebMouseOver;
jsx3.gui.Menu.prototype._tbbDoMouseOut = jsx3.gui.ToolbarButton.prototype._ebMouseOut;
jsx3.Menu = jsx3.gui.Menu;

// === jsx3/gui/Stack.js

//jsx3.require("jsx3.gui.Block");

jsx3.Class.defineClass("jsx3.gui.Stack", jsx3.gui.Block, null, function(Stack, Stack_prototype) {

  var gui = jsx3.gui;
  var Event = gui.Event;
  var Block = gui.Block;

  Stack.ORIENTATIONV = 0;

  Stack.ORIENTATIONH = 1;

  Stack.ACTIVECOLOR = "#aaaafe";

  Stack.INACTIVECOLOR = "#aaaacb";

  Stack.CHILDBGCOLOR = "#ffffff";

  Stack.BORDER = "solid 1px #ffffff;solid 1px #9898a5;solid 1px #9898a5;solid 1px #ffffff";
  Stack.CAPTION_BORDER = "solid 1px #c8c8d5;solid 1px #9898a5;solid 1px #9898a5;solid 1px #c8c8d5";

  Stack.BACKGROUND = jsx3.html.getCSSFade(false);
  Stack.BACKGROUNDH = jsx3.html.getCSSFade(true);

  Stack_prototype.init = function(strName,strCaption) {};
  Stack_prototype.onSetParent = function(objParent) {};
  Stack_prototype.doShowStack = function() {};
  Stack_prototype.doShow = function() {};
  Stack_prototype._doShowStack = function(objEvent, objGUI) {};
  Stack_prototype._ebMouseOver = function(objEvent, objGUI) {};
  Stack_prototype._ebMouseOut = function(objEvent, objGUI) {};
  Stack_prototype.getContentChild = function() {};
  Stack_prototype._ebKeyDown = function(objEvent, objGUI) {};
  Stack.BRIDGE_EVENTS = {};
  Stack.BRIDGE_EVENTS[Event.CLICK] = "_doShowStack";
  Stack.BRIDGE_EVENTS[Event.KEYPRESS] = true;
  Stack.BRIDGE_EVENTS[Event.MOUSEOVER] = true;
  Stack.BRIDGE_EVENTS[Event.MOUSEOUT] = true;

  Stack_prototype.getClientDimensions = function(objChild) {};
  Stack_prototype.updateBoxProfile = function(objImplicit, objGUI, objQueue) {};
  Stack_prototype.createBoxProfile = function(objImplicit) {};
  Stack_prototype.paint = function() {};
  Stack_prototype._setContentDisplay = function(objContent, bActive) {};
  Stack_prototype.paintTextAlign = function() {};
  Stack_prototype.setText = function(strText, bRepaint) {};
  Stack_prototype.getPadding = function() {};
  Stack_prototype.getFontWeight = function() {};
  Stack_prototype.paintBackground = function() {};
  Stack_prototype.paintIndex = function() {};
  Stack_prototype.getActiveColor = function() {};
  Stack_prototype.setActiveColor = function(strActiveColor) {};
  Stack_prototype.getInactiveColor = function() {};
  Stack_prototype.setInactiveColor = function(strInactiveColor) {};
  Stack_prototype.getOrientation = function() {};
  Stack_prototype.focus = function() {};
  Stack_prototype.isFront = function() {};
  Stack_prototype.getMaskProperties = function() {};
  Stack.getVersion = function() {};
  // need to implement this because the HTML DOM hierarchy does not mirror the JSX DOM
  Stack_prototype.destroyView = function(objParent) {};
});

jsx3.gui.Stack.prototype.getBackgroundColor = jsx3.gui.Stack.prototype.getInactiveColor;

jsx3.gui.Stack.prototype.setBackgroundColor = jsx3.gui.Stack.prototype.setInactiveColor;

jsx3.Stack = jsx3.gui.Stack;

// === jsx3/gui/StackGroup.js

//jsx3.require("jsx3.gui.LayoutGrid", "jsx3.gui.Stack");

jsx3.Class.defineClass("jsx3.gui.StackGroup", jsx3.gui.LayoutGrid, null, function(StackGroup, StackGroup_prototype) {

  var LayoutGrid = jsx3.gui.LayoutGrid;

  StackGroup.ORIENTATIONV = 0;

  StackGroup.ORIENTATIONH = 1;

  StackGroup.DEFAULTSTACKCOUNT = 2;

  StackGroup.DEFAULTDIMENSIONS = ["27","*"];

  StackGroup.DEFAULTBARSIZE = 27;

  StackGroup_prototype.init = function(strName) {};
  StackGroup_prototype.getBarSize = function() {};
  StackGroup_prototype.setBarSize = function(intBarSize) {};
  StackGroup_prototype.getClientDimensions = function(objChild, intIndex) {};
  StackGroup_prototype.updateBoxProfile = function(objImplicit, objGUI, objQueue) {};
  StackGroup_prototype.paint = function() {};
  StackGroup_prototype.paintBarSize = function(intBarSize) {};
  StackGroup_prototype.getSelectedIndex = function() {};
  StackGroup_prototype.setSelectedIndex = function(intIndex) {};
  StackGroup_prototype.paintChild = function(objJSX, bLoop) {};
  StackGroup_prototype.onSetChild = function(objChild) {};
  StackGroup_prototype.onRemoveChild = function(objChild, intIndex) {};
  StackGroup_prototype._updateDimensionArray = function(bRepaint) {};
  StackGroup_prototype.getOrientation = function() {};
  StackGroup_prototype.setOrientation = function(intOrientation) {};
  StackGroup.getVersion = function() {};
});

jsx3.StackGroup = jsx3.gui.StackGroup;

// === jsx3/gui/Window.js

//jsx3.require("jsx3.gui.Block");

jsx3.Class.defineClass('jsx3.gui.Window', jsx3.app.Model, null, function(Window, Window_prototype) {

  var Exception = jsx3.Exception;
  var Logger = jsx3.util.Logger;

  var LOG = Logger.getLogger(Window.jsxclass.getName());

  Window.HTML_URI = jsx3.resolveURI("jsx:///../jsx3.gui.window.html");

  Window.HTML_URI_XHTML = jsx3.resolveURI("jsx:///../jsx3.gui.window.xhtml");

  // TODO: put this in a Browser utility class
 if (jsx3.CLASS_LOADER.IE) {

  Window._SCREENX = "screenLeft";

  Window._SCREENY = "screenTop";
 } else {
  Window._SCREENX = "screenX";
  Window._SCREENY = "screenY";
 }

  Window.DID_OPEN = "open";

  Window.WILL_CLOSE = "close";

  Window.DID_FOCUS = "focus";

  Window.DID_RESIZE = "resize";

  Window.PARENT_DID_CLOSE = "pclose";

  Window_prototype.jsxwidth = 400;

  Window_prototype.jsxheight = 300;

  Window_prototype.jsxresizable = jsx3.Boolean.FALSE;

  Window_prototype.jsxscrollable = jsx3.Boolean.FALSE;

  Window_prototype.jsxdependent = jsx3.Boolean.TRUE;

  Window_prototype.jsxtitle = "";

  Window_prototype._jsxwindow = null;

  Window_prototype._jsxopener = null;

  // window manipulation

  Window_prototype.init = function(strName) {};

  Window_prototype.open = function() {

//          "dependent=" + (this.isDependent() ? "yes" : "no") + "," +

  };

  Window_prototype.close = function() {};
  Window_prototype.doClose = function() {};
  Window_prototype.focus = function() {};
  Window_prototype.isOpen = function() {};
  Window_prototype.isParentOpen = function() {};
  Window_prototype.moveTo = function(intOffsetLeft, intOffsetTop) {};
  Window_prototype.constrainToScreen = function() {};
  Window_prototype.getOffsetLeft = function() {};
  Window_prototype.getOffsetTop = function() {};

  // event handlers

  Window_prototype.onLoad = function(w) {

//        if (LOG.isLoggable(Logger.TRACE))
//          LOG.trace("appending stylesheet " + href + " to window " + this);

  };

  Window_prototype.onFocus = function() {};
  Window_prototype.onBeforeUnload = function() {};
  Window_prototype.onResize = function() {};
  Window_prototype.onParentUnload = function() {};
  Window_prototype.getRootBlock = function() {};
  Window_prototype.getWindow = function() {};
  Window_prototype.getParentWindow = function() {};
  Window_prototype.getDocument = function() {};
  Window_prototype.getClientDimensions = function() {};
  Window_prototype.repaint = function() {};

  // getters and setters

  Window_prototype.getWidth = function() {};
  Window_prototype.setWidth = function(intWidth) {};
  Window_prototype.getHeight = function() {};
  Window_prototype.setHeight = function(intHeight) {};
  Window_prototype.isResizable = function() {};
  Window_prototype.setResizable = function(bResizable) {};
  Window_prototype.isScrollable = function() {};
  Window_prototype.setScrollable = function(bScrollable) {};
  Window_prototype.isDependent = function() {};
  Window_prototype.setDependent = function(bDependent) {};
  Window_prototype.getTitle = function() {};
  Window_prototype.setTitle = function(strTitle) {};
  Window_prototype.toString = function(strTitle) {};

});

// === jsx3/net/Form.js

jsx3.Class.defineClass("jsx3.net.Form", null, [jsx3.util.EventDispatcher], function(Form, Form_prototype) {

  var LOG = jsx3.util.Logger.getLogger(Form.jsxclass.getName());

  Form.SERIAL = 0;

  Form.DEFAULT_POLL = 250;

  Form.DEFAULT_TIMEOUT = 30000;

  Form.METHOD_GET = "get";

  Form.METHOD_POST = "post";

  Form.ENCTYPE_NORMAL = "application/x-www-form-urlencoded";

  Form.ENCTYPE_MULTIPART = "multipart/form-data";

  Form.EVENT_FILE_SELECTED = "file";

  Form.EVENT_ON_RESPONSE = "response";

  Form.EVENT_ON_ERROR = "error";

  Form.EVENT_ON_TIMEOUT = "timeout";

  Form_prototype.init = function(strMethod, strAction, bMultipart) {};
  Form.newFromFragment = function(strFragment) {};
  Form_prototype.initIFrame = function(strFormHtml) {};
  Form_prototype.getMethod = function() {};
  Form_prototype.setMethod = function( method ) {};
  Form_prototype.getAction = function() {};
  Form_prototype.setAction = function( action ) {};
  Form_prototype.getMultipart = function() {};
  Form_prototype.setMultipart = function( multipart ) {};
  Form_prototype.getRenderedSpan = function() {};
  Form_prototype.getRenderedIFrame = function() {};
  Form_prototype.getRenderedForm = function() {};
  Form_prototype.getField = function(strName) {};
  Form_prototype.getFields = function() {};
  Form_prototype.setField = function(strName, strValue, bConcat) {};
  Form_prototype.removeField = function(strName) {};
  Form_prototype.addFileUploadField = function(strName) {};
  Form_prototype.promptForFile = function(strFieldName) {};
  Form_prototype.onFileFieldChanged = function(strField, strValue) {};
  Form_prototype.onResponseLoad = function() {};
  Form_prototype.send = function(intPollInterval, intTimeout) {};
  Form_prototype.abort = function() {};
  Form_prototype.onResponseError = function(strMessage) {};
  Form_prototype._onIFrameLoad = function() {};
  Form_prototype.onIFrameTimeout = function() {};
  Form_prototype.getResponseText = function() {};
  Form_prototype.getResponseXML = function() {};
  Form_prototype.destroy = function() {};
  Form_prototype.reveal = function(l, t, w, h) {};
  Form_prototype.conceal = function() {};
  Form_prototype.toString = function() {};

});

jsx3.HttpForm = jsx3.net.Form;

// *** amp
// === amp.js
jsx3.lang.Package.definePackage("jsx3.amp", function(amp) {

  amp.NS = "http://www.tibco.com/gi/amp";

  amp.XML_NS = {};
  amp.XML_NS[amp.NS] = "amp";

  amp.DESCRIPTOR = "plugins.xml";

  amp.METAFILE = "plugin.xml";

  amp.DIR = "plugins";

  amp.LOG = jsx3.util.Logger.getLogger("jsx3.amp");

  amp._getConstructor = function(objClass) {
    var fct = objClass;

    if (typeof(fct) == "string")
      fct = jsx3.Class.forName(fct) || jsx3.lang.getVar(fct);

    if (fct instanceof jsx3.Class)
      fct = fct.getConstructor();

    if (typeof(fct) != "function")
      fct = null;

    return fct;
  };

  amp._getBestLocaleKey = function(strLocales, objLocale) {
    var l = jsx3.$S(strLocales || "").trim();
    if (l.length > 0) {
      var available = jsx3.$A(l.split(/\s/g));
      var path = objLocale.getSearchPath();
      var loc = jsx3.$A(path).find(function(e) { return available.contains(e.toString()); });
      if (loc)
        return loc.toString();
    }

    return "";
  };

});

jsx3.lang.Package.definePackage("jsx3.amp.util", function(util) {

});

// === Bindable.js

// @jsxobf-clobber  _id _expr

jsx3.lang.Class.defineInterface("jsx3.amp.Bindable", null, function(Bindable, Bindable_prototype) {

  Bindable_prototype._getBindings = function() {
    if (!this._bindings)
      this._bindings = jsx3.$H();
    return this._bindings;
  };

  Bindable_prototype.addBindableProp = function(key, expression) {
    var b = this._getBindings();
    b[key] = {_id:key, _expr:expression};
  };

  Bindable_prototype.getBindableProps = function() {
    return this._getBindings().keys();
  };

  Bindable_prototype.updateBindableOn = function(key, publisher, subject) {
    publisher.subscribe(subject, jsx3.$F(this.updateBindable).bind(this, [key]));
  };

  Bindable_prototype.updateBindable = function(key) {
    var b = this._getBindings()[key];
    this.setBindableProp(key, this.eval(b._expr));
  };

  Bindable_prototype.setBindableProp = function(key, newValue) {
    var oldValue = this[key];
    if (oldValue !== newValue) {
      this[key] = newValue;
      if (this.publish)
        this.publish({subject:key, oldValue:oldValue, value:newValue});
    }
  };

});

// === Ext.js

jsx3.lang.Class.defineClass("jsx3.amp.Ext", null, null, function(Ext, Ext_prototype) {

  var amp = jsx3.amp;

  Ext_prototype.init = function(objPlugIn, objElm) {
    this._xml = new amp.XML(objElm);

    this._plugin = objPlugIn;
  };

  Ext_prototype.getId = function() {
    var lid = this.getLocalId();
    return this.getPlugIn() + "." + (lid || "?");
  };

  Ext_prototype.getLocalId = function() {
    return this._xml.attr("id");
  };

  Ext_prototype.getName = function() {
    return this._xml.attr("name");
  };

  Ext_prototype.getPlugIn = function() {
    return this._plugin;
  };

  Ext_prototype.getEngine = function() {
    return this._plugin.getEngine();
  };

  Ext_prototype.getPointId = function() {
    return this._xml.attr("point");
  };

  Ext_prototype.getPoint = function() {
    return this.getEngine().getExtPoint(this.getPointId());
  };

  Ext_prototype.getData = function() {
    return this._xml.children();
  };

  Ext_prototype.toString = function() {
    return this.getId();
  };

});

// === ExtPoint.js

jsx3.lang.Class.defineClass("jsx3.amp.ExtPoint", null, [jsx3.util.EventDispatcher], function(ExtPoint, ExtPoint_prototype) {

  var amp = jsx3.amp;

  ExtPoint.EXTENDED = "extended";

  ExtPoint_prototype.init = function(objPlugIn, objElm) {
    this._xml = new amp.XML(objElm, true);

    this._plugin = objPlugIn;
  };

  ExtPoint_prototype.getId = function() {
    return this._plugin.getId() + "." + this.getLocalId();
  };

  ExtPoint_prototype.getLocalId = function() {
    return this._xml.attr("id");
  };

  ExtPoint_prototype.getName = function() {
    return this._xml.attr("name");
  };

  ExtPoint_prototype.getPlugIn = function() {
    return this._plugin;
  };

  ExtPoint_prototype.getEngine = function() {
    return this._plugin.getEngine();
  };

  ExtPoint_prototype.getExts = function() {
    return this.getEngine().getExts(this.getId());
  };

  ExtPoint_prototype.processExts = function(objProcessor, arrExt) {
    if (!objProcessor) {
      var def = this._xml.child("processor");
      if (def)
        objProcessor = amp.ExtProc.getProcessor(def.attr("type"), def);

      if (!objProcessor)
        throw new jsx3.Exception("Parameter objProcessor must not be null.");
    }

    if (!arrExt) arrExt = this.getExts();
    return amp.ExtProc.process(arrExt, objProcessor);
  };

  ExtPoint_prototype.onExtension = function(arrExts) {
    this.publish({subject:ExtPoint.EXTENDED, exts:arrExts});
  };

  ExtPoint_prototype.toString = function() {
    return this.getId();
  };

});

// === ExtProc.js

// @jsxobf-clobber-shared  _getConstructor

jsx3.lang.Class.defineClass("jsx3.amp.ExtProc", null, null, function(ExtProc, ExtProc_prototype) {

  var amp = jsx3.amp;

  ExtProc.process = function(arrExt, objVisitor) {
    var o = jsx3.$A();

    for (var i = 0; i < arrExt.length; i++) {
      var ext = arrExt[i];
      var data = ext.getData();
      for (var j = 0; j < data.length; j++) {
        var elm = data[j];

        if (typeof(objVisitor) == "function") {
          o.push(objVisitor(ext, elm));
        } else {
          o.push(objVisitor.process(ext, elm));
        }
      }
    }

    return o;
  };

  ExtProc._PROC_FACTORIES = {
    "eval": function(x) { return ExtProc.EVAL; },
    "return": function(x) { return ExtProc.RETURN; },
    "return-async": function(x) { return ExtProc.RETURN_ASYNC; },
    "instantiator": function(x) { return ExtProc.newDescrProc(x.attr("instance-class")); }
  };

  ExtProc.addProcessorFactory = function(strType, fctFactory) {
    ExtProc._PROC_FACTORIES[strType] = fctFactory;
  };

  ExtProc.getProcessor = function(strType, xml) {
    var factory = ExtProc._PROC_FACTORIES[strType];
    if (factory) {
      return factory(xml);
    } else {
      return null;
    }
  };

  ExtProc._DESCRIPTOR_VISITOR = function(fctConstructor) {
    this._constructor = fctConstructor;
  };

  ExtProc._DESCRIPTOR_VISITOR.prototype.process = function(objExt, objData) {
    var className = objData.attr("ext-class");
    var c = this._constructor;
    if (className) {
      var customClass = amp._getConstructor(className);

      if (customClass)
        c = customClass
      else
        amp.LOG.error(jsx3._msg("amp.36", className));
    }

    return new c(objExt, objData);
  };

  ExtProc.EVAL = {
    process: function(objExt, objData) {
      var bLoad = objData.attr("load") == "true";
      var script = objData.value();

      if (bLoad) {
        objExt.getPlugIn().load().when(function() {
          objExt.eval(script);
        });
      } else {
        objExt.eval(script);
      }
    }
  };

  ExtProc.RETURN = {
    process: function(objExt, objData) {
      var script = objData.value();
      return objExt.eval(script);
    }
  };

  ExtProc.RETURN_ASYNC = {
    process: jsx3.$Y(function(cb) {
      var objExt = cb.args()[0];
      var objData = cb.args()[1];

      var bLoad = objData.attr("load") == "true";
      var script = objData.value();

      if (bLoad) {
        objExt.getPlugIn().load().when(function __ExtProc_RETURN_ASYNC_process_onLoad() {
          cb.done(objExt.eval(script));
        });
      } else {
        cb.done(objExt.eval(script));
      }
    })
  };

  ExtProc.newDescrProc = function(objClass) {
    return new ExtProc._DESCRIPTOR_VISITOR(amp._getConstructor(objClass));
  };

});

// === PlugIn.js

// @jsxobf-clobber-shared  _plugin _loadPlugIn _extendInstance
// @jsxobf-clobber-shared  _getConstructor _setPlugInOnInit

jsx3.lang.Class.defineClass("jsx3.amp.PlugIn", null, [jsx3.util.EventDispatcher, jsx3.net.URIResolver, jsx3.amp.Bindable], function(PlugIn, PlugIn_prototype) {

  var amp = jsx3.amp;

  PlugIn.READY = "ready";

  PlugIn.EXTENDED = "extended";

  PlugIn.NOT_LOADED = 0;

  PlugIn.LOADING = 1;

  PlugIn.LOADED = 2;

  PlugIn_prototype.init = function() {

    this._state = PlugIn.NOT_LOADED;

    this._req = jsx3.$A();

    this._resources = jsx3.$A();

    this._resourcemap = {};

    this._extpt = jsx3.$A();

    this._extptmap = {};

    this._ext = jsx3.$A();

    this._extmap = {};

    this._events = jsx3.$A();
  };

  PlugIn_prototype.setData = function(objElm) {

    this._id = objElm.getAttribute("id");

    this._global = objElm.getAttribute("global") == "true";

    this._name = objElm.getAttribute("name");

    this._version = objElm.getAttribute("version");

    var children = objElm.getChildNodes().toArray(true);
    for (var i = 0; i < children.length; i++) {
      var node = children[i];
      var name = node.getBaseName();

      if (name == "requires") {
        for (var j = node.selectNodeIterator("amp:plugin", amp.XML_NS); j.hasNext(); )
          this._req.push(j.next().getAttribute("id"));
      } else if (name == "event") {

        this._events.push(node.getAttribute("id"));

      } else if (name == "extension-point") {

        var xpClass = null;

        var xpClassName = node.getAttribute("class");
        if (xpClassName) {
          xpClass = amp._getConstructor(xpClassName);
          if (!xpClass)
            amp.LOG.error(jsx3._msg("amp.38", xpClassName));
        }
        if (!xpClass) xpClass = amp.ExtPoint;

        var xp = new xpClass(this, node);
        var id = xp.getLocalId();
        if (this._extptmap[id]) {
          amp.LOG.error(jsx3._msg("amp.39", this, id));
        } else {
          amp.Engine._extendInstance(xp, node);
          this._extptmap[id] = xp;
          this._extpt.push(xp);
        }

      } else if (name == "extension") {
        var xClass = null;
        var xClassName = node.getAttribute("class");
        if (xClassName) {
          xClass = amp._getConstructor(xClassName);
          if (!xpClass)
            amp.LOG.error(jsx3._msg("amp.40", xClassName));
        }
        if (!xClass) xClass = amp.Ext;

        var x = new xClass(this, node);
        var id = x.getLocalId();
        if (id != null) {
          if (this._extmap[id]) {
            amp.LOG.error(jsx3._msg("amp.41", this, id));
          } else {
            this._extmap[id] = x;
          }
        }
        amp.Engine._extendInstance(x, node);
        this._ext.push(x);

      }
    }
  };

  PlugIn_prototype.setPath = function(strPath) {

    this._path = strPath;

    this._uri = new jsx3.net.URI(strPath + "/");

    this._uriabs = jsx3.app.Browser.getLocation().resolve(this._uri);
  };

  PlugIn_prototype.setResources = function(arrRsrc) {
    this._resources = jsx3.$A(arrRsrc);
    this._resourcemap = {};
    for (var i = 0; i < arrRsrc.length; i++) {
      var rsrc = arrRsrc[i];

      rsrc._setPlugInOnInit(this);
      if (!rsrc.isLoaded())
        rsrc.subscribe(amp.Resource.READY, this, "_onResourceReady");

      this._resourcemap[rsrc.getLocalId()] = rsrc;
    }
  };

  PlugIn_prototype.getId = function() {
    return this._id;
  };

  PlugIn_prototype.isGlobal = function() {
    return this._global;
  };

  PlugIn_prototype.getName = function() {
    return this._name;
  };

  PlugIn_prototype.getVersion = function() {
    return this._version;
  };

  PlugIn_prototype.getResources = function() {
    return this._resources;
  };

  PlugIn_prototype.getEvents = function() {
    return this._events;
  };

  PlugIn_prototype.getResource = function(strId) {
    return this._resourcemap[strId];
  };

  PlugIn_prototype.getRequires = function() {
    return this._req;
  };

  PlugIn_prototype.load = jsx3.$Y(function(cb) {
    if (this._state == PlugIn.NOT_LOADED) {
      amp.LOG.debug(jsx3._msg("amp.42", this));
      this._state = PlugIn.LOADING;
      return this._engine._loadPlugIn(this);
    } else if (!this.isLoaded())
      this.subscribe(PlugIn.READY, jsx3.$F(cb.done).bind(cb));
    else
      cb.done();
  });

  PlugIn_prototype.loaded = jsx3.$Y(function(cb) {
    if (this.isLoaded()) {
      cb.done();
    } else {
      this.subscribe(PlugIn.READY, jsx3.$F(cb.done).bind(cb));
    }
  });

  PlugIn_prototype._onResourceReady = function(objEvent) {

  };

  PlugIn_prototype._onLastResourceLoaded = function __PlugIn_prototype_onLastResourceLoaded() {
    this._state = PlugIn.LOADED;

    this.onLoaded();
    this.publish({subject:PlugIn.READY});
  };

  PlugIn_prototype.isLoaded = function() {
    return this._state == PlugIn.LOADED;
  };

  PlugIn_prototype.getEngine = function() {
    return this._engine;
  };

  PlugIn_prototype.getServer = function() {
    return this._engine.getServer();
  };

  PlugIn_prototype.getExtPoints = function() {
    return this._extpt;
  };

  PlugIn_prototype.getExtPoint = function(strId) {
    return this._extptmap[strId];
  };

  PlugIn_prototype.getExts = function() {
    return this._ext;
  };

  PlugIn_prototype.getExt = function(strId) {
    return this._extmap[strId];
  };

  PlugIn_prototype.onRegister = function() {
    ;
  };

  PlugIn_prototype.onLoaded = function() {
    ;
  };

  PlugIn_prototype.onStartup = function() {
    ;
  };

  PlugIn_prototype.onExtension = function(objExtPt, arrExts) {
    this.publish({subject:PlugIn.EXTENDED, extpt:objExtPt, exts:arrExts});
  };

  PlugIn_prototype.resolveURI = function(strURI) {
    var uri = jsx3.net.URI.valueOf(strURI);

    // Special handling of relative jsxapp:/path URIs
    if (uri.getScheme() == "jsxapp" && !uri.getHost())
      return this.getServer().resolveURI(uri.getPath().substring(1));

    if (!jsx3.net.URIResolver.isAbsoluteURI(uri))
      uri = this._uri.resolve(uri);

    return jsx3.net.URIResolver.DEFAULT.resolveURI(uri);
  };

  PlugIn_prototype.getUriPrefix = function() {
    return this._uri.toString();
  };

  PlugIn_prototype.relativizeURI = function(strURI, bRel) {
    var loc = jsx3.app.Browser.getLocation();
    var relative = this._uriabs.relativize(loc.resolve(strURI));

    if (relative.isAbsolute() || bRel)
      return relative;
    else
      return jsx3.net.URI.fromParts("jsxplugin", null, this.getId(), null,
          "/" + relative.getPath(), relative.getQuery(), relative.getFragment());
  };

  PlugIn_prototype.toString = function() {
    return this._id;
  };

  PlugIn_prototype.getLog = function() {
    return jsx3.util.Logger.getLogger(this.getId());
  };

  PlugIn_prototype.loadRsrcComponent = function(strRsrcId, objParent, bPaint) {
    if (!objParent)
      throw new jsx3.Exception("Parent container not specified for loading resource " + strRsrcId + ".");

    var rsrc = strRsrcId instanceof amp.Resource ? strRsrcId : this.getResource(strRsrcId);

    if (!rsrc)
      throw new jsx3.Exception("No resource " + strRsrcId + " in plug-in " + this + ".");

    var content = objParent.loadXML(rsrc.getData(), false, this);
    content.getPlugIn = jsx3.$F(function() { return this; }).bind(this);
    if (content.onRsrcLoad) {
      try {
        content.onRsrcLoad();
      } catch (e) {
        amp.LOG.error(jsx3._msg("amp.44", strRsrcId), jsx3.NativeError.wrap(e));
      }
    }

    if (bPaint !== false)
      objParent.paintChild(content);

    return content;
  };

  PlugIn.isBindExpr = function(e) {
    return e.indexOf("{") == 0 && jsx3.$S(e).endsWith("}");
  };
});

jsx3.lang.Class.defineClass("jsx3.amp.ClassPlugIn", jsx3.amp.PlugIn, null, function(ClassPlugIn, ClassPlugIn_prototype) {

  var amp = jsx3.amp;

  ClassPlugIn_prototype.isLoaded = function() {
    return jsx3.Class.forName(this.getId()) != null;
  };

  ClassPlugIn_prototype.setResource = function(arrRsrc) {};

  ClassPlugIn_prototype.getResources = function() {
    if (!this._resources || this._resources.length == 0) {
      var r = new amp.Resource(this, "class",
          {"@path":"jsx:/js/" + this.getId().replace(/\./g, "/") + ".js", "name()":"script"});
      this._resources = jsx3.$A([r]);
    }

    return this._resources;
  };

});

// === XML.js

jsx3.lang.Class.defineClass("jsx3.amp.XML", null, null, function(XML, XML_prototype) {

  XML_prototype.init = function(elm) {
    if (elm instanceof jsx3.xml.Entity) {
      this._native = true;
    }
    this._xml = elm;
  };

  XML_prototype.attr = function(a) {
    return this._native ? this._xml.getAttribute(a) : this._xml["@" + a];
  };

  XML_prototype.nname = function() {
    return this._native ? this._xml.getBaseName() : this._xml["name()"];
  };

  XML_prototype.child = function(name) {
    if (this._native) {
      for (var i = this._xml.getChildIterator(); i.hasNext(); ) {
        var c = i.next();
        if (c.getBaseName() == name)
          return new XML(c);
      }
      return null;
    } else {
      var e = this._xml["/" + name];
      return e ? new XML(e) : null;
    }
  };

  XML_prototype.children = function() {
    if (this._native)
      return jsx3.$A(this._xml.getChildNodes().toArray()).map(function(e) { return new XML(e); });
    else
      return jsx3.$A(this._xml["children()"]).map(function(e) { return new XML(e); });
  };

  XML_prototype.value = function() {
    if (this._native)
      return this._xml.getValue();
    else
      return this._xml["value()"];
  };

  XML_prototype.toNative = function() {
    if (this._native)
      return this._xml;
  };

  XML_prototype.toString = function() {
    if (this._native)
      return this._xml.toString();
    else
      return "";
  };

});

// === Resource.js

// @jsxobf-clobber-shared  _loadResourceShared _getBestLocaleKey

jsx3.lang.Class.defineClass("jsx3.amp.Resource", null, [jsx3.util.EventDispatcher], function(Resource, Resource_prototype) {

  var amp = jsx3.amp;

  Resource.READY = "ready";

  Resource.TYPE_SCRIPT = "script";

  Resource.TYPE_CSS = "css";

  Resource.TYPE_XML = "xml";

  Resource.TYPE_XSL = "xsl";

  Resource.TYPE_JSS = "jss";

  Resource.TYPE_BUNDLE = "propsbundle";

  Resource.LOAD_EARLY = "early";

  Resource.LOAD_NORMAL = "normal";

  Resource.LOAD_MANUAL = "manual";

  Resource._LOAD_MAP = {early:1, normal:1, manual:1};

  Resource.NOT_LOADED = 0;

  Resource.LOADING = 1;

  Resource.LOADED = 2;

  Resource._newBeforePlugIn = function(strPlugInId, strPlugInPath, strId, elm, objEngine) {
    var rsrc = new Resource(null, strId, elm);

    rsrc._pluginid = strPlugInId;

    rsrc._pluginpath = strPlugInPath;

    rsrc._pluginengine = objEngine;
    return rsrc;
  };

  Resource_prototype.init = function(objPlugIn, strId, elm) {

    this._xml = new amp.XML(elm || {});

    this._xmlnative = elm;

    this._plugin = objPlugIn;

    this._id = strId;

    this._prereqs = jsx3.$A();

    this._state = Resource.NOT_LOADED;

    this._data = null;
  };

  Resource_prototype._setPlugInOnInit = function(p) {
    this._plugin = p;
    delete this._pluginid;
    delete this._pluginpath;
    delete this._pluginengine;
  };

  Resource_prototype.attr = function(k) {
    return this._xml.attr(k);
  };

  Resource_prototype.xml = function() {
    return this._xmlnative;
  };

  Resource_prototype.getPlugIn = function() {
    return this._plugin;
  };

  Resource_prototype.getId = function() {
    return (this._plugin ? this._plugin.getId() : this._pluginid) + "." + this._id;
  };

  Resource_prototype.getLocalId = function() {
    return this._id;
  };

  Resource_prototype.getPath = function() {
    return this.attr("path");
  };

  Resource_prototype.getFullPath = function(p) {
    var path = p || this.getPath();
    return this._plugin ? this._plugin.resolveURI(path) : this._pluginpath + path;
  };

  Resource_prototype.getLocales = function() {
    var l = this.attr("locales");
    if (l) {
      l = jsx3.$S(l).trim();
      if (l.length > 0)
        return l.split(/\s+/g);
    }
    return [];
  };

  Resource_prototype.getPathForLocale = function(objLocale) {
    var path = this.getPath();
    if (objLocale) {
      var key = amp._getBestLocaleKey(this.attr("locales"), objLocale);
      if (key) {
        var index = path.lastIndexOf(".");
        if (index < 0 || index < path.lastIndexOf("/"))
          index = path.length;
        path = path.substring(0, index) + "." + key + path.substring(index);
      }
    }
    return path;
  };

  Resource_prototype.getType = function() {
    return this._xml.nname();
  };

  Resource_prototype.getLoadType = function() {
    var load = this.attr("load");
    return Resource._LOAD_MAP[load] ? load : Resource.LOAD_NORMAL;
  };

  Resource_prototype._getPrereqs = function() {
    return this._prereqs;
  };

  Resource_prototype._addPrereq = function(strPrereqId, type) {
    this._prereqs.push({id:strPrereqId, type:type});
  };

  Resource_prototype.isLoaded = function() {
    return this._state == Resource.LOADED;
  };

  Resource_prototype.loaded = jsx3.$Y(function(cb) {
    if (this.isLoaded()) {
      cb.done();
    } else {
      this.subscribe(Resource.READY, jsx3.$F(cb.done).bind(cb));
    }
  });

  Resource_prototype.load = jsx3.$Y(function(cb) {
    if (this._state == Resource.NOT_LOADED) {
      return (this._plugin ? this._plugin.getEngine() : this._pluginengine)._loadResourceShared(this);
    } else if (!this.isLoaded())
      this.subscribe(Resource.READY, jsx3.$F(cb.done).bind(cb));
    else
      cb.done();
  });

  Resource_prototype._engineStart = function(objData) {
    this._state = Resource.LOADING;
  };

  Resource_prototype._engineFinish = function(objData) {
    this._state = Resource.LOADED;
    this._data = objData;
    this.publish({subject:Resource.READY});
  };

  Resource_prototype.getData = function(bClear) {
    var d = this._data;
    if (bClear) delete this._data;
    return d;
  };

  Resource_prototype.toString = function() {
    return this.getId();
  };

});

// === Engine.js

// @jsxobf-clobber-shared  _addPrereq _getPrereqs _engineStart _engineFinish _getConstructor _newBeforePlugIn
// @jsxobf-clobber-shared  _getBestLocaleKey _onLastResourceLoaded _pluginid

jsx3.lang.Class.defineClass("jsx3.amp.Engine", null, [jsx3.util.EventDispatcher], function(Engine, Engine_prototype) {

  var amp = jsx3.amp;
  var Document = jsx3.xml.Document;
  var Job = jsx3.util.Job;

  Engine.LOAD = "load";

  Engine.ERROR = "error";

  Engine.REGISTER = "register";

  Engine.PROGRESS = "progress";

  Engine._ENGINES = {};

  Engine._GLOBAL_PLUGINS = {};

  Engine.getEngine = function(objServer) {
    var key = objServer.getEnv("namespace");

    if (! Engine._ENGINES[key])
      Engine._ENGINES[key] = new Engine(objServer);
    return Engine._ENGINES[key];
  };

  Engine._initIfAddin = function(objServer) {
    var a = objServer.getAddins();
    for (var i = 0; i < a.length; i++)
      if (a[i] == amp.ADDIN) {
        Engine.getEngine(objServer);
        return;
      }
  };

  Engine._init = function() {
    var Server = jsx3.app.Server;
    var s = Server.allServers();
    for (var i = 0; i < s.length; i++)
      Engine._initIfAddin(s[i]);

    Server.subscribe(Server.INITED, Engine, "_onAppInit");
  };

  Engine._onAppInit = function(onjEvent) {
    Engine._initIfAddin(onjEvent.target);
  };

  jsx3.net.URIResolver.register("jsxplugin", function(uri) {
    var pluginId = uri.getHost();
    for (var f in Engine._ENGINES) {
      var p = Engine._ENGINES[f].getPlugIn(pluginId);
      if (p) return p;
    }
    return null;
  });

  Engine_prototype.init = function(objServer) {

    this._server = objServer;

    this._plugins = jsx3.$A();

    this._pluginmap = {};

    this._pluginregdata = {__ct:0};

    this._extptmap = {};

    this._extmap = {};

    this._rsrcserial = 0;

    this._msgbus = jsx3.util.EventDispatcher.jsxclass.newInnerClass();

    this._evtcnt = 0;

    this._pgdata = {};

    this._pgrsrc = {};

    this._prog = new Prog(this);

    this._loaded = false;
    this._load();
  };

  Engine_prototype._load = jsx3.$Y(function(cb) {
    var strPath = amp.DIR + "/" + amp.DESCRIPTOR;

    var mainPluginsURI = amp.ADDIN.resolveURI(strPath);

    var addinXML = new jsx3.xml.Document().load(mainPluginsURI);
    var addinXMLDone = this._loadPluginsDescriptor(addinXML, mainPluginsURI);

    addinXMLDone.when(jsx3.$F(function() {
      this._prog._start();
    }).bind(this));

    var mainXML = Engine._loadXML(this._server.resolveURI(strPath));
    var mainXMLDone = this._loadPluginsDescriptor(mainXML, addinXMLDone); // 2nd param just for temporal ordering

    var autoDone = this._checkAutoReg(mainXMLDone);   // param just for ordering
    return jsx3.$Z(this._onFinished, this)(autoDone); // param just for ordering
  });

  Engine_prototype._checkAutoReg = jsx3.$Y(function(cb) {
    cb.done();
  });

  Engine_prototype._loadPluginsDescriptor = jsx3.$Y(function(cb) {
    var objXML = cb.args()[0];
    var xmlPath = cb.args()[1] || objXML.getSourceURL();

    amp.LOG.debug(jsx3._msg("amp.02", xmlPath));

    if (!objXML.hasError()) {
      var baseName = objXML.getBaseName();
      var uri = objXML.getNamespaceURI();

      if (baseName == "plugins" && uri == amp.NS) {
        var pathPrefix = new jsx3.net.URI(xmlPath).resolve("").toString();
        pathPrefix = pathPrefix.substring(0, pathPrefix.length - 1);
        var condRV = null;

        for (var i = objXML.getChildNodes().iterator(); i.hasNext(); ) {
          var objNode = i.next();
          if (objNode.getBaseName() == "plugin" && objNode.getNamespaceURI() == amp.NS) {
            var c = this._registerPlugInFromRegEntry(objNode, pathPrefix);
            condRV = condRV ? condRV.and(c) : c;
          }
        }

        if (condRV) return condRV;
        cb.done();
      } else {
        amp.LOG.error(jsx3._msg("amp.04", baseName, uri));
        this.publish({subject: Engine.ERROR, xml:objXML});
        cb.done();
      }
    } else {
      amp.LOG.error(jsx3._msg("amp.03", objXML.getError()));
      this.publish({subject: Engine.ERROR, xml:objXML});
      cb.done();
    }
  });

  Engine_prototype._registerPlugInFromRegEntry = jsx3.$Y(function(cb) {
    var objElm = cb.args()[0], strPrefix = cb.args()[1];

    // keep track of number of plug-ins requested so we can report progress
    var id = objElm.getAttribute("id");
    this._pluginregdata[id] = this._pluginregdata.__ct++;
//    amp.LOG.debug("_registerPlugInFromRegEntry " + id);

    // Support the path="../" attribute of the <plugin> registration.
    var pathPrefix = objElm.getAttribute("path");
    if (pathPrefix)
      strPrefix = jsx3.net.URI.valueOf(strPrefix).resolve(pathPrefix).toString();

    return this._registerPlugIn(strPrefix, id, objElm);
  });

  Engine_prototype._registerPlugIn = jsx3.$Y(function(cb) {
    var args = cb.args();
    var strPath = args[0], strId = args[1], objXML = args[2];
    this._prog._add("p." + strId);

    if (!objXML)
      throw fit;
    return this._onDescriptorResponse(strPath, strId, objXML);
  });

  Engine_prototype._onDescriptorResponse = jsx3.$Y(function(cb) {
    var args = cb.args();
    var strPath = args[0], strId = args[1], objXML = args[2];

    //    amp.LOG.debug("_onDescriptorResponse " + strId);
    this._prog._done("p." + strId);

    if (!objXML.hasError()) {
      var baseName = objXML.getBaseName();
      var uri = objXML.getNamespaceURI();

      if (baseName == "plugin" && uri == amp.NS) {
        return this._registerPlugInFromElm(strId, strPath, objXML);
      } else {
        amp.LOG.error(jsx3._msg("amp.05", strId, baseName, uri));
        cb.done();
      }
    } else {
      amp.LOG.error(jsx3._msg("amp.06", strId, objXML.getError()));
      cb.done();
    }
  });

  Engine_prototype._registerPlugInFromElm = jsx3.$Y(function(cb) {
    var args = cb.args();
    var strId = args[0], strPath = args[1], objElm = args[2];

    var id = objElm.getAttribute("id");
    if (!id || id != strId) {
      amp.LOG.error(jsx3._msg("amp.07", strId, id));
      cb.done();
    } else {
      var key = amp._getBestLocaleKey(objElm.getAttribute("locales"), this.getServer().getLocale());
      if (key) {
        this._getLocalizedDesc(strPath + "/" + strId, objElm, key).when(jsx3.$F(function() {
          cb.done(this._registerPlugInFromElm2(strId, strPath, objElm));
        }).bind(this));
      } else {
        return this._registerPlugInFromElm2(strId, strPath, objElm);
      }
    }
  });

  Engine_prototype._getLocalizedDesc = jsx3.$Y(function(cb) {
    var args = cb.args();
    var strPath = args[0], objElm = args[1], strKey = args[2];

    strPath += "/plugin." + strKey + ".xml";
    Engine._loadXML(strPath).when(jsx3.$F(function(xml) {
      if (xml && !xml.hasError())
        this._mergeLocalizedDoc(objElm, xml);
      else
        amp.LOG.error(jsx3._msg("amp.53", strPath, (xml ? xml.getError() : null)));

      cb.done();
    }).bind(this));
  });

  Engine._MERGE_SKIP_XP = {script:1, method:1, field:1, processor:1};

  Engine._MERGE_SKIP_X = {script:1, method:1, field:1};

  Engine_prototype._mergeLocalizedDoc = function(xml, locData) {
    if (locData.getBaseName() != "plugin" || locData.getNamespaceURI() != amp.NS) {
      amp.LOG.error(jsx3._msg("amp.54", locData.getSourceURL()));
      return;
    }

    // 1. Overwrite all attributes of <plugin>
    jsx3.$A(locData.getAttributeNames()).each(function(e) {
      xml.setAttribute(e, locData.getAttribute(e));
    });

    // 2. Overwrite all contents of <extension-point> that are not script, method, field, processor
    this._mergeLocalizedDocClob(xml, locData, "extension-point", Engine._MERGE_SKIP_XP);

    // 3. Overwrite all contents of <extension> that are not script, method, field
    this._mergeLocalizedDocClob(xml, locData, "extension", Engine._MERGE_SKIP_X);
  };

  Engine_prototype._mergeLocalizedDocClob = function(xml, locData, elmName, skipMap) {
    for (var i = locData.selectNodeIterator("amp:" + elmName + "[@id]", amp.XML_NS); i.hasNext(); ) {
      var xpNode = i.next();
      var id = xpNode.getAttribute("id");
      var originalNode = xml.selectSingleNode('amp:' + elmName + '[@id="' + id + '"]', amp.XML_NS);

      if (originalNode) {
        jsx3.$A(xpNode.getAttributeNames()).each(function(e) {
          originalNode.setAttribute(e, xpNode.getAttribute(e));
        });

        var newChildren = xpNode.getChildNodes().toArray();
        if (newChildren.length > 0) {
          jsx3.$A(originalNode.getChildNodes().toArray().reverse()).each(function(e) {
            if (e.getNamespaceURI() != amp.NS || !skipMap[e.getBaseName()]) {
              originalNode.removeChild(e);
            }
          });

          jsx3.$A(newChildren).each(function(e) {
            originalNode.appendChild(e);
          });
        }
      } else {
        amp.LOG.error(jsx3._msg("amp.55", xml.getAttribute("id"), elmName, id));
      }
    }
  };

  Engine_prototype._registerPlugInFromElm2 = jsx3.$Y(function(cb) {
    var args = cb.args();
    var strId = args[0], strPath = args[1], objElm = args[2];
    __jtolog += "registering plug-in: " + strId + "\n";

    // Save the XML metadata for each plug-in for later use.
    this._pgdata[strId] = objElm;
    var arrRsrc = this._createResources(objElm.selectSingleNode("amp:resources", amp.XML_NS), strId, strPath);

    if (strId == 'jsx3.amp.main')
      return jsx3.$Z(this._createAmpMainPlugIn, this)(strId, strPath, objElm, arrRsrc);

    return jsx3.$Z(this._createPlugIn, this)(strId, strPath, objElm, arrRsrc);
  });

  Engine_prototype._createResources = function(objElm, strPlugInId, strPath) {
//    amp.LOG.debug("_createResources " + objElm);
    var idMap = {};

    var r = jsx3.$A();
    if (objElm) {
      for (var i = objElm.getChildNodes().iterator(); i.hasNext(); ) {
        var e = i.next();

        if (e.getNamespaceURI() == amp.NS) {
          var id = e.getAttribute("id");

          if (idMap[id]) {
            amp.LOG.error(jsx3._msg("amp.08", id, strPlugInId));
            id = null;
          }

          if (id == null || id == "")
            id = "_assigned_" + strPlugInId + "_" + (++this._rsrcserial);

          var rsrc = amp.Resource._newBeforePlugIn(strPlugInId, strPath + "/" + strPlugInId + "/", id, e, this);

          for (var j = e.selectNodeIterator("amp:prereq", amp.XML_NS); j.hasNext(); ) {
            var n = j.next();
            var nid = n.getAttribute("id");
            if (nid)
              rsrc._addPrereq(nid, "rsrc");
            else
              rsrc._addPrereq(n.getAttribute("plugin"), "plugin");
          }

          r.push(rsrc);
          idMap[id] = rsrc;
        }
      }
    }

    return r;
  };

  Engine_prototype._getRequires = function(objElm) {
    var r = jsx3.$A();
    for (var i = objElm.selectNodeIterator("amp:requires/amp:plugin", amp.XML_NS); i.hasNext(); )
      r.push(i.next().getAttribute("id"));
    return r;
  };

  Engine_prototype._onProgress = function() {
    var pct = this._prog.pct();

    var objEvt = {subject:Engine.PROGRESS, pct:100*pct};
    if (pct >= 1)
      objEvt.done = true;

    this.publish(objEvt);
  };

  Engine_prototype._createPlugIn = function(strId, strPath, objElm, arrRsrc) {
    // Jump through some hoops if a specific class is specified for the plug-in instance. The class must either
    // be defined before this engine initializes or the <plugin> element must define a classfile attribute that
    // is the relative path to a JavaScript file that defines the class.
    var c;
    var className = objElm.getAttribute("class");
    if (className) {
      c = amp._getConstructor(className);
      if (!c)
        amp.LOG.error(jsx3._msg("amp.09", className, strId));
    }
    if (!c) c = amp.PlugIn;

//    amp.LOG.debug("_createPlugIn " + strId);

    // create the plug-in
    var p = new c();
    p._engine = this;
    p.setPath(strPath + "/" + strId);
    p.setData(objElm);
    p.setResources(arrRsrc);

    this._plugins.push(p);
    this._pluginmap[strId] = p;
    amp.LOG.debug(jsx3._msg("amp.10", p));

    // register all extension points with this engine
    var pts = p.getExtPoints();
    for (var i = 0; i < pts.length; i++) {
      amp.LOG.debug(jsx3._msg("amp.11", pts[i]));
      this._extptmap[pts[i].getId()] = pts[i];
    }

    var ptsExtended = {};

    // register all extensions with this engine
    var exs = p.getExts();
    for (var i = 0; i < exs.length; i++) {
      var ex = exs[i];
      var pointId = ex.getPointId();

      if (!this._extmap[pointId])
        this._extmap[pointId] = jsx3.$A();

      this._extmap[pointId].push(ex);
      // TODO: performance tune so as not to sort too much
      this._extmap[pointId].sort(jsx3.$F(function(a, b) {
        var i1 = this._pluginregdata[a.getPlugIn().getId()] || 0;
        var i2 = this._pluginregdata[b.getPlugIn().getId()] || 0;
        return i1 > i2 ? 1 : (i1 == i2 ? 0 : -1);
      }).bind(this));

      amp.LOG.debug(jsx3._msg("amp.12", ex, pointId));

      if (!ptsExtended[pointId]) ptsExtended[pointId] = jsx3.$A();
      ptsExtended[pointId].push(ex);
    }

    Engine._extendInstance(p, objElm);

    // Notify extension points that they have been extended.
    for (var pointId in ptsExtended) {
      var point = this._extptmap[pointId];
      if (point) {
        point.getPlugIn().onExtension(point, ptsExtended[pointId]);
        point.onExtension(ptsExtended[pointId]);
      }
    }

    p.onRegister();
  };

  Engine_prototype._createAmpMainPlugIn = function(strId, strPath, objElm, arrRsrc) {
    // Jump through some hoops if a specific class is specified for the plug-in instance. The class must either
    // be defined before this engine initializes or the <plugin> element must define a classfile attribute that
    // is the relative path to a JavaScript file that defines the class.
    var c;
    var className = "jsx3.amp.Main";

    // create the plug-in
    var p = new jsx3.amp.Main();
    p._engine = this;
    p.setPath(strPath + "/" + strId);
    p.setData(objElm);
    p.setResources(arrRsrc);

    this._plugins.push(p);
    this._pluginmap[strId] = p;
    amp.LOG.debug(jsx3._msg("amp.10", p));

    // register all extension points with this engine
    var pts = p.getExtPoints();
    for (var i = 0; i < pts.length; i++) {
      amp.LOG.debug(jsx3._msg("amp.11", pts[i]));
      this._extptmap[pts[i].getId()] = pts[i];
    }

    Engine._extendInstance(p, objElm);

    p.onRegister();
  };


  Engine_prototype._forwardEvent = function(objEvent) {
    var e = jsx3.$O(objEvent).clone();
    e.subject = objEvent.target.getId() + "." + objEvent.subject;
    amp.LOG.debug(jsx3._msg("amp.13", e.subject));
    this._msgbus.publish(e);

    // OpenAjax Hub integration
    if (window.OpenAjax && OpenAjax.hub) {
      try {
        OpenAjax.hub.publish(e.subject, e);
      } catch (e) {
        amp.LOG.error(jsx3._msg("amp.17", e.subject), jsx3.NativeError.wrap(e));
      }
    }
  };

  Engine._extendInstance = function(obj, objElm) {
    for (var i = objElm.selectNodeIterator("amp:script | amp:field | amp:method", amp.XML_NS); i.hasNext(); ) {
      var n = i.next();
      var name = n.getBaseName();

      if ("script" == name) {
//        amp.LOG.debug("Eval script on " + obj);
        try {
          obj.eval(n.getValue());
        } catch (e) {
          amp.LOG.error(jsx3._msg("amp.14", obj), jsx3.NativeError.wrap(e));
        }
      } else if ("field" == name) {
        try {
//        amp.LOG.debug("Define field " + n.getAttribute("id") + " on " + obj);
          obj[n.getAttribute("id")] = obj.eval(n.getValue());
        } catch (e) {
          amp.LOG.error(jsx3._msg("amp.15", n.getAttribute("id"), obj), jsx3.NativeError.wrap(e));
        }
      } else if ("method" == name) {
//        amp.LOG.debug("Define method " + n.getAttribute("id") + " on " + obj);
        try {
          var id = n.getAttribute("id");
          if (n.getAttribute("lazy") == "true") {
            fct = this._makeLazyFct(id);
          } else {
            var p = n.getAttribute("params") || "";
            var fct = jsx3.eval("var " + id + " = function(" + p + ") {" + n.getValue() + "}; " + id + ";");
            if (n.getAttribute("async") == "true")
              fct = jsx3.$Y(fct);
          }

          obj[id] = fct;
        } catch (e) {
          amp.LOG.error(jsx3._msg("amp.16", n.getAttribute("id"), obj), jsx3.NativeError.wrap(e));
        }
      }

      // Remove the node from the XML so that extension processing is not messed up.
      n.getParent().removeChild(n);
    }
  };

  Engine._makeLazyFct = function(strMethod) {
    return function() {
      this.load().when(jsx3.$F(function(methodName, arrArgs) {
        this[methodName].apply(this, arrArgs);
      }).bind(this, [strMethod, arguments]));
    };
  };

  Engine_prototype.isLoaded = function() {
    return this._loaded;
  };

  Engine_prototype.getServer = function() {
    return this._server;
  };

  Engine_prototype.getPlugIns = function() {
    return this._plugins;
  };

  Engine_prototype.getPlugIn = function(strId) {
    return this._pluginmap[strId];
  };

  Engine_prototype.getExtPoint = function(strId) {
    return this._extptmap[strId];
  };

  Engine_prototype.getExts = function(strId) {
    return this._extmap[strId] || jsx3.$A();
  };

  Engine_prototype.register = jsx3.$Y(function(cb) {
    var args = cb.args();
    var strId = args[0];
    var strPath = args[1];
    var objXML = args[2];

    if (this._pluginmap[strId])
      throw new jsx3.IllegalArgumentException("Already loaded plug-in " + strId + ".");

    return this._registerPlugIn(strPath, strId, objXML);
  });

  Engine_prototype.deregister = function(strId) {
    var p = this.getPlugIn(strId);
    if (p) {
      this._plugins.remove(p);

      var xp = p.getExtPoints();
      for (var i = 0; i < xp.length; i++) {
        var xpid = xp[i].getId();
        delete this._extptmap[xpid];
        delete this._extmap[xpid];
      }

      var exts = p.getExts();
      for (var i = 0; i < exts.length; i++) {
        var ext = exts[i];
        var extList = this._extmap[ext.getPointId()];
        if (extList)
          extList.remove(ext);
      }

      delete this._pluginmap[strId];
      delete this._pluginregdata[strId];
      delete this._pgdata[strId];
      delete this._pgrsrc[strId];
    }
  };

  Engine_prototype._loadPlugIn = jsx3.$Y(function(cb) {
    var objPlugIn = cb.args()[0];
    //    amp.LOG.debug("_loadPlugIn " + objPlugIn);

    var presDone = this._loadPrereqPlugIns(objPlugIn);
    var rsrcDone = this._loadNormalRsrcs(objPlugIn, presDone); // 2nd parameter for ordering only
    return jsx3.$Z(this._onAfterPlugInLoaded, this)(objPlugIn, rsrcDone); // 2nd parameter for ordering only
  });

  Engine_prototype._loadPrereqPlugIns = jsx3.$Y(function(cb) {
    var objPlugIn = cb.args()[0];

    var condRV = null;

    var arrReqs = objPlugIn.getRequires();
    arrReqs.each(jsx3.$F(function(e) {
      var p = this.getPlugIn(e);
      if (p) {
        if (!p.isLoaded()) {
          var c = p.load();
          condRV = condRV ? condRV.and(c) : c;
        }
      } else {
        amp.LOG.error(jsx3._msg("amp.18", objPlugIn, e));
      }
    }).bind(this));

    if (condRV) return condRV;
    else cb.done();
  });

  Engine_prototype._loadNormalRsrcs = jsx3.$Y(function(cb) {
    var objPlugIn = cb.args()[0];
    var condRV = null;

    var arrRsrc = objPlugIn.getResources();
    arrRsrc.each(function(r) {
      if (!r.isLoaded() && r.getLoadType() == amp.Resource.LOAD_NORMAL) {
        var c = r.load();
        condRV = condRV ? condRV.and(c) : c;
      }
    });

    if (condRV) return condRV;
    else cb.done();
  });

  Engine_prototype._onAfterPlugInLoaded = function __Engine_prototype_onAfterPlugInLoaded(objPlugIn) {
//    amp.LOG.debug("_onAfterPlugInLoaded " + objPlugIn.getId() + " " + this._pgdata[objPlugIn.getId()]);

    var data = this._pgdata[objPlugIn.getId()];
    if (data) {
      // gc
      delete this._pgdata[objPlugIn.getId()];
      delete this._pgrsrc[objPlugIn.getId()];

      objPlugIn.getBindableProps().each(function(e) {
        objPlugIn.updateBindable(e);
      });

      var propName = data.getAttribute("property");
      if (propName)
        jsx3.lang.setVar(objPlugIn.isGlobal() ? propName :
                           objPlugIn.getServer().getEnv("namespace") + "." + propName, objPlugIn);
    }

    objPlugIn._onLastResourceLoaded();
    amp.LOG.debug(jsx3._msg("amp.43", objPlugIn));
  };

  Engine_prototype._loadResourceShared = jsx3.$Y(function(cb) {
    var objResource = cb.args()[0];
    objResource._engineStart();

    var presDone = this._loadResourcePres(objResource, objResource.getPlugIn());
    this._loadResourceReal(objResource, presDone ).when(function __Engine_prototype_loadResourceShared_onLoaded(data) {
      objResource._engineFinish(data);
      cb.done();
    });
  });

  Engine_prototype._loadResourceReal = jsx3.$Y(function(cb) {
    var thisEngine = this;
    var objResource = cb.args()[0];

    var objServer = this.getServer();
    var strRsrcPath = objResource.getPathForLocale(objServer.getLocale());
    var strType = objResource.getType();

    var progId = "r." + objResource.getId();
    this._prog._add(progId);

    if (strRsrcPath) {
      var strSrc = objResource.getFullPath(strRsrcPath);
      // __jtolog += "loading resource: " + strSrc + "\n";
      amp.LOG.debug(jsx3._msg("amp.52", objResource, strSrc));

//      amp.LOG.debug("_newResourceJob " + objResource + " " + strSrc);
      var onDone = function __Engine_prototype_loadResourceReal_onDone(rv) {
        amp.LOG.debug(jsx3._msg("amp.23", objResource, strSrc));
        thisEngine._prog._done(progId);
        cb.done(rv);
      };

      switch (strType) {
        case "script":
          if (objResource.attr("eval") == "true")
            Engine._loadText(strSrc).when(jsx3.$F(function(rv) {
	      __jtolog += "loaded script " + strSrc + "\n";
              if (rv != null) {
                var target = objResource.getPlugIn() || jsx3;
                try {
                  target.eval(rv);
                } catch (e) {
                  amp.LOG.error(jsx3._msg("amp.32", strSrc, target), jsx3.NativeError.wrap(e));
                }
              } else {
                amp.LOG.error(jsx3._msg("amp.33", strSrc));
              }
              onDone();
            }).bind(this));
          else
            Engine._loadJS(strSrc).when(onDone);
          break;
        case "css":
          Engine._loadCSS(strSrc).when(onDone);
          break;
        case "jss":
          Engine._loadXML(strSrc).when(jsx3.$F(function(rv) {
	    __jtolog += "loaded jss " + strSrc + "\n";
            var c = this._getRsrcCache(objServer, objResource.attr("cache"));
            var cacheid = objResource.attr("cachekey") || objResource.getId();
            if (c)
              c.setDocument(cacheid, rv);
            objServer.JSS.loadXML(rv, cacheid);
            onDone(rv);
          }).bind(this));
          break;
        case "propsbundle":
          jsx3.app.PropsBundle.getPropsAsync(strSrc, objServer.getLocale(), function(props) {
            objServer.LJSS.addParent(props);
            onDone(props);
          }, objServer.getCache());
          break;
        case "xml":
          Engine._loadXML(strSrc).when(jsx3.$F(function(rv) {
	    __jtolog += "loaded xml " + strSrc + "\n";
            var c = this._getRsrcCache(objServer, objResource.attr("cache"));
            if (c)
              c.setDocument(objResource.attr("cachekey") || objResource.getId(), rv);
            onDone(rv);
          }).bind(this));
          break;
        default:
          amp.LOG.error(jsx3._msg("amp.22", strType));
          onDone();
      }

    } else {
      amp.LOG.debug(jsx3._msg("amp.25", objResource));

      var xml = objResource.xml();
      var dataNode = xml.selectSingleNode("amp:data", amp.XML_NS);
      var objData = null;

      switch (strType) {
        case "script":
          // Any load="early" resource will not have access to the PlugIn object, so they should not assume
          // "this" context.
          (objResource.getPlugIn() || jsx3).eval((dataNode || xml).getValue());
          break;
        case "css":
          if (jsx3.CLASS_LOADER.IE) {
            var styleNode = document.createElement("style");
            styleNode.setAttribute("type", "text/css");
            document.getElementsByTagName("head")[0].appendChild(styleNode);
            styleNode.styleSheet.cssText = (dataNode || xml).getValue().toString();
          } else {
            jsx3.html.insertAdjacentHTML(document.getElementsByTagName("head")[0], "beforeEnd",
                    '<style type="text/css">\n' + (dataNode || xml).getValue() + "\n</style>");
          }
          break;
        case "jss":
          if (dataNode) {
            objServer.JSS.loadXML(dataNode.getFirstChild(), objResource.getId());
            objData = objServer.JSS;
          } else {
            amp.LOG.error(jsx3._msg("amp.29", objResource));
          }
          break;
        case "propsbundle":
          amp.LOG.warn(jsx3._msg("amp.28"));
          break;
        case "xml":
          if (dataNode) {
            objData = new jsx3.xml.Document(dataNode.getFirstChild());
            this._getRsrcCache(objServer, objResource.attr("cache")).setDocument(objResource.attr("cachekey") || objResource.getId(), objData);
          } else {
            amp.LOG.error(jsx3._msg("amp.29", objResource));
          }
          break;
        case "xsl":
          if (dataNode) {
            objData = new jsx3.xml.XslDocument(dataNode.getFirstChild());
            this._getRsrcCache(objServer, objResource.attr("cache")).setDocument(objResource.attr("cachekey") || objResource.getId(), objData);
          } else {
            amp.LOG.error(jsx3._msg("amp.29", objResource));
          }
          break;
        default:
          amp.LOG.error(jsx3._msg("amp.22", strType));
      }

      this._prog._done(progId);
      cb.done(objData);
    }
  });

  Engine_prototype._loadResourcePvt = jsx3.$Y(function(cb) {
    var args = cb.args();
    var objResource = args[0];

    this._loadResourcePres(objResource).when(function() {
      objResource.load().when(cb);
    });
  });

  Engine_prototype._getSiblingResource = function(r, id) {
    var p = r.getPlugIn();
    return p ? p.getResource(id) : this._pgrsrc[r._pluginid][id];
  };

  Engine_prototype._loadResourcePres = jsx3.$Y(function(cb) {
    var args = cb.args();
    var objResource = args[0];

    var condRV = null;

    var arrPres = objResource._getPrereqs();

    arrPres.each(jsx3.$F(function(e) {
      var c = null;

      if (e.type == "plugin") {
        var plugIn = this.getPlugIn(e.id);
        if (plugIn) {
          if (!plugIn.isLoaded())
            c = plugIn.load();
        } else {
          amp.LOG.error(jsx3._msg("amp.20", e.id, objResource));
        }
      } else {
        var preReq = this._getSiblingResource(objResource, e.id);

        if (preReq) {
          if (!preReq.isLoaded())
            c = preReq.load();
        } else {
          amp.LOG.error(jsx3._msg("amp.21", e.id, objResource));
        }
      }

      if (c)
        condRV = condRV ? condRV.and(c) : c;
    }).bind(this));

    if (condRV) return condRV;
    else cb.done();
  });

  Engine_prototype._onFinished = function() {
    this._loaded = true;

    for (var i = 0; i < this._plugins.length; i++)
      this._plugins[i].onStartup();

    this.publish({subject: Engine.LOAD});
  };

  Engine_prototype._getRsrcCache = function(objServer, strType) {
    if ("shared" == strType)
      return jsx3.getSharedCache();
    else if ("system" == strType)
      return jsx3.getSystemCache();
    else
      return objServer.getCache();
  };

  Engine._loadXML = jsx3.$Y(function(cb) {
    var args = cb.args();
    var path = args[0], objClass = args[1];

    var d = (objClass || jsx3.xml.Document.jsxclass).newInstance();
    d.setAsync(true);
    d.subscribe("*", function() {
      cb.done(d);
    });
    d.load(path);
  });

  Engine._loadText = jsx3.$Y(function(cb) {
    var args = cb.args();
    var path = args[0];

    var r = jsx3.net.Request.open("GET", path, true);
    r.subscribe("*", function() {
      cb.done(r.getResponseText());
    });
    r.send();
  });

  Engine._loadCSS = jsx3.$Y(function(cb) {
    return this._loadOnce(cb.args()[0], "_loadCSS2");
  });

  Engine._loadCSS2 = jsx3.$Y(function(cb) {
    var path = cb.args()[0];

    // instance a new DOM element
    var element = document.createElement("link");
    element.href = path;
    element.rel = "stylesheet";
    element.type = "text/css";

    //bind the element to the browser DOM to begin loading the resource
    document.getElementsByTagName("head")[0].appendChild(element);
    cb.done();
  });

  Engine._loadJS = jsx3.$Y(function(cb) {
    return this._loadOnce(cb.args()[0], "_loadJS2");
  });

  Engine._loadJS2 = jsx3.$Y(function(cb) {
    var path = cb.args()[0];

    __jtolog += "loading script: " + path + "\n";
    var element = document.createElement("script");
    element.setAttribute("src", path);
    element.setAttribute("type", 'text/javascript');

    // set up onload handler
    if (element.addEventListener) {
      var evtHandler = function __eventHandler(e) {
        element.removeEventListener("load", evtHandler, false);
        cb.done();
      };

      element.addEventListener("load", evtHandler, false);
    } else {
      element.onreadystatechange = function() {
        var state = this.readyState;
        if (state == "loaded" || state == "interactive" || state == "complete") {
          element.onreadystatechange = null;
          cb.done();
        }
      };
    }

    // bind the element to the browser DOM to begin loading the resource
    document.getElementsByTagName("head")[0].appendChild(element);
  });

  Engine._ONCE = {};

  Engine._loadOnce = jsx3.$Y(function(cb) {
    var path = cb.args()[0];

    var already = Engine._ONCE[path];
    if (already) {
      if (already instanceof jsx3.$AsyncRV)
        return already;
      else {
        cb.done();
      }
    } else {
      var fct = cb.args()[1];
      var retVal = Engine._ONCE[path] = this[fct](path);
      retVal.when(function() {
        Engine._ONCE[path] = 1;
      });
      return retVal;
    }
  });

  var Prog = function(eng) {
    // TODO: don't bother with tracking IDs when logic is confirmed correct
    this._eng = eng;
    this._ids = {};
    this._total = 0;
    this._donect = 0;
    this._on = 0;
  };

  jsx3.$O(Prog.prototype).extend({

    _start: function() {
      this._on = 1;
    },

    _add: function(id) {
      if (this._on) {
        if (this._ids[id])
          amp.LOG.warn(jsx3._msg("amp.34", id));
        else {
          this._ids[id] = 1;
          this._total++;
          this._eng._onProgress();
        }
      }
    },

    _done: function(id) {
      if (this._on) {
        if (this._ids[id]) {
          delete this._ids[id];
          this._donect++;
          this._eng._onProgress();
        } else {
          amp.LOG.warn(jsx3._msg("amp.35", id));
        }
      }
    },

    pct: function() {
      return this._total > 0 ? this._donect / this._total : 0;
    }
  });

});

// === jsx3.amp.main/Main.js

jsx3.lang.Class.defineClass("jsx3.amp.Main", jsx3.amp.PlugIn, null, function(Main, Main_prototype) {

  var amp = jsx3.amp;

  Main_prototype.onRegister = function() {
    amp.LOG.debug("Main.onRegister");
    this._progress = jsx3.$A();
    this._pctdone = 0;
    this._mainComp = null;

    this.getEngine().subscribe(amp.Engine.PROGRESS, this, "_onProgress");
    this.load();
    // Since this is the first plug-in to load, no need to check pre-existing extensions.
  };

  Main_prototype.onExtension = function(objExtPt, arrExts) {
    this.jsxsuper(objExtPt, arrExts);

    amp.LOG.debug("Main.onExtension " + objExtPt + " [" + arrExts + "]");
    var id = objExtPt.getLocalId();

    if (id == "progress") {
      objExtPt.processExts(null, arrExts).each(jsx3.$F(function(arv) {
        arv.when(jsx3.$F(function(rv) {
          rv.setProgress(this._pctdone);
          this._progress.push(rv);
        }).bind(this));
      }).bind(this));
    } else if (id == "init") {
      jsx3.$A(arrExts).each(function(e) { e.getPlugIn().load(); });
    } else if (id == "layout") {
      jsx3.$A(arrExts).each(function(e) { e.getPlugIn().load(); });
    }
  };

  Main_prototype._onProgress = function(objEvent) {
    this._pctdone = objEvent.pct;
//    this.getLog().debug("_onProgress " + objEvent.pct + " " + objEvent.done);

    var msg = objEvent.done ? "onComplete" : "setProgress";
    var pct = this._pctdone;
    this._progress.each(function(e) {
      e[msg](pct);
    });
  };

  Main_prototype.onStartup = function() {
    // Make sure that required plug-ins are loaded before doing this.
    this.loaded().when(jsx3.$F(function __Main_prototype_onStartup_outerLambda() {
      amp.LOG.debug("Main.onStartup");

      var layouts = this.getExtPoint("layout").processExts();
      if (layouts.length > 0) {
        var container = this.getServer().getBodyBlock();
        layouts[0].when(function __Main_prototype_onStartup_innerLambda(rv) { rv(container); });
      }
    }).bind(this));
  };

});

// === jsx3.amp.util/MenuManager.js

jsx3.Class.defineClass("jsx3.amp.util.MenuManager", null, null, function(MenuManager, MenuManager_prototype) {
  var amp = jsx3.amp;
  var LOG = jsx3.util.Logger.getLogger(MenuManager.jsxclass.getName());
  MenuManager_prototype.init = function() {};
  MenuManager_prototype.addMenuBar = function(strPath, objContainer) {};
  MenuManager_prototype.getMenu = function(strPath) {};
  MenuManager_prototype.getMenus = function() {};
  MenuManager_prototype.finishInit = function() {};
  MenuManager_prototype.addMenu = function(objMenu) {};
  MenuManager_prototype.addItem = function(objItem) {};
  MenuManager_prototype._getPathAndSection = function(p) {};
});

jsx3.Class.defineClass("jsx3.amp.util.MenuItem", null, null, function(MenuItem, MenuItem_prototype) {
  var amp = jsx3.amp;
  MenuItem_prototype.init = function(objExt, objData) {};
  MenuItem_prototype.attr = function(strKey) { return this._elm.attr(strKey); }
  MenuItem_prototype.getId = function() {};
  MenuItem_prototype.getLabel = function() {};
  MenuItem_prototype.getImg = function() {};
  MenuItem_prototype.getTip = function() {};
  MenuItem_prototype.getPath = function() {};
  MenuItem_prototype._getFullPath = function() {};
  MenuItem_prototype.execute = function() {};
  MenuItem_prototype.toString = function() {};
  MenuItem_prototype.isEnabled = function() {};
  MenuItem_prototype.isSelected = function() {};
  MenuItem_prototype.getHotKey = function() {};
  MenuItem_prototype.getMenu = function() {};
  MenuItem_prototype.getRootMenu = function() {};
  MenuItem_prototype.getExt = function() {};
});

jsx3.Class.defineClass("jsx3.amp.util.Menu", jsx3.amp.util.MenuItem, null, function(Menu, Menu_prototype) {
  var amp = jsx3.amp;
  var LOG = jsx3.util.Logger.getLogger("jsx3.amp.util.MenuManager");
  Menu_prototype.init = function(objExt, objElm) {};
  Menu_prototype.getItem = function(id) {};
  Menu_prototype._onOpenMenu = function(objEvent) {};
  Menu_prototype.getXML = function() {};
  Menu_prototype.onShow = function(objMenu, objElm) {};
  Menu_prototype._onMenuExe = function(objEvent) {};
  Menu_prototype.getId = function() {};
  Menu_prototype.getPath = function() {};
  Menu_prototype.getNativeMenu = function() {};
  Menu_prototype.addSection = function(strId, bDivider) {};
  Menu_prototype.addItem = function(objItem, strSection) {};
  Menu_prototype.getItems = function() {};
});

// *** GI_Builder
// === jsx3.ide.ui/PlugIn.js

jsx3.Class.defineClass("jsx3.ide.ui.PlugIn", jsx3.amp.PlugIn, null, function(PlugIn, PlugIn_prototype) {
  var ui = jsx3.ide.ui;
  var amp = jsx3.amp;

  ui.CONTENT = {
  };

  PlugIn_prototype.onLoaded = function() {
    this._menuManager = new amp.util.MenuManager();
    this._paletteManager = null;
    //    this._paletteManager = new ui.PaletteManager();
    //this._paletteManager.setMenuManager(this._menuManager);
    //this._paletteManager.setPlugIn(this);
  };

  PlugIn_prototype.getMenuManager = function() {
    return this._menuManager;
  };

  PlugIn_prototype.getPaletteManager = function() {
    return this._paletteManager;
  };

  PlugIn_prototype.getPalette = function(objOwner, strId) {
    return this._paletteManager ? this._paletteManager.getPalette(objOwner.getId() + "." + strId) : null;
  };

  PlugIn_prototype.paintLayout = function __PlugIn_prototype_paintLayout(objContainer) {
    var layout = this.loadRsrcComponent("layout", objContainer, false);
    var mainMenu = layout.getDescendantOfName("mainMenu");

    // Insert any extensions to the menubar.
    try {
      var exts = this.getExtPoint("menubar-ext").processExts();
      var objChild = exts[0];
      var Model = jsx3.app.Model;
      var objServer = mainMenu.getServer();
      if (!objServer)
        objServer.die();
      alert("we got here: " + objServer);
    } catch (exc) {
      document.write("<pre>" + __jtolog + "\n\n" + exc.stack.replace(/@file/g, '\n  file') + "</pre>");
      throw exc;
    }
  };

  PlugIn_prototype.paintIDELayout = function(objContainer) {};

  PlugIn_prototype.setProgress = function() {};

  PlugIn_prototype.onComplete = function() {
    if (this._progimage && this._progimage._progon) {
      this._progimage._progon = false;
      this._progimage.setSrc("images/progress_off.gif");
      this._progimage.repaint();
      jsx3.html.updateCSSOpacity(this._progimage.getRendered(), .25);
    }
  };

  PlugIn_prototype.createProjectPathExt = function() {
    var b = this._projectpath = new jsx3.gui.Block();
    b.setText();
    b.setPadding("6 16 1 8");
    b.setHeight("100%");
    b.setBorder("0px;2px dotted #9898a5;0px;0px");
    b.setMenu("jsxmenu_apppath");

    if (jsx3.ide.PROJECT)
      this._setProjectPath();
    else
      jsx3.IDE.subscribe("startup", this, "_setProjectPath");

    return b;
  };

  PlugIn_prototype._setProjectPath = function() {
    var dir = jsx3.ide.getActiveProjectDirectory();
    if (dir) {
      this._projectpath.setText('<nobr><a target="_new" style="color:darkblue;" href="' +
            dir.toURI() + '">' + jsx3.ide.PROJECT.getPathFromHome() + '</a></nobr>', true);
    }
  };
});

window.jsx_main();
